package com.ninexiu.sixninexiu.activity

import android.content.Context
import android.text.SpannableStringBuilder
import android.text.Spanned
import android.text.style.ForegroundColorSpan
import android.view.View
import android.view.inputmethod.InputMethodManager
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import java.lang.Exception
import java.lang.StringBuilder
import java.net.URLEncoder

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/09
 *     desc   : 账户安全辅助类
 *     version: 1.0
 * </pre>
 */
object AccountSecurityHelper {
    fun hideKeyBoard(view: View) {
        val imm: InputMethodManager? = view.context.getSystemService(Context.INPUT_METHOD_SERVICE) as? InputMethodManager
        imm?.hideSoftInputFromWindow(view.windowToken, 0)
    }

    // 替换tip中的%s成手机号码，并显示高亮
    fun setPhoneNumberHighLight(context: Context, tv: TextView, tip: String?,number : String?) {
        if(tip.isNullOrBlank() || number.isNullOrBlank()) {
            return
        }

        var numberTemp = number
        if(number.length == 11) {
            numberTemp = StringBuilder().append(number.substring(0,3)).append("****").append(number.substring(7,11)).toString()
        }

        val tipTemp = tip.replace("%s",numberTemp)

        setPhoneNumberHighLight(context, tv, tipTemp)
    }

    // 负责将文字中的手机号码高亮
    fun setPhoneNumberHighLight(context: Context, tv: TextView, tip: String?) {
        if (tip.isNullOrBlank()) {
            return
        }
        val indexF = tip.indexOf("1")
        if (indexF != -1 && indexF + 11 <= tip.length) {
            val ssb = SpannableStringBuilder(tip)
            ssb.setSpan(ForegroundColorSpan(context.resources.getColor(R.color.color_56a3d2)), indexF, indexF + 11, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
            tv.text = ssb
            return
        }

        tv.text = tip
    }

    fun toURLEncoded(paramsString : String) : String{
        return try {
            val str = String(paramsString.toByteArray())
            URLEncoder.encode(str,"UTF-8")
        }catch (e : Exception) {
            paramsString
        }
    }
}