package com.ninexiu.sixninexiu.activity

import android.content.Context
import android.content.Intent
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.fragment.SelectCityAnchorFragment
import com.ninexiu.sixninexiu.view.fitterViewSize
import kotlinx.android.synthetic.main.activity_dynamic_selected_city.*
import org.jetbrains.anko.displayMetrics

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/26
 *     desc   : 动态的选择城市
 *     version: 1.0
 * </pre>
 */
class DynamicSelectedCityActivity : BaseActivity() {
    companion object {
        const val FRAGMENT_TAG = "dynamic_selected_city"

        fun startActivity(context: Context) {
            context.startActivity(Intent(context, DynamicSelectedCityActivity::class.java))
        }
    }

    override fun setContentView() {
        setContentView(R.layout.activity_dynamic_selected_city)
    }

    override fun initViews() {
        super.initViews()

        frameLayoutDynamic.post {
            fitterViewSize(frameLayoutDynamic, { this.displayMetrics.widthPixels }, { (this.displayMetrics.heightPixels * 0.816).toInt() })
        }

        val fragment = SelectCityAnchorFragment()
        supportFragmentManager.beginTransaction()
                .replace(R.id.frameLayoutDynamic, fragment, FRAGMENT_TAG)
                .commit()
    }

}