package com.ninexiu.sixninexiu.activity

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.KeyEvent
import android.widget.ImageView
import androidx.core.app.ActivityOptionsCompat
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.GlideUtils
import kotlinx.android.synthetic.main.activity_content_image.*


/**
 * @author: lou
 * @date: 2021/8/30
 * desc:用来加载单个大图的Activity  点击图片关闭该页面
 */
class ImageContentActivity : BaseActivity() {

    companion object {
        //共享动画，第一个参数原activity,第二个参数图片的地址，第三个参数联动的view
        fun startActivity(context: Activity, path: String?, view: ImageView) {
            val intent = Intent(context, ImageContentActivity::class.java)
            val bundle = ActivityOptionsCompat.makeSceneTransitionAnimation(context, view, "bigImg")
                .toBundle()
            intent.putExtra("bigImg", path)
            context.startActivity(intent,bundle)
        }
    }


    override fun setContentView() {
        setContentView(R.layout.activity_content_image)
        val bigImg = intent.getStringExtra("bigImg")
        GlideUtils.loadImageView(this, bigImg, imageview)
        imageview.setOnClickListener() {
            onBackPressed()
        }


    }


}