package com.ninexiu.sixninexiu.activity

import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.DensityUtil
import com.ninexiu.sixninexiu.common.util.ScreenUtils
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import com.thirdparty.utils.StatusBarUtil
import kotlinx.android.synthetic.main.mblive_room_guide_pic.*

class MBLiveRoomGuideActivity :BaseActivity() {
    companion object{
        const val RESULT_CODE_GUIDE=1112
    }
    override fun setContentView() {
        setContentView(R.layout.mblive_room_guide_pic)
    }

    override fun initViews() {
        super.initViews()

        StatusBarUtil.setTranslucentForImageViewInFragment(this, null)
        StatusBarUtil.setDarkMode(this)

        val attLoc=intent.getIntArrayExtra("attention_location")
        val userLoc=intent.getIntArrayExtra("onlineuser_location")
        val moreLoc=intent.getIntArrayExtra("more_location")

        attLoc?.let {
            val attentStrokeParams = iv_attention.layoutParams as ConstraintLayout.LayoutParams
            attentStrokeParams.leftMargin = it[0] - dp2px(this,2)
            attentStrokeParams.topMargin = it[1] + dp2px(this,2)
        }

        moreLoc?.let {
            val moreParams = guide_more.layoutParams as ConstraintLayout.LayoutParams
            moreParams.rightMargin = ScreenUtils.getScreenWidth(this) - it.get(0) - dp2px(this, 53)
        }

        userLoc?.let {
            val onlineUserParams = iv_guide_onlineuser.layoutParams as ConstraintLayout.LayoutParams
            onlineUserParams.leftMargin = it[0] - dp2px(this, 4)
            onlineUserParams.topMargin = it[1] - dp2px(this, 4)
        }

        rl_guide_touch.setOnClickListener {
            if (guide_page1.visibility == View.VISIBLE) { //建议加动画效果
                guide_page1.setVisible(false)
                guide_page2.setVisible(true)
            } else {
                setResult(RESULT_CODE_GUIDE)
                finish()
                overridePendingTransition(0,0)
            }
        }
    }


}