package com.ninexiu.sixninexiu.activity

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import com.google.gson.Gson
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.DynamicTitleBean
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.DiscoveryRankingPersonFragment
import com.ninexiu.sixninexiu.values.DynamicTitleType
import com.ninexiu.sixninexiu.view.popwindow.DiscoveryPopWindow
import kotlinx.android.synthetic.main.activity_person_rank.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/13
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class PersonRankActivity : BaseActivity() {
    companion object {
        fun startActivity(context: Context) {
            val intent = Intent(context, PersonRankActivity::class.java)
            context.startActivity(intent)
        }
    }

    override fun initEvents() {
        super.initEvents()
        fl_rank_top_btn.setOnClickListener {
            val discoveryPopWindow = DiscoveryPopWindow()
            discoveryPopWindow.create(this)
            discoveryPopWindow.show(tv_rank_top_btn, mSelectPosition)
            discoveryPopWindow.setOnClickCallback { type, text -> refresh(type, text) }
        }

        left_btn.setOnClickListener{
            finish()
        }
    }

    fun refresh(type: Int, text: String?) {
        tv_rank_top_btn?.text = text
        fragment?.refresh(mSelectPosition, type)
    }

    private var mSelectPosition = 0
    fun selectedRank(position: Int, currentTab: String?) {
        mSelectPosition = position
        tv_rank_top_btn?.text = currentTab
    }

    override fun setContentView() {
        setContentView(R.layout.activity_person_rank)
    }

    private var fragment : DiscoveryRankingPersonFragment? = null
    private var dynamicTitleBean: DynamicTitleBean? = null
    override fun initViews() {
        super.initViews()
        getTitleBean()

        var tempData = dynamicTitleBean

        if(tempData?.data?.size?:0 > 0) {
            for(bean in (tempData?.data)!!) {
                if(TextUtils.equals(bean.type, DynamicTitleType.DYNAMIC_TITLE_ONE_RANK)) {
                    fragment = DiscoveryRankingPersonFragment.newInstance(bean)
                    fragment?.let {
                        supportFragmentManager.beginTransaction().add(R.id.rankContainer, it).commitAllowingStateLoss()
                    }
                }
            }
        }
    }

    private fun getTitleBean() {
        var dynamicTitleStr = AppCnfSpHelper.getInstance().dynamicTitleStr
        if (TextUtils.isEmpty(dynamicTitleStr)) {
            val inputStream = resources.openRawResource(R.raw.dynamic_title)
            dynamicTitleStr = Utils.getLineString(inputStream)
        }

        dynamicTitleBean = Gson().fromJson(dynamicTitleStr, DynamicTitleBean::class.java)
    }
}