package com.ninexiu.sixninexiu.activity

import android.animation.Keyframe
import android.animation.ObjectAnimator
import android.animation.PropertyValuesHolder
import android.content.Context
import android.content.Intent
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.util.Property
import android.util.TypedValue
import android.view.*
import android.view.View.OnTouchListener
import android.view.animation.LinearInterpolator
import android.view.inputmethod.EditorInfo
import androidx.core.content.ContextCompat
import com.blankj.utilcode.util.KeyboardUtils
import com.loopj.android.http.TextHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.audio.AudioRecordManager
import com.ninexiu.sixninexiu.audio.OnAudioRecordListener
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.common.KeyBoardListener
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.view.HeadBoxView
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import com.ninexiu.sixninexiu.view.shape.RoundTextView
import com.tencent.imsdk.TIMConversationType
import com.tencent.qcloud.tim.uikit.PushContants
import com.tencent.qcloud.tim.uikit.base.IUIKitCallBack
import com.tencent.qcloud.tim.uikit.component.dialog.SendVoiceDialog
import com.tencent.qcloud.tim.uikit.modules.chat.C2CChatManagerKit
import com.tencent.qcloud.tim.uikit.modules.chat.base.ChatInfo
import com.tencent.qcloud.tim.uikit.modules.message.MessageInfo
import com.tencent.qcloud.tim.uikit.modules.message.MessageInfoUtil
import com.tencent.qcloud.tim.uikit.utils.PermissionManager
import com.tencent.qcloud.tim.uikit.utils.SoftKeyBoardUtil
import com.tencent.qcloud.tim.uikit.utils.ToastUtil
import com.thirdparty.utils.StatusBarUtil
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.dialog_say_hello.*
import kotlinx.android.synthetic.main.mb_layout_liveroom_input_copy_dialog.*
import org.json.JSONObject
import kotlin.math.sqrt
import kotlin.random.Random


/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2021/04/06
 *     desc   : 打招呼
 * </pre>
 */
class SayHelloHalfActivity : BaseActivity(), View.OnClickListener {

    companion object {
        const val TYPE_TEXT = 1
        const val TYPE_VOICE = 2
        fun start(context: Context, anchorInfo: AnchorInfo) {
            StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SAY_HI_HELF)
            val intent = Intent(context, SayHelloHalfActivity::class.java)
            intent.putExtra("anchor", anchorInfo)
            context.startActivity(intent)
        }
    }

    private val keyframeList = ArrayList<Float>()
    private val keysOne = ArrayList<String>()
    private val keysTwo = ArrayList<String>()
    private val keysThree = ArrayList<String>()
    private val colors = ArrayList<Int>()
    private val backgrounds = ArrayList<Int>()

    private var mIvHead: HeadBoxView? = null
    private var chatContent: String? = null

    private var mAudioCancel: Boolean = false
    private var mStartRecordY: Float = 0.toFloat()
    private var choseList: Int = 2
    private var anchorInfo: AnchorInfo? = null

    private var mSendVoiceDialog: SendVoiceDialog? = null
    private val recordManager:AudioRecordManager by lazy {
        AudioRecordManager(1,60,recordListener)
    }

    //录音文件路径
    private var audioFilePath: String? = null
    //录音时长
    private var audioDuration = 0

    private val recordListener= object :OnAudioRecordListener{
        override fun onAudioInitFailed(msg: String) {

        }

        override fun onAudioRecordStart() {
        }

        override fun onAudioProgress(duration: Int) {
        }

        override fun onAudioFinish(effective: Boolean, audioFilePath: String?, duration: Int) {
            if (effective) {
                this@SayHelloHalfActivity.audioFilePath = audioFilePath
                audioDuration = duration
                recordComplete(effective)
            }
        }
    }

    override fun setContentView() {
        setContentView(R.layout.dialog_say_hello)
    }


//    override fun getContentView() = R.layout.dialog_say_hello


    override fun initViews() {
        super.initViews()

        StatusBarUtil.setTranslucentForImageViewInFragment(this, null)
        StatusBarUtil.setDarkMode(this)

        overridePendingTransition(0, 0)


        anchorInfo = intent.getSerializableExtra("anchor") as? AnchorInfo

        val offset = 8
        val path = (sqrt(3.0) / 2 * offset).toFloat()

        if (keyframeList.isEmpty()) {
            keyframeList.add(offset / 2.toFloat())
            keyframeList.add(path)
            keyframeList.add(offset.toFloat())
            keyframeList.add(0f)
            keyframeList.add(-offset / 2.toFloat())
            keyframeList.add(-path)
            keyframeList.add(-offset.toFloat())
            keyframeList.add(-path)
            keyframeList.add(-offset / 2.toFloat())
        }

        isCanSendVoiceMessage()
        keysOne.add("关注你好久了")
        keysOne.add("来，漂亮的\n人先说话")
        keysOne.add("理我一下，我专门为\n你学的打字")
        keysOne.add("我想做你的快乐")
        keysOne.add("今天最高兴的事情就是遇到你哦")

        keysTwo.add("我有故事你有酒吗？")
        keysTwo.add("偷心盗贼\n不请自来")
        keysTwo.add("你的小可爱突然\n出现啦")
        keysTwo.add("膜拜在姐姐的\n气质之下")
        keysTwo.add("拦都拦不住手机非要给你打个招呼")

        keysThree.add("头像是我，不满意？")
        keysThree.add("有些话想\n说给你听")
        keysThree.add("看见你很漂亮我就\n给你打招呼了")
        keysThree.add("我是月老派过来\n执行任务的")
        keysThree.add("为什么不理我，是不是欲擒故纵")


        colors.add(ContextCompat.getColor(this, R.color.color_ff567b))
        colors.add(ContextCompat.getColor(this, R.color.color_ff6e10))
        colors.add(ContextCompat.getColor(this, R.color.color_5793ff))
        colors.add(ContextCompat.getColor(this, R.color.color_f886eb))
        colors.add(ContextCompat.getColor(this, R.color.color_ff814a))
        backgrounds.add(ContextCompat.getColor(this, R.color.color_ffeaef))
        backgrounds.add(ContextCompat.getColor(this, R.color.color_fff8e2))
        backgrounds.add(ContextCompat.getColor(this, R.color.color_eaf2ff))
        backgrounds.add(ContextCompat.getColor(this, R.color.color_f8f0fc))
        backgrounds.add(ContextCompat.getColor(this, R.color.color_fff1e4))

        rootView_say_hi.setBackgroundColor(ContextCompat.getColor(this, R.color.color_black_7f000000))
        initGreeView(keysOne)
    }

    private fun initGreeView(list: ArrayList<String>) {
        flow_layout.removeAllViews()
        startEnterAnim(flow_layout, 400)
        for ((index, key) in list.withIndex()) {
            val tvKey = RoundTextView(this)
            val layoutParams = ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, dp2px(this, 60))
            tvKey.layoutParams = layoutParams
            tvKey.setTextColor(colors[index])
            tvKey.setBackgroundColor(backgrounds[index])
            tvKey.gravity = Gravity.CENTER_VERTICAL
            tvKey.delegate.backgroundColor = backgrounds[index]
            tvKey.delegate.cornerRadius_TL = dp2px(this, 12)
            tvKey.delegate.cornerRadius_TR = dp2px(this, 12)
            tvKey.delegate.cornerRadius_BL = dp2px(this, 12)
            tvKey.delegate.cornerRadius_BR = 0
            if (key.length < 3) {
                tvKey.setTextSize(TypedValue.COMPLEX_UNIT_SP, 22f)
                tvKey.setPadding(dp2px(this, 27), 0, dp2px(this, 27), 0)
            } else {
                tvKey.setTextSize(TypedValue.COMPLEX_UNIT_SP, 14f)
                tvKey.setPadding(dp2px(this, 10), 0, dp2px(this, 10), 0)
            }
            tvKey.text = key
            val animator = getTransAnim(tvKey, 6000)
            animator?.start()
            tvKey.setOnClickListener {
                edit_click_input.setText(tvKey.text.toString().replace("\n", ""))
                setViewShow(false)
            }
            flow_layout.addView(tvKey)
        }

    }

    /**
     * 进场动画
     */
    private fun startEnterAnim(parent: View, duration: Int) {
        parent.post {
            parent.pivotX = parent.width.toFloat()
            parent.pivotY = parent.height.toFloat()
            val scaleX = PropertyValuesHolder.ofKeyframe(View.SCALE_X,
                    Keyframe.ofFloat(0f, 0f),
                    Keyframe.ofFloat(1 / 4f, 1 / 4f),
                    Keyframe.ofFloat(2 / 4f, 1 / 2f),
                    Keyframe.ofFloat(3 / 4f, 3 / 4f),
                    Keyframe.ofFloat(1f, 1f))

            val scaleY = PropertyValuesHolder.ofKeyframe(View.SCALE_Y,
                    Keyframe.ofFloat(0f, 0f),
                    Keyframe.ofFloat(1 / 4f, 1 / 4f),
                    Keyframe.ofFloat(2 / 4f, 1 / 2f),
                    Keyframe.ofFloat(3 / 4f, 3 / 4f),
                    Keyframe.ofFloat(1f, 1f))
            val animator = ObjectAnimator.ofPropertyValuesHolder(parent, scaleX, scaleY).setDuration(duration.toLong())
            animator.interpolator = LinearInterpolator()
            animator.repeatCount = 0
            animator.start()
        }
    }


    /**
     * 气泡漂浮动画
     * @param view
     * @param duration  动画运行时间
     * @param offset    动画运行幅度
     * @param repeatCount   动画运行次数
     * @return
     */
    private fun getTransAnim(view: View?, duration: Int): ObjectAnimator? {
        val translateX = getPropertyValuesHolder(View.TRANSLATION_X)
        val translateY = getPropertyValuesHolder(View.TRANSLATION_Y)
        val animator = ObjectAnimator.ofPropertyValuesHolder(view, translateX, translateY).setDuration(duration.toLong())
        animator.interpolator = LinearInterpolator()
        animator.repeatCount = -1
        return animator
    }

    private fun getPropertyValuesHolder(name: Property<View, Float>): PropertyValuesHolder {
        return PropertyValuesHolder.ofKeyframe(name,
                Keyframe.ofFloat(0f, 0f),
                Keyframe.ofFloat(1 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(2 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(3 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(4 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(5 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(6 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(7 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(8 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(9 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(10 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(11 / 12f, keyframeList[Random.nextInt(keyframeList.size)]),
                Keyframe.ofFloat(1f, 0f)
        )
    }

    override fun initDatas() {
        super.initDatas()
        anchorInfo?.let {
            mIvHead = HeadBoxView(this)
            mIvHead?.bindHead(halfgreet_iv_headimg)
            // 头像
            mIvHead?.setScale(1.4f)
            mIvHead?.loadBoxImage(it.headframe)
            GlideUtils.loadCirclePic(this, it.headimage, mIvHead?.iv_head)

            tv_nickname.text = if (!TextUtils.isEmpty(it.nickname)) it.nickname else ""
        }
    }

    override fun initEvents() {
        super.initEvents()
        tv_click_input?.setOnClickListener(this)
        halfgreet_tv_send?.setOnClickListener(this)
        view_placeholder?.setOnClickListener(this)
        iv_refresh?.setOnClickListener(this)
        tv_voice_enable?.setOnClickListener(this)

        edit_click_input?.setOnEditorActionListener { v, actionId, event ->
            if (actionId == KeyEvent.ACTION_DOWN || actionId == EditorInfo.IME_ACTION_DONE) {
                KeyboardUtils.hideSoftInput(edit_click_input)
            }
            return@setOnEditorActionListener true
        }


        // 表情和键盘图标切换
        SoftKeyBoardUtil.SoftKeyboardStateHelper(window.decorView, object : SoftKeyBoardUtil.SoftKeyboardStateListener {
            override fun onSoftKeyboardOpened(keyboardHeightInPx: Int) {
                NSLog.d("SoftKeyBoardUtil", "onSoftKeyboardOpened : $keyboardHeightInPx")
                setViewShow(false)
            }

            override fun onSoftKeyboardClosed() {
                NSLog.d("SoftKeyBoardUtil", "onSoftKeyboardClosed")
                val input=edit_click_input.text.toString().trim()
                if (TextUtils.isEmpty(input) && (TextUtils.isEmpty(audioFilePath) || audioDuration<=0)){
                    setViewShow(true)
                }
            }
        })


        edit_click_input?.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {
                halfgreet_tv_send?.isEnabled = s?.toString()?.length ?: 0 > 0

                if (s?.toString()?.length ?: 0 >= 50) {
                    tv_maxhint_vaule?.setTextColor(ContextCompat.getColor(this@SayHelloHalfActivity, R.color.color_fd4259))
                } else {
                    tv_maxhint_vaule?.setTextColor(ContextCompat.getColor(this@SayHelloHalfActivity, R.color.color_999999))
                }
                edit_click_input.setSelection(s?.length ?: 0)
                tv_maxhint_vaule?.text = s?.length.toString() + "/50"
            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {

            }
        })

        halfgreet_ll_voice?.setOnTouchListener(object : OnTouchListener {
            override fun onTouch(v: View?, motionEvent: MotionEvent?): Boolean {
                PermissionManager.create().showVoice(this@SayHelloHalfActivity, object : PermissionManager.GrantedCallBack {
                    override fun allGranted(allGranted: Boolean) {
                        when (motionEvent?.action) {
                            MotionEvent.ACTION_DOWN -> {
                                if (PushContants.ISSENDVOICEMESSAGE != 1) {
                                    ToastUtil.toastShortMessage(PushContants.SENDVOICEMESSAGEREASON)
                                    return
                                }
                                if (PushContants.ISINLIVEROOM) {
                                    ToastUtil.toastShortMessage("直播间内无法使用此功能")
                                    return
                                }
                                mAudioCancel = true
                                mStartRecordY = motionEvent.getY()
                                showVoiceDialog(true)
                                recordManager.startRecording()
                            }

                            MotionEvent.ACTION_MOVE -> {
                                if (PushContants.ISSENDVOICEMESSAGE != 1) {
                                    return
                                }
                                if (PushContants.ISINLIVEROOM) {
                                    return
                                }
                                if (motionEvent.getY() - mStartRecordY < -345) {
                                    mAudioCancel = true
                                    showVoiceDialog(false)
                                } else {
                                    if (mAudioCancel) {
                                        showVoiceDialog(true)
                                    }
                                    mAudioCancel = false
                                }

                            }

                            MotionEvent.ACTION_CANCEL, MotionEvent.ACTION_UP -> {
                                if (PushContants.ISSENDVOICEMESSAGE != 1) {
                                    return
                                }
                                if (PushContants.ISINLIVEROOM) {
                                    return
                                }
                                mAudioCancel = motionEvent.getY() - mStartRecordY < -345
                                dismissVoiceDialog()
                                recordManager.stopAudioRecord()

                            }

                            else -> {
                            }
                        }
                    }
                })

                return true
            }
        })

    }

    override fun onBackPressed() {
        KeyboardUtils.hideSoftInput(edit_click_input)
        rootView_say_hi.setBackgroundColor(ContextCompat.getColor(this, R.color.transparent))
        super.onBackPressed()
        overridePendingTransition(0, R.anim.anim_view_bottom_out)
    }


    override fun onClick(v: View?) {

        when (v?.id) {
            R.id.view_placeholder -> {
                KeyboardUtils.hideSoftInput(edit_click_input)
                rootView_say_hi.setBackgroundColor(ContextCompat.getColor(this, R.color.transparent))
                finish()
                overridePendingTransition(0, R.anim.anim_view_bottom_out)
            }
            R.id.tv_click_input -> {
                KeyboardUtils.showSoftInput(edit_click_input)

            }
            R.id.iv_refresh -> {
                when (choseList) {
                    1 -> {
                        initGreeView(keysOne)
                        choseList++
                    }
                    2 -> {
                        initGreeView(keysTwo)
                        choseList++
                    }
                    3 -> {
                        initGreeView(keysThree)
                        choseList = 1
                    }
                }


            }
            R.id.halfgreet_tv_send -> {
                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SAY_HI_HELF_SEND)
                KeyboardUtils.hideSoftInput(edit_click_input)
                if (!TextUtils.isEmpty(edit_click_input?.text.toString())) {
                    chatContent = edit_click_input?.text.toString()
                    sendGreet(TYPE_TEXT, null, 0)
                }

                if (!TextUtils.isEmpty(audioFilePath) && audioDuration > 0 && cl_voice_container.visibility == View.VISIBLE) {
                    sendGreet(TYPE_VOICE, audioFilePath, audioDuration)
                }
            }
            R.id.iv_delete_voice -> {
                aiv_voice?.deleteAudio()
                audioFilePath = null
                audioDuration = 0
                cl_voice_container?.visibility = View.INVISIBLE

                tv_voice_enable.setVisible(false)

                if (TextUtils.isEmpty(edit_click_input?.text.toString().trim())) {
                    KeyboardUtils.hideSoftInput(edit_click_input)
                    halfgreet_tv_send?.isEnabled = false
                }
            }
            R.id.tv_voice_enable -> {

            }
        }
    }

    private fun sendGreet(type: Int, path: String?, duration: Int) {
        anchorInfo?.let {
            var message: MessageInfo? = null
            when (type) {
                1 -> {
                    message = MessageInfoUtil.buildTextMessage(chatContent)
                }

                2 -> {
                    message = MessageInfoUtil.buildAudioMessage(path, duration*1000)
                }

            }
            val chatInfo = ChatInfo()
            chatInfo.type = TIMConversationType.C2C
            chatInfo.id = it.uid
            chatInfo.chatName = it.nickname
            val chatManager = C2CChatManagerKit.getInstance()
            chatManager.currentChatInfo = chatInfo
            chatManager.setIsFriend(0)
            chatManager.setIs_anchor(1)
            chatManager.setNickName(it.nickname)
            chatManager.setSelfNickName(NineShowApplication.mUserBase?.nickname)
            chatManager.sendMessage(message, false, object : IUIKitCallBack {
                override fun onSuccess(data: Any?) {
                    MyToast.MakeToast("发送成功")
                }

                override fun onError(module: String?, errCode: Int, errMsg: String?) {

                }
            })
            finish()
        }
    }

    /**
     * 发送语音 dialog
     */
    private fun showVoiceDialog(flag: Boolean) {

        if (flag) {
            if (mSendVoiceDialog == null) {
                mSendVoiceDialog = SendVoiceDialog.create(this)
                mSendVoiceDialog?.show()
                mSendVoiceDialog?.setCountDown(60)
            }
        }
        if (mSendVoiceDialog?.isShowing == true) {
            mSendVoiceDialog?.setSendFlag(flag)
        }
    }

    /**
     * 关闭发送语音 dialog
     *
     */
    private fun dismissVoiceDialog() {
        if (mSendVoiceDialog?.isShowing == true) {
            mSendVoiceDialog?.dismiss()
            mSendVoiceDialog = null
        }
    }

    /**
     * 设置view隐藏或者显示
     * show 标识flowlayout 显示或者隐藏
     */
    private fun setViewShow(show: Boolean) {
        if (show) {
            tv_click_input?.visibility = View.VISIBLE
            flow_layout?.visibility = View.VISIBLE
            iv_refresh?.visibility = View.VISIBLE
            edit_click_input?.visibility = View.GONE
            tv_maxhint_vaule?.visibility = View.GONE
            edit_click_input?.isFocusable = false
            edit_click_input?.isFocusableInTouchMode = false
            cl_voice_container?.visibility = View.GONE
            tv_voice_enable?.visibility = View.GONE
        } else {
            tv_click_input?.visibility = View.GONE
            flow_layout?.visibility = View.GONE
            iv_refresh?.visibility = View.GONE
            edit_click_input?.visibility = View.VISIBLE
            tv_maxhint_vaule?.visibility = View.VISIBLE
            edit_click_input?.post {
                edit_click_input?.isFocusable = true
                edit_click_input?.isFocusableInTouchMode = true
                edit_click_input?.requestFocus()
            }
            cl_voice_container?.visibility = View.INVISIBLE
            if (!TextUtils.isEmpty(audioFilePath) && audioDuration > 0){
                UIUtils.showView(cl_voice_container)
                aiv_voice.setAudioItemSource(audioFilePath!!, audioDuration)
                halfgreet_tv_send?.isEnabled = true
                iv_delete_voice.setOnClickListener(this)
                //录制按钮 不可点击
                tv_voice_enable?.visibility = View.VISIBLE
            }else{
                cl_voice_container?.visibility = View.INVISIBLE
                tv_voice_enable?.visibility = View.GONE
            }
        }
    }

    private fun recordComplete(success: Boolean) {
        if (!success || audioDuration == 0 || TextUtils.isEmpty(audioFilePath)) {
            stopAbnormally()
            return
        }
        if (mAudioCancel) {
            dismissVoiceDialog()
            return
        }
        if (audioDuration <= 1) {
            stopAbnormally()
            return
        }
        dismissVoiceDialog()
        setViewShow(false)

    }

    private fun stopAbnormally() {
        halfgreet_rv_tooshort.visibility = View.VISIBLE
        halfgreet_ll_voice.postDelayed({ halfgreet_rv_tooshort.visibility = View.GONE }, 2000)
    }

    /**
     * 是否可以发送语音消息
     */
    private fun isCanSendVoiceMessage() {
        val params = NSRequestParams()
        val instance = NSAsyncHttpClient.getInstance()
        params.put("uid", anchorInfo?.uid)
        instance.setTimeout(1200)
        instance.post(
                Constants.POST_CAN_SENDVIOCE, params, object : TextHttpResponseHandler() {
            override fun onSuccess(statusCode: Int, headers: Array<out Header>?, responseString: String?) {
                val obj: JSONObject
                try {
                    obj = JSONObject(responseString)
                    if (obj.has("code")) {
                        val responceCode = obj.optInt("code")
                        val message = obj.getString("message")
                        if (responceCode == 200) {
                            PushContants.ISSENDVOICEMESSAGE = 1
                        } else {
                            PushContants.ISSENDVOICEMESSAGE = 2
                        }
                        PushContants.SENDVOICEMESSAGEREASON = message
                    }
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }

            override fun onFailure(statusCode: Int, headers: Array<out Header>?, responseString: String?, throwable: Throwable?) {
            }
        })
    }
}