package com.ninexiu.sixninexiu.activity

import android.content.Context
import android.content.Intent
import android.view.View
import androidx.fragment.app.Fragment
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.fragment.UserReturnLiveFragment
import com.ninexiu.sixninexiu.fragment.UserReturnWelfareFragment
import com.ninexiu.sixninexiu.view.UserReturnTabLayout
import com.ninexiu.sixninexiu.view.dialog.UserReturnRuleDialog
import kotlinx.android.synthetic.main.activity_return_welfare.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/23
 *     desc   : 回归福利，邂逅主播聚合页
 *     version: 1.0
 * </pre>
 */
class UserReturnWelfareAndLiveActivity : BaseActivity() {
    companion object {
        fun startActivity(context: Context) {
            val intent = Intent(context, UserReturnWelfareAndLiveActivity::class.java)
            context.startActivity(intent)
        }
    }

    override fun setContentView() {
        setContentView(R.layout.activity_return_welfare)
    }

    override fun initViews() {
        super.initViews()

        llBack.setOnClickListener { this.finish() }
        llInfo.setOnClickListener {
            (fragmentWelfare as? UserReturnWelfareFragment)?.let {
                UserReturnRuleDialog(this, UserReturnRuleDialog.USER_RETURN_TOGETHER_TYPE,it.getGameStatus()).show()
            }
        }

        userReturnTabLayout.onUserSelected = {
            switchFragment(it)
        }

        supportFragmentManager.beginTransaction().add(R.id.frameContainer, fragmentWelfare).commit()
        supportFragmentManager.beginTransaction().add(R.id.frameContainer, fragmentLive).commit()

        switchFragment(UserReturnTabLayout.TAB_WELFARE)
    }

    private var fragmentWelfare: Fragment = UserReturnWelfareFragment.getInstance()
    private var fragmentLive: Fragment = UserReturnLiveFragment.getInstance()

    // 切换Fragment
    private fun switchFragment(index: Int) {
        when (index) {
            UserReturnTabLayout.TAB_WELFARE -> {
                llInfo.visibility = View.VISIBLE
                supportFragmentManager.beginTransaction().show(fragmentWelfare).hide(fragmentLive).commit()
            }
            UserReturnTabLayout.TAB_LIVE -> {
                StatisticsUtil.onEvent(StatisticsEventID.UM_USER_RETURN_SWITCH_LIVE)
                StatisticsUtil.onEvent(StatisticsEventID.UM_USER_RETURN_SWITCH_LIVE_COUNT)
                llInfo.visibility = View.INVISIBLE
                supportFragmentManager.beginTransaction().show(fragmentLive).hide(fragmentWelfare).commit()
            }
        }
    }
}