package com.ninexiu.sixninexiu.activity.store

import android.app.Activity
import android.app.ActivityOptions
import android.content.Intent
import android.os.Build
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.widget.TextView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.BaseActivity
import com.ninexiu.sixninexiu.adapter.store.StoreBeautyNumberAdapter
import com.ninexiu.sixninexiu.bean.Account
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.fragment.store.StoreBuyDialog
import kotlinx.android.synthetic.main.activity_store_beauty_number_search.*
import kotlinx.android.synthetic.main.layout_for_show_state.*
import kotlinx.android.synthetic.main.title_tab_bar.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class StoreBeautyNumberSearchActivity : BaseActivity() {
    companion object {
        fun start(context: Activity, transView: View) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {//判断Android版本
                val bundle =
                        ActivityOptions.makeSceneTransitionAnimation(context, transView, "search_beauty_number")
                                .toBundle()
                context.startActivity(Intent(context, StoreBeautyNumberSearchActivity::class.java), bundle)
            } else {
                context.startActivity(Intent(context, StoreBeautyNumberSearchActivity::class.java))
            }
        }
    }

    private lateinit var beautyNumberAdapter: StoreBeautyNumberAdapter
    private var numberList = ArrayList<Account>()

    override fun setContentView() {
        setContentView(R.layout.activity_store_beauty_number_search)
    }

    override fun initViews() {
        findViewById<TextView>(R.id.title).text = "商城"

        rv_search_result.layoutManager = GridLayoutManager(this, 3, GridLayoutManager.VERTICAL, false)
        beautyNumberAdapter = StoreBeautyNumberAdapter(this, true, numberList)
        rv_search_result.adapter = beautyNumberAdapter

        beautyNumberAdapter.onNumberClick = { number, position ->
            StoreBuyDialog.create(this, number).show()
        }
    }

    override fun initEvents() {
        super.initEvents()
        left_btn.setOnClickListener {
            finishAfterTransition()
        }

        tv_cancel.setOnClickListener {
            finishAfterTransition()
        }

        et_search.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {
                s?.let {
                    if (!it.isNullOrEmpty()) {
                        searchBeautyNumber(it.toString())
                    } else {
                        if (numberList.isNotEmpty()) {
                            numberList.clear()
                            beautyNumberAdapter.notifyDataSetChanged()
                        }
                    }
                }

            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

        })
    }

    private fun searchBeautyNumber(number: String) {
        StoreHelper.searchBeautyNumber(number, {
            if (it.isNullOrEmpty()) {
                sv_state_view?.showEmpty("喔哦，很遗憾!\n暂时没有相关靓号出售，建议您\n选购其他靓号")
            } else {
                sv_state_view?.showSuccess()
                numberList.clear()
                for ((key, data) in it) {
                    numberList.addAll(data)
                }
                beautyNumberAdapter.notifyDataSetChanged()
            }
        }, { code, msg ->
            MyToast.MakeToast(msg)
        })
    }
}