package com.ninexiu.sixninexiu.activity.store

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import androidx.core.content.ContextCompat
import com.ninexiu.sixninexiu.CommonApplication
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AccountIdentityDialog
import com.ninexiu.sixninexiu.activity.BaseActivity
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.pay.ZhiFuFastCDialog
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.CommonRemindDialog
import com.ninexiu.sixninexiu.view.dialog.OnZhiFuFastDialogDismissListener
import com.ninexiu.sixninexiu.view.dp2px
import com.tencent.qcloud.tim.uikit.utils.SoftKeyBoardUtil
import com.thirdparty.utils.StatusBarUtil
import kotlinx.android.synthetic.main.dialog_store_give.*
import org.json.JSONObject


/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/19
 *     desc   : 新版商城赠送弹窗
 *     version: 1.0
 * </pre>
 */
class StoreGiveActivity : BaseActivity() {
    override fun setContentView() {
        setContentView(R.layout.dialog_store_give)
    }


    companion object {
        const val KEY_GOODS_TYPE = "key_goods_type"
        const val KEY_GOODS = "key_goods"
        const val KEY_GOODS_PRICE = "key_goods_price"
        const val KEY_GOODS_TAB = "key_goods_tab"

        //需要返回的回调
        var onBackClick: ((Boolean) -> Unit)? = null

        fun start(context: Context, goodsNumber: Account, price: BuyTimeList, onBackClick: ((Boolean) -> Unit)? = null) {
            this.onBackClick = onBackClick
            val intent = Intent(context, StoreGiveActivity::class.java)
            intent.putExtra(KEY_GOODS_TYPE, StoreHelper.TYPE_BEAUTY_NUMBER)
            intent.putExtra(KEY_GOODS, goodsNumber)
            intent.putExtra(KEY_GOODS_PRICE, price)
            context.startActivity(intent)
        }

        fun start(context: Context, props: StoreProps, price: BuyTimeList, onBackClick: ((Boolean) -> Unit)? = null) {
            this.onBackClick = onBackClick
            val intent = Intent(context, StoreGiveActivity::class.java)
            intent.putExtra(KEY_GOODS_TYPE, StoreHelper.TYPE_BEAUTY_PROPS)
            intent.putExtra(KEY_GOODS, props)
            intent.putExtra(KEY_GOODS_PRICE, price)
            context.startActivity(intent)
        }

        fun start(context: Context, vipInfo: VipPrivilege, price: BuyTimeList, onBackClick: ((Boolean) -> Unit)? = null) {
            this.onBackClick = onBackClick
            val intent = Intent(context, StoreGiveActivity::class.java)
            intent.putExtra(KEY_GOODS_TYPE, StoreHelper.TYPE_BEAUTY_VIP)
            intent.putExtra(KEY_GOODS, vipInfo)
            intent.putExtra(KEY_GOODS_PRICE, price)
            context.startActivity(intent)
        }

        fun start(context: Context, dressUpTab: DressUpTab, dressupGoods: DressUpGoods, price: BuyTimeList, onBackClick: ((Boolean) -> Unit)? = null) {
            this.onBackClick = onBackClick
            val intent = Intent(context, StoreGiveActivity::class.java)
            intent.putExtra(KEY_GOODS_TYPE, StoreHelper.TYPE_BEAUTY_DRESSUP)
            intent.putExtra(KEY_GOODS_TAB, dressUpTab)
            intent.putExtra(KEY_GOODS, dressupGoods)
            intent.putExtra(KEY_GOODS_PRICE, price)
            context.startActivity(intent)
        }
    }


    private var type: Int = 0
    private var beautyNumber: Account? = null
    private var props: StoreProps? = null
    private var vipInfo: VipPrivilege? = null
    private var dressUpTab: DressUpTab? = null
    private var dressupGoods: DressUpGoods? = null
    private var price: BuyTimeList? = null

    //是否需要返回上一页面
    private var needBack = true


    override fun initViews() {
        StatusBarUtil.setTransparent(this)
        overridePendingTransition(R.anim.activity_games_bottom_in,R.anim.activity_games_bottom_out)

        type = intent.getIntExtra(KEY_GOODS_TYPE, 0)
        if (type == StoreHelper.TYPE_BEAUTY_NUMBER) {
            beautyNumber = intent.getParcelableExtra(KEY_GOODS)
        } else if (type == StoreHelper.TYPE_BEAUTY_PROPS) {
            props = intent.getParcelableExtra(KEY_GOODS)
        } else if (type == StoreHelper.TYPE_BEAUTY_VIP) {
            vipInfo = intent.getParcelableExtra(KEY_GOODS)
        } else if (type == StoreHelper.TYPE_BEAUTY_DRESSUP) {
            dressupGoods = intent.getParcelableExtra(KEY_GOODS)
            dressUpTab = intent.getParcelableExtra(KEY_GOODS_TAB)

            tv_give.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(this, R.color.color_ff567b), ContextCompat.getColor(this, R.color.color_FFAD9B))
        }

        price = intent.getParcelableExtra(KEY_GOODS_PRICE)





        setupBalance()
        when (type) {
            StoreHelper.TYPE_BEAUTY_NUMBER -> {
                tv_store_give_desc.text = "赠送给Ta 靓号：${beautyNumber?.accountid}*${price?.timeLimit}"
                tv_store_give_price.text = "${price?.pre_price}九币"
            }
            StoreHelper.TYPE_BEAUTY_PROPS -> {
                tv_store_give_desc.text = "赠送给Ta 隐身卡*${price?.timeLimit}"
                tv_store_give_price.text = "${price?.pre_price}九币"
            }
            StoreHelper.TYPE_BEAUTY_DRESSUP -> {
                tv_store_give_desc.text = "赠送给Ta ${dressUpTab?.name}：${dressupGoods?.name}*${price?.timeLimit}"
                if (dressUpTab != null && dressUpTab!!.id == 2) {
                    tv_store_give_price.text = "${price?.pre_price}九币"
                } else {
                    tv_store_give_price.text = "${price?.money}九币"
                }
                tv_store_give_price.setTextColor(ContextCompat.getColor(this,R.color.color_ff567b))
            }
            StoreHelper.TYPE_BEAUTY_VIP -> {
                tv_store_give_desc.text = "赠送给Ta ${vipInfo?.name}*${price?.timeLimit}"
                tv_store_give_price.text = "${price?.pre_price}九币"
            }
            else -> ""
        }

        SoftKeyBoardUtil.SoftKeyboardStateHelperNew(window?.decorView, object : SoftKeyBoardUtil.SoftKeyboardStateListener {
            override fun onSoftKeyboardClosed() {
                NSLog.e("隐藏键盘 ------------------")
                cl_give_container.translationY = 0f
            }

            override fun onSoftKeyboardOpened(keyboardHeightInPx: Int) {
                NSLog.e("打开键盘 ===================" + keyboardHeightInPx)
                cl_give_container.translationY = -keyboardHeightInPx + dp2px(this@StoreGiveActivity, 160).toFloat()

            }
        })

    }

    override fun initDatas() {
        super.initDatas()
    }

    override fun initEvents() {
        super.initEvents()

        tv_give.setOnClickListener {
            if (type == StoreHelper.TYPE_BEAUTY_NUMBER) {
                giveBeautyNumber()
            } else if (type == StoreHelper.TYPE_BEAUTY_PROPS) {
                giveProps()
            } else if (type == StoreHelper.TYPE_BEAUTY_DRESSUP) {
                giveDressUp()
            } else if (type == StoreHelper.TYPE_BEAUTY_VIP) {
                giveVipBefore()
            }
        }

        iv_give_close.setOnClickListener {
            setResultFinish()
        }

        view_placeholder.setOnClickListener {
            setResultFinish()
        }
    }


    /**
     * 余额设置
     */
    private fun setupBalance() {
        var nineCoin: String? = ""
        var nineDot: String? = ""
        CommonApplication.mUserBase?.let {
            if (it.money >= 0 || it.tokencoin >= 0) {
                nineCoin = when {
                    it.money in StoreHelper.TENTHOUSAND..StoreHelper.A_HUNDRED_MILLION -> {
                        Utils.convertToTenThousand((it.money / (StoreHelper.TENTHOUSAND * 1.0)))
                    }
                    it.money > StoreHelper.A_HUNDRED_MILLION -> {
                        val double2 = it.money / (StoreHelper.A_HUNDRED_MILLION * 1.0)
                        Utils.convertToAHundredMillion(double2)
                    }
                    else -> {
                        it.money.toString() + ""
                    }
                }
                nineDot = when {
                    it.tokencoin in StoreHelper.TENTHOUSAND..StoreHelper.A_HUNDRED_MILLION -> {
                        Utils.convertToTenThousand((it.tokencoin / (StoreHelper.TENTHOUSAND * 1.0)))
                    }
                    it.tokencoin > StoreHelper.A_HUNDRED_MILLION -> {
                        Utils.convertToAHundredMillion((it.tokencoin / (StoreHelper.A_HUNDRED_MILLION * 1.0)))
                    }
                    else -> {
                        it.tokencoin.toString() + ""
                    }
                }
            }
            tv_blance_9bi?.text = "${nineCoin}九币"
            tv_blance_9dian?.text = "${nineDot}九点"
        }
    }


    /**
     * 赠送靓号
     */
    private fun giveBeautyNumber() {
        if (Utils.isNotClickable()) {
            return
        }

        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(resources.getString(R.string.super_account_input_number))
            return
        }

        if (beautyNumber == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        if (price == null) {
            MyToast.MakeToast("未获取到商品价格，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        beautyNumber?.let { goods ->
            price?.let { price ->
                StoreHelper.buyBeautyNumber(beautyNumber = goods, price = price, sendTo = giveId, onSuccess = { result ->
                    MyToast.MakeToast("赠送成功")
                    CommonApplication.mUserBase?.let {
                        result?.let{ res->
                            it.money = res.money
                            it.tokencoin = res.tokencoin
                        }
                    }
                    needBack = false
                    setResultFinish()
                }, onFail = { code, msg, json ->
                    if (4301 == code) {
                        // 调用充值对话框
                        showBuyDialog(JSONObject(json))
                        needBack = false
                    } else if (4302 == code) {
                        Utils.MakeToast("用户未登录")
                    } else if (409 == code) {// 409被占用
                        Utils.MakeToast("该靓号已被占用")
                    } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                        AccountIdentityDialog.showDialog(this, code.toString(), msg)
                    } else {// 400请求参数有误
                        MyToast.MakeToast(msg)
                    }
                })
            }
        }
    }

    /**
     * 赠送 隐身卡
     */
    private fun giveProps() {
        if (Utils.isNotClickable()) {
            return
        }

        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(resources.getString(R.string.super_account_input_number))
            return
        }

        if (props == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        if (price == null) {
            MyToast.MakeToast("未获取到商品价格，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        props?.let { goods ->
            price?.let { price ->
                StoreHelper.buyPropsYinshen(props = goods, price = price, sendTo = giveId, onSuccess = { result ->
                    MyToast.MakeToast("赠送成功")
                    CommonApplication.mUserBase?.let {
                        result?.let { res ->
                            it.money = res.money
                            it.tokencoin = res.tokencoin
                        }
                    }
                    needBack = false
                    setResultFinish()
                }, onFail = { code, msg, json ->
                    if (4301 == code) {
                        // 调用充值对话框
                        showBuyDialog(JSONObject(json))
                        needBack = false
                    } else if (4302 == code) {
                        Utils.MakeToast("用户未登录")
                    } else if (409 == code) {// 409被占用
                        Utils.MakeToast("该靓号已被占用")
                    } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                        AccountIdentityDialog.showDialog(this, code.toString(), msg)
                    } else {// 400请求参数有误
                        MyToast.MakeToast(msg)
                    }
                })
            }
        }
    }

    /**
     * 赠送 隐身卡
     */
    private fun giveVipBefore() {
        if (Utils.isNotClickable()) {
            return
        }

        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(resources.getString(R.string.super_account_input_number))
            return
        }

        if (vipInfo == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        if (price == null) {
            MyToast.MakeToast("未获取到商品价格，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        vipInfo?.let { goods ->
            price?.let { price ->
                StoreHelper.buyVipBefore(goods, price, giveId, {
                    //校验成功，去购买
                    giveVip(goods, price, giveId)
                }, { code, msg ->
                    if (code == 4304) {
                        CommonRemindDialog.create(this).setTitleText(msg).setText("确定", "取消").setOnClickCallback {
                            if (it == BaseDialog.SELECT_FIRST) {
                                //校验成功，去购买
                                giveVip(goods, price, giveId)
                            }
                        }
                    } else {
                        MyToast.MakeToast(msg)
                    }
                })
            }
        }
    }

    fun giveVip(goods: VipPrivilege, price: BuyTimeList, giveId: String) {
        StoreHelper.buyVip(vipInfo = goods, price = price, sendTo = giveId, onSuccess = { result ->
            MyToast.MakeToast("赠送成功")
            CommonApplication.mUserBase?.let {
                result?.let { res ->
                    it.money = res.money
                    it.tokencoin = res.tokencoin
                }
            }
            needBack = false
            setResultFinish()
        }, onFail = { code, msg, json ->
            if (4301 == code) {
                // 调用充值对话框
                showBuyDialog(JSONObject(json))
                needBack = false
            } else if (4302 == code) {
                Utils.MakeToast("用户未登录")
            } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                AccountIdentityDialog.showDialog(this, code.toString(), msg)
            } else {// 400请求参数有误
                MyToast.MakeToast(msg)
            }
        })
    }

    /**
     * 装扮的购买
     */
    private fun giveDressUp() {
        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(resources.getString(R.string.super_account_input_number))
            return
        }

        if (dressUpTab != null && dressupGoods == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        if (price == null) {
            MyToast.MakeToast("未获取到商品价格，请重试！")
            needBack = false
            setResultFinish()
            return
        }

        dressUpTab?.let { tab ->
            dressupGoods?.let { good ->
                price?.let { price ->
                    StoreHelper.buyDressUp(tab.id, good, price, giveId, { result ->
                        MyToast.MakeToast("赠送成功")
                        CommonApplication.mUserBase?.let {
                            if (!result.data.isNullOrEmpty()) {
                                it.money = result.data[0].money
                                it.tokencoin = result.data[0].tokencoin
                            }
                        }
                        needBack = false
                        setResultFinish()
                    }, { code, msg, responseStr ->
                        if (4301 == code) {
                            // 调用充值对话框
                            showBuyDialog(JSONObject(responseStr))
                        } else if (4302 == code) {
                            Utils.MakeToast("用户未登录")
                        } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                            AccountIdentityDialog.showDialog(this, code.toString(), msg)
                        } else {// 400请求参数有误
                            MyToast.MakeToast(msg)
                        }
                    })
                }
            }
        }
    }


    // 快捷支付
    private fun showBuyDialog(jsonObject: JSONObject) {
        MyToast.MakeToast(getString(R.string.balance_not_enough))
        val dataObj = jsonObject.optJSONObject("data") ?: return
        val diffmoney = dataObj.optLong("diffMoney")
        // 调用充值对话框
        ZhiFuFastCDialog.showBugDialog(this, 0, diffmoney, object : OnZhiFuFastDialogDismissListener {
            override fun ondismissCallback() {
                needBack = true
            }
        })
    }

    override fun onBackPressed() {
//        super.onBackPressed()
        setResultFinish()
    }

    fun setResultFinish() {
//        cl_give_root.background = null
        finish()
        overridePendingTransition(-1, R.anim.activity_games_bottom_out)
    }

    override fun onDestroy() {
        super.onDestroy()
        onBackClick?.invoke(needBack)
    }


//    override fun onDismiss(dialog: DialogInterface?) {
//        super.onDismiss(dialog)
//        if (needBack) {
//            onBackClick?.invoke()
//        }
//    }
}