package com.ninexiu.sixninexiu.adapter

import android.graphics.Color
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.AccountLockItem
import com.ninexiu.sixninexiu.bean.GiftReturnItem
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.view.shape.RoundConstraintLayout

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/08/30
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class AccountLockAdapter(data: MutableList<AccountLockItem>) : BaseQuickAdapter<AccountLockItem, BaseViewHolder>(R.layout.item_account_lock, data) {
    private val colorBgList = mutableListOf(
            R.color.color_ff4179,
            R.color.color_266fff,
            R.color.color_5bd81e,
            R.color.color_8873f6,
            R.color.color_26fabc0a
    )

    override fun convert(helper: BaseViewHolder?, item: AccountLockItem?) {
        helper ?: return
        item ?: return

        helper.getView<TextView>(R.id.tvName).text = item.name
        helper.getView<ImageView>(R.id.ivComplete).setImageResource(if (item.lock == 1) R.drawable.ic_account_info_complete else R.drawable.shape_info_uncomplete)

        if (item.lock == 1) {
            helper.getView<RoundConstraintLayout>(R.id.constraintContainer).delegate.backgroundColor = (ContextCompat.getColor(helper.itemView.context, colorBgList[helper.layoutPosition % (colorBgList.size)]))
        } else {
            helper.getView<RoundConstraintLayout>(R.id.constraintContainer).delegate.backgroundColor = ContextCompat.getColor(helper.itemView.context, R.color.color_f5f5f5)
        }
    }

}