package com.ninexiu.sixninexiu.adapter

import android.annotation.SuppressLint
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.SeeMeData
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.TimeUtil
import com.ninexiu.sixninexiu.common.util.UIUtils
import com.tencent.qcloud.tim.uikit.utils.DateTimeUtil
import java.util.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/29
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class AccountSeeMeAdapter(data: MutableList<SeeMeData>) : BaseQuickAdapter<SeeMeData, AccountSeeMeAdapter.AccountSeeMeHolder>(R.layout.item_account_see_me, data) {

    var itemClick: ((String) -> Unit)? = null

    @SuppressLint("SetTextI18n")
    override fun convert(helper: AccountSeeMeAdapter.AccountSeeMeHolder?, item: SeeMeData?) {
        helper ?: return
        item ?: return

        if (!item.headimage.isNullOrBlank()) {
            GlideUtils.loadCirclePic(helper.itemView.context, item.headimage, helper.ivAnchor)
        }

        helper.tvNickName.text = item.nickname

        helper.tvTime.text = "最近访问 ${TimeUtil.getDescriptionTimeFromTimestamp(item.visit_time)}"

        helper.tvInfo.text = item.desc

        helper.tvCount.text = "${item.visit_count}次"

        if (helper.layoutPosition == itemCount - 1) {
            UIUtils.goneView(helper.viewDivider)
        } else {
            UIUtils.showView(helper.viewDivider)
        }


        // 头像点击回调进入个人主页
        helper.itemView.setOnClickListener {
            item.uid?.let { itemClick?.invoke(it) }

        }
    }

    inner class AccountSeeMeHolder(view: View) : BaseViewHolder(view) {
        val ivAnchor: ImageView = view.findViewById(R.id.ivAnchor)
        val tvNickName: TextView = view.findViewById(R.id.tvNickName)
        val tvTime: TextView = view.findViewById(R.id.tvTime)
        val tvInfo: TextView = view.findViewById(R.id.tvInfo)
        val tvCount: TextView = view.findViewById(R.id.tvCount)
        val viewDivider: View = view.findViewById(R.id.viewDivider)
    }

}