package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.text.TextUtils
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.PersonalInforActivity
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.AnchorHeadView
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.fitterViewSize
import com.ninexiu.sixninexiu.view.setVisible
import com.opensource.svgaplayer.SVGAVideoEntity

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/07
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class AttentionAnchorItemAdapter(var context: Context, var svgEntry: SVGAVideoEntity? = null, var anchorAttention: List<Boolean>, var list: List<AnchorInfo>) :
        BaseQuickAdapter<AnchorInfo, BaseViewHolder>(R.layout.item_attention_anchor_sub, list) {

    var followClick: ((Int) -> Unit)? = null

    override fun convert(helper: BaseViewHolder?, item: AnchorInfo?) {
        NSLog.d("AttentionAnchorItemAdapter : ", helper?.layoutPosition?.toString())
        helper ?: return
        item ?: return

        val ivRecommend = helper.getView<ImageView>(R.id.ivRecommend)
        val ivFocus = helper.getView<ImageView>(R.id.ivFocus)
        val tvFocusAlready = helper.getView<TextView>(R.id.tvFocusAlready)
        val attentionAnchorItem = helper.getView<ConstraintLayout>(R.id.attentionAnchorItem)

        val params1 = attentionAnchorItem.layoutParams

        // 都是关注的数据
        if (anchorAttention[0]) {
            ivRecommend.setVisible(false)
            ivFocus.setVisible(false)
            tvFocusAlready.setVisible(false)
            // 动态设置高度
            params1.height = dp2px(attentionAnchorItem.context,121)
        } else {
            params1.height = ViewGroup.LayoutParams.WRAP_CONTENT
            if (item.isfollow == 1) {
                ivRecommend.setVisible(false)
                ivFocus.setVisible(false)
                tvFocusAlready.setVisible(true)
            } else {
                ivRecommend.setVisible(true)
                ivFocus.setVisible(true)
                tvFocusAlready.setVisible(false)
            }
        }
        attentionAnchorItem.layoutParams = params1

        // 设置头像和用户名
        val tvLiving = helper.getView<TextView>(R.id.tvLiving)
        val anchorView = helper.getView<AnchorHeadView>(R.id.anchorHeadView)


        val head = if(TextUtils.isEmpty(item.headimage)) {
            item.phonehallposter
        }else {
            item.headimage
        }
        anchorView.setAnchorInfo(head)

        if (item.status == 1) {
            anchorView.startAnchorAnimation(svgEntry)
            tvLiving.setVisible(true)
        } else {
            anchorView.stopAnchorAnimation()
            tvLiving.setVisible(false)
        }

        helper.getView<TextView>(R.id.tvAnchor).text = item.nickname

        // 设置间距
        val params = attentionAnchorItem.layoutParams as? ViewGroup.MarginLayoutParams
        when (helper.adapterPosition) {
            0 -> {
                params?.leftMargin = dp2px(helper.itemView.context, 15)
                params?.rightMargin = 0
            }
            list.size - 1 -> {
                params?.leftMargin = dp2px(helper.itemView.context, 6)
                params?.rightMargin = dp2px(helper.itemView.context, 15)
            }
            else -> {
                params?.leftMargin = dp2px(helper.itemView.context, 6)
                params?.rightMargin = 0
            }
        }

        attentionAnchorItem.layoutParams = params

        // 关注
        ivFocus.setOnClickListener {
            followClick?.invoke(helper.layoutPosition)
        }

        // 点击主播
        attentionAnchorItem.setOnClickListener {
            if(item.status == 1) {
                Utils.openLiveRoom(helper.itemView.context, item)
            } else {
                PersonalInforActivity.start(helper.itemView.context, true, item.uid.toLong())
            }
        }

    }

    override fun onViewAttachedToWindow(holder: BaseViewHolder) {
        super.onViewAttachedToWindow(holder)
        val anchorHeadView = holder.getView<AnchorHeadView>(R.id.anchorHeadView)
        val pos = holder.adapterPosition
        if (pos < list.size && list[pos].isplay == 1) {
            anchorHeadView.startAnchorAnimation(svgEntry)
        }
    }
}