package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.view.View
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.AutumnChargeItemBean
import com.ninexiu.sixninexiu.view.dp2px
import org.jetbrains.anko.displayMetrics

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/08/06
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class AutumnChargeTitleAdapter(context: Context, data: MutableList<AutumnChargeItemBean>) : BaseQuickAdapter<AutumnChargeItemBean, AutumnChargeTitleAdapter.AutumnChargeTitleHolder>(R.layout.adapter_autumn_chage_title, data) {

    private val widthScreen: Int by lazy {
        context.displayMetrics.widthPixels
    }

    override fun convert(helper: AutumnChargeTitleHolder?, item: AutumnChargeItemBean?) {
        helper ?: return
        item ?: return

        // 适配宽度
        val params = helper.autumnTitleContainer?.layoutParams
        val subDis = dp2px(helper.itemView.context, 6) * (data.size + 1)
        params?.width = (((0.837 * widthScreen).toInt() - subDis) / data.size - 0.5f).toInt()
        params?.height = (widthScreen * 0.12).toInt()
        helper.autumnTitleContainer.layoutParams = params


        helper.tvTitle?.text = "${item.price}"
        if (item.selected) {
            helper.autumnTitleContainer?.setBackgroundResource(R.drawable.shape_autumn_title_selected)
            helper.tvTitle?.setTextColor(ContextCompat.getColor(helper.itemView.context, R.color.white))
            helper.tvAutumnSuffix?.setTextColor(ContextCompat.getColor(helper.itemView.context, R.color.white))
        } else {
            helper.autumnTitleContainer?.setBackgroundResource(R.drawable.shape_autumn_title_unselected)
            helper.tvTitle?.setTextColor(ContextCompat.getColor(helper.itemView.context, R.color.color_743300))
            helper.tvAutumnSuffix?.setTextColor(ContextCompat.getColor(helper.itemView.context, R.color.color_743300))
        }

        helper.itemView.setOnClickListener {
            onItemClick?.invoke(helper.layoutPosition)
        }
    }

    var onItemClick: ((Int) -> Unit)? = null


    inner class AutumnChargeTitleHolder(view: View) : BaseViewHolder(view) {
        val autumnTitleContainer = view.findViewById<ConstraintLayout>(R.id.autumnTitleContainer)
        val tvTitle = view.findViewById<TextView>(R.id.tvTitle)
        val tvAutumnSuffix = view.findViewById<TextView>(R.id.tvAutumnSuffix)
    }

}