package com.ninexiu.sixninexiu.adapter

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseMultiItemQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.HomeTagInfo.DataBean
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.Utils

/**
 * @Description:
 * @Author: liuguangyu
 * @date :     2019/5/22 14:57
 * @Version:
 */
class ChildAdapter
/**
 * 1.控件转换问题 比如一个 findViewById(R.id.TextView) 声明为 ImageView
 * 2.addItemType 添加两种数据类型 addItemType添加一个布局
 * java.lang.ClassCastException: com.chad.library.adapter.base.BaseViewHolder cannot
 * be cast to com.ninexiu.sixninexiu.adapter.ChildAdapter$ApplicationHolder
 * 3.你有几种布局，就写几个addItemType，如果你的list中样式有10种，但你只写了8种，一定会报错的
 * @param data
 */
internal constructor(data: List<DataBean>) : BaseMultiItemQuickAdapter<DataBean, ChildAdapter.ApplicationHolder>(data) {
    init {
        addItemType(Utils.ITEM_TYPE_0, R.layout.adapter_child_adapter_item)
        addItemType(Utils.ITEM_TYPE_1, R.layout.adapter_child_adapter_fool_item)
    }

    override fun convert(helper: ApplicationHolder, item: DataBean) {
        when (helper.itemViewType) {
            Utils.ITEM_TYPE_0 -> setData(helper, item)
            Utils.ITEM_TYPE_1 -> setData(helper, item)
            else -> {
            }
        }
    }

    /**
     * @param helper
     * @param item
     */
    private fun setData(helper: ApplicationHolder, item: DataBean) {
        NSLog.d(item.toString())
        helper.setText(R.id.tv_child, Utils.formatViewerCount(item.name + ""))
                .addOnClickListener(R.id.parent)
        // 5:天籁  3:歌唱 2:舞蹈  1:畅聊 4:特色 游戏 7:女团 15:乐器  16:pk 17:新人 18：电台 19:手机
        GlideUtils.loadNormalCacheImg(mContext, item.pic, helper.iv_child)


    }

    inner class ApplicationHolder(view: View) : BaseViewHolder(view) {
        var iv_child: ImageView = view.findViewById(R.id.iv_child)
        var tv_child: TextView = view.findViewById(R.id.tv_child)

    }

}
