package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.FirstGiftList
import com.ninexiu.sixninexiu.bean.GiftReturnItem
import com.ninexiu.sixninexiu.common.util.GlideUtils

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/05/19
 *     desc   : 一元充值的recy的adapter
 *     version: 1.0
 * </pre>
 */
class FirstRechargeAdapter(data: List<FirstGiftList>, val context :Context) : BaseQuickAdapter<FirstGiftList, FirstRechargeAdapter.FirstRechargeHolder>(R.layout.item_first_recharge, data) {

    var onItemClick: ((Int,View,FirstGiftList?) -> Unit)? = null

    override fun convert(helper: FirstRechargeHolder?, item: FirstGiftList?) {
        helper ?: return
        item ?: return

        helper.tvItem.text = item.name
        GlideUtils.loadImageView(helper.itemView.context, item.image, helper.ivItem)

        helper.itemView.setOnClickListener {
            onItemClick?.invoke(helper.adapterPosition,helper.itemView,item)
        }
    }

    inner class FirstRechargeHolder(view: View) : BaseViewHolder(view) {
        val ivItem: ImageView = view.findViewById(R.id.ivIconItem)
        val tvItem: TextView = view.findViewById(R.id.tvNameItem)
    }
}