package com.ninexiu.sixninexiu.adapter

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.HomeTagInfo
import com.ninexiu.sixninexiu.common.util.GlideUtils

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/06/25
 *     desc   : 热门标签的适配器
 *     version: 1.0
 * </pre>
 */
class HomeLabelAdapter(data: List<HomeTagInfo.DataBean>,val onClick : ((HomeTagInfo.DataBean) -> Unit)? = null) : BaseQuickAdapter<HomeTagInfo.DataBean, HomeLabelHolder>(R.layout.adapter_child_adapter_item, data) {
    override fun convert(helper: HomeLabelHolder?, item: HomeTagInfo.DataBean?) {
        helper ?: return
        item ?: return

        helper.tv.text = item.name ?: ""
        GlideUtils.loadNormalCacheImg(helper.iv.context, item.pic, helper.iv)

        helper.itemView.setOnClickListener {
            onClick?.invoke(item)
        }
    }
}

class HomeLabelHolder(view: View) : BaseViewHolder(view) {
    val tv: TextView = view.findViewById(R.id.tv_child)
    val iv: ImageView = view.findViewById(R.id.iv_child)
}