package com.ninexiu.sixninexiu.adapter

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.view.HomeHotAnchorItemView

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/02
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class HotGridRecyAdpter(var list: List<AnchorInfo>?, var onItemClick: ((Int, AnchorInfo) -> Unit)? = null) : RecyclerView.Adapter<HotGridRecyHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): HotGridRecyHolder {
        return HotGridRecyHolder(LayoutInflater.from(parent.context).inflate(R.layout.adapter_anchor_home_item, parent, false))
    }

    override fun onBindViewHolder(holder: HotGridRecyHolder, position: Int) {
        val data = list?.get(position)
        data?.let {
            holder.homeItemView.setAnchor(it, position) {
                onItemClick?.invoke(position, data)
            }

            holder.homeItemView.background = null
        }
    }

    override fun getItemCount(): Int {
        NSLog.d("itemAdpater : ","${list?.size?:-1}")
        return list?.size ?: 0
    }

}

class HotGridRecyHolder(view: View) : RecyclerView.ViewHolder(view) {
    val homeItemView: HomeHotAnchorItemView = view.findViewById(R.id.itemLeft)
}