package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.graphics.Bitmap
import android.graphics.drawable.Drawable
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.bumptech.glide.request.Request
import com.bumptech.glide.request.target.SimpleTarget
import com.bumptech.glide.request.target.SizeReadyCallback
import com.bumptech.glide.request.target.Target
import com.bumptech.glide.request.transition.Transition
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.HotWord
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.HotWordRoomView
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_hotword_room.view.*

class HotWordAdapter(val context: Context, val type: Int,
                     val hotwordList: ArrayList<HotWord>) : RecyclerView.Adapter<HotWordAdapter.HotWordHolder>() {
    class HotWordHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): HotWordHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_hotword_room, parent, false)
        return HotWordHolder(view)
    }

    override fun getItemCount(): Int {
        if (type == HotWordRoomView.TYPE_LIVE_ROOM && hotwordList.size > 5) {
            return 5
        }
        return hotwordList.size
    }

    override fun onBindViewHolder(holder: HotWordHolder, position: Int) {
        val hotWord = hotwordList[position]
        if (hotWord.type == 0) {
            holder.view.tv_hot_word?.setVisible(true)
            holder.view.iv_hot_word?.setVisible(false)
            holder.view.tv_hot_word?.text = hotWord.chatWord
        } else if (hotWord.type == 1) {
            holder.view.tv_hot_word?.setVisible(false)
            holder.view.iv_hot_word?.setVisible(true)
            Glide.with(holder.view).asBitmap().load(hotWord.imgsrc).into(object : SimpleTarget<Bitmap>() {
                override fun onResourceReady(resource: Bitmap, transition: Transition<in Bitmap>?) {
                    val newWidth = dp2px(context,30).toDouble()*resource.width/resource.height
                    holder.view.iv_hot_word?.layoutParams?.width=newWidth.toInt()
                    holder.view.iv_hot_word?.layoutParams?.height=dp2px(context,30)
                    holder.view.iv_hot_word?.setImageBitmap(resource)
                }
            })
        }
        holder.view.setOnClickListener {
            onHotWordClick?.invoke(position, hotWord)
        }
    }

    var onHotWordClick: ((position: Int, hotWord: HotWord) -> Unit)? = null
}