package com.ninexiu.sixninexiu.adapter

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.graphics.drawable.AnimationDrawable
import android.os.Bundle
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.RelativeLayout
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager.widget.ViewPager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AdvertiseActivity
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.AdvertiseInfo
import com.ninexiu.sixninexiu.bean.AdvertiseMent
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.EnterRoomResultInfo
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.common.util.HomeHotHelper.formatViewerCountNew
import com.ninexiu.sixninexiu.fragment.HotNewTableMoreFragment
import com.ninexiu.sixninexiu.thirdfunc.nextjoy.NjGameSdkUtils
import com.ninexiu.sixninexiu.view.banner.BGABanner
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.fragement_discovery_child_family_adapter_item.view.*
import kotlinx.android.synthetic.main.fragment_livehall_mainpage_list_groupitem.view.*
import kotlinx.android.synthetic.main.item_banner_layout.view.*

/**
 * @Description: 发现模块 首页列表Adapter
 * @Author: zhangbing
 * @date :     2019/5/8 14:09
 * @Version:
 */
class LiveTabChildAdapter(val context: Context, var bannerData: List<AdvertiseInfo>?, var anchorData: MutableList<AnchorInfo>) : RecyclerView.Adapter<RecyclerView.ViewHolder>() {
    class LiveTabChildHolder(val view: View) : RecyclerView.ViewHolder(view)
    class LiveTabBannerHolder(val view: View) : RecyclerView.ViewHolder(view)

    companion object {
        const val VIEW_TYPE_BANNER = 1 //顶部banner
        const val VIEW_TYPE_ANCHOR = 2 //下边的主播列表
    }

    override fun getItemViewType(position: Int): Int {
        //banner 和标签都不显示
        return if (position==0){
            VIEW_TYPE_BANNER
        }else{
            VIEW_TYPE_ANCHOR
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecyclerView.ViewHolder {
        return when(viewType){
            VIEW_TYPE_BANNER->{
                val view = LayoutInflater.from(context).inflate(R.layout.item_banner_layout, parent, false)
                LiveTabBannerHolder(view)
            }
            else->{
                val view = LayoutInflater.from(context).inflate(R.layout.fragement_discovery_child_family_adapter_item, parent, false)
                LiveTabChildHolder(view)
            }
        }
    }

    override fun getItemCount(): Int {
        //banner 和标签都不显示
        return if (bannerData.isNullOrEmpty() && anchorData.isEmpty()){
            0
        }else if (anchorData.isNotEmpty() && anchorData.size<=2) {
            1
        } else {
            anchorData.size -1
        }
    }


    private var currentItem = 0
    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        when (getItemViewType(position)) {
            VIEW_TYPE_BANNER -> {//顶部banner
                val bannerHolder = holder as LiveTabBannerHolder
                bannerHolder.view.ll_parent.setVisible(true)
                bannerHolder.view.line10.setVisible(true)
                setSlideshow(bannerHolder, bannerData)
            }
            VIEW_TYPE_ANCHOR -> {
                val anchorHolder = holder as LiveTabChildHolder
                anchorHolder.view.setBackgroundColor(ContextCompat.getColor(context,R.color.white))
                setData(anchorHolder, anchorData[position+1],position)
            }
        }
    }

    /**
     * 根据条目给View设置数据
     *
     * @param helper
     * @param item
     */
    private fun setData(helper: LiveTabChildHolder, item: AnchorInfo,position: Int) {
        setAnchorData(helper.view, item,position%2==0)
    }

    private fun setAnchorData(view: View,item: AnchorInfo, isRight: Boolean){
        view.findViewById<RelativeLayout>(R.id.parent).layoutParams.width = imageHeight
        if (isRight) {
            view.findViewById<RelativeLayout>(R.id.parent).setPadding(dp2px(context, 7), 0, dp2px(context, 7), dp2px(context, 7))
        } else {
            view.findViewById<RelativeLayout>(R.id.parent).setPadding(dp2px(context, 7), 0, 0, dp2px(context, 7))
        }

        val (first,second,three) = formatViewerCountNew(context,item.status,item.usercount,item.fanscount)
        first?.let { view.anchor_count.typeface = it }
        view.anchor_count.text = second
        view.tvAnchorSuffix.text = "${three?:""}人观看"

        view.anchor_name.text = HomeHotHelper.getUserName(item.nickname)
        view.recommend_anthor_leftTag.setVisible(false)
        if (TextUtils.equals(item.rid, "666")) {
            view.recommend_anthor_leftTag.setBackgroundResource(R.drawable.fragment_live_666_icon)
            view.iv_room_Tag.setVisible(false)
            view.tv_left_name.setVisible(false)
            view.recommend_anthor_leftTag.setVisible(true)
        } else if (TextUtils.equals(item.rid, "999")) {
            view.recommend_anthor_leftTag.setBackgroundResource(R.drawable.fragment_live_999_icon)
            view.iv_room_Tag.setVisible(false)
            view.tv_left_name.setVisible(false)
            view.recommend_anthor_leftTag.setVisible(true)
        }
        val rightLable = item.subTag
        if (rightLable != null) {
            val school_name = rightLable.name
            val tagImg = rightLable.tagImg
            if (!TextUtils.isEmpty(tagImg)) {
                view.iv_left_sublabels.setVisible(true)
                view.tv_school_name.setVisible(false)
                GlideUtils.loadNormalImg(context, tagImg, view.iv_left_sublabels)
                //NineShowApplication.displayImage(helper.mIvSublable, tagImg);
            } else if (!TextUtils.isEmpty(school_name)) {
                view.tv_school_name.text = school_name
                view.iv_left_sublabels.setVisible(false)
                view.tv_school_name.visibility = View.VISIBLE
            }
        } else {
            view.tv_school_name.visibility = View.GONE
            view.iv_left_sublabels.setVisible(false)
        }
        val leftLable = item.mainTag
        if (view.recommend_anthor_leftTag.visibility != View.VISIBLE && leftLable != null) {
            val school_name = leftLable.name
            val tagImg = leftLable.tagImg
            if (!TextUtils.isEmpty(tagImg)) {
                view.iv_room_Tag.setVisible(true)
                view.tv_left_name.setVisible(false)

                if(item.tagId == 2) {
                    view.iv_room_Tag.setBackgroundResource(R.drawable.animation_week_star)
                    val animationDrawable  = view.iv_room_Tag.background as? AnimationDrawable
                    animationDrawable?.start()
                }else {
                    view.iv_room_Tag.background = null
                    GlideUtils.loadNormalImg(context, tagImg, view.iv_room_Tag)
                }
            } else if (!TextUtils.isEmpty(school_name)) {
                view.tv_left_name.text = school_name
                view.tv_left_name.delegate.backgroundColor = Color.parseColor(leftLable.color)
                view.iv_room_Tag.setVisible(false)
                view.tv_left_name.setVisible(true)
            } else {
                view.iv_room_Tag.setVisible(false)
                view.tv_left_name.setVisible(false)
            }
        } else {
            view.iv_room_Tag.setVisible(false)
            view.tv_left_name.visibility = View.GONE
        }
        val lp = view.icon.layoutParams
        if (lp.height != mImageViewHeight) {
            mImageViewHeight = Utils.getHallAnchorIconHeight(context)
            lp.height = mImageViewHeight
            view.icon.layoutParams = lp
        }
        GlideUtils.loadSimpleImgWithRoundCorner(context, item.phonehallposter, view.icon, R.drawable.anthor_moren_item, 8)

        view.setOnClickListener {
            onAnchorItemClick?.invoke(item)
        }
    }

    private var mImageViewHeight = -10
    private val imageHeight: Int
        get() {
            val screenWidth = (context as Activity).windowManager.defaultDisplay.width
            return screenWidth/ 2
        }

    private fun setSlideshow(helper: LiveTabBannerHolder, adsLists: List<AdvertiseInfo?>?) {
        if (!adsLists.isNullOrEmpty()) {
            helper.view.bg_banner.setVisible(true)
            val lp = helper.view.bg_banner.layoutParams
            lp.height = adHeight
            helper.view.bg_banner.layoutParams = lp
            val mBannerAdapter: BGABanner.Adapter<*, *> = BGABanner.Adapter<View?, AdvertiseInfo?> { banner, itemView, model, position ->
                if (model != null) {
                    val iv_show = itemView?.findViewById<ImageView>(R.id.iv_show)
                    GlideUtils.loadBannerPic(context, model.focus_pic_url, iv_show)
                }
            }
            var loopTime = 2000
            if (!adsLists.isNullOrEmpty()) {
                if (adsLists[0] != null) loopTime = adsLists[0]!!.loop_time
                helper.view.bg_banner.setAutoPlayAble(adsLists.size > 1)
            }
            helper.view.bg_banner.setAutoPlayInterval(loopTime)
            helper.view.bg_banner.setAdapter(mBannerAdapter)
            helper.view.bg_banner.setData(R.layout.layout_for_banner_round, adsLists, null)
            helper.view.bg_banner.setDelegate(object : BGABanner.Delegate<View?, AdvertiseInfo?> {
                override fun onBannerItemClick(banner: BGABanner?, itemView: View?, model: AdvertiseInfo?, position: Int) {
                    if (Utils.isNotClickable() || adsLists == null) {
                        return
                    }
                    val info = adsLists[position]
                    if (info != null && info.focus_type != 5) {
                        if (info.focus_type == 1) { //直播间
                            if (info.focus_rid != 0L) {
                                enterRoom2("" + info.focus_rid)
                            }
                        } else if (info.focus_type == 3) { //明日世界h5
                            NjGameSdkUtils.startGameActivity(context, info.focus_link_url)
                        } else if (info.focus_type == 4) { //明日世界app
                            val ad = AdvertiseMent()
                            ad.download_url = info.download_url
                            ad.package_name = info.package_name
                            ad.open_name = info.open_name
                            ad.link_url = info.focus_link_url
                            ad.title = info.focus_title
                            NjGameSdkUtils.startGameApp(context, ad)
                        } else {
                            val intent = Intent(context, AdvertiseActivity::class.java)
                            intent.putExtra("url", info.focus_link_url)
                            intent.putExtra("title", info.focus_title)
                            intent.putExtra("desc", info.focus_desc)
                            context.startActivity(intent)
                        }
                        StatisticsUtil.onEvent(StatisticsEventID.MAIN_AD)
                        StatisticsUtil.submitAdClickEvent(StatisticsUtil.AD_LOC_BANNER, info.id,
                                StatisticsUtil.AD_ACTION_CLICK) //统计事件
                    }
                }
            })
            helper.view.bg_banner.setOnPageChangeListener(object : ViewPager.OnPageChangeListener {
                override fun onPageSelected(arg0: Int) {
                    if (currentItem != arg0) {
                        currentItem = arg0
                        StatisticsUtil.onEvent(StatisticsEventID.MAIN_AD_SCROLL)
                    }
                }

                override fun onPageScrolled(i: Int, v: Float, i1: Int) {}
                override fun onPageScrollStateChanged(i: Int) {}
            })
        }else{
            helper.view.bg_banner.setVisible(false)
        }

        helper.view.ll_top_anchor_container.removeAllViews()
        if (anchorData.isNotEmpty()) {
            helper.view.ll_top_anchor_container.addView(getTopAnchorView(helper.view.ll_top_anchor_container, 0))
        }
        if (anchorData.size > 1) {
            helper.view.ll_top_anchor_container.addView(getTopAnchorView(helper.view.ll_top_anchor_container, 1))
        }

        helper.view.iv_placeholder_bottom.setVisible(true)
        helper.view.ll_parent.post {
            helper.view.iv_placeholder_bottom.layoutParams.height = helper.view.ll_parent.height - dp2px(context, 139)
        }
    }

    private fun getTopAnchorView(container: ViewGroup, index: Int): View {
        val view = LayoutInflater.from(context).inflate(R.layout.fragement_discovery_child_family_adapter_item, container, false)
        setAnchorData(view, anchorData[index], index == 1)
        return view
    }


    private val adHeight: Int
        get() {
            val dpx = Utils.dip2px(context, 14f)
            return (NineShowApplication.getScreenWidth(context) - dpx) * 88 / 363
        }

    /**
     * 进房请求
     */
    fun enterRoom2(roomId: String) {
        NSLog.e("---enterRoom--")
        // 请求链接不进行转码
        val params = NSRequestParams()
        params.put("rid", roomId)
        params.put("imei", NineShowApplication.IMEIcode)
        if (NineShowApplication.mUserBase != null) {
            params.put("token", NineShowApplication.mUserBase?.token)
        }
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.HTTP_ENTER_ROOM_V2, params, object : NSGsonObjectCallback<EnterRoomResultInfo?>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: EnterRoomResultInfo?) {
                if (response != null && response.code == 200) {
                    val roomInfo = response.data
                    if (roomInfo != null) {
                        Utils.openLiveRoom(context, roomInfo.roomType, roomInfo.rid.toString() + "", 0, "")
                    }
                } else {
                    Utils.openLiveRoom(context, 0, roomId + "", 0, "")
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
                Utils.openLiveRoom(context, 0, roomId + "", 0, "")
            }
        })
    }

    var onAnchorItemClick: ((anchorInfo: AnchorInfo) -> Unit)? = null

}