package com.ninexiu.sixninexiu.adapter

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.dialog.MoreDataBean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MoreCommenDialogAdapter(data: List<MoreDataBean>, val onItemClick: ((Int) -> Unit)? = null) : BaseQuickAdapter<MoreDataBean, MoreCommenDialogAdapter.MoreCommenVH>(R.layout.item_more_dialog, data) {

    override fun convert(helper: MoreCommenVH?, item: MoreDataBean?) {
        helper ?: return
        item ?: return
        helper.ivMore.setImageResource(item.res)
        helper.tvMore.text = item.name

        helper.itemView.setOnClickListener {
            onItemClick?.invoke(item.type)
        }
    }

    inner class MoreCommenVH(view: View) : BaseViewHolder(view) {
        val ivMore: ImageView = view.findViewById(R.id.ivMore)
        val tvMore: TextView = view.findViewById(R.id.tvMore)
    }

}