package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.RealLoveDailyTaskInfo
import com.ninexiu.sixninexiu.bean.RealLovePrivilegeInfo
import com.ninexiu.sixninexiu.common.inter.OnItemClickListener
import kotlinx.android.synthetic.main.item_reallove_daily_task.view.*
import kotlinx.android.synthetic.main.item_reallove_privilege.view.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/10/09
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class RealLoveDailyTaskAdapter(val context: Context, var isAnchor:Boolean,var taskList:ArrayList<RealLoveDailyTaskInfo.DataBean.ListBean>) :RecyclerView.Adapter<RealLoveDailyTaskAdapter.RealLoveDailyTaskHolder>(){

    class RealLoveDailyTaskHolder(val view:View):RecyclerView.ViewHolder(view)

    private var onItemClickListener:OnItemClickListener<RealLoveDailyTaskInfo.DataBean.ListBean>?=null

    fun setOnItemClickListener(onItemClickListener:OnItemClickListener<RealLoveDailyTaskInfo.DataBean.ListBean>?){
        this.onItemClickListener=onItemClickListener
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RealLoveDailyTaskHolder {
        val view=LayoutInflater.from(context).inflate(R.layout.item_reallove_daily_task,parent,false)
        return RealLoveDailyTaskHolder(view)
    }

    override fun getItemCount(): Int {
        return taskList.size
    }

    override fun onBindViewHolder(holder: RealLoveDailyTaskHolder, position: Int) {
        val taskInfo= taskList[position]
        if (taskInfo.id==6){//打卡
            holder.view.iv_reallove_task_icon.setImageResource(R.drawable.icon_reallove_task_daka)
            holder.view.tv_reallove_task_name.text="打卡"
            holder.view.tv_reallove_task_desc.text="每日进入直播间自动打卡可获得10点真爱值"
            holder.view.tv_reallove_task_giftremind.visibility=View.GONE
            holder.view.view_line.visibility=View.VISIBLE
        }else if (taskInfo.id==7){//陪伴
            holder.view.iv_reallove_task_icon.setImageResource(R.drawable.icon_reallove_task_peiban)
            holder.view.tv_reallove_task_name.text="陪伴"
            holder.view.tv_reallove_task_desc.text="每日观看5分钟可获得3点真爱值（${taskInfo.completed}/${taskInfo.total}）"
            holder.view.tv_reallove_task_giftremind.visibility=View.GONE
            holder.view.view_line.visibility=View.VISIBLE
        }else if (taskInfo.id==8){//互动
            holder.view.iv_reallove_task_icon.setImageResource(R.drawable.icon_reallove_task_hudong)
            holder.view.tv_reallove_task_name.text="互动"
            holder.view.tv_reallove_task_desc.text="每日在直播间发言一次可获得3点真爱值（${taskInfo.completed}/${taskInfo.total}）"
            holder.view.tv_reallove_task_giftremind.visibility=View.GONE
            holder.view.view_line.visibility=View.VISIBLE
        }else if (taskInfo.id==9){//赠送
            holder.view.iv_reallove_task_icon.setImageResource(R.drawable.icon_reallove_task_zengsong)
            holder.view.tv_reallove_task_name.text="赠送"
            holder.view.tv_reallove_task_desc.text="每日在直播间赠送礼物可以获得真爱值（${taskInfo.completed}/${taskInfo.total}）"
            holder.view.tv_reallove_task_giftremind.visibility=View.VISIBLE
            holder.view.view_line.visibility=View.GONE
        }else{
            holder.view.iv_reallove_task_icon.setImageResource(R.drawable.icon_reallove_task_daka)
            holder.view.tv_reallove_task_name.text="新任务"
            holder.view.tv_reallove_task_desc.text="请更新app至最新版本"
            holder.view.tv_reallove_task_giftremind.visibility=View.GONE
            holder.view.view_line.visibility=View.VISIBLE
        }

        if (isAnchor){
            holder.view.tv_reallove_task_state.visibility=View.GONE
        }else {
            if (taskInfo.status == 1) {//已完成
                holder.view.tv_reallove_task_state.delegate.backgroundColor = context.resources.getColor(R.color.white)
                holder.view.tv_reallove_task_state.setTextColor(context.resources.getColor(R.color.c_ff638a))
                holder.view.tv_reallove_task_state.setText("已完成")
            } else {
                holder.view.tv_reallove_task_state.delegate.backgroundColor = context.resources.getColor(R.color.c_ff638a)
                holder.view.tv_reallove_task_state.setTextColor(context.resources.getColor(R.color.white))
                holder.view.tv_reallove_task_state.setText("去完成")
            }
        }

        holder.view.setOnClickListener {
            if (onItemClickListener!=null){
                onItemClickListener!!.onItemClick(position,taskInfo)
            }
        }
    }
}