package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.graphics.drawable.Drawable
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.LoveFansListResult
import com.ninexiu.sixninexiu.bean.UserBase
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import kotlinx.android.synthetic.main.item_reallove_fans_rank.view.*

/**
 * Created by jared-wang
 */
class RealLoveFansRankAdapter(
    private val mContext: Context,
    private var mFansList: ArrayList<LoveFansListResult.DataBean.RankListBean>
) : RecyclerView.Adapter<RealLoveFansRankAdapter.RealLoveFansRankHolder>() {

    class RealLoveFansRankHolder(val view: View) : RecyclerView.ViewHolder(view)

    var rankType = ""

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RealLoveFansRankHolder {
        val view =
            LayoutInflater.from(mContext).inflate(R.layout.item_reallove_fans_rank, parent, false)
        return RealLoveFansRankHolder(view)
    }

    override fun getItemCount(): Int {
        return mFansList.size
    }

    override fun onBindViewHolder(holder: RealLoveFansRankHolder, position: Int) {

        val info = mFansList[position]

        val levelDrawable: Int = Utils.getTrueLoveFansLeve(info.loveLevel, 1, false, info.loveTagStyle)



        if (position == 0) {
            val drawable = mContext.resources.getDrawable(R.drawable.icon_reallove_fans_rank_1)
            drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
            holder.view.tv_reallove_rank_number.setCompoundDrawables(drawable, null, null, null)
            holder.view.tv_reallove_rank_number.text = ""

            if (rankType == "week") {
                holder.view.tv_reallove_rank_lovename.text = ""
                holder.view.iv_reallove_rank_lovelevel.setImageResource(R.drawable.love_level_leader)
            } else {
                holder.view.tv_reallove_rank_lovename.text = info.badgeTitle
                holder.view.tv_reallove_rank_level.text = info.loveLevel.toString()
                holder.view.iv_reallove_rank_lovelevel.setImageResource(levelDrawable)
            }
        } else if (position == 1) {
            val drawable = mContext.resources.getDrawable(R.drawable.icon_reallove_fans_rank_2)
            drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
            holder.view.tv_reallove_rank_number.setCompoundDrawables(drawable, null, null, null)
            holder.view.tv_reallove_rank_number.text = ""
            holder.view.tv_reallove_rank_lovename.text = info.badgeTitle
            holder.view.tv_reallove_rank_level.text = info.loveLevel.toString()
            holder.view.iv_reallove_rank_lovelevel.setImageResource(levelDrawable)
        } else if (position == 2) {
            val drawable = mContext.resources.getDrawable(R.drawable.icon_reallove_fans_rank_3)
            drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
            holder.view.tv_reallove_rank_number.setCompoundDrawables(drawable, null, null, null)
            holder.view.tv_reallove_rank_number.text = ""
            holder.view.tv_reallove_rank_lovename.text = info.badgeTitle
            holder.view.tv_reallove_rank_level.text = info.loveLevel.toString()
            holder.view.iv_reallove_rank_lovelevel.setImageResource(levelDrawable)
        } else {
            holder.view.tv_reallove_rank_number.text = "${position + 1}"
            holder.view.tv_reallove_rank_number.setCompoundDrawables(null, null, null, null)
            holder.view.tv_reallove_rank_lovename.text = info.badgeTitle
            holder.view.iv_reallove_rank_lovelevel.setImageResource(levelDrawable)
            holder.view.tv_reallove_rank_level.text = info.loveLevel.toString()
        }
        holder.view.tv_reallove_rank_count.text = info.points.toString()
        holder.view.tv_reallove_rank_nickname.text = info.nickname

        //        NineShowApplication.displayImage(mContext,holder.avatar,info.getHeadimage120());
//        Utils.setUserLevel(""+info.getWealth(), holder.level);

        if (position + 1 == mFansList.size) {
            (holder.view.cl_reallove_fans_rank.layoutParams as ViewGroup.MarginLayoutParams).setMargins(
                0,
                0,
                0,
                ConvertUtils.dp2px(100f)
            )
        } else {
            (holder.view.cl_reallove_fans_rank.layoutParams as ViewGroup.MarginLayoutParams).setMargins(
                0,
                0,
                0,
                0
            )
        }
//        if (info.stealthCard == 0) {
//            holder.view.tv_reallove_rank_nickname.text = info.nickname //显示
//        } else {
//            holder.view.tv_reallove_rank_nickname.text = "神秘人" //隐身
//        }
        if ("神秘人".equals(info.nickname)) {
            holder.view.iv_reallove_rank_avatar.setImageResource(R.drawable.sendgift_mystery_head_icon)
        } else {
            GlideUtils.loadCirclePic(mContext, info.headimage, holder.view.iv_reallove_rank_avatar)
        }
    }


}