package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.RealLoveDailyTaskInfo
import com.ninexiu.sixninexiu.bean.RealLovePrivilegeInfo
import com.ninexiu.sixninexiu.common.util.GlideUtils
import kotlinx.android.synthetic.main.item_reallove_daily_task.view.*
import kotlinx.android.synthetic.main.item_reallove_privilege.view.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/10/09
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class RealLovePrivilegeAdapter(val context: Context,var privilegeList:ArrayList<RealLovePrivilegeInfo.DataBean.ListBean>) :RecyclerView.Adapter<RealLovePrivilegeAdapter.RealLovePrivilegeHolder>(){

    class RealLovePrivilegeHolder(val view:View):RecyclerView.ViewHolder(view)

    var userLoveLevel=0

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RealLovePrivilegeHolder {
        val view=LayoutInflater.from(context).inflate(R.layout.item_reallove_privilege,parent,false)
        return RealLovePrivilegeHolder(view)
    }

    override fun getItemCount(): Int {
        return privilegeList.size
    }

    override fun onBindViewHolder(holder: RealLovePrivilegeHolder, position: Int) {
        holder.view.tv_reallove_privilege_level.text="lv.${privilegeList[position].unlockLevel}解锁"
        holder.view.tv_reallove_privilege_name.text=privilegeList[position].title
        GlideUtils.loadNormalImg(context,privilegeList[position].icon,holder.view.iv_reallove_privilege)

        if (isLastRow(position)){
            holder.view.cl_reallove_privilege.setPadding(0,0,0,ConvertUtils.dp2px(100f))
        }else{
            holder.view.cl_reallove_privilege.setPadding(0,0,0,0)
        }

        if (privilegeList[position].unlockLevel<=userLoveLevel){
            holder.view.tv_reallove_privilege_level.visibility=View.GONE
        }else{
            holder.view.tv_reallove_privilege_level.visibility=View.VISIBLE
        }
    }

    /**
     * 是否时最后一行
     */
    private fun isLastRow(position: Int) :Boolean{
        if (privilegeList.size%4==0){
            if (position/4 >=privilegeList.size/4){
                return true
            }
        }else{
            if (position/4 >=privilegeList.size/4){
                return true
            }
        }
        return false
    }
}