package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.CheckBox
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.ParsePrivateSetBean
import com.ninexiu.sixninexiu.bean.PrivateSetBean

/**
 * author wangyu
 * date: on 2020/04/24
 * describe: 私聊设置Adapter
 */


internal class TimPrivateSetAdapter : RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private var context: Context? = null
    private var datas: ArrayList<ParsePrivateSetBean>? = null
    private var type: Int = 0

    constructor(context: Context, datas: ArrayList<ParsePrivateSetBean>) {
        this.context = context
        this.datas = datas
    }

    override fun getItemViewType(position: Int): Int {
        return if (datas?.get(position)?.title == null) {
            0
        } else {
            1
        }

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecyclerView.ViewHolder {
        return if (viewType == 0) {
            TimPrivateSetViewHolder(LayoutInflater.from(context).inflate(R.layout.item_recycle_privateset, parent, false))
        } else {
            TimPrivateSetViewTitleHolder(LayoutInflater.from(context).inflate(R.layout.item_recycle_privatesettitle, parent, false))
        }

    }


    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        val setBean = datas?.get(position)
        if (holder is TimPrivateSetViewHolder) {

            holder?.privateset_check?.isChecked = setBean?.value == 1


            holder?.tv_name?.text = setBean?.index?.minus(0).toString() + "." + setBean?.optioname
            when (setBean?.index) {
                7 -> {
                    holder?.tv_name?.text = "1." + setBean?.optioname
                }
                8 -> {
                    holder?.tv_name?.text = "2." + setBean?.optioname
                }
                9 -> {
                    holder?.tv_name?.text = "3." + setBean?.optioname
                }
            }

            holder?.privateset_check?.setOnClickListener {

                setBean?.index?.let { it1 ->
                    mOnItemClickListener?.onItemClick(it1, setBean?.value)
                }
            }
        } else if (holder is TimPrivateSetViewTitleHolder) {
            holder?.rv_title?.text = setBean?.title
        }


    }

    override fun getItemCount(): Int {
        if (datas != null && datas!!.size > 0) {
            return datas!!.size
        }
        return 0
    }


    internal class TimPrivateSetViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {

        val privateset_check: CheckBox = itemView.findViewById(R.id.item_privateset_check)

        val tv_name: TextView = itemView.findViewById(R.id.item_privateset_tv_name)


    }

    internal class TimPrivateSetViewTitleHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {


        val rv_title: TextView = itemView.findViewById(R.id.tim_privateset_rv_title)


    }

    //**********************itemClick************************
    interface OnItemClickListener {
        fun onItemClick(position: Int, onoff: Int)
    }

    private var mOnItemClickListener: OnItemClickListener? = null

    fun setOnItemClickListener(mOnItemClickListener: OnItemClickListener) {
        this.mOnItemClickListener = mOnItemClickListener
    }

    fun getData(): ArrayList<ParsePrivateSetBean>? {
        return datas
    }
}