package com.ninexiu.sixninexiu.adapter

import android.content.Context
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.CheckBox
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.IsAllowListBean
import com.ninexiu.sixninexiu.bean.ParsePrivateSetBean
import com.ninexiu.sixninexiu.bean.PrivateSetBean
import com.ninexiu.sixninexiu.bean.VoiceUserSetBean
import com.ninexiu.sixninexiu.common.util.Utils

/**
 * author wangyu
 * date: on 2020/08/04
 * describe: 私聊设置Adapter
 */


internal class TimVoiceSetAdapter : RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private var context: Context? = null
    private var datas: ArrayList<ParsePrivateSetBean>? = null
    private var allowDatas: ArrayList<IsAllowListBean>? = null
    private var noAllowdatas: ArrayList<IsAllowListBean>? = null

    constructor(context: Context, datas: ArrayList<ParsePrivateSetBean>, allowDatas: ArrayList<IsAllowListBean>,
                noAllowdatas: ArrayList<IsAllowListBean>) {
        this.context = context
        this.datas = datas
        this.allowDatas = allowDatas
        this.noAllowdatas = noAllowdatas
    }

    override fun getItemViewType(position: Int): Int {
        return if (datas?.get(position)?.title == null){
            0
        }else{
            1
        }

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecyclerView.ViewHolder {
        return if (viewType == 0){
            TimPrivateSetViewHolder(LayoutInflater.from(context).inflate(R.layout.item_recycle_voiceset, parent, false))
        }else{
            TimPrivateSetViewTitleHolder(LayoutInflater.from(context).inflate(R.layout.item_recycle_privatesettitle, parent, false))
        }

    }


    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        val setBean = datas?.get(position)
        if (holder is TimPrivateSetViewHolder){

            holder?.privateset_check?.isChecked = setBean?.value == 1


            if (position > 7){
                holder?.tv_name?.text =   position.minus(7) .toString()+"."+setBean?.optioname
            }else{
                holder?.tv_name?.text = setBean?.index.toString()+"."+setBean?.optioname
            }

            holder?.privateset_check?.setOnClickListener {

                setBean?.index?.let { it1 ->
                    mOnCheckClickListener?.onCheckClick(it1, setBean?.value,setBean?.option)
                }
            }
            if (TextUtils.equals(setBean?.option,"allowPart") || TextUtils.equals(setBean?.option,"notAllowPart")){
                holder?.itemView?.setOnClickListener {

                    setBean?.index?.let { it1 ->
                        mOnItemClickListener?.onItemClick(it1, setBean?.value,setBean?.option)
                    }
                }
                if (setBean?.value == 1){
                    holder?.voiceset_title.visibility = View.VISIBLE
//                    val layoutParams = holder?.voiceset_title.layoutParams as RelativeLayout.LayoutParams
//                    layoutParams.bottomMargin = Utils.dip2px(context,10f)
//                    holder?.voiceset_title.setL
                }else{
                    holder?.voiceset_title.visibility = View.GONE
                }


                if ((allowDatas != null && allowDatas?.size!! > 0) && TextUtils.equals(setBean?.option,"allowPart")){

                    var niceName :String? = allowDatas?.get(0)?.nickname
                    for (i in 1 until allowDatas?.size!!) {
                        niceName = niceName+"，"+allowDatas?.get(i)?.nickname
                    }
                    holder?.nameList.text = niceName
                    if (setBean?.value == 1){
                        holder?.nameList.visibility = View.VISIBLE
                    }else{
                        holder?.nameList.visibility = View.GONE
                    }
                }



                if ((noAllowdatas != null && noAllowdatas?.size!! > 0) && TextUtils.equals(setBean?.option,"notAllowPart")){
                    var niceName :String? = noAllowdatas?.get(0)?.nickname
                    for (i in 1 until noAllowdatas?.size!!) {
                        niceName = niceName+"，"+noAllowdatas?.get(i)?.nickname
                    }
                    holder?.nameList.text = niceName
                    if (setBean?.value == 1){
                        holder?.nameList.visibility = View.VISIBLE
                    }else{
                        holder?.nameList.visibility = View.GONE
                    }
                }
            }else{
                holder?.voiceset_title.visibility = View.GONE
                holder?.nameList.visibility = View.GONE
            }
        }else if (holder is TimPrivateSetViewTitleHolder){
            holder?.rv_title?.text = setBean?.title
        }


    }

    override fun getItemCount(): Int {
        if (datas != null && datas!!.size > 0) {
            return datas!!.size
        }
        return 0
    }


    internal class TimPrivateSetViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {

        val privateset_check: CheckBox = itemView.findViewById(R.id.item_voiceset_check)

        val tv_name: TextView = itemView.findViewById(R.id.item_voiceset_tv_name)

        val voiceset_title: TextView = itemView.findViewById(R.id.item_voiceset_title)

        val nameList: TextView = itemView.findViewById(R.id.item_voiceset_name)


    }

    internal class TimPrivateSetViewTitleHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {


        val rv_title: TextView = itemView.findViewById(R.id.tim_privateset_rv_title)


    }

    //**********************itemClick************************
    interface OnItemClickListener {
        fun onItemClick(position: Int, onoff: Int ,name :String)
    }

    private var mOnItemClickListener: OnItemClickListener? = null

    fun setOnItemClickListener(mOnItemClickListener: OnItemClickListener) {
        this.mOnItemClickListener = mOnItemClickListener
    }


    //**********************CheckClick************************
    interface OnCheckClickListener {
        fun onCheckClick(position: Int, onoff: Int ,name :String)
    }

    private var mOnCheckClickListener: OnCheckClickListener? = null

    fun setOnCheckClickListener(mOnItemClickListener: OnCheckClickListener) {
        this.mOnCheckClickListener = mOnItemClickListener
    }


    fun getData(): ArrayList<ParsePrivateSetBean>? {
        return datas
    }
}