package com.ninexiu.sixninexiu.adapter

import android.app.Dialog
import android.content.Context
import android.text.Html
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.PersonalInforActivity
import com.ninexiu.sixninexiu.bean.TrueLoveAnchor
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.HeadBoxView
import kotlinx.android.synthetic.main.item_reallove_anchor_header.view.*
import kotlinx.android.synthetic.main.item_true_love_anchor.view.*
import kotlinx.android.synthetic.main.item_true_love_anchor.view.tv_reallove_lovename
import java.lang.ClassCastException

/**
 * author: wangjiyuan
 * Created on 2017/5/15.
 * description:
 */
class TrueLoveAnchorAdapter(val context: Context, var infos: List<TrueLoveAnchor.DataBean.ListBean>) : RecyclerView.Adapter<TrueLoveAnchorAdapter.TrueLoveHolder>() {

    class TrueLoveHolder(val view: View) : RecyclerView.ViewHolder(view)

    private val TYPE_HEADER = 1
    private val TYPE_ITEM = 2
    private var pushEnable = false

    fun resetList(infos: List<TrueLoveAnchor.DataBean.ListBean>?, pushEnable: Boolean) {
        if (infos != null) {
            this.infos = infos
        }
        this.pushEnable = pushEnable
    }

    override fun getItemViewType(position: Int): Int {
        if (position == 0) {
            return TYPE_HEADER
        } else {
            return TYPE_ITEM
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TrueLoveHolder {
        var view: View
        if (viewType == TYPE_HEADER) {
            view = LayoutInflater.from(context).inflate(R.layout.item_reallove_anchor_header, parent, false)
        } else {
            view = LayoutInflater.from(context).inflate(R.layout.item_true_love_anchor, parent, false)
        }
        return TrueLoveHolder(view)
    }

    override fun getItemCount(): Int {
        return infos.size + 1
    }

    override fun onBindViewHolder(holder: TrueLoveHolder, position: Int) {
        if (getItemViewType(position) == TYPE_HEADER) {

            var wearInfo: TrueLoveAnchor.DataBean.ListBean? = null
            var joined = 0
            for (anchorInfo in infos) {
                if (anchorInfo.is_rep == 1) {
                    wearInfo = anchorInfo
                }
                if (anchorInfo.is_expire != 1) {
                    joined++
                }
            }
            if (wearInfo == null) {
                holder.view.iv_reallove_user_tag.visibility = View.GONE
                holder.view.tv_reallove_lovename_header.visibility = View.GONE
                holder.view.txt_reallove_wear.visibility = View.GONE
            } else {
                holder.view.iv_reallove_user_tag.visibility = View.VISIBLE
                holder.view.tv_reallove_lovename_header.visibility = View.VISIBLE
                holder.view.txt_reallove_wear.visibility = View.VISIBLE
                holder.view.iv_reallove_user_tag.setImageResource(Utils.getTrueLoveFansLeve(wearInfo.loveLevel, 1, false,wearInfo.loveTagStyle))
                holder.view.tv_reallove_lovename_header.text = wearInfo.badgeTitle
            }

            if (joined <= 10) {
                holder.view.tv_reallove_joinmore.text = Html.fromHtml("还可以拥有<font color=\"#FD265C\">${10 - joined}</font>枚真爱粉丝徽章")
            } else {
                holder.view.tv_reallove_joinmore.text = Html.fromHtml("还可以拥有<font color=\"#FD265C\">0</font>枚真爱粉丝徽章")
            }
            holder.view.toggle_reallove_push.status = pushEnable
            holder.view.toggle_reallove_push.setOnToggleStateChangeListener {
                if (listener != null) {
                    listener!!.pushStateChange(if (it) 1 else 0)
                }
            }
        } else {
            val anchorInfo = infos.get(position - 1)
            try {
                val headBox= HeadBoxView(context)
                headBox.bindHead(holder.view.iv_reallove_anchor_avatar)
                headBox.loadBoxImage(anchorInfo.headframe)
                GlideUtils.loadCirclePic(context, anchorInfo.headimage, headBox.iv_head)
            }catch (e:ClassCastException){
                e.printStackTrace()
            }

            holder.view.tv_reallove_anchor_nickname?.text = "${anchorInfo.nickname}的真爱团"
            holder.view.tv_reallove_lovename?.text = anchorInfo.badgeTitle
            holder.view.iv_reallove_anchor_tag?.setImageResource(Utils.getTrueLoveFansLeve(anchorInfo.loveLevel, 1, false,anchorInfo.loveTagStyle))
            holder.view.tv_reallove_info_level?.text = anchorInfo.loveLevel.toString()
            holder.view.tv_reallove_anchor_liveing?.visibility = if (anchorInfo.status == 1) View.VISIBLE else View.GONE
            GlideUtils.loadNormalImg(context, R.drawable.attention_list_live, holder.view.tv_reallove_anchor_liveing)
            holder.view.tv_reallove_anchor_wear?.visibility = if (anchorInfo.is_rep == 1) View.VISIBLE else View.GONE
            holder.view.tv_reallove_anchor_expe?.text = "我的真爱值：${anchorInfo.points}"
            if (anchorInfo.love_chg_range > 0) {
                holder.view.tv_reallove_anchor_expechange.visibility=View.VISIBLE
                holder.view.tv_reallove_anchor_expechange.setTextColor(context.resources.getColor(R.color.c_ff638a))
                val drawable = context.resources.getDrawable(R.drawable.icon_reallove_level_up)
                drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                holder.view.tv_reallove_anchor_expechange?.setCompoundDrawables(null, null, drawable, null)
            } else if (anchorInfo.love_chg_range < 0) {
                holder.view.tv_reallove_anchor_expechange.visibility=View.VISIBLE
                holder.view.tv_reallove_anchor_expechange.setTextColor(context.resources.getColor(R.color.c_63a0ff))
                val drawable = context.resources.getDrawable(R.drawable.icon_reallove_level_down)
                drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                holder.view.tv_reallove_anchor_expechange?.setCompoundDrawables(null, null, drawable, null)
            }else{
                holder.view.tv_reallove_anchor_expechange.visibility=View.GONE
            }
            holder.view.tv_reallove_anchor_expechange?.text = "${Math.abs(anchorInfo.love_chg_range)}"
            if (anchorInfo.day_points >= anchorInfo.max_points) {
                holder.view.tv_reallove_anchor_expeearn?.text = "今日已达上限"
            } else {
                holder.view.tv_reallove_anchor_expeearn?.text = "今日可得真爱值${anchorInfo.day_points}/${anchorInfo.max_points}"
            }

//            if (anchorInfo.is_expire == 1) {
//                holder.view.tv_reallove_anchor_overtime.text = "已到期"
//            } else {
//                holder.view.tv_reallove_anchor_overtime.text = "${deadlineStealth(anchorInfo.expire)}"
//            }
            holder.view.tv_reallove_anchor_overtime.text = anchorInfo.expireStr

            holder.view.iv_reallove_anchor_more.setOnClickListener {
                if (listener != null) {
                    listener!!.showMore(position, anchorInfo, holder.view.iv_reallove_anchor_more)
                }
            }

            holder.view.tv_reallove_anchor_renew.setOnClickListener {
                if (listener != null) {
                    listener!!.renewLove(position, anchorInfo)
                }
            }

            holder.view!!.setOnClickListener {
                //未开播跳转到主播个人主页   开播了跳转到直播间
                if (anchorInfo.status != 1) {
                    PersonalInforActivity.start(context, true, anchorInfo.uid.toLong())
                } else {
                    Utils.openLiveRoom(context, 7, anchorInfo.rid + "", 1,
                            anchorInfo.nickname)
                }
            }

        }
    }

    fun deadlineStealth(stealthDueTime: Long): String {
        val days = (stealthDueTime - System.currentTimeMillis() / 1000).toInt() / 24 / 3600
        var content = ""
        content = if (days >= 0 && days <= 5) {
            "到期" + days + "天"
        } else {
            "到期 " + Utils.getFormatDate2(stealthDueTime)
        }
        return content
    }

    private var listener: OnClickChangeLisener? = null

    fun setItemOnclickChangeListener(listener: OnClickChangeLisener?) {
        this.listener = listener
    }

    /**
     * 点击事件
     */
    interface OnClickChangeLisener {
        fun pushStateChange(state: Int)
        fun renewLove(position: Int, anchorInfo: TrueLoveAnchor.DataBean.ListBean?)
        fun showMore(position: Int, anchorInfo: TrueLoveAnchor.DataBean.ListBean?, moreIcon: View)
    }
}