package com.ninexiu.sixninexiu.adapter

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.GiftReturnItem
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.fitterViewSize

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/20
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class UserReturenActiveAdapter(data: MutableList<GiftReturnItem>) :
        BaseQuickAdapter<GiftReturnItem, UserReturenActiveAdapter.UserActiveHolder>(R.layout.item_user_return_active, data) {
    companion object {
        const val ITEM_WIDTH_PERCENT = 0.195
        const val ITEM_WIDTH_HEI_PERCENT = 0.81

        const val ITEM_IV_PERCENT = 0.15
        const val ITEM_IV_W_H_PERCENT = 0.85
    }

    override fun convert(helper: UserActiveHolder?, item: GiftReturnItem?) {
        helper ?: return
        item ?: return

        helper.tvItemInfo.text = item.name
        GlideUtils.loadImageView(helper.itemView.context,item.img,helper.ivItem)
    }


    inner class UserActiveHolder(view: View) : BaseViewHolder(view) {
        val itemContent: ConstraintLayout = view.findViewById(R.id.itemContent)
        val tvItemInfo: TextView = view.findViewById(R.id.tvItemInfo)
        val ivItem : ImageView = view.findViewById(R.id.ivItem)

        // 适配
        init {
            val widthScreenSize = view.context.resources.displayMetrics.widthPixels

            val params = itemContent.layoutParams
            val width = (widthScreenSize * ITEM_WIDTH_PERCENT).toInt()
            params.width = width
            params.height = (width * ITEM_WIDTH_HEI_PERCENT).toInt()
            itemContent.layoutParams = params

            fitterViewSize(ivItem,{
                (widthScreenSize * ITEM_IV_PERCENT).toInt()
            },{
                (it * ITEM_IV_W_H_PERCENT).toInt()
            })
        }
    }

}