package com.ninexiu.sixninexiu.adapter

import android.view.View
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.Option
import com.ninexiu.sixninexiu.view.ZhiFuItemView
import com.ninexiu.sixninexiu.view.dp2px

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/25
 *     desc   : 支付选项 Adapter
 *     version: 1.0
 * </pre>
 */
class ZhiFuAdapter(data: MutableList<Option>, val type: Int = ZHIFU_TYPE) : BaseQuickAdapter<Option, ZhiFuAdapter.ZhiFuViewHolder>(R.layout.item_adapter_zhifu, data) {
    companion object {
        const val ZHIFU_TYPE = 0
        const val ZHIFU_FAST_TYPE = 1
    }

    var onSelected: ((Int, Int) -> Unit)? = null
    var userInputMoney: ((CharSequence?) -> Unit)? = null

    private var lastPosSelect = 0

    override fun convert(helper: ZhiFuViewHolder?, item: Option?) {
        helper ?: return
        item ?: return

        helper.zhifuItemView
                .setType(item.itemType)
                .setMoney(item.money, item.amount)
                .setZhiFuSelected(item.selected)

        helper.zhifuItemView.setOnClickListener {
            if(helper.adapterPosition == lastPosSelect) {
                if(helper.zhifuItemView.type == ZhiFuItemView.CUSTOM) {
                    helper.zhifuItemView.showKeyBoard()     // 显示键盘
                }
                return@setOnClickListener
            }

            lastPosSelect = helper.adapterPosition
            onSelected?.invoke(helper.adapterPosition, helper.zhifuItemView.type)
        }

        // 适配高度
        val params = helper.zhifuItemView.layoutParams
        params.height = if (type == ZHIFU_TYPE) {
            dp2px(helper.zhifuItemView.context, 69)
        } else {
            dp2px(helper.zhifuItemView.context, 55)
        }

        // 用户自定义金额时的回调
        helper.zhifuItemView.userInputMoney = userInputMoney
    }

    class ZhiFuViewHolder(view: View) : BaseViewHolder(view) {
        val zhifuItemView: ZhiFuItemView = view.findViewById(R.id.zhifuItem)
    }
}