package com.ninexiu.sixninexiu.adapter.auction

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.BiddingShopInfo
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.UIUtils
import kotlinx.android.synthetic.main.item_auction_goods.view.*
import kotlinx.android.synthetic.main.ns_dynamic_notice_item.view.*

class AuctionGoodsAdapter(val context: Context, val goodsType: Int, var goodsList: List<BiddingShopInfo>) : RecyclerView.Adapter<AuctionGoodsAdapter.AuctionGoodsHolder>() {
    class AuctionGoodsHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): AuctionGoodsHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_auction_goods, parent, false)
        return AuctionGoodsHolder(view)
    }

    override fun getItemCount(): Int {
        return goodsList.size
    }

    override fun onBindViewHolder(holder: AuctionGoodsHolder, position: Int) {
        val goods = goodsList[position]

        GlideUtils.loadSimpleImgWithRoundCorner(context, goods.img1, holder.view.iv_goods_cover, R.drawable.icon_personal_default_bg, ConvertUtils.dp2px(4f))
        holder.view.tv_goods_name.text = goods.goods_name

        when (goods.auction_type) {
            1 -> {
                holder.view.tv_goods_auction_state.text = "未开始"
                holder.view.tv_goods_auction_state.setTextColor(ContextCompat.getColor(context, R.color.color_999999))
            }
            2 -> {
                holder.view.tv_goods_auction_state.text = "竞拍中"
                holder.view.tv_goods_auction_state.setTextColor(ContextCompat.getColor(context, R.color.color_ff567b))
            }
            3 -> {
                holder.view.tv_goods_auction_state.text = "已结束"
                holder.view.tv_goods_auction_state.setTextColor(ContextCompat.getColor(context, R.color.color_999999))
            }
        }
        if (goodsType == LiveGoodsListFragment.GOODS_LIST_TYPE_AUCTION) {
            UIUtils.goneView(holder.view.tv_buy_now)
            UIUtils.showView(holder.view.txt_current_price)
            UIUtils.showView(holder.view.tv_goods_raise_price)
            holder.view.tv_current_price.text = "${goods.amount}"
            holder.view.tv_goods_raise_price.text = "加价幅度¥${goods.incrby_price}"
        } else {
            UIUtils.showView(holder.view.tv_buy_now)
            UIUtils.goneView(holder.view.txt_current_price)
            UIUtils.goneView(holder.view.tv_goods_raise_price)
            holder.view.tv_current_price.text = "${goods.fixed_price}"
            holder.view.tv_buy_now.setOnClickListener {
                buynowClick?.invoke(holder.view, goods)
            }
        }
        holder.view.setOnClickListener {
            goodsClick?.invoke(holder.view, goods)
        }
    }

    var buynowClick: ((view: View, goods: BiddingShopInfo) -> Unit)? = null
    var goodsClick: ((view: View, goods: BiddingShopInfo) -> Unit)? = null

}