package com.ninexiu.sixninexiu.adapter.auction

import android.content.Context
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.AuctionOrderData
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.UIUtils
import kotlinx.android.synthetic.main.item_auction_order.view.*
import java.text.DecimalFormat

class AuctionOrderAdapter(val context: Context, var orderList: ArrayList<AuctionOrderData>) : RecyclerView.Adapter<AuctionOrderAdapter.AuctionOrderHolder>() {

    val df = DecimalFormat("0.00")

    class AuctionOrderHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): AuctionOrderHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_auction_order, parent, false)
        return AuctionOrderHolder(view)
    }

    override fun getItemCount(): Int {
        return orderList.size
    }

    override fun onBindViewHolder(holder: AuctionOrderHolder, position: Int) {
        val orderData = orderList[position]
        holder.view.tv_order_id.text = "订单编号：${orderData.order_id}"

        if (orderData.sell_type == "1") {//1竞拍  2一口价购买
            UIUtils.showView(holder.view.iv_order_is_auction)
        } else {
            UIUtils.goneView(holder.view.iv_order_is_auction)
        }

        when (orderData.status) {
            "0" -> {//0 待支付 1已支付 2已取消 3 已退款 4已发货
                holder.view.tv_order_state.text = "待支付"
            }
            "1" -> {
                holder.view.tv_order_state.text = "已支付"
            }
            "2" -> {
                holder.view.tv_order_state.text = "已取消"
            }
            "3" -> {
                holder.view.tv_order_state.text = "已退款"
            }
            "4" -> {
                holder.view.tv_order_state.text = "已发货"
            }
        }

        GlideUtils.loadSimpleImgWithRoundCorner(context, orderData.img1, holder.view.iv_order_goods_cover, R.drawable.icon_personal_default_bg, ConvertUtils.dp2px(4f))
        holder.view.tv_order_goods_name.text = orderData.goods_name
        holder.view.tv_order_goods_number.text = "x${orderData.count}"
        var amount = orderData.amount
        if (TextUtils.isEmpty(amount)){
            amount = "0"
        }
        holder.view.tv_order_goods_price.text = "${df.format(amount?.toFloat())}"

        holder.view.setOnClickListener {
            onOrderClick?.invoke(position,orderData)
        }

    }

    var onOrderClick: ((position:Int,orderData: AuctionOrderData) -> Unit)? = null
}