package com.ninexiu.sixninexiu.adapter.auction

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.BasePagerFragment
import com.ninexiu.sixninexiu.fragment.auction.OrderListFragment
import com.ninexiu.sixninexiu.login.LoginEntryActivity
import com.ninexiu.sixninexiu.view.dialog.BiddingServiceDescriptionDialog
import kotlinx.android.synthetic.main.fragment_live_goods_parent.*

class LiveGoodsParentFragment : BasePagerFragment() {

    private lateinit var roomId: String

    companion object {
        fun newInstance(rid: String): LiveGoodsParentFragment {
            val args = Bundle()
            args.putString("room_id", rid)
            val fragment = LiveGoodsParentFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fragment_live_goods_parent, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        if (arguments != null) {
            roomId = arguments!!.getString("room_id","")
        }
        val fragments = ArrayList<Fragment>()
        fragments.add(LiveGoodsListFragment.newInstance(LiveGoodsListFragment.GOODS_LIST_TYPE_AUCTION, roomId))
        fragments.add(LiveGoodsListFragment.newInstance(LiveGoodsListFragment.GOODS_LIST_TYPE_BUY_NOW, roomId))
        val titles = Array<String>(2) {
            if (it == 0) {
                "竞拍"
            } else {
                "一口价"
            }
        }
        vp_goods_list?.offscreenPageLimit = titles.size
        vp_goods_list?.adapter = CommonPagerAdapter(childFragmentManager, titles, fragments)

        tab_goods_list?.tipsScroll(0)
        tab_goods_list?.setItemWidthAndInterWidth(0, 10, 0)
        tab_goods_list?.setTextColorResource(R.color.color_ff567b, R.color.color_333333)
        tab_goods_list?.textSize = resources.getDimensionPixelSize(R.dimen.ns_textsize_16)
        tab_goods_list?.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_16))
        tab_goods_list?.setViewPager(vp_goods_list)

        tv_goods_list_desc?.setOnClickListener {
            if (activity != null && !activity!!.isFinishing) {
                BiddingServiceDescriptionDialog.create(activity!!).show()
            }
        }

        tv_live_order?.setOnClickListener {
            if (activity != null && !activity!!.isFinishing) {

                if (NineShowApplication.mUserBase == null) {
                    Utils.startLogin(activity, LoginEntryActivity.FROM_LIVEROOM)
                    return@setOnClickListener
                }

                val intentOrder = Intent(activity, SubPageActivity::class.java)
                intentOrder.putExtra(SubPageActivity.CLASSFRAMENT, OrderListFragment::class.java)
                startActivity(intentOrder)
            }
        }

    }

}