package com.ninexiu.sixninexiu.adapter.liveroom

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.makeramen.roundedimageview.RoundedImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.UserBase
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.liveroom.LiveRoomUserFragment
import com.ninexiu.sixninexiu.view.*
import kotlinx.android.synthetic.main.item_liveroom_user.view.*
import kotlinx.android.synthetic.main.item_liveroom_user_rank_head.view.*

class LiveRoomUserAdapter(val context: Context, val anchorId: Long, val type: Int, var userList: ArrayList<UserBase>) : RecyclerView.Adapter<RecyclerView.ViewHolder>() {

    class LiveRoomUserRankHeadHolder(val view: View) : RecyclerView.ViewHolder(view)
    class LiveRoomUserHolder(val view: View) : RecyclerView.ViewHolder(view)


    companion object {
        const val TYPE_COMMON = 1
        const val TYPE_RANK_HEAD = 2
        const val badgeTag = "  "
    }

    override fun getItemViewType(position: Int): Int {
        if (type == LiveRoomUserFragment.TYPE_CONTRIBUTION_RANK && position == 0) {
            return TYPE_RANK_HEAD
        }

        return TYPE_COMMON
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecyclerView.ViewHolder {
        return if (viewType == TYPE_RANK_HEAD) {
            val view = LayoutInflater.from(context).inflate(R.layout.item_liveroom_user_rank_head, parent, false)
            LiveRoomUserRankHeadHolder(view)
        } else {
            val view = LayoutInflater.from(context).inflate(R.layout.item_liveroom_user, parent, false)
            LiveRoomUserHolder(view)
        }
    }

    override fun getItemCount(): Int {
        if (type == LiveRoomUserFragment.TYPE_CONTRIBUTION_RANK) {
            if (!userList.isNullOrEmpty()) {
                if (userList.size < 3) {
                    return 1
                } else {
                    return userList.size - 3 + 1
                }
            }
        }
        return userList.size
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        if (getItemViewType(position) == TYPE_RANK_HEAD) {
            val headHold = holder as LiveRoomUserRankHeadHolder
            if (!userList.isNullOrEmpty()) {
                GlideUtils.loadCirclePic(context, userList[0].headimage120, headHold.view.iv_rank_one, R.drawable.icon_head_default)
                headHold.view.tv_nickname_one.text = userList[0].nickname
                headHold.view.tv_contribution_count_one.text = LiveRoomUserFragment.transformContributeNumber(userList[0].totalprice)
                headHold.view.iv_rank_one.setOnClickListener {
                    showPersonInfoDialog?.invoke(userList[0])
                    // PersonalInforActivity.start(context, userList[0].uid)
                }
            } else {
                headHold.view.tv_contribution_count_one.setVisible(false)
                headHold.view.iv_rank_one.setVisible(false)
                headHold.view.iv_rank_one_bg.setVisible(false)
                headHold.view.tv_nickname_one.setVisible(false)
            }
            if (userList.size > 1) {
                GlideUtils.loadCirclePic(context, userList[1].headimage120, headHold.view.iv_rank_two, R.drawable.icon_head_default)
                headHold.view.tv_nickname_two.text = userList[1].nickname
                headHold.view.tv_contribution_count_two.text = LiveRoomUserFragment.transformContributeNumber(userList[1].totalprice)
                headHold.view.iv_rank_two.setOnClickListener {
                    showPersonInfoDialog?.invoke(userList[1])
                    // PersonalInforActivity.start(context, userList[1].uid)
                }
            } else {
                headHold.view.tv_contribution_count_two.setVisible(false)
                headHold.view.iv_rank_two.setVisible(false)
                headHold.view.iv_rank_two_bg.setVisible(false)
                headHold.view.tv_nickname_two.setVisible(false)
            }
            if (userList.size > 2) {
                GlideUtils.loadCirclePic(context, userList[2].headimage120, headHold.view.iv_rank_three, R.drawable.icon_head_default)
                headHold.view.tv_nickname_three.text = userList[2].nickname
                headHold.view.tv_contribution_count_three.text = LiveRoomUserFragment.transformContributeNumber(userList[2].totalprice)
                headHold.view.iv_rank_three.setOnClickListener {
                    showPersonInfoDialog?.invoke(userList[2])
                    // PersonalInforActivity.start(context, userList[2].uid)
                }
            } else {
                headHold.view.tv_contribution_count_three.setVisible(false)
                headHold.view.iv_rank_three.setVisible(false)
                headHold.view.iv_rank_three_bg.setVisible(false)
                headHold.view.tv_nickname_three.setVisible(false)
            }

        } else {
            val userHolder = holder as LiveRoomUserHolder

            val userBase: UserBase
            if (type == LiveRoomUserFragment.TYPE_CONTRIBUTION_RANK) {
                userBase = userList[position + 3 - 1]

                setItemViewPadding(position, userHolder.view.cl_user_container, position + 3 - 1 == userList.size - 1)
            } else {
                userBase = userList[position]

                setItemViewPadding(position, userHolder.view.cl_user_container, position == userList.size - 1)
            }

            //昵称
            userHolder.view.tv_nickname.text = userBase.nickname

            //头像
            val head: View = userHolder.view.findViewById(R.id.iv_avatar)
            var headImg: HeadBoxView? = null
            if (head is RoundedImageView) {
                headImg = HeadBoxView(context)
                headImg.setScale(1.4f)
                headImg.bindHead(head)
            } else if (head is HeadBoxView) {
                headImg = head
            }

            if (TextUtils.equals(userBase.nickname, "神秘人")) {
                GlideUtils.loadCirclePic(context, userBase.headimage120, headImg?.iv_head, R.drawable.sendgift_mystery_head_icon_new)
            } else {
                GlideUtils.loadCirclePic(context, userBase.headimage120, headImg?.iv_head, R.drawable.icon_head_default)
                // 神秘人不加载头像框
                if (!TextUtils.isEmpty(userBase.headframe)) {
                    headImg?.loadBoxImage(userBase.headframe)
                }
            }

            if (type == LiveRoomUserFragment.TYPE_ONLINE_USER) {
                if (anchorId == userBase.uid) {
                    userHolder.view.tv_reallove.setVisible(true)
                } else {
                    userHolder.view.tv_reallove.setVisible(false)
                }
                userHolder.view.tv_rank_count.setVisible(false)
                userHolder.view.tv_contribution_count.setVisible(false)
                userHolder.view.txt_contribution.setVisible(false)

                // 设置靓号
                val number = getBeautifulNumber(userBase.accountid)
                if(number.isNullOrBlank() || TextUtils.equals(userBase.nickname, "神秘人")){
                    userHolder.view.tvBeautifulNumber.setVisible(false)
                }else {
                    userHolder.view.tvBeautifulNumber.setVisible(true)
                    userHolder.view.tvBeautifulNumber.text = number
                }
            } else {
                userHolder.view.tv_rank_count.setVisible(true)
                userHolder.view.tv_contribution_count.setVisible(true)
                userHolder.view.txt_contribution.setVisible(true)
                userHolder.view.tv_reallove.setVisible(false)
                userHolder.view.tvBeautifulNumber.setVisible(false)
                userHolder.view.tv_contribution_count.text = LiveRoomUserFragment.transformContributeNumber(userBase.totalprice)

                // 本场贡献榜 & 语音房的隐形富豪榜
                if (type == LiveRoomUserFragment.TYPE_CONTRIBUTION_THIS_TIME || type == LiveRoomUserFragment.TYPE_VOICE_HEART) {
                    if (position < 3) {
                        (headImg?.iv_head as RoundedImageView).borderWidth = dp2px(context, 2).toFloat()

                        userHolder.view.cl_user_container.delegate
                                .setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_ffeaea), ContextCompat.getColor(context, R.color.white))

                        userHolder.view.tv_rank_count.text = ""
                        userHolder.view.tv_rank_count.setBackgroundResource(getDrawableResource(context,"ic_contribute_${position + 1}"))
                    } else {
                        (headImg?.iv_head as RoundedImageView).borderWidth = dp2px(context, 0).toFloat()

                        userHolder.view.cl_user_container.delegate
                                .setBackgroundColorStartEnd(-1, -1)

                        userHolder.view.tv_rank_count.text = "${position + 1}"
                        userHolder.view.tv_rank_count.background = null
                    }

                    when (position) {
                        0 -> {
                            (headImg.iv_head as RoundedImageView).borderColor = ContextCompat.getColor(context, R.color.color_ffcc00)
                        }
                        1 -> {
                            (headImg.iv_head as RoundedImageView).borderColor = ContextCompat.getColor(context, R.color.color_93cfff)
                        }
                        2 -> {
                            (headImg.iv_head as RoundedImageView).borderColor = ContextCompat.getColor(context, R.color.color_ffae52)
                        }
                    }
                } else {
                    userHolder.view.tv_rank_count.text = "${position + 3}"
                }
            }

            val spanBuilder = SpannableStringBuilder("")
            val isMystery : Boolean = TextUtils.equals(userBase.nickname, "神秘人")

            var start = 0
            //主播身份
            if (!isMystery && anchorId == userBase.uid) {
                spanBuilder.append(badgeTag)
                val anchorImageSpan = VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.ns_live_chat_anchor_tag))
                spanBuilder.setSpan(anchorImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                start += 2
            }

            //管理
            if (!isMystery && userBase.managerLevel > 0) {
                spanBuilder.append(badgeTag)
                val managerImageSpan = VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.ns_live_audience_user_manager))
                spanBuilder.setSpan(managerImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                start += 2
            }

            // 神秘人
            if (isMystery) {
                spanBuilder.append(badgeTag)
                val managerImageSpan = VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.mystery_level_icon))
                spanBuilder.setSpan(managerImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                start += 2
            }

            //守护
            if (!isMystery && userBase.guardLevel > 0 && Utils.getGuardLevelDrawable(userBase.guardId.toLong(), userBase.guardLevel) != -1) {
                spanBuilder.append(badgeTag)
                val managerImageSpan = VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, Utils.getGuardLevelDrawable(userBase.guardId.toLong(), userBase.guardLevel)))
                spanBuilder.setSpan(managerImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                start += 2
            }

            //设置vip
            if (!isMystery && userBase.viplevel in 1..4) {
                spanBuilder.append(badgeTag)
                val vipImageSpan: VerticalImageSpan = when (userBase.viplevel) {
                    1 -> VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.ns_live_audience_vip_one))
                    2 -> VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.ns_live_audience_vip_two))
                    3 -> VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.ns_live_audience_vip_three))
                    else -> VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, R.drawable.ns_live_audience_vip_four))
                }
                spanBuilder.setSpan(vipImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                start += 2
            }

            //至尊vip红色名字
            if (userBase.viplevel == 4) {
                holder.view.tv_nickname.setTextColor(ContextCompat.getColor(context, R.color.color_ff567b))
            } else {
                holder.view.tv_nickname.setTextColor(ContextCompat.getColor(context, R.color.color_333333))
            }

            // 财富等级
            if(!isMystery) {
                spanBuilder.append(badgeTag)
                val levelImageSpan = if (userBase.is_anchor == 1) {
                    VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, Utils.getHostLevelDrawable(userBase.creditlevel)))
                } else {
                    val bitmap : Bitmap? = Utils.getUserLevelDrawableCommon(context,userBase.wealthlevel,userBase.uid.toString())
                    bitmap?.let {  VerticalImageSpan(context, bitmap) }
                }
                spanBuilder.setSpan(levelImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                start += 2
            }

            //排位赛
            if(!isMystery) {
                val res = Utils.getUserRankLevelId(userBase.dan, userBase.grade, userBase.gradeStar)
                if (userBase.dan == 0 || userBase.grade == 0 || res == -1) {

                } else {
                    spanBuilder.append(badgeTag)
                    val rankImageSpan = VerticalImageSpan(context, BitmapFactory.decodeResource(context.resources, res))
                    spanBuilder.setSpan(rankImageSpan, start, start + 1, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                    start += 2
                }
            }

            spanBuilder.trim()
            userHolder.view.tv_badge_container.text = spanBuilder

            //真爱团徽章
            if (userBase.loveLevel > 0) {
                userHolder.view.tv_reallove_badge.setVisible(true)
                userHolder.view.tv_reallove_rank_level_num.setVisible(true)
                userHolder.view.iv_reallove_rank_level.setVisible(true)
                val loveLeader = userBase.loveRep != 2 && userBase.loveFansPointsRank == 1
                userHolder.view.tv_reallove_badge.text = if (loveLeader) "" else userBase.loveTitle
                userHolder.view.tv_reallove_rank_level_num.text = if (loveLeader) "" else userBase.loveLevel.toString()
                userHolder.view.iv_reallove_rank_level.setImageResource(Utils.getLoveFansLeve(userBase.loveLevel, 1, loveLeader))
            } else {
                userHolder.view.tv_reallove_badge.setVisible(false)
                userHolder.view.tv_reallove_rank_level_num.setVisible(false)
                userHolder.view.iv_reallove_rank_level.setVisible(false)
            }

            userHolder.view.tv_reallove.setOnClickListener {
                realLoveOnClick?.invoke()
            }

            userHolder.view.setOnClickListener {
                showPersonInfoDialog?.invoke(userBase)
                // PersonalInforActivity.start(context, userBase.uid)
            }

        }
    }

    fun getBeautifulNumber(accoundId : String?) : String? {
        if(!accoundId.isNullOrBlank() && accoundId.length in 1..7) {
            return "靓号$accoundId"
        }
        return null
    }

    fun setItemViewPadding(position: Int,lastView:View,isLast:Boolean){
        if (position > 2 && isLast) {
            lastView.setPadding(0, 0, 0, dp2px(context, 80))
        } else {
            lastView.setPadding(0, 0, 0, 0)
        }
    }

    var realLoveOnClick: (() -> Unit)? = null
    var showPersonInfoDialog : ((UserBase?) -> Unit)? = null
}