package com.ninexiu.sixninexiu.adapter.store

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.BitmapFactory
import android.graphics.NinePatch
import android.graphics.Rect
import android.graphics.drawable.Drawable
import android.graphics.drawable.NinePatchDrawable
import android.text.TextUtils
import android.util.TypedValue
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.request.target.CustomTarget
import com.bumptech.glide.request.target.SimpleTarget
import com.bumptech.glide.request.target.Target
import com.bumptech.glide.request.transition.Transition
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.DressUpGoods
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_dress_up.view.*
import kotlinx.android.synthetic.main.layout_my_dressup_bubble.view.*
import java.io.File
import java.io.FileInputStream

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/24
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MyDressUpAdapter(val context: Context, val tabId: Int, val dressUpList: MutableList<DressUpGoods>) : RecyclerView.Adapter<MyDressUpAdapter.DressUpHolder>() {

    class DressUpHolder(val view: View) : RecyclerView.ViewHolder(view)

    var onDressUpItemClick: ((dressUpGoods: DressUpGoods, position: Int) -> Unit)? = null

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): DressUpHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_dress_up, parent, false)
        return DressUpHolder(view)
    }

    override fun getItemCount(): Int {
        return dressUpList.size
    }

    @SuppressLint("CheckResult")
    override fun onBindViewHolder(holder: DressUpHolder, position: Int) {
        holder.view.cl_dressup_container.layoutParams.width = (NineShowApplication.getScreenWidth(context) - dp2px(context, 44)) / 3

        holder.view.tv_bubble_content.setTextSize(TypedValue.COMPLEX_UNIT_SP, 11f)
        val dressUpGoods = dressUpList[position]
        holder.view.tv_dressup_name.text = dressUpGoods.name
        if ((dressUpGoods.state == 4 || dressUpGoods.state == 5) && !TextUtils.isEmpty(dressUpGoods.price)) {
            holder.view.tv_dressup_price.text = "${dressUpGoods.price}九币"
            holder.view.tv_dressup_price.setVisible(true)
        } else {
            holder.view.tv_dressup_price.setVisible(false)
        }
        holder.view.tv_dressup_state.setVisible(!TextUtils.isEmpty(dressUpGoods.labelstr))
        holder.view.tv_dressup_state.text = dressUpGoods.labelstr

        //背景设置
        if (!TextUtils.isEmpty(dressUpGoods.background)) {
            Glide.with(context).load(dressUpGoods.background).into(object : CustomTarget<Drawable>() {
                override fun onResourceReady(resource: Drawable, transition: Transition<in Drawable>?) {
                    holder.view.cl_dressup_cover.background = resource
                }

                override fun onLoadCleared(placeholder: Drawable?) {

                }
            })
        } else {
            holder.view.cl_dressup_cover.setBackgroundColor(ContextCompat.getColor(context, R.color.color_e9eaeb))
        }

        //穿戴设置
        if (dressUpGoods.isactive == 1) {
            holder.view.tv_dressup_state.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_ff97ae), ContextCompat.getColor(context, R.color.color_ff567b))
            holder.view.tv_dressup_state.text = "穿戴中"
            holder.view.tv_dressup_state.setVisible(true)
        } else {
            holder.view.tv_dressup_state.setVisible(false)
        }



        holder.view.tv_dressup_price.setVisible(true)
        if (dressUpGoods.is_fast_expiration == 1) {//即将到期
            holder.view.tv_dressup_price.setTextColor(ContextCompat.getColor(context, R.color.color_fd638a))
            holder.view.tv_dressup_price.text = "即将到期  剩余${dressUpGoods.deadLine}"
        } else {
            holder.view.tv_dressup_price.setTextColor(ContextCompat.getColor(context, R.color.color_999999))
            holder.view.tv_dressup_price.text = dressUpGoods.deadLine
        }

        if (tabId == 1) {//头像框
            holder.view.iv_dressup_cover.layoutParams.width = dp2px(context, 52)
            holder.view.iv_dressup_cover.layoutParams.height = dp2px(context, 52)
            NewSvgaFrameUtil.getInstance().startAnimator(holder.view.svga_dressup_frame, dressUpGoods.frame_id)
            NineShowApplication.mUserBase?.let {
                GlideUtils.loadCirclePic(context, it.avatarUrl120, holder.view.iv_dressup_cover)
            }
        } else if (tabId == 3) {//徽章
            holder.view.iv_dressup_cover.layoutParams.width = dp2px(context, 74)
            GlideUtils.loadNormalPic(context, if (TextUtils.isEmpty(dressUpGoods.imgurl)) dressUpGoods.url else dressUpGoods.imgurl, holder.view.iv_dressup_cover, R.drawable.icon_gift_default)
        } else if (tabId == 4) {//聊天气泡
            holder.view.tv_nickname.setVisible(false)
            holder.view.layout_bubble.setVisible(true)
            loadBubbleImage(dressUpGoods, holder)
        } else if (tabId == 5) {//资料卡
            holder.view.iv_dressup_cover.layoutParams.width = dp2px(context, 95)
            holder.view.svga_dressup_frame.layoutParams.width = dp2px(context, 54)
            holder.view.svga_dressup_frame.layoutParams.height = dp2px(context, 54)
            (holder.view.iv_dressup_cover.layoutParams as ViewGroup.MarginLayoutParams).topMargin = dp2px(context, 12)
            NineShowApplication.mUserBase?.let {
                GlideUtils.loadCirclePic(context, it.avatarUrl120, holder.view.iv_dressup_infocard_circle)
            }
            GlideUtils.loadNormalImg(context, dressUpGoods.nameplate_frame, holder.view.svga_dressup_frame)
            GlideUtils.loadNormalImg(context, dressUpGoods.nameplate_img, holder.view.iv_dressup_cover)
        } else if (tabId == 6) {//麦位圈
            holder.view.svga_dressup_frame.layoutParams.width = dp2px(context, 60)
            holder.view.svga_dressup_frame.layoutParams.height = dp2px(context, 60)
            SvgaCommonUtil.getInstance().initView(context).startAnimator(holder.view.svga_dressup_frame, dressUpGoods.imgurl)
            NineShowApplication.mUserBase?.let {
                GlideUtils.loadCirclePic(context, it.avatarUrl120, holder.view.iv_dressup_infocard_circle)
            }
        } else {
            holder.view.iv_dressup_cover.layoutParams.width = dp2px(context, 74)
            GlideUtils.loadNormalPic(context, if (TextUtils.isEmpty(dressUpGoods.imgurl)) dressUpGoods.url else dressUpGoods.imgurl, holder.view.iv_dressup_cover, R.drawable.icon_gift_default)
        }

        if (position >= if (itemCount % 3 == 0) itemCount - 3 else itemCount - itemCount % 3) {
            (holder.view.layoutParams as ViewGroup.MarginLayoutParams).bottomMargin = dp2px(context, 12)
        }

        if (position >= if (itemCount % 3 == 0) itemCount - 3 else itemCount - itemCount % 3) {
            (holder.view.layoutParams as ViewGroup.MarginLayoutParams).bottomMargin = dp2px(context, 12)
        }

        holder.view.setOnClickListener {
            onDressUpItemClick?.invoke(dressUpGoods, position)
        }


    }


    /**
     * 加载气泡view
     */
    private fun loadBubbleImage(dressUpGoods: DressUpGoods, holder: MyDressUpAdapter.DressUpHolder) {
        dressUpGoods.chat_path?.let { paths ->
            if (paths.size >= 5) {
                for ((index, path) in paths.withIndex()) {
                    if (!TextUtils.isEmpty(path)) {
                        if (holder.view.cl_bubble_container.getChildAt(index) is ImageView) {
                            if (index != 0) {
                                Glide.with(context).load(path).override(Target.SIZE_ORIGINAL, Target.SIZE_ORIGINAL).into(holder.view.cl_bubble_container.getChildAt(index) as ImageView)
                            } else {
                                Glide.with(context).asFile().load(path).into(object : CustomTarget<File>() {

                                    override fun onLoadCleared(placeholder: Drawable?) {
                                    }

                                    override fun onResourceReady(resource: File, transition: Transition<in File>?) {
                                        val bitmap = BitmapFactory.decodeStream(FileInputStream(resource))
                                        if (bitmap.ninePatchChunk != null && NinePatch.isNinePatchChunk(bitmap.ninePatchChunk)) {
                                            holder.view.cl_bubble_container.getChildAt(index).layoutParams.width = dp2px(context, 78)
                                            holder.view.cl_bubble_container.layoutParams.width = dp2px(context, 78)
                                            holder.view.cl_bubble_container.layoutParams.height = dp2px(context, 38)
                                            val npf = NinePatchDrawable(context.resources, bitmap, bitmap.ninePatchChunk, Rect(), null)
                                            holder.view.cl_bubble_container.getChildAt(index).background = npf
                                        } else {
                                            (holder.view.cl_bubble_container.getChildAt(index) as ImageView).setImageBitmap(bitmap)
                                        }
                                    }

                                })
                            }
                        }
                    }
                }
            }
        }
    }


    override fun onViewAttachedToWindow(holder: DressUpHolder) {
        super.onViewAttachedToWindow(holder)
        if (tabId == 1 && holder.view.svga_dressup_frame.drawable != null) {
            holder.view.svga_dressup_frame.startAnimation()
        }
    }
}