package com.ninexiu.sixninexiu.adapter.store

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.drawable.Drawable
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.bumptech.glide.request.target.CustomTarget
import com.bumptech.glide.request.transition.Transition
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.Props
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_my_props.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MyPropsAdapter(val context: Context, val propsList: MutableList<Props>) : RecyclerView.Adapter<MyPropsAdapter.MyPropsHolder>() {

    class MyPropsHolder(val view: View) : RecyclerView.ViewHolder(view)

    var onPropsClick: ((Props, Int) -> Unit)? = null

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MyPropsHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_my_props, parent, false)
        return MyPropsHolder(view)
    }

    override fun getItemCount(): Int {
        return propsList.size
    }

    @SuppressLint("CheckResult")
    override fun onBindViewHolder(holder: MyPropsHolder, position: Int) {
        holder.view.cl_props_container.layoutParams.width = ((NineShowApplication.getScreenWidth(context) - dp2px(context, 44)).toFloat() / 3).toInt()

        val props = propsList[position]

        holder.view.tv_prop_name.text = props.name

        if (props.stocktype == 4) {//VIP
            holder.view.iv_prop_cover.layoutParams.width = dp2px(context, 74)
            holder.view.iv_prop_cover.layoutParams.height = ConstraintLayout.LayoutParams.WRAP_CONTENT
        } else if (props.stocktype == 11) {//隐身卡
            holder.view.iv_prop_cover.layoutParams.width = dp2px(context, 74)
            holder.view.iv_prop_cover.layoutParams.height = ConstraintLayout.LayoutParams.WRAP_CONTENT
        } else if (props.stocktype == 12) {//靓号
            holder.view.iv_prop_cover.layoutParams.width = dp2px(context, 74)
            holder.view.iv_prop_cover.layoutParams.height = ConstraintLayout.LayoutParams.WRAP_CONTENT
            setupBeautyNumber(holder, props.gid)
        } else if (props.stocktype == 16 || props.stocktype == 18 || props.stocktype == 0) {//礼物
            holder.view.iv_prop_cover.layoutParams.width = dp2px(context, 60)
            holder.view.iv_prop_cover.layoutParams.height = dp2px(context, 60)
        } else {
            holder.view.iv_prop_cover.layoutParams.width = dp2px(context, 74)
            holder.view.iv_prop_cover.layoutParams.height = ConstraintLayout.LayoutParams.WRAP_CONTENT
        }
        holder.view.tv_beauty_number.setVisible(props.stocktype == 12)
        GlideUtils.loadNormalPic(context, props.imgurl, holder.view.iv_prop_cover, R.drawable.icon_gift_default)


        //背景设置
        if (!TextUtils.isEmpty(props.background)) {
            Glide.with(context).load(props.background).into(object : CustomTarget<Drawable>() {
                override fun onResourceReady(resource: Drawable, transition: Transition<in Drawable>?) {
                    holder.view.cl_prop_cover.background=resource
                }

                override fun onLoadCleared(placeholder: Drawable?) {

                }
            })
        } else {
            holder.view.cl_prop_cover.setBackgroundColor(ContextCompat.getColor(context, R.color.color_e9eaeb))
        }


        if (props.stocktype == 4) {
            holder.view.tv_prop_state.setVisible(props.status == 1)
            holder.view.tv_prop_state.text = "启用中"
        } else if (props.stocktype == 11 || props.stocktype == 12) {
            holder.view.tv_prop_state.setVisible(props.isactive == 1)
            holder.view.tv_prop_state.text = "启用中"
        }else{
            if (props.num>0){
                holder.view.tv_prop_state.setVisible(true)
                holder.view.tv_prop_state.text = "X${props.num}"
            }
        }

        if (props.is_fast_expiration == 1) {//即将到期
            holder.view.tv_prop_time_remain.setTextColor(ContextCompat.getColor(context, R.color.color_fd638a))
            holder.view.tv_prop_time_remain.text = "即将到期 ${props.deadLine}"
        } else {
            holder.view.tv_prop_time_remain.setTextColor(ContextCompat.getColor(context, R.color.color_999999))
            holder.view.tv_prop_time_remain.text = props.deadLine
        }

        holder.view.setOnClickListener {
            onPropsClick?.invoke(props, position)
        }

    }

    private fun setupBeautyNumber(holder: MyPropsHolder, gid: String?) {
        gid?.let {
            holder.view.tv_beauty_number.text = it
            when (it.length) {
                3 -> {
                    holder.view.tv_beauty_number.setTextColor(ContextCompat.getColor(context, R.color.color_ffda9e))
                }
                4 -> {
                    holder.view.tv_beauty_number.setTextColor(ContextCompat.getColor(context, R.color.color_333333))
                }
                5 -> {
                    holder.view.tv_beauty_number.setTextColor(ContextCompat.getColor(context, R.color.white))
                }
                6 -> {
                    holder.view.tv_beauty_number.setTextColor(ContextCompat.getColor(context, R.color.white))
                }
                else -> {
                    holder.view.tv_beauty_number.setTextColor(ContextCompat.getColor(context, R.color.white))
                }
            }
        }
    }
}