package com.ninexiu.sixninexiu.adapter.store

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.Account
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_store_beauty_number.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class StoreBeautyNumberAdapter(val context: Context, val isSearch: Boolean, val numberList: ArrayList<Account>) : RecyclerView.Adapter<StoreBeautyNumberAdapter.StoreBeautyNumberHolder>() {

    class StoreBeautyNumberHolder(val view: View) : RecyclerView.ViewHolder(view)

    var onNumberClick: ((number: Account, position: Int) -> Unit)? = null

    private var checkedIndex = -1

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): StoreBeautyNumberHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_store_beauty_number, parent, false)
        return StoreBeautyNumberHolder(view)
    }

    override fun getItemCount(): Int {
        return numberList.size
    }

    override fun onBindViewHolder(holder: StoreBeautyNumberHolder, position: Int) {
        val number = numberList[position]
        holder.view.cl_beauty_number_container.layoutParams.width = (NineShowApplication.getScreenWidth(context) - dp2px(context, 44)) / 3

        holder.view.tv_beauty_number.text = number.accountid
        holder.view.tv_beauty_number_good.setVisible(number.is_good == 1)

        if (number.bit == "3") {
            holder.view.tv_beauty_number_good.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_6c6c6c), ContextCompat.getColor(context, R.color.color_000000))
            holder.view.tv_beauty_number_good.setTextColor(ContextCompat.getColor(context, R.color.color_ffda9e))
        } else if (number.bit == "4") {
            holder.view.tv_beauty_number_good.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_fde1b4), ContextCompat.getColor(context, R.color.color_e1c389))
            holder.view.tv_beauty_number_good.setTextColor(ContextCompat.getColor(context, R.color.color_232222))
        } else if (number.bit == "5") {
            holder.view.tv_beauty_number_good.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_b474ff), ContextCompat.getColor(context, R.color.color_af2dff))
            holder.view.tv_beauty_number_good.setTextColor(ContextCompat.getColor(context, R.color.white))
        } else if (number.bit == "6") {
            holder.view.tv_beauty_number_good.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_ff7777), ContextCompat.getColor(context, R.color.color_ff2828))
            holder.view.tv_beauty_number_good.setTextColor(ContextCompat.getColor(context, R.color.white))
        } else if (number.bit == "7") {
            holder.view.tv_beauty_number_good.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_ff97ae), ContextCompat.getColor(context, R.color.color_ff567b))
            holder.view.tv_beauty_number_good.setTextColor(ContextCompat.getColor(context, R.color.white))
        }

        if (position == checkedIndex) {
            if (number.bit == "3") {
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 1
                holder.view.cl_beauty_number_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_d3aa52)
            } else if (number.bit == "4") {
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 1
                holder.view.cl_beauty_number_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_e1c389)
            } else if (number.bit == "5") {
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 1
                holder.view.cl_beauty_number_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_af2dff)
            } else if (number.bit == "6") {
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 1
                holder.view.cl_beauty_number_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_ff2828)
            } else if (number.bit == "7") {
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 1
                holder.view.cl_beauty_number_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_ff567b)
            }

        } else {
            if (isSearch) {//搜索有边框
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 1
                holder.view.cl_beauty_number_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_e2e2e2)
            } else {
                holder.view.cl_beauty_number_container.delegate.strokeWidth = 0
            }
        }

        holder.view.setOnClickListener {
            if (position != checkedIndex) {
                val lastCheck = checkedIndex
                checkedIndex = position
                if (lastCheck >= 0) {
                    notifyItemChanged(lastCheck)
                }
                notifyItemChanged(checkedIndex)
            }

            onNumberClick?.invoke(number, position)
        }
    }
}