package com.ninexiu.sixninexiu.adapter.store

import android.content.Context
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BuyTimeList
import com.ninexiu.sixninexiu.view.dp2px
import kotlinx.android.synthetic.main.item_store_price.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/19
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class StorePriceAdapter(val context: Context, var isStore: Boolean = false, val priceList: MutableList<BuyTimeList>, var onPriceClick: ((position: Int, buyPrice: BuyTimeList) -> Unit)? = null) : RecyclerView.Adapter<StorePriceAdapter.StorePriveHolder>() {

    var checkedPosition = 0

    class StorePriveHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): StorePriveHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_store_price, parent, false)
        return StorePriveHolder(view)
    }

    override fun getItemCount(): Int {
        return priceList.size
    }

    override fun onBindViewHolder(holder: StorePriveHolder, position: Int) {
        holder.view.cl_price_container.layoutParams.width = (NineShowApplication.getScreenWidth(context) - dp2px(context, 64)) / 3
        holder.view.setOnClickListener {
            if (checkedPosition!=position){
                onPriceClick?.invoke(position, priceList[position])
            }
            checkedPosition = position

        }
        if (isStore) {
            if (checkedPosition == position) {
                holder.view.cl_price_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_e9b769)
                holder.view.cl_price_container.delegate.strokeWidth = 1
                holder.view.cl_price_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_fff3e1)
                holder.view.tv_price.setTextColor(ContextCompat.getColor(context, R.color.color_bd8020))
                holder.view.tv_price_unit.setTextColor(ContextCompat.getColor(context, R.color.color_bd8020))
            } else {
                holder.view.cl_price_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_f3f2f1)
                holder.view.cl_price_container.delegate.strokeWidth = 1
                holder.view.cl_price_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_f3f2f1)
                holder.view.tv_price.setTextColor(ContextCompat.getColor(context, R.color.color_666666))
                holder.view.tv_price_unit.setTextColor(ContextCompat.getColor(context, R.color.color_bd8020))
            }
        } else {
            if (checkedPosition == position) {
                holder.view.cl_price_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_fd638a)
                holder.view.cl_price_container.delegate.strokeWidth = 1
                holder.view.cl_price_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_ffeff3)
                holder.view.tv_price.setTextColor(ContextCompat.getColor(context, R.color.color_fd638a))
                holder.view.tv_price_unit.setTextColor(ContextCompat.getColor(context, R.color.color_fd638a))
            } else {
                holder.view.cl_price_container.delegate.strokeColor = ContextCompat.getColor(context, R.color.color_f3f2f1)
                holder.view.cl_price_container.delegate.strokeWidth = 1
                holder.view.cl_price_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_f3f2f1)
                holder.view.tv_price.setTextColor(ContextCompat.getColor(context, R.color.color_666666))
                holder.view.tv_price_unit.setTextColor(ContextCompat.getColor(context, R.color.color_fd638a))
            }
        }

        if (TextUtils.isEmpty(priceList[position].labelstr)) {
            holder.view.tv_price_discount.visibility = View.GONE
        } else {
            holder.view.tv_price_discount.visibility = View.VISIBLE
            holder.view.tv_price_discount.text = priceList[position].labelstr
            //是否是回归
            if (priceList[position].is_old_user == 1) {
                holder.view.tv_price_discount.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_8f36fb), ContextCompat.getColor(context, R.color.color_ff2afa))
            } else {
                holder.view.tv_price_discount.delegate.setBackgroundColorStartEnd(ContextCompat.getColor(context, R.color.color_ff5d00), ContextCompat.getColor(context, R.color.color_ff9700))
            }
        }

        if (TextUtils.isEmpty(priceList[position].timeLimit)) {
            holder.view.tv_price_unit.text = "${priceList[position].type}个月"
        }else{
            holder.view.tv_price_unit.text = priceList[position].timeLimit
        }
        holder.view.tv_price.text = "${priceList[position].money}九币"
    }
}