package com.ninexiu.sixninexiu.adapter.store

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.StoreProps
import kotlinx.android.synthetic.main.item_store_prop.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/30
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class StorePropsAdapter(val context: Context, val propsList: MutableList<StoreProps>) : RecyclerView.Adapter<StorePropsAdapter.StorePropsHolder>() {
    class StorePropsHolder(val view: View) : RecyclerView.ViewHolder(view)

    var onPropClick: ((StoreProps, Int) -> Unit)? = null
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): StorePropsHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_store_prop, parent, false)
        return StorePropsHolder(view)
    }

    override fun getItemCount(): Int {
        return propsList.size
    }

    override fun onBindViewHolder(holder: StorePropsHolder, position: Int) {
        val props = propsList[position]
        if (!props.priceInfo.isNullOrEmpty()) {
            holder.view.tv_props_price.text = "${props.priceInfo[0].money}九币/月"
        }

        holder.view.setOnClickListener {
            onPropClick?.invoke(props,position)
        }
    }

}