package com.ninexiu.sixninexiu.adapter.store

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.VipPrivilege
import com.ninexiu.sixninexiu.view.dp2px
import kotlinx.android.synthetic.main.item_store_vip.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/18
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class StoreVipAdapter(val context: Context, val vipLevelList: MutableList<VipPrivilege>) : RecyclerView.Adapter<StoreVipAdapter.StoreVipHolder>() {

    class StoreVipHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): StoreVipHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_store_vip, parent, false)
        return StoreVipHolder(view)
    }

    override fun getItemCount(): Int {
        return vipLevelList.size * 20000
    }

    override fun onBindViewHolder(holder: StoreVipHolder, position: Int) {

        holder.view.iv_store_vip_level.setImageResource(
                when (vipLevelList[position % vipLevelList.size].gid) {
                    "800001" -> {
                        R.drawable.icon_store_vip_1
                    }
                    "800002" -> {
                        R.drawable.icon_store_vip_2
                    }
                    "800003" -> {
                        R.drawable.icon_store_vip_3
                    }
                    "800004" -> {
                        R.drawable.icon_store_vip_4
                    }
                    else -> {
                        0
                    }
                }
        )

    }
}