package com.ninexiu.sixninexiu.adapter.store

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.VipPrivilegeIcon
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.fragment.store.VipPrivilegeInfoDialog
import kotlinx.android.synthetic.main.item_vip_privilege.view.*

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/26
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class VipPrivilegeAdapter(val context: Context, val privileges: MutableList<VipPrivilegeIcon>) : RecyclerView.Adapter<VipPrivilegeAdapter.VipPrivilegeHolder>() {
    class VipPrivilegeHolder(val view: View) : RecyclerView.ViewHolder(view)

    var showNum: Int = 0
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): VipPrivilegeHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_vip_privilege, parent, false)
        return VipPrivilegeHolder(view)
    }

    override fun getItemCount(): Int {
        return privileges.size
    }

    override fun onBindViewHolder(holder: VipPrivilegeHolder, position: Int) {
        if (position <= (showNum - 1)) {
            holder.view.privilege_Tv.setTextColor(ContextCompat.getColor(context, R.color.color_614214))
            holder.view.setOnClickListener {
                privileges[position].info?.let { it1 -> VipPrivilegeInfoDialog.create(context, it1).show() }
            }
        } else {
            holder.view.privilege_Tv.setTextColor(ContextCompat.getColor(context, R.color.color_ada18c))
            holder.view.setOnClickListener(null)
        }
        GlideUtils.loadCirclePic(context, privileges[position].icon, holder.view.privilege_iv)
        holder.view.privilege_Tv.text = privileges[position].name
    }

}