package com.ninexiu.sixninexiu.adapter.topic

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.os.Parcelable
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.activity.TranslucentSubPageActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.Topic
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.fragment.topic.DynamicTopicDetailsFragment
import com.ninexiu.sixninexiu.fragment.topic.DynamicTopicListParentFragment
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_dynamic_topic_page.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/12
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicTopicPageAdapter(val context: Context, private val topicList: MutableList<Topic>) : RecyclerView.Adapter<DynamicTopicPageAdapter.DynamicTopicPageHolder>() {

    class DynamicTopicPageHolder(val view: View) : RecyclerView.ViewHolder(view)

    var onTabClick:((tabTopic:Topic)->Unit)?=null

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): DynamicTopicPageHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_dynamic_topic_page, parent, false)
        return DynamicTopicPageHolder(view)
    }

    override fun getItemCount(): Int {
        return topicList.size
    }

    override fun onBindViewHolder(holder: DynamicTopicPageHolder, position: Int) {
        holder.view.layoutParams.width = NineShowApplication.screenWidth / 2
        val topic = topicList[position]
        holder.view.tv_topic_name.text = topic.title
        holder.view.tv_topic_desc.text = topic.name
        holder.view.iv_topic_tip.setVisible(topic.is_activity == 1)
        GlideUtils.loadSimpleImgWithRoundCorner(context, topic.url, holder.view.iv_topic_cover, R.drawable.anthor_moren_item, dp2px(context, 8))

        holder.view.setOnClickListener {
            if (onTabClick != null) {
                onTabClick!!.invoke(topic)
            } else {
                if (topic.tab_id > 0) {
                    //跳列表
                    val intent = Intent(context, SubPageActivity::class.java)
                    intent.putExtra(SubPageActivity.CLASSFRAMENT, DynamicTopicListParentFragment::class.java)
                    val bundle = Bundle()
                    bundle.putInt(DynamicTopicListParentFragment.KEY_TOPIC_GROUP_ID, topic.tab_id)
                    intent.putExtra("bundle", bundle)
                    context.startActivity(intent)
                } else {
                    //跳详情
                    val intent = Intent(context, TranslucentSubPageActivity::class.java)
                    intent.putExtra(TranslucentSubPageActivity.CLASSFRAMENT, DynamicTopicDetailsFragment::class.java)
                    val bundle = Bundle()
                    bundle.putParcelable(DynamicTopicDetailsFragment.KEY_TOPIC, topic)
                    intent.putExtra("bundle", bundle)
                    context.startActivity(intent)
                }
            }
        }
    }
}