package com.ninexiu.sixninexiu.adapter.topic

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.Topic
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_topic_recommend.view.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/15
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class RecommendTopicAdapter(val context: Context, private val recommendTopics: List<Topic>) : RecyclerView.Adapter<RecommendTopicAdapter.TopicHistoryHolder>() {
    class TopicHistoryHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TopicHistoryHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_topic_recommend, parent, false)
        return TopicHistoryHolder(view)
    }

    override fun getItemCount(): Int {
        return recommendTopics.size
    }

    override fun onBindViewHolder(holder: TopicHistoryHolder, position: Int) {
        val topic = recommendTopics[position]
        holder.view.tv_topic_name.text = "#${topic.title}"
        if (topic.is_activity == 1) {
            holder.view.iv_topic_active.setVisible(true)
            holder.view.cl_topic_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_ffddf4)
            holder.view.tv_topic_name.setTextColor(ContextCompat.getColor(context, R.color.color_ff4fa1))
        } else {
            holder.view.iv_topic_active.setVisible(false)
            holder.view.cl_topic_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_f4f4f4)
            holder.view.tv_topic_name.setTextColor(ContextCompat.getColor(context, R.color.color_999999))
        }
        holder.view.setOnClickListener {
            onTopicClick?.invoke(topic)
        }
    }

    var onTopicClick: ((topic: Topic) -> Unit)? = null
}