package com.ninexiu.sixninexiu.adapter.topic

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.Topic
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_topic_history.view.*
import kotlinx.android.synthetic.main.item_topic_history.view.tv_topic_name

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/15
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class TopicHistoryAdapter(val context: Context, private val topicHistory: MutableList<Topic>?) : RecyclerView.Adapter<TopicHistoryAdapter.TopicHistoryHolder>() {
    class TopicHistoryHolder(val view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TopicHistoryHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_topic_history, parent, false)
        return TopicHistoryHolder(view)
    }

    override fun getItemCount(): Int {
        if (topicHistory == null) {
            return 0
        }
        return topicHistory.size
    }

    override fun onBindViewHolder(holder: TopicHistoryHolder, position: Int) {
        val topic=topicHistory!![position]
        holder.view.tv_topic_name.text = "#${topic.title}"
        if (topic.is_activity == 1) {
            holder.view.iv_topic_active.setVisible(true)
            holder.view.cl_topic_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_ffddf4)
            holder.view.tv_topic_name.setTextColor(ContextCompat.getColor(context, R.color.color_ff4fa1))
            holder.view.iv_topic_delete.setImageResource(R.drawable.icon_topic_history_delete_active)
        } else {
            holder.view.iv_topic_active.setVisible(false)
            holder.view.cl_topic_container.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_f4f4f4)
            holder.view.tv_topic_name.setTextColor(ContextCompat.getColor(context, R.color.color_999999))
            holder.view.iv_topic_delete.setImageResource(R.drawable.icon_topic_history_delete)
        }

        holder.view.setOnClickListener {
            onTopicClick?.invoke(topic)
        }

        holder.view.iv_topic_delete.setOnClickListener {
//            topicHistory.removeAt(position)
//            notifyItemRemoved(position)
            onTopicDelete?.invoke(holder.layoutPosition, topic)
        }
    }

    var onTopicClick: ((topic: Topic) -> Unit)? = null
    var onTopicDelete: ((position:Int,topic: Topic) -> Unit)? = null
}