package com.ninexiu.sixninexiu.adapter.viewholder

import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.view.View
import android.view.animation.AnimationUtils
import android.widget.ImageView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ToastUtils
import com.bumptech.glide.Glide
import com.bumptech.glide.Priority
import com.bumptech.glide.request.RequestOptions
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.loopj.android.http.BaseJsonHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.*
import com.ninexiu.sixninexiu.activity.friend.SelectFriendActivity
import com.ninexiu.sixninexiu.adapter.DynamicDataAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.audio.DynamicHelper
import com.ninexiu.sixninexiu.audio.FollowHelper
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.CommentResult
import com.ninexiu.sixninexiu.bean.Dynamic
import com.ninexiu.sixninexiu.bean.Topic
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.IM.TencentContans.CHAT_INFO
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.common.util.manager.RequestManager
import com.ninexiu.sixninexiu.common.util.manager.RequestManagerCallBack.CommentDataCallBack
import com.ninexiu.sixninexiu.common.util.manager.RequestManagerCallBack.RequestCodeMsgCallBack
import com.ninexiu.sixninexiu.fragment.topic.DynamicTopicDetailsFragment
import com.ninexiu.sixninexiu.login.LoginEntryActivity
import com.ninexiu.sixninexiu.values.EnterRoomValue
import com.ninexiu.sixninexiu.view.DynamicShareDialog
import com.ninexiu.sixninexiu.view.HeadBoxView
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.CurrencyDialog
import com.ninexiu.sixninexiu.view.popwindow.CommentSendPopWindow
import com.ninexiu.sixninexiu.view.popwindow.CommentSendPopWindow.ReplyCommentListener
import com.ninexiu.sixninexiu.view.setVisible
import com.opensource.svgaplayer.SVGADrawable
import com.opensource.svgaplayer.SVGAImageView
import com.tencent.imsdk.TIMConversationType
import com.tencent.qcloud.tim.uikit.modules.chat.base.ChatInfo
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.item_dynamic_content.view.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/09/05
 *     desc   :
 *     version: 1.0
 * </pre>
 */
abstract class BaseDynamicContentHolder : RecyclerView.ViewHolder {

    protected val view: View
    private var lineCount = 5

    constructor(view: View) : super(view) {
        this.view = view
        initVariableLayout()
    }

    abstract fun getVariableLayout(): Int

    private fun setVariableLayout(resId: Int) {
        if (view.item_dynamic_image_container.getChildCount() == 0) {
            View.inflate(view.context, resId, view.item_dynamic_image_container)
        }
        initVariableViews()
    }

    private fun initVariableLayout() {
        if (getVariableLayout() != 0) {
            setVariableLayout(getVariableLayout())
        }
    }

    abstract fun initVariableViews()

    /**
     * 公共数据设置
     */
    @SuppressLint("SetTextI18n")
    fun setupData(context: Context, currentTopic:Topic?, dynamicInfo: Dynamic, position: Int,
                  mOnClickCommentCallBack: DynamicDataAdapter.OnClickDynamicCallBack?) {
        // fun setupData(context: Context, dynamicInfo: Dynamic, position: Int, mSmileyParser: SmileyParser, mOnClickCommentCallBack: DynamicDataAdapter.OnClickDynamicCallBack?) {
        // 设置位置
        if (!TextUtils.isEmpty(dynamicInfo.address)) {
            view.item_dynamic_tv_address.setVisible(true)
            view.item_dynamic_tv_address.text = dynamicInfo.address
        } else {
            view.item_dynamic_tv_address.setVisible(false)
        }

        var beforeShow = false

        if (dynamicInfo.view_num <= 0) {
            beforeShow = false
            view.item_dynamic_tv_see.setVisible(false)
        } else {
            beforeShow = true
            view.item_dynamic_tv_see.setVisible(true)
            if(dynamicInfo.type == DynamicDataAdapter.TYPE_DYNAMIC_AUDIO || dynamicInfo.type == DynamicDataAdapter.TYPE_DYNAMIC_VIDEO) {
                view.item_dynamic_tv_see.text = "${DynamicHelper.formatViewNumber(dynamicInfo.view_num)}次播放"
            }else {
                view.item_dynamic_tv_see.text = "${DynamicHelper.formatViewNumber(dynamicInfo.view_num)}次浏览"
            }
        }

        if (dynamicInfo.fview_num <= 0) {
            view.item_dynamic_tv_fsee.setVisible(false)
        } else {
            view.item_dynamic_tv_fsee.setVisible(true)
            if(dynamicInfo.type == DynamicDataAdapter.TYPE_DYNAMIC_AUDIO || dynamicInfo.type == DynamicDataAdapter.TYPE_DYNAMIC_VIDEO) {
                if(beforeShow) {
                    view.item_dynamic_tv_fsee.text = " · ${DynamicHelper.formatViewNumber(dynamicInfo.fview_num)}次好友播放"
                }else {
                    view.item_dynamic_tv_fsee.text = "${DynamicHelper.formatViewNumber(dynamicInfo.fview_num)}次好友播放"
                }
            }else {
                if(beforeShow) {
                    view.item_dynamic_tv_fsee.text = " · ${DynamicHelper.formatViewNumber(dynamicInfo.fview_num)}次好友浏览"
                }else {
                    view.item_dynamic_tv_fsee.text = "${DynamicHelper.formatViewNumber(dynamicInfo.fview_num)}次好友浏览"
                }
            }
        }

        var head : View = view.findViewById(R.id.item_dynamic_iv_header)
        var headImg : HeadBoxView? = null
        if(head is ImageView) {
            headImg = HeadBoxView(context)
            headImg.bindHead(head)
        }else if(head is HeadBoxView) {
            headImg = head
        }

        //头像
        if (dynamicInfo.info != null) {
            GlideUtils.loadCirclePic(context, dynamicInfo.info.headimage, headImg?.iv_head)
            headImg?.setScale(1.4f)
            headImg?.loadBoxImage(dynamicInfo.info.headframe)
        } else {
            GlideUtils.loadCirclePic(context, "", headImg?.iv_head)
        }

        view.item_dynamic_tv_nickname.text = dynamicInfo.info.nickname

        //点击头像
        headImg?.iv_head?.setOnClickListener(View.OnClickListener {
//            if (isEnterAnchorPagehome) {
            if (NineShowApplication.mUserBase == null) {
                Utils.startLogin(context as Activity,
                        context.resources.getString(R.string.live_login_audience))
                return@OnClickListener
            }
            if (dynamicInfo.isplay == 1) {
                dynamicInfo.info.rid=dynamicInfo.rid.toString()
                dynamicInfo.info.enterFrom=EnterRoomValue.ENTER_ROOM_DYNAMIC
                dynamicInfo.info.fromSoucre ="发现-推荐"
                Utils.openLiveRoomObj(context,dynamicInfo.info)
            } else {
                dynamicInfo?.dynamicid?.let {
                    FollowHelper.setDynamicId(it.toString())
                }

                // 跳转到主播个人主页
                PersonalInforActivity.start(context, true, dynamicInfo.info.uid)
            }
        })


        //发送时间
        view.item_dynamic_tv_sendtime.text = TimeUtil.getDescriptionTimeFromTimestamp(dynamicInfo.addtime)

        //正在直播
        if (dynamicInfo.isplay == 1 || (dynamicInfo.info != null && dynamicInfo.info.at_room != null && dynamicInfo.info.at_room > 0L)) {
            val options = RequestOptions()
                    .priority(Priority.NORMAL).centerCrop()
            Glide.with(context).load(R.drawable.gif_dynamic_liveing).apply(options).into(view.iv_dynamic_liveing_gif)
            view.tv_dynamic_liveing.visibility = View.VISIBLE
            view.iv_dynamic_liveing_gif.visibility = View.VISIBLE
        } else {
            view.tv_dynamic_liveing.visibility = View.GONE
            view.iv_dynamic_liveing_gif.visibility = View.GONE
        }

        // 房间中跳转 : 主播跳转到直播间，普通用户跳转到所在房间
        view.tv_dynamic_liveing.setOnClickListener {
            if (NineShowApplication.mUserBase == null) {
                Utils.startLogin(context as Activity,
                        context.resources.getString(R.string.live_login_audience))
                return@setOnClickListener
            }

            if(dynamicInfo.info != null && dynamicInfo.isplay == 1) {
                dynamicInfo.info.rid=dynamicInfo.rid.toString()
                dynamicInfo.info.enterFrom=EnterRoomValue.ENTER_ROOM_DYNAMIC
                Utils.openLiveRoomObj(context,dynamicInfo.info)
            }else if(dynamicInfo.info != null && dynamicInfo.info.at_room != null && dynamicInfo.info.at_room > 0L) {
                Utils.openLiveRoom(context, 0, dynamicInfo.info.at_room.toString(), 0, "")
            }
        }

        // 认证
        view.item_dynamic_iv_vip.visibility = if (dynamicInfo.headimgAuth == 1) View.VISIBLE else View.GONE

        // 置顶
        if (dynamicInfo.istop == 1) {
            view.item_dynamic_iv_top.visibility = View.VISIBLE
            // view.item_dynamic_tv_sendtime?.visibility = View.GONE
            lineCount = 10
        } else {
            view.item_dynamic_iv_top.visibility = View.GONE
            // view.item_dynamic_tv_sendtime?.visibility = View.VISIBLE
            lineCount = 5
        }

        if(dynamicInfo.age.toInt()<=0 && (!TextUtils.equals(dynamicInfo.sex, "1") && !TextUtils.equals(dynamicInfo.sex, "2"))) {
            view.llSexAge.setVisible(false)
        }else {
            view.llSexAge.setVisible(true)
        }

        // 年龄性别
        if (dynamicInfo.age.toInt() > 0) {
            view.item_dynamic_tv_age.visibility = View.VISIBLE
            view.item_dynamic_tv_age.text = dynamicInfo.age
        } else {
            view.item_dynamic_tv_age.visibility = View.GONE
        }
        if (TextUtils.equals(dynamicInfo.sex, "1")) {
            view.ivIconSex?.visibility = View.VISIBLE
            view.ivIconSex?.setImageResource(R.drawable.icon_personal_man)
            view.llSexAge?.background = ContextCompat.getDrawable(context, R.drawable.shape_gradient_man)
            view.item_dynamic_tv_age?.setTextColor(ContextCompat.getColor(context,R.color.color_4785ff))
        } else if (TextUtils.equals(dynamicInfo.sex, "2")) {
            view.ivIconSex?.visibility = View.VISIBLE
            view.ivIconSex?.setImageResource(R.drawable.icon_personal_woman)
            view.llSexAge?.background = ContextCompat.getDrawable(context, R.drawable.shape_gradient_woman)
            view.item_dynamic_tv_age?.setTextColor(ContextCompat.getColor(context,R.color.color_ff3366))
        } else {
            view.ivIconSex?.visibility = View.GONE
            view.llSexAge?.background = ContextCompat.getDrawable(context, R.drawable.shape_gradient_no)
            view.item_dynamic_tv_age?.setTextColor(ContextCompat.getColor(context,R.color.color_333333))
        }

        //点赞
        if (dynamicInfo.ispraise == 1) {
            val likeDrawable = ContextCompat.getDrawable(context, R.drawable.ic_dynamic_like_selected)
            likeDrawable?.setBounds(0, 0, likeDrawable.minimumWidth, likeDrawable.minimumHeight)
            view.item_dynamic_tv_like_number.setCompoundDrawables(likeDrawable, null, null, null)
        } else {
            val likeDrawable = ContextCompat.getDrawable(context, R.drawable.ic_dynamic_like_normal)
            likeDrawable?.setBounds(0, 0, likeDrawable.minimumWidth, likeDrawable.minimumHeight)
            view.item_dynamic_tv_like_number.setCompoundDrawables(likeDrawable, null, null, null)
        }

        if (dynamicInfo.upnum > 0) {
            view.item_dynamic_tv_like_number.text = dynamicInfo.upnum.toString()
        } else {
            view.item_dynamic_tv_like_number.text = "喜欢"
        }

        view.item_dynamic_tv_like_number.setOnClickListener(View.OnClickListener {
            if (Utils.isFastDoubleClick()) {
                return@OnClickListener
            }
            if (!NineShowApplication.mAccountManager.isUserLogin) {
                Utils.startLogin(context as Activity,
                        NineShowApplication.applicationContext.getString(R.string.login_dynam))
                return@OnClickListener
            }
            if (dynamicInfo.dynamicid == -1L || dynamicInfo.status == "0") {
                ToastUtils.showShort("动态审核中，无法操作！")
                return@OnClickListener
            }
            if (dynamicInfo.ispraise == 0) {
                doPraiseTask(context, dynamicInfo)
            }else {
                ToastUtils.showShort("您已经喜欢过了")
            }
        })

        //评论
        if (dynamicInfo.replynum > 0) {
            view.item_dynamic_tv_comment_num.text = dynamicInfo.replynum.toString()
        } else {
            view.item_dynamic_tv_comment_num.text = "评论"
        }

        view.item_dynamic_tv_comment_num.setOnClickListener(View.OnClickListener {
            if (NineShowApplication.mUserBase == null) {
                Utils.startLogin(context as Activity,
                        context.resources.getString(R.string.live_login_audience))
                return@OnClickListener
            }
            if (Utils.isNotClickable()) {
                return@OnClickListener
            }
            if (dynamicInfo.dynamicid == -1L || dynamicInfo.status == "0") {
                ToastUtils.showShort("动态审核中，无法操作！")
                return@OnClickListener
            }
            if (dynamicListener != null) {
                dynamicListener?.onDynamicChange(dynamicInfo)
            }
            if (dynamicInfo.replynum == 0L) {
                sendPopWindow(context, view.item_dynamic_tv_comment_num, dynamicInfo)
            } else {
                if (mOnClickCommentCallBack != null && dynamicInfo.info != null) {
                    mOnClickCommentCallBack.onCommentClick(position, dynamicInfo)
                }
            }
        })

        if(dynamicInfo == null ||  dynamicInfo.dynamicid == 0L || dynamicInfo.dynamicid == -1L) {
            view.iv_dynamic_more.setVisible(false)
        }else {
            view.iv_dynamic_more.setVisible(true)
        }

        // 更多
        view.iv_dynamic_more.setOnClickListener {
            // 聊天
            if (NineShowApplication.mUserBase == null) {
                Utils.startLogin(context as Activity,
                        context.resources.getString(R.string.live_login_audience))
                return@setOnClickListener
            }
            DynamicShareDialog(context,dynamicInfo.info.uid) { type ->
                dynamicShare(context,dynamicInfo, type,mOnClickCommentCallBack)
            }.show()
        }

        // 打招呼自己不可见
        if(TextUtils.equals(NineShowApplication.mUserBase?.uid?.toString(),dynamicInfo.info.uid)) {
            view.item_dynamic_iv_hello.setViewVisible(false)
        }else {
            view.item_dynamic_iv_hello.setViewVisible(true)
        }

        //打招呼
        view.item_dynamic_iv_hello.setOnClickListener {
            if (NineShowApplication.mUserBase == null) {
                Utils.startLogin(context as Activity,
                        context.resources.getString(R.string.live_login_audience))
                return@setOnClickListener
            }
            sendGreetChat(dynamicInfo.info,view.item_dynamic_iv_hello,context)
            StatisticsUtil.onEvent(StatisticsEventID.UM_DYNAMIC_HELLO)
        }

        if (!TextUtils.isEmpty(dynamicInfo.content)) {// 有文本
            view.item_dynamic_tv_content.visibility = View.VISIBLE
//            val builder = SpannableStringBuilder(dynamicInfo.content)
//            view.item_dynamic_tv_content.text = mSmileyParser.addSmileySpans1(builder)
            view.item_dynamic_tv_content.buildClickableTopicText(dynamicInfo.content, currentTopic, dynamicInfo.topicTitleArr)

            view.item_dynamic_tv_content.post {
                if (dynamicInfo.lines == 0) {
                    dynamicInfo.lines = view.item_dynamic_tv_content.lineCount
                }
                if (view.item_dynamic_tv_content.lineCount > lineCount || dynamicInfo.lines > lineCount) {
                    view.item_dynamic_tv_more_content.visibility = View.VISIBLE
                    if (dynamicInfo.isUnfold) {
                        view.item_dynamic_tv_content.maxLines = 50
                        view.item_dynamic_tv_more_content.text = "收起"
                    } else {
                        view.item_dynamic_tv_content.maxLines = lineCount
                        view.item_dynamic_tv_more_content.text = "展开"
                    }
                    view.item_dynamic_tv_more_content.setOnClickListener {
                        if (!dynamicInfo.isUnfold) {
                            dynamicInfo.isUnfold = true
                            view.item_dynamic_tv_content.maxLines = 50
                            view.item_dynamic_tv_more_content.text = "收起"
                        } else {
                            dynamicInfo.isUnfold = false
                            view.item_dynamic_tv_content.maxLines = lineCount
                            view.item_dynamic_tv_more_content.text = "展开"
                        }
                    }
                } else {
                    view.item_dynamic_tv_more_content.visibility = View.GONE
                }
            }
        }else {
            view.item_dynamic_tv_content.setVisible(false)
            view.item_dynamic_tv_more_content.setVisible(false)
        }

        view.setOnClickListener {
            if (Utils.isNotClickable()) {
                return@setOnClickListener
            }
            if (dynamicInfo.topicTitleArr.isNullOrEmpty()) {
                return@setOnClickListener
            }
            if (currentTopic!=null && dynamicInfo.topicTitleArr.last() == currentTopic){
                return@setOnClickListener
            }
            val intent = Intent(context, TranslucentSubPageActivity::class.java)
            intent.putExtra(TranslucentSubPageActivity.CLASSFRAMENT, DynamicTopicDetailsFragment::class.java)
            val bundle = Bundle()
            bundle.putParcelable(DynamicTopicDetailsFragment.KEY_TOPIC, dynamicInfo.topicTitleArr.last())
            intent.putExtra("bundle", bundle)
            context.startActivity(intent)
        }


        //// 由子类设置指定类型的views
        layoutVariableViews(context, dynamicInfo, position)


    }

    abstract fun layoutVariableViews(context: Context, dynamicInfo: Dynamic, position: Int)

    // 动态分享
    private fun dynamicShare(context: Context,dynamicInfo: Dynamic, type: String,mOnClickCommentCallBack: DynamicDataAdapter.OnClickDynamicCallBack?) {
        // todo : 待添加
        when (type) {
            ShareUtils.TYPE_WEIXIN_FREND -> {    // 微信

            }
            ShareUtils.TYPE_WEIXIN_CIRCLE -> {  // 朋友圈

            }
            ShareUtils.TYPE_WEIBO -> {  // 微博

            }
            ShareUtils.TYPE_QQ_FRENDS -> {  // QQ

            }
            ShareUtils.TYPE_NINESHOW -> {   // 九秀好友
                if(dynamicInfo.dynamicid == 0L || dynamicInfo.dynamicid == -1L) {
                    MyToast.showShort("动态审核中,无法操作！")
                    return
                }

                if(dynamicInfo.type == DynamicDataAdapter.TYPE_DYNAMIC_SYSTEM) {
                    MyToast.showShort("系统动态,无法分享")
                    return
                }
                val bundle = Bundle()
                bundle.putSerializable(Constants.DATA_BEAN, dynamicInfo)
                SelectFriendActivity.startActivity(context,SelectFriendActivity.FROM_DYNAMIC,bundle)
            }
            DynamicShareDialog.TYPE_DYNAMIC_JUBAO -> {  // 举报
                ReportActivity.start(context,true,dynamicInfo.info.rid,dynamicInfo.info.uid)
            }
            DynamicShareDialog.TYPE_DYNAMIC_BLACK -> {  // 黑名单
                MBOperationManager.create().showPushdialog(context as Activity,true, Utils.parseLong(dynamicInfo.info.uid))
            }
            DynamicShareDialog.TYPE_DYNAMIC_DELETE -> {  // 删除
                if (mOnClickCommentCallBack != null && dynamicInfo.info != null) {
                    mOnClickCommentCallBack.onDeleteClick(layoutPosition, dynamicInfo)
                }
            }
        }
    }


    private fun startChatFloat(anchorInfo:AnchorInfo,view: View) {
        val bundle = Bundle()
        bundle.putInt("chat_type", 3)
        val chatInfo = ChatInfo()
        chatInfo.type = TIMConversationType.C2C
        chatInfo.id = anchorInfo.uid
        chatInfo.chatName = anchorInfo.nickname
        bundle.putSerializable(CHAT_INFO, chatInfo)
//
//        val mMBContentFloatChatManager =  MBContentFloatChatManager(view.context,
//        mVsContentFloatTop, this, this.getActivity().getSupportFragmentManager());
//        mMBContentFloatChatManager.setLandSpace(mIsLandScape);

        HelloChatActivity.start(view.context,bundle)
    }


    /**
     * 打招呼私聊
     */
    private fun sendGreetChat(anchorInfo:AnchorInfo,view: View,context: Context) {
        RequestManager.create().sendGreetChat(anchorInfo.uid, RequestCodeMsgCallBack { code, message ->
            if (code == 200) {
                startChatFloat(anchorInfo, view)
            }else if(code == 600){
                CurrencyDialog.create(context)
                    .setTitleText(message)
                    .setOnClickCallback { type ->
                        if (type == BaseDialog.SELECT_SECOND) {
                            startChatFloat(anchorInfo, view)
                        }
                    }
            } else if (code == 601) {
                SayHelloHalfActivity.start(context , anchorInfo)
            } else {
                if (!TextUtils.isEmpty(message)) {
                    MyToast.MakeToast(message)
                }
            }
        })
    }


    /**
     * 点赞接口
     */
    private fun doPraiseTask(context: Context, dynamic: Dynamic) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        // 请求链接不进行转码
        asyncHttpClient.setURLEncodingEnabled(false)
        val params = NSRequestParams()
        params.put("subid", dynamic.dynamicid)
        if (NineShowApplication.mUserBase != null) {
            params.put("token", NineShowApplication.mUserBase!!.token)
        }
        StatisticsUtil.onEvent(StatisticsEventID.UM_DYNAMIC_LIKE)
        asyncHttpClient[Constants.DYNAMIC_PRAISE_URL, params, object : BaseJsonHttpResponseHandler<CommentResult?>() {
            override fun onStart() {
                super.onStart()
            }

            override fun parseResponse(rawJsonData: String, isFailure: Boolean): CommentResult {
                val builder = GsonBuilder()
                val gson = builder.create()
                var baseResultInfo: CommentResult? = null
                baseResultInfo = try {
                    gson.fromJson(rawJsonData, CommentResult::class.java)
                } catch (e: JsonSyntaxException) {
                    e.printStackTrace()
                    null
                }
                return baseResultInfo!!
            }

            override fun onSuccess(statusCode: Int, headers: Array<out Header>?, rawJsonResponse: String?, response: CommentResult?) {
                if (response != null && 200 == response.code) {
                    dynamic.ispraise = 1
                    dynamic.upnum = dynamic.upnum + 1
                    view.item_dynamic_tv_like_number.text = dynamic.upnum.toString()

                    val likeDrawable = ContextCompat.getDrawable(context, R.drawable.ic_dynamic_like_selected)
                    likeDrawable?.setBounds(0, 0, likeDrawable.minimumWidth, likeDrawable.minimumHeight)
                    view.item_dynamic_tv_like_number.setCompoundDrawables(likeDrawable, null, null, null)

                    val animation = AnimationUtils.loadAnimation(context, R.anim.praise_scale_shake)
                    view.item_dynamic_tv_like_number.startAnimation(animation)
                    MyToast.MakeToast("喜欢成功")
                } else {
                    if (response != null) {
                        MyToast.MakeToast(context,response.message)
                    }
                }
            }

            override fun onFailure(statusCode: Int, headers: Array<out Header>?, throwable: Throwable?, rawJsonData: String?, errorResponse: CommentResult?) {
            }
        }]
    }

    fun startSvgAnimation(view : View){
        val svgImg : View? = view.findViewById(R.id.iv_head_box)
        if(svgImg != null && svgImg is SVGAImageView &&  svgImg.drawable != null &&  svgImg.drawable is SVGADrawable) {
            svgImg.startAnimation()
        }
    }


    /**
     * 发送评论 PopWindow
     */
    private fun sendPopWindow(context: Context, view: View, dynamic: Dynamic?) {
        if (dynamic == null) {
            return
        }
        val commentSendPopWindow = CommentSendPopWindow(context as Activity, false, null, null)
        commentSendPopWindow.showView(view)
        commentSendPopWindow.setReplyCommentListener(object : ReplyCommentListener {
            override fun replyComment(content: String, nickname: String?) {}
            override fun replyComment(content: String) {
                sendComment(content, dynamic)
            }
        })
    }


    /**
     * 发表评论
     */
    private fun sendComment(content: String, dynamic: Dynamic) {
        if (TextUtils.isEmpty(content)) {
            return
        }
        RequestManager.create().replyComment(0, dynamic.dynamicid, null, content,
                CommentDataCallBack {
                    if (dynamic.info == null) {
                        return@CommentDataCallBack
                    }
                    val bundle = Bundle()
                    bundle.putBoolean("isComment", true)
                    bundle.putString("uid", dynamic.info.uid)
                    AppBroadcastHelper.getInstance()
                            .sendBroadcast(NSReceiverAction.DYNAMIC_COMMENT, NSDataBroadcast.TYPE_OPERATION_DEFAULT, bundle)
                })
    }

    private var scaleXAnim: ObjectAnimator? = null
    private var scaleYAnim: ObjectAnimator? = null
    private var alphaAnim: ObjectAnimator? = null
    private var animSet: AnimatorSet? = null

    protected var dynamicListener: DynamicListener? = null
    fun setOnDynamicChangeListener(dynamicListener: DynamicListener?) {
        this.dynamicListener = dynamicListener
    }

    interface DynamicListener {
        fun onDynamicChange(dynamicInfo: Dynamic)
    }

}