package com.ninexiu.sixninexiu.adapter.viewholder

import android.content.Context
import android.view.View
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.Dynamic
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_dynamic_audio.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicAudioHolder(view: View) : BaseDynamicContentHolder(view) {
    override fun getVariableLayout() = R.layout.item_dynamic_audio

    override fun initVariableViews() {
    }

    override fun layoutVariableViews(context: Context, dynamicInfo: Dynamic, position: Int) {
        if(dynamicInfo.voice_url.isNullOrBlank()) {
            view.audioItemView.setVisible(false)
        }else {
            view.audioItemView.setVisible(true)
            view.audioItemView.setAudioItemSource(dynamicInfo.voice_url,dynamicInfo.voice_duration)
        }
        view.audioItemView.audioPlayStatus = {isPlay->
            // 记录item的播放状态并回调，借此更改数据,再由数据驱动item的ui
            currentAudioPlayPos?.invoke(dynamicInfo,isPlay,position)
        }

        // 这是为了音频播放时候的item复用，外层数据控制item的ui
        if(!dynamicInfo.isPlayAudio) {
            view.audioItemView.reset()
        }
    }

    var currentAudioPlayPos : ((Dynamic,Boolean,Int) -> Unit)? = null
}