package com.ninexiu.sixninexiu.adapter.viewholder

import android.app.Activity
import android.content.Context
import android.os.Bundle
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.RelativeLayout
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.MainTabActivity
import com.ninexiu.sixninexiu.activity.PersonalInforActivity
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.Dynamic
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_dynamic_image.view.*
import java.util.*


/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/09/05
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicImageHolder(view: View) : BaseDynamicContentHolder(view) {
    override fun getVariableLayout(): Int {
        return R.layout.item_dynamic_image
    }

    override fun initVariableViews() {

    }

    override fun layoutVariableViews(context: Context, dynamicInfo: Dynamic, position: Int) {
        NSLog.e("设置图片动态内容")
        if (dynamicInfo.photo.isNullOrEmpty()){
            view.item_dynamic_images.setVisible(false)
        }else {
            view.item_dynamic_images.setVisible(true)
            view.item_dynamic_images.layoutParams.width = ScreenUtils.getScreenWidth(context) - ConvertUtils.dp2px(32f)
            view.item_dynamic_images.setDynamicPhotoEntities(dynamicInfo.photo, true)

            view.item_dynamic_images.setAsivClickListener { pos, url, imageViews, isVideo ->
                if (dynamicListener != null) {
                    (dynamicListener as ImageDynamicListener).onDynamicImageClick(pos, url, imageViews, isVideo)
                }
            }
        }
    }


    interface ImageDynamicListener:DynamicListener{
        fun onDynamicImageClick(pos:Int, url:String, imageViews:ArrayList<ImageView>, isVideo:Boolean)
    }

}