package com.ninexiu.sixninexiu.adapter.viewholder

import android.content.Context
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.style.ImageSpan
import android.view.View
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.Dynamic
import com.ninexiu.sixninexiu.bean.DynamicSystemMsg
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.VerticalImageSpan
import kotlinx.android.synthetic.main.item_dynamic_content.view.*
import kotlinx.android.synthetic.main.item_dynamic_system.view.*


/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/09/05
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicSystemHolder(view: View) : BaseDynamicContentHolder(view) {
    override fun getVariableLayout(): Int {
        return R.layout.item_dynamic_system
    }

    override fun initVariableViews() {

    }

    override fun layoutVariableViews(context: Context, dynamicInfo: Dynamic, position: Int) {

        view.item_dynamic_tv_content.visibility=View.GONE

        val builder = GsonBuilder()
        val gson = builder.create()
        var resultInfo: DynamicSystemMsg? = null
        try {
            resultInfo = gson.fromJson(dynamicInfo.content, DynamicSystemMsg::class.java)
        } catch (e: JsonSyntaxException) {
            e.printStackTrace()
        }
        if (resultInfo != null) {
            if (resultInfo.type == 1) { // 主播升级
                if (view.iv_dynamic_anchor_icon.getTag() == null
                        || view.iv_dynamic_anchor_icon.getTag() != dynamicInfo.getInfo().getHeadimage()) {
                    GlideUtils.loadCirclePic(context, dynamicInfo.getInfo().getHeadimage(), view.iv_dynamic_anchor_icon)
                    view.iv_dynamic_anchor_icon.setTag(dynamicInfo.getInfo().getHeadimage())
                    view.iv_system_tag.setImageResource(R.drawable.system_msg_leveup)
                    val oldChar = resultInfo.level.toString() + ""
                    val repContent = resultInfo.content.replace(oldChar, " $oldChar")
                    val startLevel = repContent.indexOf(oldChar)
                    val bder = SpannableStringBuilder(repContent)
                    val drawable = Utils.getHostLevelDrawable(resultInfo.level)
                    bder.setSpan(VerticalImageSpan(context, drawable, ImageSpan.ALIGN_BOTTOM),
                            startLevel, repContent.length,
                            Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                    view.tv_dynamic_text.setText(bder)
                }
            } else if (resultInfo.type == 2) { // 守护
                if (view.iv_dynamic_anchor_icon.getTag() == null
                        || view.iv_dynamic_anchor_icon.getTag() != dynamicInfo.getInfo().getHeadimage()) {
                    GlideUtils.loadCirclePic(context, dynamicInfo.getInfo().getHeadimage(), view.iv_dynamic_anchor_icon)
                    view.iv_system_tag.setImageResource(R.drawable.system_msg_guard)
                    view.tv_dynamic_text.setText(resultInfo.content)
                }
            } else {
                view.tv_dynamic_text.setText(resultInfo.content)
            }
        } else {
            //                holdview.ijkPlayer.setVisibility(View.GONE);
            view.iv_system_tag.visibility = View.GONE
            view.iv_dynamic_anchor_icon.visibility = View.GONE
            view.tv_dynamic_text.setText("")
        }

    }
}