package com.ninexiu.sixninexiu.adapter.viewholder

import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager.widget.ViewPager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.topic.DynamicTopicPageAdapter
import com.ninexiu.sixninexiu.adapter.FacePagerAdapter
import com.ninexiu.sixninexiu.bean.Topic
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.NSLogger
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_dynamic_topic.view.*
import kotlinx.android.synthetic.main.page_dynamic.view.*
import kotlin.math.min

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/12
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicTopicHolder(val view: View) : RecyclerView.ViewHolder(view) {
    private var scrollState = ViewPager.SCROLL_STATE_IDLE
    fun setUpData(context: Context, topicList: MutableList<Topic>) {
        val views = mutableListOf<View>()
        var tempTopicList: MutableList<Topic>? = null
        for ((index, topic) in topicList.withIndex()) {
            if (index%4==0){
                tempTopicList= mutableListOf()
                val pageView = LayoutInflater.from(context).inflate(R.layout.page_dynamic, view.vp_dynamic_topic, false)
                pageView.rv_dynamic_topic_page.layoutManager = GridLayoutManager(context, 2, GridLayoutManager.VERTICAL, false)
                pageView.rv_dynamic_topic_page.adapter = DynamicTopicPageAdapter(context, tempTopicList)
                views.add(pageView)
            }
            tempTopicList?.add(topic)

        }
        view.vp_dynamic_topic.adapter = FacePagerAdapter(views)
        if (views.isNullOrEmpty() || views.size<=1){
            view.view_index.setVisible(false)
        }else{
            view.view_index.setVisible(true)
            view.view_index.max=views.size
            view.view_index.setSelectIndex(0)
        }

        view.vp_dynamic_topic.setOnPageChangeListener(object :ViewPager.OnPageChangeListener{
            override fun onPageScrollStateChanged(state: Int) {
                scrollState=state
            }

            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
                if (scrollState == ViewPager.SCROLL_STATE_DRAGGING) {
                    view.view_index.updateIndexMove(positionOffset)
                }
            }

            override fun onPageSelected(position: Int) {
                view.view_index.setSelectIndex(position)
            }

        })
    }
}