package com.ninexiu.sixninexiu.adapter.viewholder

import android.content.Context
import android.view.View
import com.blankj.utilcode.util.ConvertUtils
import com.blankj.utilcode.util.ToastUtils
import com.ijkplayer.widget.media.IjkVideoViewNew
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.VideoShowActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.audio.DynamicHelper
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.Dynamic
import com.ninexiu.sixninexiu.bean.DynamicPhotoInfo
import com.ninexiu.sixninexiu.bean.VideoRoomBean.VideoInfo
import com.ninexiu.sixninexiu.common.util.AnimatorUtils
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.item_dynamic_video.view.*
import java.util.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/09/05
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicVideoHolder(view: View) : BaseDynamicContentHolder(view) {

    override fun getVariableLayout(): Int {
        return R.layout.item_dynamic_video
    }

    override fun initVariableViews() {

    }

    override fun layoutVariableViews(context: Context, dynamicInfo: Dynamic, position: Int) {
        if (dynamicInfo.shortvideo != null) {
            view.item_dynamic_iv_video_cover.setVisible(true)
            view.item_dynamic_tv_video_time.setVisible(true)
            view.item_dynamic_video_container.setVisible(true)
            //如果不为空代表是短视频动态
            view.item_dynamic_tv_video_time.setText(Utils.getPKToTime(Utils.parseDouble(dynamicInfo.shortvideo.duration).toInt()))
            val sttingpoto: MutableList<DynamicPhotoInfo> = ArrayList()
            val dynamicPhotoInfo = DynamicPhotoInfo()
            dynamicPhotoInfo.photothumburl = dynamicInfo.shortvideo.videoImage
            dynamicPhotoInfo.video = true
            dynamicPhotoInfo.videoid = dynamicInfo.shortvideo.videoid
            dynamicPhotoInfo.videoUrl = dynamicInfo.shortvideo.videoUrl
            sttingpoto.add(dynamicPhotoInfo)
            dynamicInfo.photo = sttingpoto
            if (dynamicInfo.photo != null && dynamicInfo.photo.isNotEmpty()) {
                GlideUtils.loadSimpleImgWithRoundCorner(context, dynamicInfo.photo[0].photothumburl, view.item_dynamic_iv_video_cover, R.drawable.anthor_moren, ConvertUtils.dp2px(6f))
            }
            view.item_dynamic_video_container.setOnClickListener {
                ijkVideoDispose(context,dynamicInfo)
            }
        }else{
            view.item_dynamic_iv_video_cover.setVisible(false)
            view.item_dynamic_tv_video_time.setVisible(false)
            view.item_dynamic_video_container.setVisible(false)
        }

//        AnimatorUtils.startRotateAnim(view.item_dynamic_iv_roll, 2000)

    }

    private fun ijkVideoDispose(context: Context, dynamic: Dynamic?) {
        if (dynamic == null) {
            ToastUtils.showShort("未获取到视频信息，请刷新后重试！")
            return
        }

        // 存储动态数据
        if(dynamic.dynamicid != 0L) {
            DynamicHelper.addElement(dynamic.dynamicid)
        }

        val strClass: String = context.toString().substring(context.toString().lastIndexOf(".") + 1, context.toString().indexOf("@"))
        if (strClass != "SubPageActivity" && dynamic.shortvideo != null) {  //判断如果是个人资料页 则直接跳转到视频播放页
            val videoInfo = VideoInfo()
            videoInfo.videoid = dynamic.shortvideo.videoid.toInt()
            videoInfo.videourl = dynamic.shortvideo.videoUrl
            videoInfo.uid = dynamic.info?.uid?.toInt() ?: -1
            videoInfo.headimage = dynamic.info?.headimage

            val videoInfos = ArrayList<VideoInfo>()
            videoInfos.add(videoInfo)
            VideoShowActivity.start(context, "0", 4, videoInfos)
        }
    }

}