package com.ninexiu.sixninexiu.audio

import android.animation.ObjectAnimator
import android.animation.ValueAnimator
import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.animation.*
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.view_dynamic_say_hello.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/04/01
 *     desc   : 打招呼
 *     version: 1.0
 * </pre>
 */
class DynamicSayHelloView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_dynamic_say_hello, this)
    }


    override fun onAttachedToWindow() {
        super.onAttachedToWindow()
        post {
            startAnimationShake()
        }
    }

    var animator: ObjectAnimator? = null
    private fun startAnimationShake() {
        if (ivSayHello != null) {
            animator?.cancel()
            if (animator == null) {
                animator = ObjectAnimator.ofFloat(ivSayHello, "rotation", 0f, 4f, -8f, -8f, 0f, 0f, 0f, 0f)
                animator?.interpolator = BounceInterpolator()
                animator?.duration = 1500
                animator?.repeatCount = ValueAnimator.INFINITE
                animator?.repeatMode = ValueAnimator.RESTART
            }

            ivSayHello.pivotX = ivSayHello.measuredWidth.toFloat()
            ivSayHello.pivotY = ivSayHello.measuredHeight.toFloat()

            animator?.start()

            /* val animation = RotateAnimation(0f, 5f, Animation.RELATIVE_TO_SELF, 1f, Animation.RELATIVE_TO_SELF, 1f)
             animation.interpolator = BounceInterpolator()
             animation.duration = 1500
             animation.repeatCount = ValueAnimator.INFINITE
             animation.repeatMode = ValueAnimator.RESTART
             ivSayHello.startAnimation(animation)*/
        }
    }

    fun setViewVisible(visible: Boolean) {
        if (visible) {
            startAnimationShake()
        } else {
            if (ivSayHello != null) {
                ivSayHello.clearAnimation()
            }
        }
        setVisible(visible)
    }

    override fun onDetachedFromWindow() {
        super.onDetachedFromWindow()
        animator?.cancel()
    }
}
