package com.ninexiu.sixninexiu.audio

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.fitterViewSize
import kotlinx.android.synthetic.main.view_item_dynamic_share.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/04/10
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicShareItemView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_item_dynamic_share, this)
        val arr = context.obtainStyledAttributes(attrs, R.styleable.DynamicShareItemView)
        val imgW = arr.getInt(R.styleable.DynamicShareItemView_share_img_width, 0)
        val imgH = arr.getInt(R.styleable.DynamicShareItemView_share_img_height, 0)
        val img = arr.getResourceId(R.styleable.DynamicShareItemView_share_img, -1)
        val name = arr.getString(R.styleable.DynamicShareItemView_share_name)
        arr.recycle()

        if (img != -1) {
            shareIv.setImageResource(img)
        }

        name?.let {
            shareTv.text = it
        }

        // 设置图片宽高
        post {
            fitterViewSize(shareIv, { dp2px(context, imgW) }, { dp2px(context, imgH) })
        }
    }

    private var type: Int = -1
    fun setShareType(type: Int) {
        this.type = type
    }

    fun getShareType() = type
}