package com.ninexiu.sixninexiu.audio

import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.ConfigSpHelper
import com.ninexiu.sixninexiu.common.util.NSLog

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/04/06
 *     desc   : 关注帮助类
 *              关注相关的增加参数 from_type 关注来源： 1 直播间 2 个人主页 3 动态 4 缘分
 *     version: 1.0
 * </pre>  为了不对现有的代码造成太多影响和耦合，这里使用全局来设置参数
 */
object FollowHelper {
    const val FROM_TYPE_LIVEROOM = 1
    const val FROM_TYPE_PERSONAL = 2
    const val FROM_TYPE_DYNAMIC = 3
    const val FROM_TYPE_YUANFEN = 4

    private var fromType : Int = 0

    private var rid : String? = null

    private var dynamicId : String? = null

    fun setDynamicId(dynamicId : String) {
        this.dynamicId = dynamicId
        this.fromType = FROM_TYPE_DYNAMIC
    }

    fun setRoomRid(rid : String) {
        this.rid = rid
        this.fromType = FROM_TYPE_LIVEROOM
    }

    fun getRoomRid() = rid

    fun getDynamicId() = dynamicId

    fun getFollowType(): Int {
        // return AppCnfSpHelper.getInstance().followFromType
        return fromType
    }

    fun clearFollowType() {
        fromType = 0
    }

    val map = mutableMapOf<Long, Long>()

    // 是否应该上报 : 上报进入个人主页的也写在这个里面
    fun showUpLoadIntoPersonCenter(uid: Long?): Boolean {
        uid ?: return false

        val time = System.currentTimeMillis()

        if (map.containsKey(uid)) {
            val preTime = map[uid]

            preTime?.let {
                return if ((time - preTime) > (1000 * 60)) {       // 间隔大于1min才上报数据，并修改存储
                    map[uid] = time                               // 更新时间
                    true
                }else {
                    false
                }
            } ?: also {
                map[uid] = time
                return true
            }
        } else {
            map[uid] = time
            return true
        }
        return false
    }
}
