package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/03
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class AccountCertifyResult(
        val data: AccountCertifyData? = null
)

data class AccountCertifyData(
        val bind_phone: PhoneData? = null,
        val update_phone: UpdatePhoneData? = null,
        val set_pwd: SetPwdData? = null,
        val forget_pwd: ForgetPwdData? = null,
        val certify_info: CertifyInfo? = null
)

data class PhoneData(
        val header_tip: String? = null
)

data class UpdatePhoneData(
        val verify_tip: String? = null,
        val update_tip: String? = null
)

data class SetPwdData(
        val verify_tip: String? = null,
        val update_tip: String? = null
)

data class ForgetPwdData(
        val verify_tip: String? = null,
        val update_tip: String? = null
)

data class CertifyInfo(
        val show_agreement: Int,
        val certify_agreement: String? = null,
        val agreement_tip: String? = null,
        val agreement_name: String? = null,
        val header_tip: String? = null,
        val certify_tip: String? = null,
        val footer_tip: String? = null,
        val loadding_tip: String? = null,
        val wait_time: Int
)

/**
{
"code": 200,
"message": "",
"data": {
"bind_phone": {
"header_tip": "应国家政策要求，请绑定手机号码\n\n绑定成功后将为您解锁九秀的全部玩法\n\n"
},
"update_phone": {
"verify_tip": "请验证已绑定手机号码\n\n验证通过后，需要绑定一个新的手机号码\n\n",
"update_tip": "已验证13501242231手机号码\n\n请绑定一个新的手机号码并验证通过\n\n"
},
"set_pwd": {
"verify_tip": "设置密码后\n\n可以使用手机号码与密码登陆九秀平台\n\n",
"update_tip": "已验证13501242231手机号码\n\n您可以设置一个6-16位的登陆密码\n\n"
},
"forget_pwd": {
"verify_tip": "验证绑定手机号码后\n\n您可以设置一个新的登陆密码\n\n",
"update_tip": "已验证13501242231手机号码\n\n您可以设置一个6-16位的新登陆密码\n\n"
},
"certify_info": {
"show_agreement": 1,
"certify_agreement": "https://www.9xiu.com/mobileapp/rechargeAgreement",
"agreement_tip": "认证即视为已阅读并同意《九秀认证须知》",
"agreement_name": "九秀认证须知",
"header_tip": "响应国家网络安全要求\n\n使用九秀平台的相关功能，可能需要您进行实名认证",
"certify_tip": "实名认证请认证填写，5次认证失败将无法再认证（0/5）。",
"footer_tip": "如有疑问，请联系客服QQ：800099469",
"loadding_tip": "认证中，请稍后...",
"wait_time": 5
}
}
}

 */

