package com.ninexiu.sixninexiu.bean

import android.text.TextUtils
import com.ninexiu.sixninexiu.common.util.Utils


open class AuctionCountyBean(
        var areaId: String,
        var areaName: String,
) : Comparable<AuctionCountyBean> {
    var pinyin: String = Utils.getPinYin(areaName)

    override fun compareTo(other: AuctionCountyBean): Int {
        return if (!TextUtils.isEmpty(pinyin) && other != null) {
            pinyin.compareTo(other.pinyin)
        } else {
            if (other == null) {
                -1 //
            } else {
                1
            }
        }
    }
}

class AuctionProvinceBean : AuctionCountyBean {
    var cities: List<AuctionCityBean>? = null

    constructor(provinceBean: AuctionProvinceBean) : super(provinceBean.areaId, provinceBean.areaName){
        this.cities=provinceBean.cities
    }
}

class AuctionCityBean : AuctionCountyBean {
    var counties: List<AuctionCountyBean>? = null

    constructor(cityBean: AuctionCityBean) : super(cityBean.areaId, cityBean.areaName){
        this.counties=cityBean.counties
    }
}

