package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/06/18
 *     desc   : 聊天消息中的扩展字段
 *     version: 1.0
 * </pre>
 */
object ChatMessageConstants {
    const val CHAT_PATH = "chat_path"     // s11 排位赛用户背景
    const val HOT_WORD_ID = "hot_word_id"     // 点击热词发送消息时将id带上

    // 匹配热词中的svg动画
    fun getHotWordFilterSvg(hotWordListBean: HotWordListBean?, filter: (HotWord) -> Boolean): String? {
        val wordList: List<HotWord>? = hotWordListBean?.data
        if (wordList.isNullOrEmpty()) {
            return null
        }

        var hotSvgUrl: String? = null

        for (word: HotWord in wordList) {
            if (filter.invoke(word)) {
                hotSvgUrl = word.svgaurl
                break
            }
        }

        return hotSvgUrl
    }
}