package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

data class DynamicTitleBean(
    val code: Int,
    val `data`: List<DynamicOneTitleBean>?,
    val message: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.createTypedArrayList(DynamicOneTitleBean),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(code)
        parcel.writeTypedList(data)
        parcel.writeString(message)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<DynamicTitleBean> {
        override fun createFromParcel(parcel: Parcel): DynamicTitleBean {
            return DynamicTitleBean(parcel)
        }

        override fun newArray(size: Int): Array<DynamicTitleBean?> {
            return arrayOfNulls(size)
        }
    }
}

data class DynamicOneTitleBean(
        val is_default: Int,
        val name: String?,
        val options: List<DynamicTwoTitleBean>?,
        val type: String?,
        val url: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readString(),
            parcel.createTypedArrayList(DynamicTwoTitleBean),
            parcel.readString(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(is_default)
        parcel.writeString(name)
        parcel.writeTypedList(options)
        parcel.writeString(type)
        parcel.writeString(url)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<DynamicOneTitleBean> {
        override fun createFromParcel(parcel: Parcel): DynamicOneTitleBean {
            return DynamicOneTitleBean(parcel)
        }

        override fun newArray(size: Int): Array<DynamicOneTitleBean?> {
            return arrayOfNulls(size)
        }
    }
}

data class DynamicTwoTitleBean(
    val is_default: Int,
    val name: String?,
    val type: String?,
    val url: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(is_default)
        parcel.writeString(name)
        parcel.writeString(type)
        parcel.writeString(url)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<DynamicTwoTitleBean> {
        override fun createFromParcel(parcel: Parcel): DynamicTwoTitleBean {
            return DynamicTwoTitleBean(parcel)
        }

        override fun newArray(size: Int): Array<DynamicTwoTitleBean?> {
            return arrayOfNulls(size)
        }
    }
}