package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/24
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class GuardBuyInfoDataBean(
        val data: ArrayList<GuardList>?
) : BaseResultInfo()

data class GuardList(
        val gid: String?,
        val name: String?,
        val icon_list: ArrayList<IconList>?,
        val year_icon_list: ArrayList<IconList>?,
        val buy_time_list: ArrayList<BuyTimeList>?
)

data class IconList(
        val name: String?,
        val img_url: String?
)

data class BuyTimeList(
        val type: Int = 0,
        val money: Long = 0,
        val pre_price: Long = 0,
        val labelstr: String?,
        val message: String?,
        val is_old_user: Int = 0,
        val timeLimit:String?,
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readLong(),
            parcel.readLong(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(type)
        parcel.writeLong(money)
        parcel.writeLong(pre_price)
        parcel.writeString(labelstr)
        parcel.writeString(message)
        parcel.writeInt(is_old_user)
        parcel.writeString(timeLimit)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<BuyTimeList> {
        override fun createFromParcel(parcel: Parcel): BuyTimeList {
            return BuyTimeList(parcel)
        }

        override fun newArray(size: Int): Array<BuyTimeList?> {
            return arrayOfNulls(size)
        }
    }
}