package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/26
 *     desc   :vip权益 bean
 *     version: 1.0
 * </pre>
 */
data class VipPrivilegeDataBean(
        val data: List<VipPrivilege>?
) : BaseResultInfo()

data class VipPrivilege(
        val gid: String?,
        val icon_list: List<VipPrivilegeIcon>?,
        val name: String?,
        val price_info: List<BuyTimeList>?,
        val show_num: Int? = 0
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.createTypedArrayList(VipPrivilegeIcon),
            parcel.readString(),
            parcel.createTypedArrayList(BuyTimeList),
            parcel.readValue(Int::class.java.classLoader) as? Int) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(gid)
        parcel.writeTypedList(icon_list)
        parcel.writeString(name)
        parcel.writeTypedList(price_info)
        parcel.writeValue(show_num)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<VipPrivilege> {
        override fun createFromParcel(parcel: Parcel): VipPrivilege {
            return VipPrivilege(parcel)
        }

        override fun newArray(size: Int): Array<VipPrivilege?> {
            return arrayOfNulls(size)
        }
    }
}

data class VipPrivilegeIcon(
        val icon: String?,
        val info: VipPrivilegeInfo?,
        val name: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readParcelable(VipPrivilegeInfo::class.java.classLoader),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(icon)
        parcel.writeParcelable(info, flags)
        parcel.writeString(name)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<VipPrivilegeIcon> {
        override fun createFromParcel(parcel: Parcel): VipPrivilegeIcon {
            return VipPrivilegeIcon(parcel)
        }

        override fun newArray(size: Int): Array<VipPrivilegeIcon?> {
            return arrayOfNulls(size)
        }
    }
}

data class VipPrivilegeInfo(
        val background: String?,
        val message: String?,
        val name: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readString(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(background)
        parcel.writeString(message)
        parcel.writeString(name)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<VipPrivilegeInfo> {
        override fun createFromParcel(parcel: Parcel): VipPrivilegeInfo {
            return VipPrivilegeInfo(parcel)
        }

        override fun newArray(size: Int): Array<VipPrivilegeInfo?> {
            return arrayOfNulls(size)
        }
    }
}