package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : wtengfei
 *     time   : 2021/9/14
 *     desc   : 语音多麦房大乱斗
 *     version: 1.0
 * </pre>
 */

/**
 * IM 返回的数据   语音大乱斗pk信息
 * @param type 1 每场开始前  2 获取pk数据 3 pk结果
 */
data class VoiceChaosResult(
        val type :Int,
        val next_time :String,  //下一轮开始时间
        val over_second :Int,  //距离下一轮开始时间多少秒
        val voiceChaosContentResult :VoiceChaosContentResult?,
        val leftuid :String?,
        val leftnickname :String?,
        val leftheadimage :String?,
        val rightuid :String?,
        val rightnickname :String?,
        val rightheadimage :String
){

}

data class VoiceChaosContentResult(
        val type :String, // 指定pk类型
        val state :String,// pk状态  1 申请2 开始3结束
        val is_pk :Int, //0未开始 1 pk中   2pk结束
        val pkid :String,//pkid
        val startime :String,//开始时间
        val nowtime:Long, // 结束时间
        val remaintime :Int,//  pk剩余秒数
        val rest_time :Int,// 休息倒计时
        val reward_time :Int,// 结束倒计时
        val success_path :String,//胜利svga
        val failUid :String,//  失败uid
        val failRid :String, //  失败rid
        val user :List<VoiceChaosUserResult>?

){

}

data class VoiceChaosUserResult(
        val mvpuid :String,//   mvp用户
        val mvp_nickname :String,// mvp昵称
        val mvp_headimage :String, //mvp头像
        val uid :String,// 厅主uid
        val headimage :String,//头像
        val nickname :String,// 昵称
        val level :String,//主播等级
        val rid :String, //房间id
        val roomtype :String,//  房间类型
        val totalprice :String,// 贡献值
        val box_level :Int, //宝箱等级  1  2  3
        val limit_over_score :Long, //当前等级对应上限贡献
        val result :String,//pk结果
        val win_box_level :Int,//pk结束宝箱等级
        val jinzhu_over_second :Int//金主特权倒计时
){

}

/**
 * 语音大乱斗领取宝箱
 */
data class VoiceChaosBoxBean(
        val gid :Long?,
        val count :Int?,
        val gift_name :String?,
        val gift_name_str :String?,
        val url :String?
){

}

/**
 * 语音大乱斗领取宝箱
 */
data class VoiceChaosBoxList (
        val code: Int,
        val `data`: VoiceChaosBoxBean?,
        val message: String
)

/**
 * 语音大乱斗pk信息接口返回
 */
data class VoiceChaosPkBaseBean(
        val code: Int,
        val `data`: VoiceChaosPkBean,
        val message: String
){

}

data class VoiceChaosPkBean(
        val list: VoiceChaosContentResult,
        val info :VoiceChaosPkInfo
){

}

/**
 * 是否有下轮Pk
 */
data class VoiceChaosPkInfo(
        val is_jinji :String,  //是否晋级
        val next_time :String,
        val over_second :Int //距下次开始pk时长
){

}

/**
 * 报名结果通知
 */
data class VoiceChaosPkReportResult(
        val type :Int,
        val uid :String,  //主播uid
        val sign_up_result :Int, //报名结果  1通过 2失败
        val message :String //报名提示
){

}


