package com.ninexiu.sixninexiu.common.IM.custom

import android.graphics.Rect
import android.view.View
import androidx.recyclerview.widget.RecyclerView

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/24
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicRecyDecoration(val size: Int, val divider: Int) : RecyclerView.ItemDecoration() {
    override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
        super.getItemOffsets(outRect, view, parent, state)
        val index = parent.getChildAdapterPosition(view)
        when (size) {
            in 1..2 -> {
                if (index > 1) {
                    outRect.top = divider
                } else {
                    outRect.bottom = divider
                }

                if (index % 2 == 0) {
                    outRect.right = divider
                } else {
                    outRect.left = divider
                }
            }
            else -> {
                when {
                    index <= 2 -> {
                        outRect.bottom = divider
                    }
                    index >= 6 -> {
                        outRect.top = divider
                    }
                    else -> {
                        outRect.bottom = divider
                        outRect.top = divider
                    }
                }

                outRect.right = divider
                outRect.left = divider
            }
        }
    }
}