package com.ninexiu.sixninexiu.common.IM.custom

import android.view.View
import android.widget.ImageView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.view.fitterViewSize
import com.tencent.qcloud.tim.uikit.component.picture.imageEngine.impl.GlideEngine

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/24
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MsgDynamicPicAdapter(data: List<String>, val itemHeight: Int) : BaseQuickAdapter<String, MsgDynamicPicAdapter.MsgDynamicPicHolder>(R.layout.item_msg_dynamic_pic, data) {
    var onItemClick: (() -> Unit)? = null
    override fun convert(helper: MsgDynamicPicHolder?, item: String?) {
        helper ?: return
        item?.let {
            GlideEngine.loadCornerImage(helper.iv, it, null)
        }

        helper.itemView.setOnClickListener {
            onItemClick?.invoke()
        }
    }


    inner class MsgDynamicPicHolder(view: View) : BaseViewHolder(view) {
        val iv: ImageView = view.findViewById(R.id.ivDynamicPic)

        init {
            fitterViewSize(iv, { itemHeight }, { itemHeight })
        }
    }


}