package com.ninexiu.sixninexiu.common.util

import android.content.Context
import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.FragmentActivity
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.activity.TranslucentSubPageActivity
import com.ninexiu.sixninexiu.bean.FamilyHallInfo
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.fragment.AttentionCardFragment
import com.ninexiu.sixninexiu.fragment.FamilyDetailFragment
import com.ninexiu.sixninexiu.fragment.FamilyParentFragment
import com.ninexiu.sixninexiu.fragment.HistoryFragment
import com.ninexiu.sixninexiu.fragment.MBVoiceLiveStartFragment
import com.ninexiu.sixninexiu.fragment.SearchFragment
import org.jetbrains.anko.startActivity

/**
 * @Description:     Activity跳转管理类
 * @Author:          liuguangyu
 * @date  :     2019/5/5 10:38
 * @Version:
 */
object ActivityUtils {

    fun jumpAttentionCardFragment(context: androidx.fragment.app.FragmentActivity, view: Int) {
        val fragmentTransaction = context.supportFragmentManager.beginTransaction()
        fragmentTransaction.add(view, AttentionCardFragment.newInstance())
        fragmentTransaction.commit()
    }

    fun jumpSearchFragment(context: Context?) {
        context?.startActivity<SubPageActivity>(SubPageActivity.CLASSFRAMENT to SearchFragment::class.java)
        StatisticsUtil.onEvent(StatisticsEventID.MAIN_SEARCH)
    }

    fun jumpHistoryFragment(context: Context?) {
        context?.startActivity<SubPageActivity>(SubPageActivity.CLASSFRAMENT to HistoryFragment::class.java)
        StatisticsUtil.onEvent(StatisticsEventID.MAIN_HISTORY)
    }

    fun jumpFamilyRankFragment(context: Context?) {
        context?.startActivity<SubPageActivity>(SubPageActivity.CLASSFRAMENT to FamilyParentFragment::class.java)
    }

    fun jumpFamilyDetailFragment(context: Context?, isShowHeadview: Boolean, myFamilyinfo: FamilyHallInfo?) {
        if (myFamilyinfo == null) {
            return
        }
        val intent_search = Intent(context, SubPageActivity::class.java)
        intent_search.putExtra(SubPageActivity.CLASSFRAMENT, FamilyDetailFragment::class.java)
        val bundle = Bundle()
        bundle.putBoolean("myFamily", isShowHeadview)
        bundle.putSerializable("familyHallInfo", myFamilyinfo)
        intent_search.putExtra("bundle", bundle)
        context?.startActivity(intent_search)
    }

    /**
     * 主持人列表
     */
    fun jumpMBVoiceLiveStartFragment(context: Context?,playLiveType:Int) {
        context?.startActivity<TranslucentSubPageActivity>(TranslucentSubPageActivity.CLASSFRAMENT
                to MBVoiceLiveStartFragment::class.java,TranslucentSubPageActivity.ARGMENT_KEY
                to  Pair(MBVoiceLiveStartFragment.TYPE, playLiveType))
    }

}
