package com.ninexiu.sixninexiu.common.util

import android.animation.Animator
import android.animation.AnimatorListenerAdapter
import android.animation.ObjectAnimator
import android.app.Activity
import android.os.Bundle
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.style.ImageSpan
import android.util.Log
import android.view.View
import android.view.ViewStub
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.makeramen.roundedimageview.RoundedImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.MBLiveRoomActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.bean.BiddingCommodityBean
import com.ninexiu.sixninexiu.bean.BiddingShopInfo
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.fragment.auction.AuctionFailedDialog
import com.ninexiu.sixninexiu.fragment.auction.AuctionSucceedDialog
import com.ninexiu.sixninexiu.view.CountDownTextView
import com.ninexiu.sixninexiu.view.dialog.BiddingServiceDescriptionDialog
import com.ninexiu.sixninexiu.view.dialog.BiddingShopBidDialog
import org.json.JSONObject

/**
 * <pre>
 *     @author : gh
 *     time   : 2021/4/12 0013
 *     desc   : 竞拍管理类
 *     version: 1.0
 * </pre>
 */
class BiddingCommodityManager {

    companion object {

        private var instance: BiddingCommodityManager? = null

        @Synchronized
        fun get(): BiddingCommodityManager {
            if (null == instance) instance = BiddingCommodityManager()
            return instance!!
        }
    }

    var roomId: String? = null
    lateinit var mRoot: View
    lateinit var activity: Activity

    var bitInterface: BifInterface? = null

    /**
     * 初始化数据
     */
    fun initData(activity: Activity, rid: String, rootView: View) {
        this.activity = activity
        this.roomId = rid
        this.mRoot = rootView
        initView()
        requestData()
//        var test = BiddingCommodityBean()
//        test.type = 4
//        test.amount = "30000.00"
//        test.goods_id = 17
//        test.down_time = 16
//        test.deposit_price = "5000.00"
//        test.incrby_price = "1000.00"
//        test.star_price = "800.00"
//        test.time  = 30
//        test.desc  = "请在30分钟内支付尾款，否则将罚没您 的保证金用于补偿卖家。"
//        test.order_id  = "17"
//        test.goods_name = "16测试一口价商品"
//        test.img1 = "https://img11.img.9xiu.com/openappad/2021/04/14/1121025c0alpd6mce.jpg"
//        showStatus(test)

    }

    private var auctionSucceedDialog: AuctionSucceedDialog? = null
    private var auctionFailedDialog: AuctionFailedDialog? = null

    fun setListView(listView: RecyclerView){
        this.mChatListLv = listView
    }

    fun showStatus(bean: BiddingCommodityBean) {
        try {
            bean?.let {

                if (it.type == 1) {
                    UIUtils.showView(mResultView)
                    var stringBuilderStr = SpannableStringBuilder("")
                    var price = it.amount.toInt()

                    var strArry = "$price".toCharArray(0, "$price".length)
                    for (index in 1.."$price".length) {
                        stringBuilderStr.append("${strArry[index - 1]}")
                        val id = NineShowApplication.applicationContext.resources
                                .getIdentifier("icon_biding_price_num_" + strArry[index - 1], "drawable",
                                        NineShowApplication.applicationContext.packageName)
                        stringBuilderStr.setSpan(ImageSpan(activity!!, id), stringBuilderStr.length - 1, stringBuilderStr.length, Spannable.SPAN_EXCLUSIVE_INCLUSIVE)
                    }
                    mBidUnitTv?.text = stringBuilderStr
                    mBidNameTv?.text = "${it.nickname} 出价 "
                    mBidPriceTv?.text = "¥${it.amount}"

                    var objectAnimator = ObjectAnimator.ofFloat(mResultView, "alpha", 1f, 0f)
                    objectAnimator.duration = 3000
                    objectAnimator.start()
                    objectAnimator.addListener(object : AnimatorListenerAdapter() {
                        override fun onAnimationEnd(animation: Animator?) {
                            super.onAnimationEnd(animation)
                            UIUtils.goneView(mResultView)
                        }
                    })
                    var amount = it.amount
                    if (TextUtils.isEmpty(amount)){
                        amount = "0.0"
                    }

                    if (TextUtils.isEmpty(incrbyPrice)){
                        incrbyPrice = "0.0"
                    }

                    starPrice = "${amount.toFloat() + incrbyPrice.toFloat()}"
                    shopPriceTv?.text = "¥ ${it.amount}"
                    biddingShopBidDialog?.refershPreice(it.amount)
                } else if (it.type == 2) {

                } else if (it.type == 3) {
                    if (it.down_time < 0) {
                        return@let
                    }
                    if (!activity.isFinishing) {
                        auctionSucceedDialog = AuctionSucceedDialog(activity)
                    }

                    auctionSucceedDialog?.showDialog( it.goods_name, it.img1, it.desc, it.time,it.order_id)

                } else if (it.type == 4) {
                    if (!activity.isFinishing) {
                        auctionFailedDialog = AuctionFailedDialog(activity)
                    }
                    auctionFailedDialog?.showDialog(it.goods_name, it.img1, it.desc)
                } else if (it.type == 5) {
                    val bundle = Bundle()
                    bundle.putInt("sell_type ", it.sell_type)
                    AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_BIDDING_COMMODITY_REFRESH, bundle)
                } else if (it.type == 6) {
                    val bundle = Bundle()
                    bundle.putInt("sell_type ", it.sell_type)
                    AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_BIDDING_COMMODITY_REFRESH, bundle)
                    if (goodsId == it.goods_id) {
                        mChatListLv?.postDelayed(Runnable {

                            val lp = mChatListLv?.layoutParams as RelativeLayout.LayoutParams
                            lp.addRule(RelativeLayout.ABOVE, R.id.mrroot)
                            lp.height = listHeight
                            mChatListLv.layoutParams = lp
                        },600)
                        UIUtils.goneView(mRootView)
                        bitInterface?.ononAnimation(false)
                        if (biddingShopBidDialog != null && biddingShopBidDialog!!.isShowing){
                            biddingShopBidDialog?.dismiss()
                        }
                    }
                } else if (it.type == 7) {
                    if (it.down_time < 0) {
                        return@let
                    }

                    mChatListLv?.postDelayed(Runnable {

                        val lp = mChatListLv?.layoutParams as RelativeLayout.LayoutParams
                        lp.addRule(RelativeLayout.ABOVE, R.id.mrroot)
                        listHeight = lp.height
                        lp.height = (listHeight - layoutParams?.height)
                        mChatListLv.layoutParams = lp
                    },600)

                    bitInterface?.ononAnimation(true)
                    UIUtils.showView(mRootView)
                    goodsId = it.goods_id
                    incrbyPrice = it.incrby_price
                    starPrice = it.amount
                    depositPrice = it.deposit_coin
                    GlideUtils.loadSimpleImgWithRoundCorner(activity, it.img1, imgIdIv,0,Utils.dip2px(activity,6f))
                    showNameTv?.text = it.goods_name
                    setDwonTime(it.down_time)
                    shopPriceTv?.text = "¥ ${it.amount}"
                } else if (it.type == 8) {
                    if (it.down_time < 0) {
                        return@let
                    }
                    setDwonTime(it.down_time)
                } else if (it.type == 9) {

                    mChatListLv?.postDelayed(Runnable {

                        val lp = mChatListLv?.layoutParams as RelativeLayout.LayoutParams
                        lp.addRule(RelativeLayout.ABOVE, R.id.mrroot)
                        lp.height = listHeight
                        mChatListLv.layoutParams = lp

                    },400)
                    val bundle = Bundle()
                    bundle.putInt("sell_type ", it.sell_type)
                    AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_BIDDING_COMMODITY_REFRESH, bundle)
                    if (goodsId == it.goods_id) {
                        UIUtils.goneView(mRootView)
                        bitInterface?.ononAnimation(false)
                        if (biddingShopBidDialog != null && biddingShopBidDialog!!.isShowing){
                            biddingShopBidDialog?.dismiss()
                        }
                    }
                }

            }
        } catch (e: Exception){
            e.printStackTrace()
        }
    }

    private var mRootView: RelativeLayout? = null
    private var imgIdIv: RoundedImageView? = null
    private var showNameTv: TextView? = null
    private var showTimeTv: CountDownTextView? = null
    private var shopPriceTv: TextView? = null
    private var buyBtn: TextView? = null
    private var buyStatusTv: TextView? = null

    private var biddingShopBidDialog: BiddingShopBidDialog? = null
    private var goodsId: Long = 0
    private var incrbyPrice: String = ""
    private var starPrice: String = ""
    private var depositPrice: String = ""

    private var mResultView: RelativeLayout? = null
    private var mBidNameTv: TextView? = null
    private var mBidUnitTv: TextView? = null
    private var mBidPriceTv: TextView? = null

    lateinit var mChatListLv: RecyclerView
    lateinit var layoutParams:RelativeLayout.LayoutParams
    var listHeight:Int = 0

    /**
     * 初始化商品信息
     */
    fun initView() {
        var shopInfoView: ViewStub? = mRoot?.findViewById(R.id.view_bidding_shop_info)
        var resultView: ViewStub? = mRoot?.findViewById(R.id.view_bidding_bid_result)
//        mChatListLv = mRoot?.findViewById(R.id.lv_chat_list)

        shopInfoView?.let {
            it.layoutResource = R.layout.layout_bidding_commodity_live_chat_show

            mRootView = it.inflate() as RelativeLayout

            layoutParams = mRootView!!.layoutParams as RelativeLayout.LayoutParams
            layoutParams?.leftMargin = Utils.dip2px(activity,10f)
            layoutParams?.height = Utils.dip2px(activity,84f)
            mRootView?.layoutParams = layoutParams

            UIUtils.goneView(mRootView)
            imgIdIv = mRootView?.findViewById(R.id.iv_shop_img_id)
            showNameTv = mRootView?.findViewById(R.id.tv_shop_name)
            showTimeTv = mRootView?.findViewById(R.id.tv_shop_time)
            shopPriceTv = mRootView?.findViewById(R.id.tv_shop_price)
            buyBtn = mRootView?.findViewById(R.id.btn_buy)
            buyStatusTv = mRootView?.findViewById(R.id.tv_buy_status)

            buyBtn?.setOnClickListener {
                if (Utils.isLongPeriodNotClickable()){
                    return@setOnClickListener
                }
                if (!AppCnfSpHelper.getInstance().bidingFirst){
                    if (!activity.isFinishing) {
                        var dialog = BiddingServiceDescriptionDialog(activity)
                        dialog.show()
                        AppCnfSpHelper.getInstance().bidingFirst = true
                    }
                    return@setOnClickListener
                }

                if (!activity.isFinishing) {
                    biddingShopBidDialog = BiddingShopBidDialog(activity)
                }
                bitInterface?.onBid(true)

                biddingShopBidDialog?.bidShopInterface = object: BiddingShopBidDialog.BidShopInterface {
                    override fun onBidHide() {
                        UIUtils.goneView(buyStatusTv)
                        UIUtils.showView(buyBtn)
                        bitInterface?.onBid(false)
                    }
                }
                biddingShopBidDialog?.showDialog("$goodsId",starPrice, incrbyPrice, depositPrice)
                UIUtils.showView(buyStatusTv)
                UIUtils.goneView(buyBtn)


            }
        }

        resultView?.let {
            it.layoutResource = R.layout.layout_bid_result_anim
            mResultView = it.inflate() as RelativeLayout
            UIUtils.goneView(mResultView)

            mBidUnitTv = mResultView?.findViewById(R.id.tv_unit)
            mBidNameTv = mResultView?.findViewById(R.id.tv_nickname)
            mBidPriceTv = mResultView?.findViewById(R.id.tv_price)

        }



    }

    /**
     * 获取正在竞拍的商品
     */
    fun requestData() {
        var okHttpClient = NsOkHttpClient.getNsOkHttpClient()
        var params = NSRequestParams()
        params.put("rid", roomId)
        okHttpClient.doGet(Constants.GET_SHOP_GETAUCTIONGOODS, params, object : NSGsonObjectNewCallback<BaseResultInfo>() {

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: BaseResultInfo?) {
                if (activity == null) {
                    return
                }
                if (statusCode == 200) {
                    UIUtils.showView(mRoot)
                    var jsonObject = JSONObject(responseString)
                    var data = jsonObject.optJSONObject("data")
                    if (data == null){
                        return
                    }
                    var bean = GsonUtil.fromJson(jsonObject.optString("data"), BiddingShopInfo::class.java)

                    bitInterface?.ononAnimation(true)
                    UIUtils.showView(mRootView)
                    goodsId = bean.goods_id
                    incrbyPrice = bean.incrby_price
                    starPrice = bean.amount
                    depositPrice = bean.deposit_coin
                    GlideUtils.loadSimpleImgWithRoundCorner(activity, bean.img1, imgIdIv,0,Utils.dip2px(activity,6f))
                    showNameTv?.text = bean.goods_name
                    setDwonTime(bean.down_time)
                    shopPriceTv?.text = "¥ ${bean.amount}"

                    mChatListLv?.postDelayed(Runnable {

                        val lp = mChatListLv?.layoutParams as RelativeLayout.LayoutParams
                        lp.addRule(RelativeLayout.ABOVE, R.id.mrroot)
                        listHeight = lp.height
                        lp.height = (listHeight - layoutParams?.height)
                        mChatListLv.layoutParams = lp
                    },600)

                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

    private fun setDwonTime(time: Int) {
        showTimeTv?.startCutDown("倒计时: ", "", time.toLong(), "") { time: Long ->
            val lsTime = time.toInt()
            val hour = lsTime / 3600
            val minute = lsTime / 60 % 60  // / :先转换成秒  % : 过滤出小时
            val second = lsTime % 60
            return@startCutDown "${showTimeTv?.timeToString(hour)}:${showTimeTv?.timeToString(minute)}:${showTimeTv?.timeToString(second)}"
        }

    }

    /**
     * 释放资源
     */
    fun onRelease() {

    }

    interface BifInterface {
        fun onBid(hide: Boolean)
        fun ononAnimation(anim: Boolean)
    }

}