package com.ninexiu.sixninexiu.common.util

import android.text.TextUtils
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.common.util.svg.down.DownloadCallback
import com.ninexiu.sixninexiu.common.util.svg.down.OkhttpDownload
import com.ninexiu.sixninexiu.view.MBLiveAlphaVideoHelper
import com.senseme.effects.download.OkHttpManager
import com.zhongrun.nineshow_base.utils.NineShowFilePathManager
import java.io.File
import java.io.FileInputStream
import java.io.FileNotFoundException
import java.io.IOException
import java.util.ArrayList


/**
 * <pre>
 *     @author : gh
 *     time   : 2020/7/03 0029
 *     desc   : 大资源管理类
 *     version: 1.0
 * </pre>
 */
class BigResourcesDownManage {

    private val TAG: String = BigResourcesDownManage.javaClass.simpleName

    private val deskPath = NineShowFilePathManager.INSTANCE.getExterFileDir(NineShowFilePathManager.GIFT_DIR)

    private val pkPath = NineShowFilePathManager.INSTANCE.getExterFileDir(NineShowFilePathManager.SVGA_DIR)

    private var oldBackList: ArrayList<String> = arrayListOf(OLD_BACK_NIUDAN, OLD_BACK_RED_EGG, OLD_BACK_YELLOW_EGG, OLD_USER_PHONE_3, OLD_USER_PHONE_5, OLD_USER_PHONE_7)


    /**
     * 语音直播间
     */
    //心动资源
    private var bigHeartList: ArrayList<String> = arrayListOf(HEART_CORRECT_MAN,TEAMPK_MVP_UP_MAN,TEAMPK_MVP_UP_WOMAN,TEAMPK_MVP_MAN,TEAMPK_MVP_WOMAN,HEART_CORRECT_FAILURE,HEART_CORRECT_SUCCESS,HEART_CORRECT_WOMAN)
    //土豪特权进房
    private var bigEnterRoomList: ArrayList<String> = arrayListOf(ENTERROOM_LOCALTYCOON_2000561,ENTERROOM_LOCALTYCOON_2000560,ENTERROOM_LOCALTYCOON_2000558,ENTERROOM_LOCALTYCOON_2000559,ENTERROOM_LOCALTYCOON_2000556,ENTERROOM_LOCALTYCOON_2000557,ENTERROOM_LOCALTYCOON_2000555)
    //语音房-团战、PK
    private var voicePkList: ArrayList<String> = arrayListOf(VOICE_PK_BG_START, VOICE_CHAOS_START)

    /**
     * 判断是否执行一次
     */
    var isVoicePk = true
    var isBigEnter = true
    var isBigHeartr = true


    var is3v3Pk = true


    /**
     * 视频直播间
     */
    // 3V3PK
    private var pkFileList: ArrayList<String> = arrayListOf(PK_START_1V1, PK_START_3V3)


    /**
     * 活动结束
     */
    private var activeList: ArrayList<String> = arrayListOf(ACTIVE_SVG_LIANAI, ACTIVE_SVG_HAOHUA)



    private var downloadManager: OkhttpDownload? = null

    companion object {

        const val HEART_CORRECT_MAN = "heart_correct_man.svga"
        const val TEAMPK_MVP_UP_MAN = "teampk_mvp_up_man.svga"
        const val TEAMPK_MVP_UP_WOMAN = "teampk_mvp_up_woman.svga"
        const val TEAMPK_MVP_MAN = "teampk_mvp_man.svga"
        const val TEAMPK_MVP_WOMAN = "teampk_mvp_woman.svga"
        const val HEART_CORRECT_FAILURE = "heart_correct_failure.svga"
        const val HEART_CORRECT_SUCCESS = "heart_correct_success.svga"
        const val HEART_CORRECT_WOMAN = "heart_correct_woman.svga"

        const val ENTERROOM_LOCALTYCOON_2000561 = "enterroom_localtycoon_2000561.svga"
        const val ENTERROOM_LOCALTYCOON_2000560 = "enterroom_localtycoon_2000560.svga"
        const val ENTERROOM_LOCALTYCOON_2000558 = "enterroom_localtycoon_2000558.svga"
        const val ENTERROOM_LOCALTYCOON_2000559 = "enterroom_localtycoon_2000559.svga"
        const val ENTERROOM_LOCALTYCOON_2000556 = "enterroom_localtycoon_2000556.svga"
        const val ENTERROOM_LOCALTYCOON_2000557 = "enterroom_localtycoon_2000557.svga"
        const val ENTERROOM_LOCALTYCOON_2000555 = "enterroom_localtycoon_2000555.svga"

        const val OLD_BACK_NIUDAN = "anim_niudan.svga"
        const val OLD_BACK_RED_EGG = "anim_red_egg.svga"
        const val OLD_BACK_YELLOW_EGG = "anim_yellow_egg.svga"

        /**
         * 老用户回归3.0 全栈资源
         */
        const val OLD_USER_PHONE_3 = "phone_3.svga"
        const val OLD_USER_PHONE_5 = "phone_5.svga"
        const val OLD_USER_PHONE_7 = "phone_7.svga"

        /**
         * 活动资源-豪华礼物废弃
         */
        const val ACTIVE_SVG_LIANAI = "2000725.svga"
        const val ACTIVE_SVG_HAOHUA = "2000724.svga"

        /**
         * pk开始
         */
        const val PK_START_1V1 = "1v1_about_to_start.svga"
        const val PK_START_3V3 = "3v3_about_to_start.svga"

        /**
         * 语音房布局
         */
        // 团战开始
        const val VOICE_PK_BG_START = "voice_pk_bg_start.svga"
        //语音pk活动
        const val VOICE_CHAOS_START = "voice_chaos_start.svga"

        private var instance: BigResourcesDownManage? = null
            get() {
                if (field == null) {
                    field = BigResourcesDownManage()
                }
                return field
            }
        fun get(): BigResourcesDownManage{
            return instance!!
        }
    }

    /**
     * 启动页检查需要下载的大资源
     */
    fun checkBigResources(){
        NSLog.d(TAG, "download_svga >> checkBigResources : 00")
        Thread(Runnable {
//            for (str in bigHeartList) {
//                getSvga(str)
//            }

//            for (str in bigEnterRoomList) {
//                getSvga(str)
//            }

            for (str in oldBackList) {
                getOldBackSvga(Constants.HTTP_OLD_BACK_SVGA,str)
            }

//            for (str in activeList){
//                getSvga(str)
//            }

//            for (str in pkFileList) {
//                getPkFileSvga(Constants.HTTP_PK_FILE,str)
//            }

        }).start()


    }

    /**
     * 检查语音房Svga资源
     */
    fun checkVoiceSvga() {

        if (isVoicePk) {
            isVoicePk = false;
            Thread({
                for (str in voicePkList) {
                    getPkFileSvga(Constants.HTTP_PK_FILE, str)
                }
            })
        } else {
            if (isBigHeartr) {
                isBigHeartr = false;
                Thread({
                    for (str in bigHeartList) {
                        getSvga(str)
                    }
                })
            }
        }


    }

    /**
     * 检查视频直播间Svga资源
     */
    fun checkVideoSvga(){

        if (is3v3Pk){
            is3v3Pk = false
            Thread({
                for (str in bigEnterRoomList) {
                    getSvga(str)
                }


            })
        }

    }


    /**
     * 获取指定文件大小
     * @param file
     * @return
     * @throws Exception 　　
     */
    fun getFileSize(file: File): Long {
        var size: Long = 0
        try {
            if (file.exists()) {
                var fis: FileInputStream? = null
                fis = FileInputStream(file)
                size = fis.available().toLong()
            } else {
                file.createNewFile()
            }
        } catch (e: FileNotFoundException) {
            e.printStackTrace()
        } catch (e: IOException) {
            e.printStackTrace()
        }

        return size
    }

    /**
     * 获取当前的本地动画
     */
    fun getSvga(name: String): FileInputStream? {

        try{
            val file = File(deskPath, name)

            /**getPkFileSvga
             * 删除当前别的动画
             */
            var directory = File(deskPath)

            if (directory?.exists()){
                if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                    //本地下载
                    if (downloadManager == null) {
                        downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
                    }
//                    var fileName = name
//                    if (name.contains(".svga")){
//                        fileName = name.replace(".svga","")
//                    }
                    downloadManager?.downLoadCallback(Constants.HTTP_BIG_RESOURCES + name, name, object : DownloadCallback {
                        override fun downloadSuccess() {
                            NSLog.d(TAG, "downloadSuccess")
                        }

                        override fun downloadFailure(errorMsg: String) {

                        }
                    })
                } else {

                    return FileInputStream(file)
                }

            }
        } catch (e : Exception){
            e.printStackTrace()
        }

        return null
    }

    /**
     * 删除播放失败的资源
     */
    fun deleteFile(name: String?){
        if (TextUtils.isEmpty(name)){
            return
        }
        try {
            val file = File(deskPath, name)
            if (file.exists())
                file.delete()
        } catch (e:Exception){

        }

    }

    /**
     * 获取当前的本地动画
     */
    fun getSvgaUrl(url: String,fileName : String): FileInputStream? {

        try{
            val file = File(deskPath, fileName)

            /**
             * 删除当前别的动画
             */
            var directory = File(deskPath)

            if (directory?.exists()){
                if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                    //本地下载
                    if (downloadManager == null) {
                        downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
                    }
//                    var fileName = name
//                    if (name.contains(".svga")){
//                        fileName = name.replace(".svga","")
//                    }
                    downloadManager?.downLoadCallback(url + fileName, fileName, object : DownloadCallback {
                        override fun downloadSuccess() {
                            NSLog.d(TAG, "download >> Success : ${url}${fileName}")
                        }

                        override fun downloadFailure(errorMsg: String) {

                        }
                    })
                } else {

                    return FileInputStream(file)
                }

            }
        } catch (e : Exception){
            e.printStackTrace()
        }

        return null
    }

    /**
     * 获取当前的本地动画
     */
    fun getPkFileSvga(url: String,name: String): FileInputStream? {
        NSLog.d(TAG, "download_svga >> getPkFileSvga : $name")
        try{
            val file = File(pkPath, name)

            /**
             * 删除当前别的动画
             */
            var directory = File(pkPath)

            if (directory?.exists()){
                NSLog.d("getPkFileSvga    礼物是否存在 ${!file.exists() || getFileSize(file) <= 0}")
                if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                    //本地下载
                    if (downloadManager == null) {
                        downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
                    }
//                    var fileName = name
//                    if (name.contains(".svga")){
//                        fileName = name.replace(".svga","")
//                    }
                    downloadManager?.downLoadCallback(url + name, name, object : DownloadCallback {
                        override fun downloadSuccess() {
                            NSLog.d(TAG, "download_svga >> Success : $url$name")
                        }

                        override fun downloadFailure(errorMsg: String) {
                            NSLog.d(TAG, "download_svga >> fialed : $url$name")
                        }
                    })
                } else {

                    return FileInputStream(file)
                }

            }
        } catch (e : Exception){
            e.printStackTrace()
        }

        return null
    }


    /**
     * 获取当前的本地动画
     */
    fun getOldBackSvga(url: String,name: String): FileInputStream? {
        NSLog.d(TAG, "download_svga >> getOldBackSvga : $name")
        try{
            val file = File(deskPath, name)

            /**
             * 删除当前别的动画
             */
            var directory = File(deskPath)

            if (directory?.exists()){
                if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                    //本地下载
                    if (downloadManager == null) {
                        downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
                    }
//                    var fileName = name
//                    if (name.contains(".svga")){
//                        fileName = name.replace(".svga","")
//                    }
                    downloadManager?.downLoadCallback(url + name, name, object : DownloadCallback {
                        override fun downloadSuccess() {
                            NSLog.d(TAG, "download_svga >> Success : $url$name")
                        }

                        override fun downloadFailure(errorMsg: String) {
                            NSLog.d(TAG, "download_svga >> fialed : $url$name")
                        }
                    })
                } else {

                    return FileInputStream(file)
                }

            }
        } catch (e : Exception){
            e.printStackTrace()
        }

        return null
    }

    /**
     * 下载直播间视频文件(动画效果)
     * @param parentDir : 优先存放在外部存储的私有路径
     * @param fileName :  文件的下载路径 && 文件的保存name 相同
     */
    fun getMBLiveRoomVideoFile(url: String, parentDir: String, fileName: String) {
        val parentFile=File(parentDir)
        if (!parentFile.exists()){
            parentFile.mkdirs()
        }
        val file = File(parentDir, fileName)
        if (file.exists() && getFileSize(file) > 0) {
            return
        }
        file.createNewFile()


        NSLog.d(MBLiveAlphaVideoHelper.Tag, "downLoad : url : $url , path : ${file.absolutePath}")

        // 下载路径    下载后需要保存的文件   回调
        OkHttpManager.getInstance().downLoadVideoFile(url,parentDir,fileName, file, object : DownloadCallback {
            override fun downloadSuccess() {
                NSLog.d(MBLiveAlphaVideoHelper.Tag, "end : down load video file success")
            }

            override fun downloadFailure(errorMsg: String) {
                file.delete()
                NSLog.d(MBLiveAlphaVideoHelper.Tag, "end : down load video file failure : $errorMsg")
            }
        })
    }


}