package com.ninexiu.sixninexiu.common.util

import android.app.Activity
import android.app.AlarmManager
import android.app.PendingIntent
import android.content.Context
import android.content.Intent
import com.ninexiu.sixninexiu.activity.TeensModelVerActivity
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.CommonChildrenAndParentsUtils
import com.ninexiu.sixninexiu.receiver.SystemInfoReceivers

object ChildrenAndParentsUitls: CommonChildrenAndParentsUtils() {

    // 进行闹铃注册
    var manager: AlarmManager? = null

    // 防止重复登录后弹出22点弹框
    var isShow: Boolean = false

    // 40分钟
    const val FORTY_MINUTE_MAX:Long = 40 * 60 * 1000

    fun init(context: Context) {
        everyDayTask(context)
    }

    // 获取青少年状态
    fun isChildrenModle(): Boolean {
        return AppCnfSpHelper.getInstance().isChildrenModle
    }

    // 设置青少年状态
    fun setChildrenModle(isChildrenModle: Boolean) {
        AppCnfSpHelper.getInstance().isChildrenModle = isChildrenModle
    }

    // 获取青少年密码
    fun getTeenagersPassword(): String? {
        return AppCnfSpHelper.getInstance().teenagersPassword
    }

    // 设置青少年密码
    fun setTeenagersPassword(teenagersPassword: String) {
        AppCnfSpHelper.getInstance().saveTeenagersPassword(teenagersPassword)
    }

    fun isIsShow(): Boolean {
        return isShow
    }

    fun setIsShow(isShow: Boolean) {
        this.isShow = isShow
    }

    //青少年每日22点和第二天6点发送定时任务
    fun everyDayTask(context: Context) {


        val alarmMgr = context.getSystemService(Context.ALARM_SERVICE) as AlarmManager
        val twentyAndSixTime = TimeUtil.getTwentyAndSixTime()

        // 22点定时广播
        val intent22 = Intent(context, SystemInfoReceivers::class.java)
        intent22.action = NSReceiverAction.ACTION_CHILDRENMODLE_NIGHT
        val pendIntent22 = PendingIntent.getBroadcast(context,
            0, intent22, PendingIntent.FLAG_UPDATE_CURRENT)

        NSLog.d("NSActivityLifecycleCallbacks"," 22 dian " + twentyAndSixTime[0])

        alarmMgr.set(AlarmManager.RTC_WAKEUP, twentyAndSixTime[0], pendIntent22)
    }

    /**
     * 是否22时至次日6时期间的青少年模式
     */
    fun isNightState(): Boolean {
        return TimeUtil.isCurrentInTimeScope(22, 0, 6, 0) && isChildrenModle()
    }

    /**
     * 开启40分钟广播
     */
    fun startFortyMinutesBordcats(activity : Activity) {
        var laveTime = FORTY_MINUTE_MAX - AppCnfSpHelper.getInstance().childrenStatistics!!

        if (laveTime < 0){
            TeensModelVerActivity.startFlags(activity, false, 1)
            return
        }

        NSLog.d("NSActivityLifecycleCallbacks", "开启40 分钟 laveTime = $laveTime")
        //        if (ConfigSpHelper.getInstance().childrenStatistics!! > (2 * 60 * 1000)) {
        val alarmMgr = activity.getSystemService(Context.ALARM_SERVICE) as AlarmManager
        val intent = Intent(activity, SystemInfoReceivers::class.java)
        intent.action = NSReceiverAction.ACTION_TEENS_MODEL_TIMER
        val requestCode = 3
        val pendIntent = PendingIntent.getBroadcast(activity,
            requestCode, intent, PendingIntent.FLAG_UPDATE_CURRENT)
        // 5秒后发送广播，只发送一次
        var triggerAtTime: Long = System.currentTimeMillis() + laveTime

        //            if (Build.VERSION.SDK_INT < 19) {
        alarmMgr.set(AlarmManager.RTC_WAKEUP, triggerAtTime, pendIntent)
        //            } else {
        //                alarmMgr.setExact(AlarmManager.RTC_WAKEUP, triggerAtTime, pendIntent)
        //            }
        //        }
    }

    /**
     * 重置40分钟计时
     */
    fun resetFortyMinutes(activity : Activity){
        AppCnfSpHelper.getInstance().childrenStatistics = 0L
        val alarmMgr = activity.getSystemService(Context.ALARM_SERVICE) as AlarmManager
        val intent = Intent(activity, SystemInfoReceivers::class.java)
        intent.action = NSReceiverAction.ACTION_TEENS_MODEL_TIMER
        val requestCode = 3
        val pendIntent = PendingIntent.getBroadcast(activity,
            requestCode, intent, PendingIntent.FLAG_UPDATE_CURRENT)
        alarmMgr.cancel(pendIntent)
    }


}