package com.ninexiu.sixninexiu.common.util.CountTechnology

import java.lang.Exception

/**
 *
 * @CreateDate: 2021/5/28 15:42
 * @Author:     wangyu
 * @Description: 数数科技功能模块事件保存集合
 * @Version:    1.0
 */
object TDEventMap {

    val tableEventMap = HashMap<String, Int>() //table
    val liveEventMap = HashMap<String, Int>() //首页table
    val findEventMap = HashMap<String, Int>() //发现table
    val attentionEventMap = HashMap<String, Int>() //关注table
    val mineEventMap = HashMap<String, Int>() //我的table
    val liveRoomEventMap = HashMap<String, Any>() //离开直播间

    fun getLiveRoomEventMapIntValue(key: String): Int {
        try {
            return liveRoomEventMap[key] as Int
        } catch (e: Exception) {
            return 0
        }
    }

    fun putLiveRoomEventMapIntValue(key: String, value: Any) {
        try {
            liveRoomEventMap[key] = value
        }catch (e:Exception){

        }
    }

//    companion object {
//        private var tdebeinstance: TDEventMap? = null
//            get() {
//                if (field == null) {
//                    field = TDEventMap()
//                }
//                return field
//            }
//
//        @Synchronized
//        fun get(): TDEventMap {
//            return tdebeinstance!!
//        }
//    }

    /**
     * 重置本地统计消息
     * -1为全部
     * 0 首页  1  发现   3 关注  4  我的  5 直播间
     */
    fun init(type:Int) {
        when(type){
            0-> resetHome()
            1-> resetFind()
            3-> resetAttention()
            4-> resetMine()
            5->resetLiveRoom()
            -1->{
                resetHome()
                resetFind()
                resetAttention()
                resetMine()
                resetLiveRoom()
            }
        }
    }

    fun initialTable() {
        tableEventMap[TDEventName.TD_LIVE] = 0
        tableEventMap[TDEventName.TD_CONCERN] = 0
        tableEventMap[TDEventName.TD_NEWS] = 0
        tableEventMap[TDEventName.TD_FIND] = 0
        tableEventMap[TDEventName.TD_MINE] = 0
    }

    private fun resetHome(){
        liveEventMap[TDEventName.LIVE_SEARCH] = 0
        liveEventMap[TDEventName.LIVE_HISTORY_PLAY] = 0
        liveEventMap[TDEventName.LIVE_HOT] = 0
        liveEventMap[TDEventName.LIVE_FRIEND] = 0
        liveEventMap[TDEventName.LIVE_NEARBY] = 0
        liveEventMap[TDEventName.LIVE_WARTH_DUATION] = 0
        liveEventMap[TDEventName.LIVE_HOT_ANTHOR_NUMBER] = 4
        liveEventMap[TDEventName.POSITIVE_ENERGY] = 0
        liveEventMap[TDEventName.LIVE_MUSIC] = 0
        liveEventMap[TDEventName.LIVE_DANCE] = 0
        liveEventMap[TDEventName.LIVE_RECREATION] = 0
        liveEventMap[TDEventName.LIVE_CAMPUS] = 0
        liveEventMap[TDEventName.LIVE_MORE_RECOMMEND] = 0
        liveEventMap[TDEventName.LIVE_MORE_NEWANTHOR] = 0
        liveEventMap[TDEventName.LIVE_MORE_HOT] = 0
        liveEventMap[TDEventName.LIVE_FRIEND_WARTH_DUATION] = 0
        liveEventMap[TDEventName.LIVE_FRINED_ANTHOR_NUMBER] = 0
        liveEventMap[TDEventName.LIVE_HOST_LIST] = 0
        liveEventMap[TDEventName.LIVE_NEARBY_WARTH_DUATION] = 0
        liveEventMap[TDEventName.LIVE_NEARBY_ANTHOR_NUMBER] = 0
    }

    private fun resetFind(){
        findEventMap[TDEventName.FIND_PUBLISH] = 0
        findEventMap[TDEventName.FIND_RECOMMEND] = 0
        findEventMap[TDEventName.FIND_FIND] = 0
        findEventMap[TDEventName.FIND_LEADERBOARD] = 0
        findEventMap[TDEventName.FIND_RECOMMEND_WARTH_DUATION] = 0
        findEventMap[TDEventName.FIND_DYNAMIC_NUMBER] = 0
        findEventMap[TDEventName.FIND_NEWCOMER] = 0
        findEventMap[TDEventName.FIND_FAMILY] = 0
        findEventMap[TDEventName.FIND_ACTIVITY] = 0
    }

    private fun resetAttention(){
        attentionEventMap[TDEventName.ATTENTION_CONCERN] = 0
        attentionEventMap[TDEventName.ATTENTION_DYNAMIC] = 0
        attentionEventMap[TDEventName.ATTENTION_SEARCH] = 0
    }

    private fun resetMine(){
        mineEventMap[TDEventName.MINE_MINE] = 0
        mineEventMap[TDEventName.MINE_RECHARGE] = 0
        mineEventMap[TDEventName.MINE_PROPS_MALL] = 0
        mineEventMap[TDEventName.MINE_HELP] = 0
    }

    private fun resetLiveRoom(){
        liveRoomEventMap[TDEventName.Live_Room_01] = false
        liveRoomEventMap[TDEventName.Live_Room_ROOMID] = 0
        liveRoomEventMap[TDEventName.Live_Room_CHANLE] = ""
        liveRoomEventMap[TDEventName.Live_Room_ROOMTYPE] = ""
        liveRoomEventMap[TDEventName.LIVE_ROOM_PUBLIC_CHAT] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_PRIVATE_CHAT] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_MENU] = 0
        liveRoomEventMap[TDEventName.Live_Room_TASK] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_FULL_SCREEN] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_SERVING_WHEAT] = 0
        liveRoomEventMap[TDEventName.Live_Room_GIFT] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_SEND] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_SEND_SUCCESS] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_SEND_FAST] = 0
        liveRoomEventMap[TDEventName.Live_Room_FirstRECHARGE] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_ONEPACKAGE] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_SWIPELEFT_NUMBER] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_SWIPELEFT_TIME] = 0
        liveRoomEventMap[TDEventName.Live_Room_ANTHORCARD] = 0
        liveRoomEventMap[TDEventName.Live_Room_ANTHORCARD_GREET] = 0
        liveRoomEventMap[TDEventName.Live_Room_ANTHORCARD_DATA] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_ONLINEBTN] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_CLOSEBTN] = 0
        liveRoomEventMap[TDEventName.LIVE_ROOM_UPANDDOWN] = 0
    }
}