package com.ninexiu.sixninexiu.common.util

import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.common.util.svg.down.DownloadCallback
import com.ninexiu.sixninexiu.common.util.svg.down.OkhttpDownload
import com.zhongrun.nineshow_base.utils.NineShowFilePathManager
import java.io.File
import java.io.FileInputStream
import java.io.FileNotFoundException
import java.io.IOException


/**
 * <pre>
 *     @author : wangyu
 *     time   : 2020/10/13
 *     desc   : 头像框svg管理类
 *     version: 1.0
 * </pre>
 */
class FrameResourcesDownManage {

    private val TAG: String = BigResourcesDownManage.javaClass.simpleName

    private val deskPath = NineShowFilePathManager.INSTANCE.getExterFileDir(NineShowFilePathManager.FRAME_DIR)

    private var downloadManager: OkhttpDownload? = null

    companion object {

        private var instance: FrameResourcesDownManage? = null
            get() {
                if (field == null) {
                    field = FrameResourcesDownManage()
                }
                return field
            }
        fun get(): FrameResourcesDownManage{
            return instance!!
        }
    }




    /**
     * 获取指定文件大小
     * @param file
     * @return
     * @throws Exception 　　
     */
    fun getFileSize(file: File): Long {
        var size: Long = 0
        try {
            if (file.exists()) {
                var fis: FileInputStream? = null
                fis = FileInputStream(file)
                size = fis.available().toLong()
            } else {
                file.createNewFile()
            }
        } catch (e: FileNotFoundException) {
            e.printStackTrace()
        } catch (e: IOException) {
            e.printStackTrace()
        }

        return size
    }

    /**
     * 获取当前的本地动画
     */
    fun getSvga(frameID: String): FileInputStream? {

        try{
            val file = File(deskPath, frameID)

            /**
             * 删除当前别的动画
             */
            var directory = File(deskPath)

            if (directory?.exists()){
                if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                    //本地下载
                    if (downloadManager == null) {
                        downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
                    }
//                    var fileName = frameID
//                    if (frameID.contains(".svga")){
//                        fileName = frameID.replace(".svga","")
//                    }
                    downloadManager?.downLoadCallback(Constants.HTTP_HEADFRAME_RESOURCES + frameID, frameID, object : DownloadCallback {
                        override fun downloadSuccess() {
                            NSLog.d(TAG, "downloadSuccess")
                        }

                        override fun downloadFailure(errorMsg: String) {

                        }
                    })
                } else {

                    return FileInputStream(file)
                }

            }
        } catch (e : Exception){
            e.printStackTrace()
        }

        return null
    }

}