package com.ninexiu.sixninexiu.common.util

import android.annotation.SuppressLint
import android.app.Activity
import android.text.TextUtils
import android.util.Log
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.RelativeLayout
import android.widget.Toast
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication.roomType
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.bean.GiftInfo
import com.ninexiu.sixninexiu.bean.SummerUnionContestLiveBean
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.view.*
import com.opensource.svgaplayer.*
import com.opensource.svgaplayer.SVGAParser.ParseCompletion
import kotlinx.android.synthetic.main.pop_summer_union_gold_master_layout.view.*
import kotlinx.android.synthetic.main.popup_summer_union_contest_treasure_chest.view.*
import org.jetbrains.anko.alignParentRight
import org.jetbrains.anko.alignParentStart
import org.jetbrains.anko.alignParentTop
import org.jetbrains.anko.below
import org.json.JSONObject


class SummerUnionContestManger {

    var roomId: String? = null
    lateinit var mRoot: View
    lateinit var dragLayout: SummerGuildTimerView
    lateinit var activity: Activity
    var showType: Int = 2

    companion object {

        const val TAG = "SummerUnionContestManger"

        private var instance: SummerUnionContestManger? = null

        @Synchronized
        fun get(): SummerUnionContestManger {
            if (null == instance) instance = SummerUnionContestManger()
            return instance!!
        }
    }


    /**
     * 初始化数据
     */
    fun initData(activity: Activity, rid: String, rootView: View, showType: Int) {
        this.activity = activity
        this.roomId = rid
        this.mRoot = rootView
        this.showType = showType
        requestData()
        initVoiceView()

    }

    /**
     * 根据房间类型设置不同的位置
     */

    private fun initVoiceView() {

        //倒计时view
        var consSummerUnionContestCountDown =
                mRoot.findViewById<ConstraintLayout>(R.id.include_summer_union_contest_count_down)
        var countDownParams = RelativeLayout.LayoutParams(
                ViewGroup.LayoutParams.WRAP_CONTENT,
                ViewGroup.LayoutParams.WRAP_CONTENT
        )

        //工会PK View
        dragLayout = mRoot.findViewById<SummerGuildTimerView>(R.id.include_summer_union_contest_pk)
        var pkLayoutParams = RelativeLayout.LayoutParams(dp2px(activity, 154), dp2px(activity, 74))

        dragLayout.initData(activity)

        //直播间
        if (showType != 19) {

            countDownParams.apply {

                below(R.id.ll_mblive_head)
                alignParentStart()
                marginStart = dp2px(activity, 7)
                topMargin = dp2px(activity, 6)

            }

            pkLayoutParams.apply {

                alignParentRight()
                below(R.id.ns_live_video)
                rightMargin = dp2px(activity, 12)
                topMargin = dp2px(activity, 12)

            }


        } else {//语音房


            countDownParams.apply {

                alignParentTop()
                alignParentRight()
                rightMargin = dp2px(activity, 7)
                topMargin = dp2px(activity, 40)

            }

            pkLayoutParams.apply {

                alignParentRight()
                below(R.id.rl_voice_root)
                rightMargin = dp2px(activity, 12)
                topMargin = dp2px(activity, 12)

            }
        }

        consSummerUnionContestCountDown.layoutParams = countDownParams
        dragLayout.layoutParams = pkLayoutParams

    }


    //夏季工会赛弹窗点击事件
    val summerUnionContestClick = View.OnClickListener {
        when (it.id) {
            //萌新中奖送出
            R.id.img_summer_union_new_blood_give -> {

                val giftInfo = GiftInfo()
                giftInfo.gid = 2000707
                giftInfo.name = "助力票"
                summerUnionContestInterface?.onSendNewBloodPowerTicket(giftInfo)
                newBloodPopupHelr?.dismiss()

            }
            //取消
            R.id.img_summer_union_new_blood_accept, R.id.cancel, R.id.img_open_privilege_cancel -> {

                popupHelper?.dismiss()
            }
            //确定开启金主特权
            R.id.img_open_privilege_commit -> {

                val giftInfo = GiftInfo()
                giftInfo.gid = 2000709
                giftInfo.name = "金主特权"
                summerUnionContestInterface?.onSendNewBloodPowerTicket(giftInfo)
                popupHelper?.dismiss()

            }


        }
    }

    var popupHelper: PopupWindowHelper? = null


    /**
     * 展示投票
     */
    fun liveVoteShow(bean: SummerUnionContestLiveBean?) {

//        var view = mRoot.findViewById<DragLayout>(R.id.include_summer_union_contest_pk)
        if (dragLayout?.visibility != View.VISIBLE) {
            UIUtils.showView(dragLayout)
        }

        dragLayout?.liveVoteShow(bean)
        //左侧工会信息
//        dragLayout?.tv_union_contest_left_name.text = bean?.fname
//        dragLayout?.tv_union_contest_left_num.text = bean?.score.toString()
//
//        if (bean?.combat_family != null) {
//            //右侧工会信息
//            var combatFamily = bean?.combat_family
//            dragLayout?.tv_union_contest_right_name.text = combatFamily?.fname
//            dragLayout?.tv_union_contest_right_num.text = combatFamily?.score.toString()
//        }


    }

    /**
     * 倒计时启动
     */

    fun startCountDown(time: Int) {

        //显示倒计时
        UIUtils.showView(mRoot.findViewById(R.id.include_summer_union_contest_count_down))

        //倒计时textView
        var tvSummerContestCountDown =
                mRoot.findViewById<CountDownTextView>(R.id.tv_summer_contest_count_down)

        //开始倒计时
        tvSummerContestCountDown.startCutDown("", "s", time.toLong()) { time: Long ->
            return@startCutDown time.toString()
        }

        //倒计时结束
        tvSummerContestCountDown.timeOver = {
            //隐藏倒计时
            UIUtils.goneView(mRoot.findViewById(R.id.include_summer_union_contest_count_down))
        }


    }

    var bean: SummerUnionContestLiveBean? = null


    /**
     * 加载夏日工会赛数据
     */
    fun requestData() {
        var okHttpClient = NsOkHttpClient.getNsOkHttpClient()
        var params = NSRequestParams()
        params.put("rid", roomId)
        okHttpClient.doGet(
                Constants.GET_SUMMER_UNION_CONTEST,
                params,
                object : NSGsonObjectNewCallback<BaseResultInfo>() {

                    @SuppressLint("LongLogTag")
                    override fun onSuccess(
                            statusCode: Int,
                            responseString: String?,
                            message: String?,
                            response: BaseResultInfo?
                    ) {

                        //防止後台亂返回數據
                        try {

                            if (statusCode == 200) {
                                UIUtils.showView(mRoot)
                                var jsonObject = JSONObject(responseString)
                                NSLog.d(TAG, "onSuccess: $responseString")
                                //data为null直接结束方法
                                var data: JSONObject? = jsonObject.optJSONObject("data") ?: return

                                bean = GsonUtil.fromJson(
                                        jsonObject?.optString("data"),
                                        SummerUnionContestLiveBean::class.java
                                )
                                        ?: return

                                NSLog.d(TAG, "onSuccess: $bean")


                                //展示家族对战信息
                                if (TextUtils.equals(bean?.stage, "final") && bean?.is_die != null && bean?.is_die == 0) {
                                    liveVoteShow(bean)
                                }


                                //弹出金主特权宝箱
                                if (bean?.gold_master_num != 0) {

                                    NSLog.d(TAG, "onSuccess: " + bean?.gold_master_num)
                                    var view = LayoutInflater.from(activity).inflate(
                                            R.layout.popup_summer_union_contest_treasure_chest,
                                            null
                                    )
                                    openSummerUnionContestPopup(view, mRoot)
                                    //当不满足金主特权弹窗的条件时，判断是否符合萌新弹窗的条件
                                } else if (bean?.is_first != 0) {

                                    var view = LayoutInflater.from(activity).inflate(
                                            R.layout.pop_summer_union_contest_new_people_layout,
                                            null
                                    )
                                    openSummerUnionContestPopup(view, mRoot)

                                } else {
                                    //当公会赛两种弹窗都不满足的情况下，直接执行新弹窗
                                    summerUnionPopupStatus?.onPopupStatus()
                                }


                                //倒计时
                                if (bean?.gold_master_time != null && bean?.gold_master_time != 0) {
                                    startCountDown(bean?.gold_master_time!!)
                                }


                            }


                        } catch (e: Exception) {
                            e.printStackTrace()
                        }


                    }

                    @SuppressLint("LongLogTag")
                    override fun onFailure(statusCode: Int, errorMsg: String?) {
                        NSLog.d(TAG, "onFailure: $errorMsg+errorCode$statusCode")
                    }

                })
    }

    var svgaImageView: SVGAImageView? = null
    var svgParser: SVGAParser? = null
    var newBloodPopupHelr: PopupWindowHelper? = null

    /**
     * 打开弹窗
     */
    fun openSummerUnionContestPopup(view: View, parentView: View) {

        popupHelper = PopupWindowHelper(view)

        popupHelper?.showAtLocation(parentView, Gravity.CENTER, 0, 0)


        when (view.id) {
            //开启金主特权弹窗
            R.id.cons_summer_union_gold_master -> {
                view.findViewById<ImageView>(R.id.img_open_privilege_cancel)
                        .setOnClickListener(summerUnionContestClick)
                view.findViewById<ImageView>(R.id.img_open_privilege_commit)
                        .setOnClickListener(summerUnionContestClick)
            }
            //萌新中奖弹窗
            R.id.cons_summer_union_new_blood -> {
                view.findViewById<ImageView>(R.id.img_summer_union_new_blood_accept)
                        .setOnClickListener(summerUnionContestClick)
                view.findViewById<ImageView>(R.id.img_summer_union_new_blood_give)
                        .setOnClickListener(summerUnionContestClick)
                newBloodPopupHelr = popupHelper


                popupHelper?.setPopupWindowDismissListener {
                    //直接加载新弹窗
                    summerUnionPopupStatus?.onPopupStatus()
                }


            }

            //充值宝箱弹窗
            R.id.img_summer_union_treasure_chest -> {


                svgaImageView = view.svga_summer_union_treasure_chest

                playGiftAnimation("summer_union_contest_treasure_chest.svga")
            }

            //充值中奖弹窗
            R.id.cons_summer_union_gold_master_win_the_prize -> {

                Toast.makeText(activity, "三秒后自动关闭", Toast.LENGTH_SHORT).show()
                //三秒后自动关闭
                NsOkHttpClient.getNsOkHttpClient().handler.postDelayed({

                    popupHelper?.dismiss()


                }, 3000)


                popupHelper?.setPopupWindowDismissListener {

                    Log.d("chengle", "openSummerUnionContestPopup: ")

                    //充值弹窗关闭时判断是否符合执行萌新弹窗的条件
                    if (bean?.is_first != 0) {

                        var newView = LayoutInflater.from(activity).inflate(
                                R.layout.pop_summer_union_contest_new_people_layout,
                                null
                        )
                        openSummerUnionContestPopup(newView, mRoot)

                    } else {
                        //不符合直接加载新弹窗
                        summerUnionPopupStatus?.onPopupStatus()
                    }


                }

            }

        }


    }


    /**
     * 加载宝箱动画
     */
    private fun playGiftAnimation(svgName: String) {
        svgParser = SVGAParser.Companion.shareParser()

        svgParser?.decodeFromAssets(svgName, object : ParseCompletion {
            override fun onComplete(mSVGAVideoEntity: SVGAVideoEntity) {
                NSLog.d("SummerUnion", "onPause: ")
                svgaImageView?.setVideoItem(mSVGAVideoEntity)
                svgaImageView?.startAnimation()
            }

            @SuppressLint("LongLogTag")
            override fun onError() {
                NSLog.d(TAG, "onError: ")

            }
        },null)


        svgaImageView?.callback = object : SVGACallback {
            override fun onPause() {
                NSLog.d("SummerUnion", "onPause: ")
                //动画暂停
            }

            //svg播放结束展示金主特权卡
            override fun onFinished() {

                //结束释放svg
                svgaImageView = null
                svgParser = null

                //加载宝箱弹框
                val view = LayoutInflater.from(activity)
                        .inflate(R.layout.pop_summer_union_gold_master_layout, null)

                view.tv_summer_gold_master_num.text = activity.getString(
                        R.string.congratulations_on_getting_the_gold_lord_privilege,
                        bean?.gold_master_num.toString()
                )

                openSummerUnionContestPopup(view, mRoot)
            }

            override fun onRepeat() {
                NSLog.d("SummerUnion", "onRepeat: ")

                //重复播放
            }

            override fun onStep(i: Int, v: Double) {
                NSLog.d("SummerUnion", "onStep: ")

                //动画步骤
            }
        }

    }

    //长连接数据
    fun showSummerUnionContestSocket(summerUnionContestLiveBean: SummerUnionContestLiveBean?) {


        summerUnionContestLiveBean?.let {

            //倒计时
            if (it.gold_master_time != null && it.gold_master_time != 0) {
                startCountDown(it.gold_master_time)
            }

            //展示家族对战信息
            if (TextUtils.equals(it.stage, "final") && it.is_die != null && it.is_die != 1) {
                liveVoteShow(it)
            }


        }


    }

    var summerUnionContestInterface: SummerUnionContestInterface? = null


    interface SummerUnionContestInterface {
        //萌新送礼接口回调
        fun onSendNewBloodPowerTicket(giftInfo: GiftInfo)

    }

    var summerUnionPopupStatus: SummerUnionPopupStatusInterface? = null

    interface SummerUnionPopupStatusInterface {
        fun onPopupStatus()
    }


    //释放资源
    fun onRelease() {


        if (popupHelper != null) {

            popupHelper?.dismiss()
            popupHelper = null

        }

        if (svgaImageView != null) {
            svgaImageView = null
        }

        if (svgParser != null) {
            svgParser = null
        }

        if (newBloodPopupHelr != null) {
            newBloodPopupHelr?.dismiss()
            newBloodPopupHelr = null
        }


    }


}