package com.ninexiu.sixninexiu.common.util

import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import java.util.*

/**
 * <pre>
 *     @author : gh
 *     time   : 2021/1/19 0019
 *     desc   : 统计刚注册用户在线时长
 *     version: 1.0
 * </pre>
 */
class UpStatisticOnlineDurationManager {

    private var mTimer: Timer? = null
    private var mTimerTask: TimerTask? = null

    companion object {
        private var instance: UpStatisticOnlineDurationManager? = null
            get() {
                if (field == null) {
                    field = UpStatisticOnlineDurationManager()
                }
                return field
            }

        @Synchronized
        fun get(): UpStatisticOnlineDurationManager {
            return instance!!
        }

    }

    /**
     * 开始上报注册用户心跳
     */
    fun startUpDuration() {
        release()
        mTimerTask = object : TimerTask() {
            override fun run() {
                upDuration()
            }
        }
        mTimer = Timer()
        // 新用户上报在线时长
        mTimer!!.schedule(mTimerTask, 0, 60000)
    }

    /**
     * 上报时长接口
     */
    fun upDuration() {
        if (NineShowApplication.mUserBase == null) {
            return
        }
        val okHttpClient: NsOkHttpClient = NsOkHttpClient.getNsOkHttpClient()
        // 请求链接不进行转码
        val params = NSRequestParams()
        params.put("uid", NineShowApplication.mUserBase?.uid)
        // 1 前台在线（用户正在使用户APP），2 后台在线（用户APP后台挂起）
        params.put("actType", if (NineShowApplication.mIsSwitchDesktop) 2 else 1)

        okHttpClient.doGet(Constants.HTTP_UP_STATISTICS_ONLINE_DURATION, params, object : NSGsonObjectNewCallback<BaseResultInfo>() {

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: BaseResultInfo?) {
//                if (statusCode == 401) {
//                    release()
//                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

    /**
     * 关闭心跳包
     */
    fun release() {
        NSLog.e("startMicHeartBeat", "-stopMicHeart-------")

        mTimer?.cancel()
        mTimerTask?.cancel()

        mTimer = null
        mTimerTask = null
    }

}