package com.ninexiu.sixninexiu.common.util

import android.content.Context
import android.os.Bundle
import android.os.Handler
import android.os.Message
import android.text.TextUtils
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.appcompat.widget.AppCompatImageView
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.view.VoiceGameSvgManagerView
import com.ninexiu.sixninexiu.view.dialog.VoiceChaosResultDialog
import com.ninexiu.sixninexiu.view.getMaskBitmap
import com.ninexiu.sixninexiu.view.popwindow.VoiceChaosRankPopWindow
import com.ninexiu.sixninexiu.view.showOrGoneView
import java.lang.ref.WeakReference
import com.ninexiu.sixninexiu.view.CountDownTextView as CountDownTextView1

/**
 * <pre>
 *     @author : wtengfei
 *     time   : 2021/9/14
 *     desc   : 多人语音房大乱斗活动
 *     version: 1.0
 * </pre>
 */
class VoiceChaosManager(val mContext: Context, private val rootView: RelativeLayout?,
                        private val voiceManager: MBLiveVoiceManeger?,val countDownView: ConstraintLayout?): View.OnClickListener {

    val handler = MyHandler(this)
    private var mContentView :RelativeLayout? = null
    private var voiceChaosRankPopWindow: VoiceChaosRankPopWindow? = null
    private var mainView : View? = null
    var boxIv :ImageView? = null
    var viewLeftSchedule :View? = null
    var viewRightSchedule :View? = null
    var bgLeftUserImageView :AppCompatImageView? = null
    var bgRightUserImageView :AppCompatImageView? = null
    var leftRankTv :TextView? = null
    var rightRankTv :TextView? = null
    var pkPushTime :TextView? = null
    var iconLeftMvpUser :ImageView? = null
    var iconRightMvpUser :ImageView? = null
    private var iconWin :ImageView? = null
    private var pkTv :TextView? = null
    private var pkIv :ImageView? = null
    private var overSecond :Int = 0
    private var leftName :String? = ""
    private var rightName :String? = ""
    private var pkState = 0 // 0未开始 1 pk中   2pk结束
    var remaintime = 0 //pk剩余秒数
    private var rewardTime = 0 // 奖励秒数
    var boxLevel = 1
    private var leftTotalPrice = "0"
    private var rightTotalPrice = "0"
    private var voiceChaosIsWin = "1" //是否胜利
    private var voiceSvgManagerTopView :VoiceGameSvgManagerView? = null
    var roomInfo :RoomInfo? = null
    private var isShowSvga = false
    var dialog :VoiceChaosResultDialog? = null
    var isClickingBox = false
    var isGetBox = false
    private var leftUserResult : VoiceChaosUserResult? = null
    private var rightUserResult : VoiceChaosUserResult? = null
    private var limitOverScore :Long = 100000
    var isFinish = false
    var responseSrc = R.drawable.icon_50w_box

    fun initView(){
        isFinish = false
        rootView?.let {
            it.showOrGoneView(true)
            if(mContentView == null){
                mContentView = rootView.findViewById(R.id.voiceChaosLayout)
                mContentView?.showOrGoneView(true)
            }
            if(mainView == null){
                mainView = LayoutInflater.from(mContext).inflate(R.layout.layout_voice_chaos, mContentView)
                mainView?.let { view->
                    boxIv = view.findViewById(R.id.boxIv)
                    boxIv?.setOnClickListener(this)
                    viewLeftSchedule = view.findViewById(R.id.viewLeftSchedule)
                    viewRightSchedule = view.findViewById(R.id.viewRightSchedule)
                    bgLeftUserImageView = view.findViewById(R.id.bgLeftUserImageView)
                    bgRightUserImageView = view.findViewById(R.id.bgRightUserImageView)
                    leftRankTv = view.findViewById(R.id.leftRankTv)
                    rightRankTv = view.findViewById(R.id.rightRankTv)
                    iconLeftMvpUser = view.findViewById(R.id.iconLeftMvpUser)
                    iconRightMvpUser = view.findViewById(R.id.iconRightMvpUser)
                    pkPushTime = view.findViewById(R.id.pkPushTime)
                    iconWin = view.findViewById(R.id.icon_win)
                    pkTv = view.findViewById(R.id.pkTv)
                    pkIv = view.findViewById(R.id.pkIv)
                    bgRightUserImageView?.setOnClickListener(this)
                }

            }
        }
    }

    /**
     * 大乱斗开始   收到chatmessage 消息
     */
    fun showStartView(voiceChaosResult :VoiceChaosResult){
        handler?.removeMessages(MyHandler.PK_START_TIME)
        isFinish = false
        pkState = 0
        this.overSecond = voiceChaosResult.over_second
        leftName = voiceChaosResult.leftnickname
        rightName = voiceChaosResult.rightnickname
        handler?.sendEmptyMessageDelayed(MyHandler.PK_START_TIME, 1000)
    }

    /**
     * 大乱斗开始   进房接口返回  getVoiceChaosInfo()
     */
    fun showStartView(overSecond :Int){
        isFinish = false
        pkState = 0
        this.overSecond = overSecond
        handler?.sendEmptyMessageDelayed(MyHandler.PK_START_TIME, 1000)
    }

    /**
     * pk中  收到chatmessage 消息  或  进房接口返回  getVoiceChaosInfo()
     */
    fun updateChaosData(voiceChaosContentResult : VoiceChaosContentResult?){
        isFinish = false
        voiceChaosContentResult?.let {
            val userList = voiceChaosContentResult.user
            if(!userList.isNullOrEmpty() && userList.size > 1){
                remaintime = it.remaintime
                initView()

                userList.forEach { userResult ->
                    if(TextUtils.equals(roomInfo?.rid.toString(),userResult.rid)){
                        leftUserResult = userResult
                    }else{
                        rightUserResult = userResult
                    }
                }
                //只初始化一次的数据
                if(pkState != 1){
                    bgLeftUserImageView?.getMaskBitmap(mContext,leftUserResult?.headimage,R.drawable.bg_left_white)
                    bgRightUserImageView?.getMaskBitmap(mContext,rightUserResult?.headimage,R.drawable.bg_right_white)
                }
                pkState = 1
                if(TextUtils.equals("神秘人",leftUserResult?.mvp_nickname)){
                    iconLeftMvpUser?.setImageResource(R.drawable.sendgift_mystery_head_icon)
                }else{
                    GlideUtils.loadCirclePic(mContext,leftUserResult?.mvp_headimage,iconLeftMvpUser,0)
                }
                if(TextUtils.equals("神秘人",rightUserResult?.mvp_nickname)){
                    iconRightMvpUser?.setImageResource(R.drawable.sendgift_mystery_head_icon)
                }else{
                    GlideUtils.loadCirclePic(mContext,rightUserResult?.mvp_headimage,iconRightMvpUser,0)
                }
                pkPushTime?.text = Utils.countDownTimeZeroFormat(remaintime)
                leftTotalPrice = leftUserResult?.totalprice?:leftTotalPrice
                rightTotalPrice = rightUserResult?.totalprice?:rightTotalPrice
                handler?.sendEmptyMessageDelayed(MyHandler.PK_REMAIN_TIME,1000)
                limitOverScore = leftUserResult?.limit_over_score?:limitOverScore
                //金主特权
                if(leftUserResult?.jinzhu_over_second?:0>0){
                    initJinZhuView(leftUserResult?.jinzhu_over_second?:0)
                }
                getBoxType(leftUserResult?.box_level?:boxLevel,limitOverScore)
                setPkProgress()
            }
        }
    }

    /**
     * pk 结束  收到chatmessage 消息  或  进房接口返回  getVoiceChaosInfo()
     */
    fun showChaosResult(voiceChaosContentResult : VoiceChaosContentResult?,tag :Boolean){
        isFinish = false
        handler?.removeMessages(MyHandler.PK_UPDATE_REST_TIME)
        voiceChaosContentResult?.let {
            val userList = voiceChaosContentResult.user
            if(!userList.isNullOrEmpty() && userList.size > 1){
                userList.forEach { userResult ->
                    if(TextUtils.equals(roomInfo?.rid.toString(),userResult.rid)){
                        leftUserResult = userResult
                    }else{
                        rightUserResult = userResult
                    }
                }
                // 只初始化一次的数据
                if(pkState != 2){
                    initView()
                    if(VoiceGameSvgHelper.svgVoiceChaosOpenBox == null){
                        VoiceGameSvgHelper.initOpenBoxSvg()
                    }
                    bgLeftUserImageView?.getMaskBitmap(mContext,leftUserResult?.headimage,R.drawable.bg_left_white)
                    bgRightUserImageView?.getMaskBitmap(mContext,rightUserResult?.headimage,R.drawable.bg_right_white)
                    if(TextUtils.equals("神秘人",leftUserResult?.mvp_nickname)){
                        iconLeftMvpUser?.setImageResource(R.drawable.sendgift_mystery_head_icon)
                    }else{
                        GlideUtils.loadCirclePic(mContext,leftUserResult?.mvp_headimage,iconLeftMvpUser,R.drawable.icon_voice_chaos_left_mvp_frame)
                    }
                    if(TextUtils.equals("神秘人",rightUserResult?.mvp_nickname)){
                        iconRightMvpUser?.setImageResource(R.drawable.sendgift_mystery_head_icon)
                    }else{
                        GlideUtils.loadCirclePic(mContext,rightUserResult?.mvp_headimage,iconRightMvpUser,R.drawable.icon_voice_chaos_right_mvp_frame)
                    }
                    pkPushTime?.text = Utils.countDownTimeZeroFormat(remaintime)
                    leftTotalPrice = leftUserResult?.totalprice?:leftTotalPrice
                    rightTotalPrice = rightUserResult?.totalprice?:rightTotalPrice
                    limitOverScore = leftUserResult?.limit_over_score?:limitOverScore
                    setPkProgress()
                }
                getBoxType(leftUserResult?.win_box_level?:boxLevel,limitOverScore)
                rewardTime = it.reward_time
                voiceChaosIsWin = leftUserResult?.result?:"1"
                if(leftTotalPrice.toLong() < 100000 ||!TextUtils.equals("1",voiceChaosIsWin)){
                    pkState = 2
                    if(tag && !TextUtils.equals("1",voiceChaosIsWin)){
                        if(dialog == null){
                            dialog = VoiceChaosResultDialog(mContext)
                        }
                        dialog?.show(0,"","",voiceChaosIsWin,leftTotalPrice.toInt())
                    }
                    resetView()
                    return
                }
                if(boxLevel<=0 || TextUtils.equals(roomInfo?.uid.toString(),leftUserResult?.uid)){
                    boxIv?.visibility = View.INVISIBLE
                }else{
                    boxIv.showOrGoneView(true)
                }
                if(pkState == 1){
                    voiceManager?.playVoiceChaosWinSvga(voiceChaosContentResult.success_path)
                }
                pkState = 2
                iconWin?.showOrGoneView(TextUtils.equals("1",voiceChaosIsWin))
                pkIv?.showOrGoneView(false)
                pkTv?.showOrGoneView(true)
                pkPushTime?.text = Utils.countDownTimeZeroFormat(rewardTime)
                handler?.sendEmptyMessageDelayed(MyHandler.PK_REST_TIME, 1000)
            }
        }
    }

    /**
     * 大乱斗开始逻辑
     */
    fun showStartAnimation(){
        overSecond --
        if(overSecond > 0){
            if(overSecond <= 5 && !isShowSvga){
                voiceSvgManagerTopView?.let {
                    isShowSvga = true
                    // 上层倒计时svg
                    it.showChaosPkCutDown(mContext,leftName?:"",rightName?:"") { isPlay ->
                        if (isPlay) {  // 结束以后开始背景动画
                            isShowSvga = false
                            voiceSvgManagerTopView?.reset()
                        } else {    //失败
                            isShowSvga = false
                            voiceSvgManagerTopView?.reset()
                        }
                    }
                }
            }
            handler?.sendEmptyMessageDelayed(MyHandler.PK_START_TIME, 1000)
        }
    }

    /**
     * 大乱斗pk中逻辑
     */
    fun updateReMainTime(){
//        handler?.removeMessages(MyHandler.PK_START_TIME)
        handler?.removeMessages(MyHandler.PK_REMAIN_TIME)
        remaintime --
        if(remaintime<0){
            handler?.sendEmptyMessageDelayed(MyHandler.PK_UPDATE_REST_TIME,5000)
            return
        }
        pkPushTime?.text = Utils.countDownTimeZeroFormat(remaintime)
        handler?.sendEmptyMessageDelayed(MyHandler.PK_REMAIN_TIME,1000)
    }
    /**
     * 大乱斗结束逻辑
     */
    fun showEndView(){
        handler?.removeMessages(MyHandler.PK_REMAIN_TIME)
        handler?.removeMessages(MyHandler.PK_REST_TIME)
        rewardTime --
        pkPushTime?.text = Utils.countDownTimeZeroFormat(rewardTime)
        if(rewardTime > 0){
            handler?.sendEmptyMessageDelayed(MyHandler.PK_REST_TIME, 1000)
        }else{
            resetView()
        }
    }

    /**
     * 设置宝箱状态
     */
    private fun getBoxType(level :Int,limitOver :Long){
       if(boxLevel != level){
           when (level) {
               2 -> {
                   responseSrc = R.drawable.icon_50w_box
               }
               3 -> {
                   responseSrc = R.drawable.icon_100w_box
               }
               else -> {
                   responseSrc = R.drawable.icon_10w_box

               }
           }
           boxIv?.setImageResource(responseSrc)
       }
        boxLevel = leftUserResult?.box_level?:boxLevel
        voiceChaosRankPopWindow?.let {
            if(it.isShow){
                it.setBoxLevel(leftTotalPrice,limitOver)
            }
        }
    }

    /**
     * 设置进度
     */
    private fun setPkProgress(){
        leftRankTv?.text = leftTotalPrice
        rightRankTv?.text = rightTotalPrice
        if(TextUtils.equals("0",leftTotalPrice) && TextUtils.equals("0",rightTotalPrice)){
            setPkProgress(viewLeftSchedule,1.toFloat())
            setPkProgress(viewRightSchedule,1.toFloat())
        }else{
            setPkProgress(viewLeftSchedule, leftTotalPrice.toFloat())
            setPkProgress(viewRightSchedule, rightTotalPrice.toFloat())
        }
    }

    /**
     * 设置单个view的进度
     */
    private fun setPkProgress(viewPk: View?, num: Float) {
        if (viewPk == null) {
            return
        }
        val layoutParams = LinearLayout.LayoutParams(0, CommonUtil.dip2px(mContext,15f),num)
        layoutParams.gravity = Gravity.CENTER_VERTICAL
        viewPk.layoutParams = layoutParams
    }

    fun setSvgaView(svgaView :VoiceGameSvgManagerView){
        this.voiceSvgManagerTopView = svgaView
    }

    fun setNowRoomInfo(roomInfo :RoomInfo){
        this.roomInfo = roomInfo
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.boxIv -> {
                boxClick(v)
            }
            R.id.bgRightUserImageView ->{
            Utils.openLiveRoom(mContext, RoomUtils.ROOM_TYPE_MORE_AUDIO,
                        rightUserResult?.rid, 0, "")
                val bundle = Bundle()
                bundle.putInt("status", 1)
                AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_NEW_GOTOCLOSE_LIVEROOM,
                        NSDataBroadcast.TYPE_OPERATION_DEFAULT, bundle)
            }
            else -> {
            }
        }
    }

    /**
     * 点击宝箱  已结束领取奖励，未结束弹出提示信息
     */
    private fun boxClick(v :View) {
        if(pkState == 2){
            if(isClickingBox){
                MyToast.showShort("正在领取，请稍候")
                return
            }
            if(isGetBox){
                MyToast.showShort("已领取")
                return
            }
            isClickingBox = true
            if(VoiceGameSvgHelper.svgVoiceChaosOpenBox == null){
                VoiceGameSvgHelper.initOpenBoxSvg()
                getBoxInfo()
            }else{
                boxIv?.visibility = View.INVISIBLE
                voiceSvgManagerTopView?.showBoxSvga(mContext, {
                    getBoxInfo()
                },responseSrc)
            }
        }else{
            if(voiceChaosRankPopWindow == null){
                voiceChaosRankPopWindow = VoiceChaosRankPopWindow()
            }
            voiceChaosRankPopWindow?.create(mContext)
            voiceChaosRankPopWindow?.setBoxLevel(leftTotalPrice,limitOverScore)
            voiceChaosRankPopWindow?.show(v)
        }
    }

    private fun resetView(){
        leftName = ""
        rightName = ""
        pkState = 0
        voiceChaosIsWin = "1"
        leftTotalPrice = "0"
        rightTotalPrice = "0"
        boxLevel = 1
        remaintime = 0
        rewardTime = 0
        isClickingBox = false
        isGetBox = false
        setPkProgress()
        dialog = null
        iconLeftMvpUser?.setImageResource(0)
        iconRightMvpUser?.setImageResource(0)
        boxIv?.setImageResource(R.drawable.icon_10w_box)
        leftUserResult = null
        rightUserResult = null
        pkIv?.showOrGoneView(true)
        pkTv?.showOrGoneView(false)
        iconWin?.showOrGoneView(false)
        mContentView.showOrGoneView(false)
        boxIv.showOrGoneView(true)
        if(voiceChaosRankPopWindow?.isShow == true){
            voiceChaosRankPopWindow?.dismiss()
        }
    }

    fun onRelease(){
        isFinish = true
        handler?.removeCallbacksAndMessages(null)
    }

    class MyHandler(manager :VoiceChaosManager?) : Handler() {

        companion object{
            const val PK_START_TIME = 1  //更新pk开始时间
            const val PK_REMAIN_TIME = 2  //pk中的时间
            const val PK_REST_TIME = 3  //pk结束后的时间
            const val PK_UPDATE_REST_TIME = 4  //pk结束后不消息情况临时处理
        }
        private var mManager: WeakReference<VoiceChaosManager> = WeakReference<VoiceChaosManager>(manager)
        override fun handleMessage(msg: Message) {
            mManager.get()?.let {
                when (msg.what) {
                    PK_START_TIME -> {
                        it.showStartAnimation()
                    }
                    PK_REMAIN_TIME -> {
                        it.updateReMainTime()
                    }
                    PK_REST_TIME ->{
                        it.showEndView()
                    }
                    PK_UPDATE_REST_TIME ->{
                        it.showEndView()
                    }
                }
            }

        }
    }


    /**
     * 显示金主view
     */
    private fun initJinZhuView(countDown :Int){
        //显示倒计时
        UIUtils.showView(countDownView)

        //倒计时textView
        var tvSummerContestCountDown =
                countDownView?.findViewById<CountDownTextView1>(R.id.tv_summer_contest_count_down)
        val layoutParams:ConstraintLayout.LayoutParams = tvSummerContestCountDown?.layoutParams as ConstraintLayout.LayoutParams
        layoutParams.marginEnd = Utils.dip2px(mContext,30f)
        tvSummerContestCountDown.layoutParams = layoutParams

        //开始倒计时
        tvSummerContestCountDown?.startCutDown("", "s", countDown.toLong()) { time: Long ->
            return@startCutDown time.toString()
        }

        //倒计时结束
        tvSummerContestCountDown?.timeOver = {
            //隐藏倒计时
            UIUtils.goneView(countDownView)
        }
    }

    /**
     * 领取宝箱
     */
    private fun getBoxInfo(){
        val params = NSRequestParams()
        params.put("rid",roomInfo?.rid)
        if(TextUtils.equals("1",voiceChaosIsWin)){
            NsOkHttpClient.getNsOkHttpClient().doGet(Constants.GET_USER_WIN_BOX,params,object : NSGsonObjectNewCallback<VoiceChaosBoxList>() {
                override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: VoiceChaosBoxList?) {
                    if(isFinish){
                        return
                    }
                    NSLog.d("$responseString  response ==  ${response.toString()}")
                    isClickingBox = false
                    val voiceChaosBoxBean = response?.data
                    voiceChaosBoxBean?.let {it->
                        if(dialog == null){
                            dialog = VoiceChaosResultDialog(mContext)
                        }
                        if(dialog?.isShowing == false){
                            dialog?.show(it.count?:0,it.gift_name?:"",it.url?:"",voiceChaosIsWin,leftTotalPrice.toInt())
                        }
                        isGetBox = true
                    }
                }
                override fun onFailure(statusCode: Int, errorMsg: String?) {
                    isClickingBox = false
                    isGetBox = false
                    MyToast.showShort(errorMsg)
                }

            })
        }
    }

    /**
     * 获取进房信息
     */
    fun getVoiceChaosInfo(){
        roomInfo?.let {
            val nsRequestParams = NSRequestParams()
            nsRequestParams.put("rid",it.rid)
            NsOkHttpClient.getNsOkHttpClient().doGet(Constants.GET_ROOM_PK_INFO,nsRequestParams,object :NSGsonObjectNewCallback<VoiceChaosPkBaseBean>(){
                override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: VoiceChaosPkBaseBean?) {
                    if(isFinish){
                        return
                    }
                    val voiceChaosPkBean = response?.data
                    voiceChaosPkBean?.let { pkBean->
                        val voiceChaosContentResult = pkBean.list

                        when (voiceChaosContentResult.state) {
                            "2" -> {
                                if(voiceChaosContentResult.remaintime > 0){
                                    updateChaosData(voiceChaosContentResult)
                                }
                            }
                            "3"->{
                                if(voiceChaosContentResult.reward_time > 0){
                                    showChaosResult(voiceChaosContentResult,false)
                                }else{
                                    resetView()
                                }
                            }
                            else -> {
                                if(TextUtils.equals("1",pkBean.info.is_jinji)){
                                    leftName = ""
                                    rightName = ""
                                    if(pkBean.info.over_second>0){
                                        handler?.removeMessages(MyHandler.PK_START_TIME)
                                        showStartView(pkBean.info.over_second)
                                    }
                                }
                            }
                        }
                    }
                }

                override fun onFailure(statusCode: Int, errorMsg: String?) {
                    NSLog.d("getVoiceChaosInfo ================ onFailure$errorMsg")
                    MyToast.showShort(errorMsg)
                }
            })
        }
    }
}