package com.ninexiu.sixninexiu.common.util

import com.ninexiu.sixninexiu.common.util.BigResourcesDownManage.Companion.get
import com.ninexiu.sixninexiu.common.util.VoiceGameSvgHelper.Tag
import com.opensource.svgaplayer.SVGAParser
import com.opensource.svgaplayer.SVGAVideoEntity
import java.net.URL
import kotlin.concurrent.thread


/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/09/14
 *     desc   : todo : 后期待优化，软引用
 *     version: 1.0
 *
 * </pre>
 */
object VoiceGameSvgHelper {
    const val Tag = "VoiceGameSvgHelper : "

    fun initSvg() {
        thread {
            initTeamPkSvg()
            initLoveSvg()
        }
    }

    private var svgParser: SVGAParser? = null
    private fun initSvgParser() {
        if (svgParser == null) {
            svgParser = SVGAParser.Companion.shareParser()
        }
    }

    var svgTeamPkBg: SVGAVideoEntity? = null            // 团战背景
    var svgTeamCutDownBg: SVGAVideoEntity? = null       // 团战倒计时
    var svgTeamDisAppear: SVGAVideoEntity? = null       // 团战背景消失

    fun initTeamPkSvg() {
        initSvgParser()

        NSLog.d(Tag, "initTeamPkSvg")

        if (svgTeamPkBg == null) {

            val fileInputStream = get().getPkFileSvga(
                Constants.HTTP_PK_FILE,
                BigResourcesDownManage.VOICE_PK_BG_START
            )
            if (fileInputStream == null) {
                svgParser?.decodeFromURL(
                    URL(Constants.HTTP_PK_FILE + BigResourcesDownManage.VOICE_PK_BG_START),
                    SVGAParserParseCompletionImpl("团战背景") { svgTeamPkBg = it })// 不回调出来无法赋值
            } else {
                svgParser?.decodeFromInputStream(
                    fileInputStream,
                    BigResourcesDownManage.VOICE_PK_BG_START,
                    SVGAParserParseCompletionImpl("团战背景") { svgTeamPkBg = it },
                    true
                )// 不回调出来无法赋值
            }

        }

        if (svgTeamCutDownBg == null) {
            svgParser?.decodeFromAssets(
                "voice_pk_cut_start.svga",
                SVGAParserParseCompletionImpl("团战倒计时") {
                    svgTeamCutDownBg = it
                })
        }

        if (svgTeamDisAppear == null) {
            svgParser?.decodeFromAssets(
                "voice_pk_dispappear.svga",
                SVGAParserParseCompletionImpl("团战消失") {
                    svgTeamDisAppear = it
                })
        }

    }

    var svgLovePkBg: SVGAVideoEntity? = null            // 心动背景
    var svgLoveCutDownBg: SVGAVideoEntity? = null       // 心动倒计时
    var svgLoveDisAppear: SVGAVideoEntity? = null      // 心动消失

    fun initLoveSvg() {
        initSvgParser()

        NSLog.d(Tag, "initLoveSvg")

        if (svgLovePkBg == null) {
            svgParser?.decodeFromAssets(
                "voice_love_bg.svga",
                SVGAParserParseCompletionImpl("心动背景") { svgLovePkBg = it })
        }

        if (svgLoveCutDownBg == null) {
            svgParser?.decodeFromAssets(
                "voice_love_cut_down.svga",
                SVGAParserParseCompletionImpl("心动倒计时") { svgLoveCutDownBg = it })
        }

        if (svgLoveDisAppear == null) {
            svgParser?.decodeFromAssets(
                "voice_love_disappear.svga",
                SVGAParserParseCompletionImpl("心动消失") { svgLoveDisAppear = it })
        }
    }

    var svgVoiceChaosStartBg: SVGAVideoEntity? = null       // 语音大乱斗开始动画

    fun initChaosStartSvg() {
        thread {
            //初始化大乱斗svga
            initSvgParser()
            if (svgVoiceChaosStartBg == null) {

                val fileInputStream = get().getPkFileSvga(
                    Constants.HTTP_PK_FILE,
                    BigResourcesDownManage.VOICE_CHAOS_START
                )
                if (fileInputStream == null) {
                    svgParser?.decodeFromURL(
                        URL(Constants.HTTP_PK_FILE + BigResourcesDownManage.VOICE_CHAOS_START),
                        SVGAParserParseCompletionImpl("语音大乱斗开始倒计时") {
                            svgVoiceChaosStartBg = it
                        })// 不回调出来无法赋值
                } else {
                    svgParser?.decodeFromInputStream(
                        fileInputStream,
                        BigResourcesDownManage.VOICE_CHAOS_START,
                        SVGAParserParseCompletionImpl("语音大乱斗开始倒计时") {
                            svgVoiceChaosStartBg = it
                        },
                        true
                    )
                }

            }
        }

    }

    var svgVoiceChaosOpenBox: SVGAVideoEntity? = null       // 语音大乱斗开宝箱动画

    fun initOpenBoxSvg() {
        thread {
            //初始化开宝箱svga
            initSvgParser()
            if (svgVoiceChaosOpenBox == null) {
                svgParser?.decodeFromAssets(
                    "dld_openbox3.svga",
                    SVGAParserParseCompletionImpl("语音大乱斗开宝箱") {
                        svgVoiceChaosOpenBox = it
                    })
            }
        }
    }

    var svgaVoiceWin: SVGAVideoEntity? = null       // 语音大乱斗胜利动画

    fun initVoiceWinSvg(path: String, parseCompletion: SVGAParser.ParseCompletion?) {
        //初始化烟花svga
        initSvgParser()
        if (svgaVoiceWin == null) {
            svgParser?.decodeFromURL(URL(path), parseCompletion)
        }
    }


    fun clear() {
        svgTeamPkBg?.clear()
        svgTeamPkBg = null

        svgTeamCutDownBg?.clear()
        svgTeamCutDownBg = null

        svgTeamDisAppear?.clear()
        svgTeamDisAppear = null

        svgLovePkBg?.clear()
        svgLovePkBg = null

        svgLoveCutDownBg?.clear()
        svgLoveCutDownBg = null

        svgLoveDisAppear?.clear()
        svgLoveDisAppear = null

        clearChaosSvga()
    }

    fun clearChaosSvga() {
        svgVoiceChaosStartBg?.clear()
        svgVoiceChaosStartBg = null

        svgVoiceChaosOpenBox?.clear()
        svgVoiceChaosOpenBox = null

        svgaVoiceWin?.clear()
        svgaVoiceWin = null
    }
}

class SVGAParserParseCompletionImpl(
    private val svgName: String?,
    val onFinish: ((SVGAVideoEntity?) -> Unit)? = null
) : SVGAParser.ParseCompletion {
    override fun onComplete(videoItem: SVGAVideoEntity) {
        NSLog.d(Tag, "onComplete : $svgName")
        onFinish?.invoke(videoItem)
    }

    override fun onError() {
        NSLog.d(Tag, "onError : $svgName")
        BigResourcesDownManage.get().deleteFile(svgName)
    }

}




