package com.ninexiu.sixninexiu.common.util.gift

import android.text.TextUtils
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.Utils
import org.json.JSONException
import org.json.JSONObject
import java.io.File


/**
 * <pre>
 *     @author : gh
 *     time   : 2021/08/20 0023
 *     desc   : 礼物图标下载管理器
 *     version: 1.0
 * </pre>
 */
class GiftResourceDownLoadManage {

    var mDownGiftMap: LinkedHashMap<String, Long> = LinkedHashMap<String, Long>(150);
    var mDownCarMap: LinkedHashMap<String, Long> = LinkedHashMap<String, Long>(150);


    companion object {

        private var instance: GiftResourceDownLoadManage? = null
            get() {
                if (field == null) {
                    field = GiftResourceDownLoadManage()
                }
                return field
            }

        fun get(): GiftResourceDownLoadManage {
            return instance!!
        }
    }

    /**
     * 检查资源有没有下载
     * @param file
     * @param gid
     * @param v
     */
    fun checkDownload(file: File, gid: String, v: String) {

        try {

            if (!file.exists() || file.length() == 0L) {
                var cache = Utils.getCachDir();

                // 取上次的时间
                var lastTime: Long = 0;
                if (mDownGiftMap != null) {
                    var uptime = mDownGiftMap[gid]
                    lastTime = if (uptime == null) 0 else uptime.toLong()
                }

                if (mDownGiftMap.get(gid) == null || System.currentTimeMillis() - lastTime > 30000) {
                    Thread {
                        mDownGiftMap.put(gid, System.currentTimeMillis());

                        Utils.downloadFile(
                            cache,
                            Constants.LIVE__ROOM_CHAT_URL + gid + ".png?v=" + v,
                            "mgift" + gid + "_" + v
                        )


                    }.start();
                }

            }
        } catch (e: Exception) {

        }
    }


    //下载座驾小图标
    fun checkCarDownload(carId: String) {
        try {
            val cache = Utils.getCachDir()
            val json = AppCnfSpHelper.getInstance().liveCarList
            val obj = JSONObject(json)

            if (obj.optInt("code") != 200) {
                return
            }
            val data = obj.optJSONObject("data")

            //下载汽车图片
            val arrayCars = data.optJSONArray("carlist")
            for (i in 0 until arrayCars.length()) {
                val car = arrayCars.getJSONObject(i)
                if (TextUtils.equals(car.getString("id"), carId)) {
                    val url = car.getString("src")
                    val fileString = url.substring(url.lastIndexOf("/") + 1, url.length)
                    val fileName = fileString.substring(0, fileString.lastIndexOf("."))
                    // 取上次的时间
                    var lastTime: Long = 0;
                    if (mDownCarMap != null) {
                        var uptime = mDownCarMap[carId]
                        lastTime = if (uptime == null) 0 else uptime.toLong()
                    }

                    if (mDownCarMap.get(carId) == null || System.currentTimeMillis() - lastTime > 30000) {

                        Thread {

                            Utils.downloadFile(cache, url, fileName)

                        }.start()
                        mDownCarMap.put(carId, System.currentTimeMillis());

                    }
                }
            }
        } catch (e: JSONException) {
            e.printStackTrace()
        } catch (e: IndexOutOfBoundsException) {
            e.printStackTrace()
        } catch (e: NullPointerException) {
            e.printStackTrace()
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }


}