package com.ninexiu.sixninexiu.common.util.gift

import android.content.Context
import android.os.Environment
import android.os.Handler
import android.text.TextUtils
import android.view.View
import android.view.ViewStub
import android.widget.ImageView
import com.ninexiu.sixninexiu.BuildConfig
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.bean.ChatMessage
import com.ninexiu.sixninexiu.bean.SvgGiftDownBean
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.AppInitDownloadResHelper
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.svg.down.DownloadCallback
import com.ninexiu.sixninexiu.common.util.svg.down.OkhttpDownload
import com.opensource.svgaplayer.SVGACallback
import com.opensource.svgaplayer.SVGAImageView
import com.opensource.svgaplayer.SVGAParser
import com.zhongrun.nineshow_base.utils.NineShowFilePathManager
import java.io.File
import java.io.FileInputStream
import java.io.FileNotFoundException
import java.io.IOException
import java.util.*

/**
 * <pre>
 *     @author : gh
 *     time   : 2020/12/16 0023
 *     desc   : 直播间Video大动画播放
 *     version: 1.0
 * </pre>
 */
class LiveGiftVideoManager {

    private val TAG: String = "LiveGiftVideoManager"

    var mRoot: ViewStub? = null

    var mGiftIv: SVGAImageView? = null
    var parser: SVGAParser? = null

    var mGiftView: LiveRoomGiftView ?= null

    private var qeque = LinkedList<ChatMessage>()
    private var pollFirst: String? = null

    /**
     * 下载数据
     */
    // private var mp4CarList: ArrayList<SvgGiftDownBean.DataBean.SvgaListBean> = ArrayList<SvgGiftDownBean.DataBean.SvgaListBean>()

    private val deskPath = NineShowFilePathManager.INSTANCE.getExterFileDir(NineShowFilePathManager.GIFT_DIR)
    private val FILE_SUFFIX = ".mp4"
    private val SVGA_FILE_SUFFIX = ".svga"

    private var downloadManager: OkhttpDownload? = null

    private var mHandler: Handler = Handler()


    constructor(){
        /*val bean = AppInitDownloadResHelper.allList
        (bean?.data?.mp4CarList as? List<SvgGiftDownBean.DataBean.SvgaListBean>)?.let {
            mp4CarList.clear()
            mp4CarList.addAll(it)
        }*/

      /*  var result:String = AppCnfSpHelper.getInstance().svgGiftList
        if (!TextUtils.isEmpty(result)) {
            try {
                var bean: SvgGiftDownBean = GsonUtil.fromJson(result, SvgGiftDownBean::class.java)
                if (bean?.code == 200) {
                    if (bean?.data!!.mp4CarList != null) {
                        mp4CarList = bean?.data!!.mp4CarList
                    }

                }
            } catch (e: JsonParseException) {
                e.printStackTrace()
            }
        }*/
    }

    companion object {

        private var instance: LiveGiftVideoManager? = null
            get() {
                if (field == null) {
                    field = LiveGiftVideoManager()
                }
                return field
            }

        fun get(): LiveGiftVideoManager {
            return instance!!
        }
    }

    public fun initView(mRoot: ViewStub) {
        this.mRoot = mRoot

        mRoot.layoutResource = R.layout.ns_liveroom_gift_video
        var mView = mRoot.inflate()
        this.mGiftIv = mView.findViewById(R.id.ns_svg)
        this.mGiftView = mView.findViewById(R.id.mblive_video_gift_anim)

        this.parser = SVGAParser.Companion.shareParser()
        setSVGAImageViewCallBack()
    }

    fun startPlay(entry: ChatMessage?) {
        if (NineShowApplication.mUserBase == null) {
            return
        }
        synchronized(this) {
            if (entry != null) {

                if (!BuildConfig.DEBUG && entry.repeat == 0) {
                    return
                }
                /**
                 * 保留最近的两个
                 */
                if (qeque.size > 1) {
                    var mCacheList = LinkedList<ChatMessage>()
                    for (chatMsg in qeque) {
                        if (NineShowApplication.mUserBase?.uid == chatMsg.uid) {
                            return
                        }
                    }
                    qeque?.clear()
                    mCacheList.add(entry)
                    qeque?.addAll(mCacheList)
                } else {

                    qeque?.add(entry)
                }
                NSLog.e(TAG, "startPlay   size = ${qeque?.size}     ")

                //下一条消息
                nextHideMessage()
            }

        }
    }

    private fun nextHideMessage() {
        val isFun = !getSvgaIvLoading()
        NSLog.e(TAG, "isFun $isFun")

        if (isFun && qeque?.size > 0) {
            mGiftView?.setTag(R.id.tag_svg_anim, true)
            var chatMessage = qeque?.pollFirst()
            pollFirst = "${chatMessage?.carId}"
            if (!TextUtils.isEmpty(pollFirst)) {
                NSLog.e(TAG, "nextHideMessage $pollFirst")

                loadAnimation()
            }
        }
    }

    /**
     * 获取指定文件大小
     * @param file
     * @return
     * @throws Exception 　　
     */
    fun getFileSize(file: File): Long {
        var size: Long = 0
        try {
            if (file.exists()) {
                var fis: FileInputStream? = null
                fis = FileInputStream(file)
                size = fis.available().toLong()
            } else {
                file.createNewFile()
            }
        } catch (e: FileNotFoundException) {
            e.printStackTrace()
        } catch (e: IOException) {
            e.printStackTrace()
        }

        return size
    }

    /**
     * 获取当前动画
     */
    /*public fun getSvga(gid: String) : SvgGiftDownBean.DataBean.SvgaListBean? {
        if (mp4CarList?.size > 0){
            for (bean:SvgGiftDownBean.DataBean.SvgaListBean in mp4CarList){
                if (TextUtils.equals(gid,bean?.gid)){
                    return bean
                }
            }
        }
        return null
    }*/

    private fun loadAnimation() {

        mGiftView?.visibility = View.VISIBLE
        mGiftIv?.visibility = View.GONE
        var gid: String = pollFirst!!
        // var bean: SvgGiftDownBean.DataBean.SvgaListBean? = getSvga(gid)
        // bean?.let {

        val updateTime = AppInitDownloadResHelper.getVersion(gid, AppInitDownloadResHelper.CAR_MP4_TYPE)

        val suffixFileName = gid + "_" + updateTime
        val file = File(deskPath, suffixFileName)

        /**
         * 删除当前别的动画
         */
        var directory = File(deskPath)
        if (directory?.exists()) {
            var fils = directory?.listFiles()
            fils?.let {
                for (f in fils) {
                    if (!TextUtils.equals(suffixFileName, f.name) && f.name.contains(gid)) {
                        if (f.exists()) {
                            f.delete()
                        }
                    }
                }

            }

        }

        if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载

            var downloadUrl: String = "https://img.img.9xiu.com/resource/mobile/phoneGiftCar/mgift"
            var path = downloadUrl + gid + FILE_SUFFIX

//                loadSvgaAnimation()
            netDownLoad(path, gid,updateTime)
        } else {

            // 开始播放
            mGiftView?.startVideoGift("$deskPath/$suffixFileName")
        }
        // }

    }

    /**
     * 网络播放、以及下载
     */
    private fun netDownLoad(path: String, gid : String,updateTime : String) {
        //本地下载
        if (downloadManager == null) {
            downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
        }

        downloadManager?.downLoadCallback(path, gid + "_" + updateTime, object : DownloadCallback {
            override fun downloadSuccess() {
                try {

                    val suffixFileName = gid + "_" + updateTime
                    mGiftView?.startVideoGift("$deskPath/$suffixFileName")
                } catch (e: Exception){

                }
                NSLog.d(TAG, "downloadSuccess")
            }

            override fun downloadFailure(errorMsg: String) {

            }
        })
    }

    private fun setSVGAImageViewCallBack() {

        mGiftIv?.let {
            it.scaleType = ImageView.ScaleType.FIT_END

            it.callback = object : SVGACallback {
                override fun onPause() {}

                override fun onFinished() {
                    NSLog.e(TAG, "onFinished")

                    it?.clearAnimation()
                    mRoot?.setTag(R.id.tag_svg_anim, null)
                    nextHideMessage()

                }

                override fun onRepeat() {}

                override fun onStep(frame: Int, percentage: Double) {
                    mRoot?.setTag(R.id.tag_svg_anim, true)

                }
            }
        }

        mGiftView?.let {

            it.initPlayerController(object : LiveRoomGiftCallBack {

                override fun startAction() {
                    NSLog.e(TAG, "startAction")

                }

                override fun endAction() {
                    NSLog.e(TAG, "onFinished")
                    mHandler.postDelayed(Runnable {
                        it?.clearAnimation()
                        it?.setTag(R.id.tag_svg_anim, null)
                        nextHideMessage()
                    }, 600)

                }

                override fun onError() {
                    NSLog.e(TAG, "onError")
//                    mHandler.post(Runnable {
//                        it?.clearAnimation()
//                        it?.setTag(R.id.tag_svg_anim, null)
//                        nextHideMessage()
//                    })

                }

                override fun onPrepared() {
                    mHandler.post(Runnable {
                        NSLog.e(TAG, "onPrepared")
                        it?.setTag(R.id.tag_svg_anim, true)
                    })


                }

            })

        }
    }


    private fun getSvgaIvLoading(): Boolean {
        val tag = mGiftView?.getTag(R.id.tag_svg_anim)
        return if (tag != null) {
            tag as Boolean
        } else false
    }

    fun release() {
        if (instance != null){
            instance = null
        }
        mGiftIv?.stopAnimation()
        mGiftIv?.clear()

        if (mGiftIv != null){
            mGiftIv = null
        }

        mGiftView?.clearAnimation()
        mGiftView?.release()
        qeque?.clear()
    }

    /**
     * 启动页初始化下载SVGA
     */
    fun downloadGiftVideo() {
        /**
         * 临时获取座驾资源的位置
         */
        val asyncHttpClient = NsOkHttpClient.getNsOkHttpClient()
        asyncHttpClient.doGet(Constants.SERVER_PATH + "/common/getresource", null, object : NSGsonObjectNewCallback<BaseResultInfo>() {

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: BaseResultInfo?) {
                if (response != null && response.code == 200) {
                    AppCnfSpHelper.getInstance().liveCarList = responseString
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })


        val mp4CarList = AppInitDownloadResHelper.allList?.data?.mp4CarList
        if(mp4CarList != null){
            Thread(Runnable {
                for (bean: SvgGiftDownBean.DataBean.SvgaListBean in mp4CarList) {
                    bean?.let {

                        val suffixFileName = it.gid + "_" + it.updatetime
//                        val file = File(deskPath, suffixFileName)

                        /**
                         * 删除当前别的动画
                         */
                        var directory = File(deskPath)
                        if (directory?.exists()) {
                            var fils = directory?.listFiles()
                            fils?.let {
                                for (f in fils) {
                                    if (!TextUtils.equals(suffixFileName, f.name) && f.name.contains(bean?.gid)) {
                                        if (f.exists()) {
                                            f.delete()
                                        }
                                    }
                                }

                            }

                        }
                        directory.mkdirs()

//                        if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
//
//                            //本地下载
//                            if (downloadManager == null){
//                                downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
//                            }
//                            var downloadUrl:String = "https://img.img.9xiu.com/resource/mobile/phoneGiftCar/mgift"
//
//                            downloadManager?.downLoadCallback(downloadUrl + bean.gid + FILE_SUFFIX + "?v=" + it.updatetime, bean.gid + "_" + bean.updatetime, object : DownloadCallback {
//                                override fun downloadSuccess() {
//                                    NSLog.d(TAG, "downloadSuccess")
//                                }
//
//                                override fun downloadFailure(errorMsg: String) {
//
//                                }
//                            })
//                        }
                    }
                }
            }).start()
        }
    }

}