package com.ninexiu.sixninexiu.common.util.gift

import android.util.LruCache
import com.opensource.svgaplayer.SVGAVideoEntity
import java.lang.ref.SoftReference


/**
 * <pre>
 *     @author : gh
 *     time   : 2021/08/27 0023
 *     desc   : Svga-SVGAVideoEntity缓存起来
 *     version: 1.0
 * </pre>
 */
class SvgaResourceSVGAVideoEntityManage {

    var mSvgaVideoEntityCache: LruCache<String, SoftReference<SVGAVideoEntity>> = LruCache<String, SoftReference<SVGAVideoEntity>>(30);


    companion object {

        private var instance: SvgaResourceSVGAVideoEntityManage? = null
            get() {
                if (field == null) {
                    field = SvgaResourceSVGAVideoEntityManage()
                }
                return field
            }

        fun get(): SvgaResourceSVGAVideoEntityManage {
            return instance!!
        }
    }

    /**
     * 获取缓存的SVGA资源
     */
    fun getSVGAVideoEntity(key: String): SVGAVideoEntity? {
        var videEntity:SVGAVideoEntity? = mSvgaVideoEntityCache.get(key)?.get()

        return videEntity
    }

    /**
     * 保存缓存的SVGA资源
     */
    fun putSVGAVideoEntity(key: String, entity: SVGAVideoEntity) {
        mSvgaVideoEntityCache.put(key, SoftReference(entity));
    }

    /**
     * 资源释放
     */
    fun onRelease(){

        mSvgaVideoEntityCache.evictAll()
    }


}