package com.ninexiu.sixninexiu.common.util.manager

import android.text.TextUtils
import androidx.fragment.app.Fragment
import com.ninexiu.sixninexiu.BuildConfig
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.fragment.AttentionCardFragment
import com.ninexiu.sixninexiu.fragment.DiscoveryParentFragment
import com.ninexiu.sixninexiu.fragment.LiveHallFragment
import com.ninexiu.sixninexiu.fragment.PersonalCenterFragment
import com.ninexiu.sixninexiu.fragment.tencentim.MessageCenterFragment
import com.ninexiu.sixninexiu.view.bottomtablayout.TabEntity
import java.util.*
import kotlin.collections.ArrayList

object BottomTabDataManager {

    /**
     * 获取需要展示的底部tab名和icon
     */
    fun getBottomTabEntityList(): List<TabEntity> {

        /**
         * 默认的tab数据
         */
        val tabNames: Array<String>
        val tabICons: IntArray
        val svgaFilList: MutableList<String>
        val videoICons: IntArray

        tabNames = if (TextUtils.equals(NineShowApplication.UMENG_CHANNEL, "mmfq_sc_huawei")) {
            arrayOf("直播", "热点", "通知", "订阅", "我")
        } else {
            arrayOf("直播", "交友", "消息", "关注", "我")
        }
        tabICons = intArrayOf(
                R.drawable.ns_maintab_livehall_btn, R.drawable.ns_maintab_discovery_btn,
                R.drawable.ns_maintab_message_btn, R.drawable.ns_maintab_micro_video_btn,
                R.drawable.ns_maintab_personalcenter_btn
        )
        svgaFilList = mutableListOf("tabbar0.svga", "tabbar1.svga", "tabbar2.svga", "tabbar3.svga", "tabbar4.svga")
        videoICons = intArrayOf(
                R.drawable.main_tab_live_unpressed_video, R.drawable.main_tab_discover_unpressed_video,
                R.drawable.main_tab_game_unpressed_video, R.drawable.main_tab_mv_unpressed_video,
                R.drawable.main_tab_me_unpressed_video
        )

        val tabEntityList: MutableList<TabEntity> = ArrayList()
        for (i in tabNames.indices) {
            tabEntityList.add(TabEntity(tabICons[i], tabNames[i],svgaFilList[i],videoICons[i]))
        }
        return tabEntityList
    }

    /**
     * 获取需要展示的fragment
     */
    fun getTabFragmentsList(): List<Fragment> {

        var fragments: MutableList<Fragment> = ArrayList()

        fragments.add(LiveHallFragment())
        fragments.add(DiscoveryParentFragment())
        fragments.add(MessageCenterFragment())
        fragments.add(AttentionCardFragment.newInstance())
        fragments.add(PersonalCenterFragment())

        return fragments
    }

}