package com.ninexiu.sixninexiu.common.util.svg

import android.annotation.SuppressLint
import android.content.Context
import android.os.Handler
import android.text.TextUtils
import android.view.View
import android.view.ViewStub
import android.widget.ImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.ChatMessage
import com.ninexiu.sixninexiu.bean.SvgGiftDownBean
import com.ninexiu.sixninexiu.common.util.AppInitDownloadResHelper
import com.ninexiu.sixninexiu.common.util.GiftVersionManage
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.gift.LiveGiftVideoManager
import com.ninexiu.sixninexiu.common.util.gift.LiveRoomGiftCallBack
import com.ninexiu.sixninexiu.common.util.gift.LiveRoomGiftView
import com.ninexiu.sixninexiu.common.util.gift.SvgaResourceSVGAVideoEntityManage
import com.ninexiu.sixninexiu.common.util.svg.down.DownloadCallback
import com.ninexiu.sixninexiu.common.util.svg.down.OkhttpDownload
import com.opensource.svgaplayer.SVGACallback
import com.opensource.svgaplayer.SVGAImageView
import com.opensource.svgaplayer.SVGAImageView.FillMode
import com.opensource.svgaplayer.SVGAParser
import com.opensource.svgaplayer.SVGAVideoEntity
import com.zhongrun.nineshow_base.utils.NineShowFilePathManager
import java.io.*
import java.net.MalformedURLException
import java.net.URL
import java.util.*

/**
 * <pre>
 *     @author : gh
 *     time   : 2020/6/23 0023
 *     desc   : 直播间SVG、MP4大动画播放
 *     version: 1.0
 * </pre>
 */
class LiveSvgManager {

    private val TAG: String = "LiveSvgManager"

    var mRoot: ViewStub ? = null
    var mGiftIv: SVGAImageView ? = null
    var parser: SVGAParser ?= null
    var mGiftView: LiveRoomGiftView?= null


    private var qeque = LinkedList<GiftData>()
    private var pollFirst: GiftData? = null

    private var mHandler: Handler = Handler()


    /**
     * 下载数据
     */
    private val deskPath = NineShowFilePathManager.INSTANCE.getExterFileDir(NineShowFilePathManager.GIFT_DIR)
    private val FILE_SUFFIX = ".svga"
    private val SVGA_FILE_SUFFIX = ".svga"
    private val VIDEO_FILE_SUFFIX = ".mp4"

    private var downloadManager: OkhttpDownload? = null

    // 下载次数
   private var downloadNum = 0


    constructor(){

        /*var result:String = AppCnfSpHelper.getInstance().svgGiftList
        if (!TextUtils.isEmpty(result)) {
            try {
                var bean: SvgGiftDownBean = GsonUtil.fromJson(result, SvgGiftDownBean::class.java)
                if (bean?.code == 200) {
                    if (bean?.data!!.svgaList != null) {
                        svgaList = bean?.data!!.svgaList
                    }
                    if (bean?.data!!.mp4GiftList != null) {
                        mp4GiftList = bean?.data!!.mp4GiftList
                    }

                }
            } catch (e: JsonParseException) {
                e.printStackTrace()
            }
        }*/
    }

    companion object {

        @SuppressLint("StaticFieldLeak")
        private var instance: LiveSvgManager? = null
            get() {
                if (field == null) {
                    field = LiveSvgManager()
                }
                return field
            }
        fun get(): LiveSvgManager{
            return instance!!
        }
    }

    /**
     * 初始化View
     */
    public fun initView(mRoot: ViewStub){
        this.mRoot = mRoot

        mRoot.layoutResource = R.layout.ns_liveroom_gift_video
        var mView = mRoot.inflate()
        this.mGiftIv = mView.findViewById(R.id.ns_svg)
        this.mGiftView = mView.findViewById(R.id.mblive_video_gift_anim)

        this.parser = SVGAParser.Companion.shareParser()
        setSVGAImageViewCallBack()
    }

    fun startPlay(entry: ChatMessage?) {
        synchronized(this) {
            if (entry != null) {
                qeque?.add(GiftData(entry?.gid, entry?.source_type, System.currentTimeMillis(),entry?.giftCount))
                NSLog.e(TAG, "startPlay   size = ${qeque?.size}     ")

                //下一条消息
                nextHideMessage()
            }

        }
    }

    private fun nextHideMessage() {
        val isFun = !getSvgaIvLoading()
        NSLog.e(TAG, "isFun $isFun")

        if (isFun && qeque?.size > 0) {
            mRoot?.setTag(R.id.tag_svg_anim,true)
            pollFirst = qeque?.pollFirst()
            if (pollFirst != null) {
                NSLog.e(TAG, "nextHideMessage $pollFirst")
                if (pollFirst?.source_type == 1){
                    NSLog.e(TAG, "loadSvgaAnimation")
                    loadSvgaAnimation()
                } else {
                    NSLog.e(TAG, "loadVideoAnimation")
                    loadVideoAnimation()
                }
            }
        }
    }

    /**
     * 获取指定文件大小
     * @param file
     * @return
     * @throws Exception 　　
     */
    fun getFileSize(file: File): Long {
        var size: Long = 0
        try {
            if (file.exists()) {
                var fis: FileInputStream? = null
                fis = FileInputStream(file)
                size = fis.available().toLong()
            } else {
                file.createNewFile()
            }
        } catch (e: FileNotFoundException) {
            e.printStackTrace()
        } catch (e: IOException) {
            e.printStackTrace()
        }

        return size
    }

    /**
     * SVGA 播放
     */
    private fun loadSvgaAnimation() {
        var path = "https://img.img.9xiu.com/resource/mobile/newSvga/mgift" + pollFirst?.gid + SVGA_FILE_SUFFIX

        if (pollFirst?.gid == 500 || pollFirst?.gid == 2000){
            path = "https://img.img.9xiu.com/resource/mobile/newSvga/mgift_" + pollFirst?.gid + SVGA_FILE_SUFFIX
        }

        mGiftIv?.let {
            it.visibility = View.VISIBLE
            mGiftView?.visibility = View.INVISIBLE
            it.clearsAfterDetached = true
            it.loops = pollFirst?.count?:1
            it.fillMode = FillMode.Clear

            var videoItem = SvgaResourceSVGAVideoEntityManage.get().getSVGAVideoEntity("${pollFirst?.gid}");
            if (videoItem != null){
                it.setVideoItem(videoItem)
                it.startAnimation()
                return
            }

            val mParseCompletion = object : SVGAParser.ParseCompletion {
                override fun onComplete(videoItem: SVGAVideoEntity) {
                    NSLog.e(TAG, "ParseCompletion onComplete    size = ${qeque?.size}     ")
                    SvgaResourceSVGAVideoEntityManage.get().putSVGAVideoEntity("${pollFirst?.gid}", videoItem)
                    it.setVideoItem(videoItem)
                    it.startAnimation()

                }

                override fun onError() {
                    NSLog.e(TAG, "ParseCompletion onError ")
                    mRoot?.setTag(R.id.tag_svg_anim, null)
                    nextHideMessage()
                }
            }

            val version = AppInitDownloadResHelper.getVersion(pollFirst?.gid?.toString(),AppInitDownloadResHelper.GIFT_TYPE)
            if(version.isBlank() || version.trim().isBlank()) {
                // 在线播放
                if (path.startsWith("http") || path.startsWith("https")) {
                    try {
                        parser?.decodeFromURL(URL(path), mParseCompletion,null)
                    } catch (e: MalformedURLException) {
                        e.printStackTrace()
                    }
                }
                return
            }

            val gid = pollFirst?.gid?.toString()
            if(version.trim().isNotBlank() && !gid.isNullOrBlank()) {

                val version = version.trim()
                val suffixFileName = gid + "_" + version + SVGA_FILE_SUFFIX
                val file = File(deskPath, suffixFileName)

                /**
                 * 删除当前别的动画
                 */
                var directory = File(deskPath)
                if (directory?.exists()){
                    var fils = directory?.listFiles()
                    fils?.let {
                        for (f in fils){
                            if (!TextUtils.equals(suffixFileName,f.name) && f.name.contains(gid)){
                                if (f.exists()){
                                    f.delete()
                                }
                            }
                        }

                    }

                }

                if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                    try {
                        parser?.decodeFromURL(URL(path), mParseCompletion,null)
                    } catch (e: MalformedURLException) {
                        e.printStackTrace()
                    }
                    netDownLoad("$path?v=$version", gid,version)
                } else {

                    parser?.decodeFromInputStream(FileInputStream(file),file.absolutePath, mParseCompletion,true,null, null)
                }
            }
        }
    }

    /**
     * 视频播放
     */
    private fun loadVideoAnimation() {
        mGiftView?.visibility = View.VISIBLE
        mGiftIv?.visibility = View.INVISIBLE

        val gid = pollFirst?.gid?.toString()
        val version = AppInitDownloadResHelper.getVersion(gid,AppInitDownloadResHelper.GIFT_TYPE)
        if(version.isBlank() || version.trim().isBlank()) {
            mRoot?.setTag(R.id.tag_svg_anim, null)
            nextHideMessage()
            return
        }

        if(version.trim().isNotBlank() && !gid.isNullOrBlank()) {

            val suffixFileName = gid + "_" + version
            val file = File(deskPath, suffixFileName)

            /**
             * 删除当前别的动画
             */
            var directory = File(deskPath)
            if (directory?.exists()) {
                var fils = directory?.listFiles()
                fils?.let {
                    for (f in fils) {
                        if (!TextUtils.equals(suffixFileName, f.name) && f.name.contains(gid)) {
                            if (f.exists()) {
                                f.delete()
                            }
                        }
                    }

                }

            }

            if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载

                var downloadUrl: String = "https://img.img.9xiu.com/resource/mobile/phoneGiftMp4/mgift"
                var path = "$downloadUrl$gid$VIDEO_FILE_SUFFIX?v=$version"

                mRoot?.setTag(R.id.tag_svg_anim, null)
                netDownLoad(path , gid, version, pollFirst?.source_type!!, pollFirst?.time!!,pollFirst?.count!!)
                nextHideMessage()
                NSLog.e(TAG, "loadSvgaAnimation onComplete    下载视频 ")
            } else {

                // 开始播放
//                mGiftView?.startVideoGift("$deskPath/demo.mp4")
                mGiftView?.startVideoGift("$deskPath/$suffixFileName")
                mGiftView?.setLoopCount(pollFirst?.count?:1)
            }
        }

    }

    /**
     * 网络播放、以及下载
     */
    private fun netDownLoad(path: String,gid : String?,version : String?) {
        if(gid.isNullOrBlank() || version.isNullOrBlank()) {
            return
        }

        //本地下载
        if (downloadManager == null){
            downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
        }

        var fileName = gid + "_" + version + SVGA_FILE_SUFFIX

        downloadManager?.downLoadCallback(path, fileName, object : DownloadCallback {
            override fun downloadSuccess() {
                NSLog.d(TAG, "downloadSuccess")
            }

            override fun downloadFailure(errorMsg: String) {

            }
        })
    }



    /**
     * 网络播放、以及下载
     */
    private fun netDownLoad(path: String, gid: String, updatetime:String,source_type:Int,time:Long,count:Int) {
        //本地下载
        if (downloadManager == null){
            downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
        }

        downloadManager?.downLoadCallback(path, gid + "_" + updatetime, object : DownloadCallback {
            override fun downloadSuccess() {
                try {

                    qeque.add(GiftData(gid.toInt(),source_type,time,count))
                } catch (e:Exception){

                }
                nextHideMessage()
                NSLog.d(TAG, "video downloadSuccess")
            }

            override fun downloadFailure(errorMsg: String) {

            }
        })
    }

    private fun setSVGAImageViewCallBack() {

        mGiftIv?.let{
            it.scaleType = ImageView.ScaleType.FIT_END

            it.callback = object : SVGACallback {
                override fun onPause() {}

                override fun onFinished() {
                    NSLog.e(TAG, "onFinished")

                    it?.clearAnimation()
                    mRoot?.setTag(R.id.tag_svg_anim, null)
                    nextHideMessage()

                }

                override fun onRepeat() {}

                override fun onStep(frame: Int, percentage: Double) {
                    mRoot?.setTag(R.id.tag_svg_anim, true)

                }
            }
        }

        mGiftView?.let{

            it.initPlayerController(object : LiveRoomGiftCallBack {

                override fun startAction() {
                    NSLog.e(TAG, "startAction")

                }

                override fun endAction() {
                    NSLog.e(TAG, "endAction")
                    mHandler.postDelayed(Runnable {
                        it?.clearAnimation()
                        mRoot?.setTag(R.id.tag_svg_anim, null)
                        nextHideMessage()
                    },600)

                }

                override fun onError() {
                    NSLog.e(TAG, "onError")
//                    mHandler.post(Runnable {
//                        it?.clearAnimation()
//                        mRoot?.setTag(R.id.tag_svg_anim, null)
//                        nextHideMessage()
//                    })

                }

                override fun onPrepared() {
                    mHandler.post(Runnable {
                        NSLog.e(TAG, "onPrepared")
                        mRoot?.setTag(R.id.tag_svg_anim, true)
                    })


                }

            })

        }
    }

    private fun getSvgaIvLoading(): Boolean {
        val tag = mRoot?.getTag(R.id.tag_svg_anim)

        return if (tag != null) {
            tag as Boolean
        } else false

    }

    fun release() {
        mGiftView?.clearAnimation()
        mGiftView?.release()

        mGiftIv?.stopAnimation()
        mGiftIv?.clear()

        if (mGiftIv != null){
            mGiftIv = null
        }

        if (instance != null){
            instance = null
        }

        qeque?.clear()

        mRoot?.removeCallbacks(null)
    }

    /**
     * 启动页初始化下载SVGA
     */
    fun downloadSvga(){

        /**
         * 刷新礼物面板，礼物图片
         */
        GiftVersionManage.get()

        /**
         * 下载座驾数据
         */
        LiveGiftVideoManager.get().downloadGiftVideo()

        val mp4GiftList = AppInitDownloadResHelper.allList?.data?.mp4GiftList
        if(mp4GiftList != null){
            Thread(Runnable {
                for (bean:SvgGiftDownBean.DataBean.SvgaListBean in mp4GiftList){
                    bean?.let {

                        val suffixFileName = it.gid + "_" + it.updatetime
                        val file = File(deskPath, suffixFileName)

                        /**
                         * 删除当前别的动画
                         */
                        var directory = File(deskPath)
                        if (directory?.exists()){
                            var fils = directory?.listFiles()
                            fils?.let {
                                for (f in fils){
                                    if (!TextUtils.equals(suffixFileName,f.name) && f.name.contains(bean.gid)){
                                        if (f.exists()){
                                            f.delete()
                                        }
                                    }
                                }

                            }

                        }

                        if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
                            if (downloadNum > 10) {
                                return@let
                            }
                            downloadNum++
                            //本地下载
                            if (downloadManager == null){
                                downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
                            }
                            var downloadUrl:String = "https://img.img.9xiu.com/resource/mobile/phoneGiftMp4/mgift"

                            downloadManager?.downLoadCallback(downloadUrl + bean.gid + VIDEO_FILE_SUFFIX + "?v=" + it.updatetime, bean.gid + "_" + bean.updatetime, object : DownloadCallback {
                                override fun downloadSuccess() {
                                    NSLog.d(TAG, "downloadSuccess")
                                }

                                override fun downloadFailure(errorMsg: String) {

                                }
                            })
                        }
                    }
                }
            }).start()
        }

//        if(svgaList != null){
//            Thread(Runnable {
//                for (bean:SvgGiftDownBean.DataBean.SvgaListBean in svgaList){
//                    bean?.let {
//
//                        val suffixFileName = it.gid + "_" + it.updatetime + SVGA_FILE_SUFFIX
//                        val file = File(deskPath, suffixFileName)
//
//                        /**
//                         * 删除当前别的动画
//                         */
//                        var directory = File(deskPath)
//                        if (directory?.exists()){
//                            var fils = directory?.listFiles()
//                            fils?.let {
//                                for (f in fils){
//                                    if (!TextUtils.equals(suffixFileName,f.name) && f.name.contains(bean.gid)){
//                                        if (f.exists()){
//                                            f.delete()
//                                        }
//                                    }
//                                }
//
//                            }
//
//                        }
//
//                        if (!file.exists() || getFileSize(file) <= 0) {//如果礼物不存在，重新下载
//
//                            //本地下载
//                            if (downloadManager == null){
//                                downloadManager = OkhttpDownload(NineShowApplication.applicationContext)
//                            }
//                            var downloadUrl:String = "https://img.img.9xiu.com/resource/mobile/newSvga/mgift"
//                            if(it.gid.contains("wealth_grade") || it.gid.contains("anchor_grade")){
//                                downloadUrl = "https://img.img.9xiu.com/resource/mobile/activeSvga/"
//                            }
//
//                            downloadManager?.downLoadCallback(downloadUrl + bean.gid + SVGA_FILE_SUFFIX + "?v=" + it.updatetime, suffixFileName, object : DownloadCallback {
//                                override fun downloadSuccess() {
//                                    NSLog.d(TAG, "downloadSuccess")
//                                }
//
//                                override fun downloadFailure(errorMsg: String) {
//
//                                }
//                            })
//                        }
//                    }
//                }
//            }).start()
//        }
    }

    data class GiftData(val gid:Int, val source_type:Int, val time:Long,val count: Int)

}