package com.ninexiu.sixninexiu.fragment

import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Build
import android.os.Bundle
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.style.ImageSpan
import android.view.LayoutInflater
import android.view.View
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import com.blankj.utilcode.util.ConvertUtils
import com.bumptech.glide.Glide
import com.bumptech.glide.Priority
import com.bumptech.glide.request.RequestOptions
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.ijkplayer.widget.media.IjkVideoView
import com.kpswitch.util.KeyboardUtil
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.*
import com.ninexiu.sixninexiu.activity.friend.SelectFriendActivity
import com.ninexiu.sixninexiu.adapter.DynamicCommentAdapter
import com.ninexiu.sixninexiu.adapter.DynamicDataAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.audio.AudioPlayerManager
import com.ninexiu.sixninexiu.audio.DynamicDetailHelper
import com.ninexiu.sixninexiu.audio.DynamicHelper
import com.ninexiu.sixninexiu.audio.FollowHelper
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.CommentData
import com.ninexiu.sixninexiu.bean.Dynamic
import com.ninexiu.sixninexiu.bean.DynamicSystemMsg
import com.ninexiu.sixninexiu.bean.VideoRoomBean
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.IM.TencentContans
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.common.util.manager.RequestManager
import com.ninexiu.sixninexiu.common.util.manager.RequestManagerCallBack
import com.ninexiu.sixninexiu.values.EnterRoomValue
import com.ninexiu.sixninexiu.view.*
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.BaseDialog.OnClickCallback
import com.ninexiu.sixninexiu.view.dialog.CurrencyBottomDialog
import com.ninexiu.sixninexiu.view.dialog.CurrencyDialog
import com.ninexiu.sixninexiu.activity.SayHelloHalfActivity
import com.tencent.imsdk.TIMConversationType
import com.tencent.qcloud.tim.uikit.modules.chat.base.ChatInfo
import com.tencent.qcloud.tim.uikit.utils.SoftKeyBoardUtil
import kotlinx.android.synthetic.main.fragment_dynamic_detail_new.*
import kotlinx.android.synthetic.main.layout_dynamic_input.*
import tv.danmaku.ijk.media.player.IMediaPlayer
import java.util.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/31
 *     desc   : 动态详情界面(此界面为重构界面,以前的界面 AnchorDynamicDetailFragment 废弃不用,暂时先不删除)
 *     version: 1.0
 * </pre>
 */
class DynamicDetailNewFragment : BaseFragment() {
    companion object {
        const val PARAMS_ID = "id"
        const val PARAMS_TYPE = "type"
        const val PARAMS_PAGE = "toPage"

        const val Tag = "DynamicDetailNewFragment > "

        const val STATUS_NORMAL = 0         // 当前页面是正常状态
        const val STATUS_SCROLL = 1         // 当前页面是滑动状态
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initView()
        initData()
        initEvent()
    }

    private val mSmileyParser = SmileyParser.getInstance()
    private var faceManager: DynamicCommentLiveFaceManager? = null

    private val comments = mutableListOf<CommentData>()
    private val commentAdapter = DynamicCommentAdapter(comments, mSmileyParser)

    private var headImg: HeadBoxView? = null

    private var manager: LinearLayoutManager? = null
    private fun initView() {
        // 初始化表情管理类
        faceManager = DynamicCommentLiveFaceManager(context, etCommentInput, faceStub)

        // 设置评论 adapter
        manager = LinearLayoutManager(context, LinearLayoutManager.VERTICAL, false)
        recyComment.layoutManager = manager
        recyComment.adapter = commentAdapter

        commentAdapter.onCommentItemClick = { comment ->
            replyToSomeOneOrDynamic(comment)
        }

        // 点击输入框,表情输入消失
        etCommentInput.getFocus = {
            if (faceManager?.isShow == true) {
                faceManager?.goneFaceView()
                ivCommentEmoji.setImageResource(R.drawable.ic_dynamic_input_emoji)
            }
        }

        // 点击外部消失
        nestedScrollView.onScrollViewClick = {
            if (faceManager?.isShow == true) {
                faceManager?.goneFaceView()
                ivCommentEmoji.setImageResource(R.drawable.ic_dynamic_input_emoji)
            }

            // llInput.setVisible(false)

            // 恢复初始状态
            KeyboardUtil.hideKeyboard(etCommentInput)
        }

        activity?.let { headImg = HeadBoxView(it) }
        headImg?.bindHead(view?.findViewById(R.id.ivAnchor))

        // 设置顶部根据滑动距离变化
        setTopTitleChange()

        refresh_layout.setOnRefreshListener {
            pageNumber = 0
            releaseVideo()
            getDynamicDetailData()
            getDynamicCommentData()
        }

        // 监听键盘状态
        // 表情和键盘图标切换
        SoftKeyBoardUtil.SoftKeyboardStateHelper(activity?.window?.decorView, object : SoftKeyBoardUtil.SoftKeyboardStateListener {
            override fun onSoftKeyboardOpened(keyboardHeightInPx: Int) {
            }

            override fun onSoftKeyboardClosed() {
                afterReplyInitView()
            }
        })
    }

    // 设置顶部根据滑动距离变化
    var margin = 0
    private fun setTopTitleChange() {

        context?.let {
            margin = dp2px(it, 56)
        }

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            nestedScrollView.setOnScrollChangeListener { _: View?, _: Int, scrollY: Int, _: Int, _: Int ->

                if (currentStatus != STATUS_SCROLL && scrollY > margin) {
                    currentStatus = STATUS_SCROLL
                    setTopStatus()
                } else if (currentStatus != STATUS_NORMAL && scrollY < margin) {
                    currentStatus = STATUS_NORMAL
                    setTopStatus()
                }

                // 加载更多
                if (isHaveMoreComment && manager?.findLastCompletelyVisibleItemPosition() ?: -1 == comments.size - 1) {
                    getDynamicCommentData()
                }
            }
        }
    }

    // 用户要回复的某条评论或动态
    private var replyComment: CommentData? = null

    // 回复某条评论/动态  comment : 空 : 回复动态    comment : 非空 : 回复评论
    private fun replyToSomeOneOrDynamic(comment: CommentData? = null) {
        if (comment != null && TextUtils.equals(NineShowApplication.mUserBase?.uid?.toString(), comment.uid.toString())) {
            MyToast.showShort("不能回复自己!")
            return
        }

        // llInput.setVisible(true)
        etCommentInput.requestFocus()
        // 弹出键盘
        KeyboardUtil.showKeyboard(etCommentInput)

        etCommentInput.hint = comment?.let {
            "回复  " + it.nickname
        } ?: "发表评论"

        replyComment = comment
    }


    // 真正的回复
    @SuppressLint("SetTextI18n")
    private fun replyReal() {
        if (NineShowApplication.mUserBase == null) {
            MyToast.MakeToast(context, "请先登录！")
            return
        }

        if (etCommentInput.text.isNullOrBlank()) {
            MyToast.MakeToast(context, "您输入的数据为空")
            return
        }

        StatisticsUtil.onEvent(StatisticsEventID.UM_DYNAMIC_COMMENT_SUC)

        // 回复动态或某条评论
        DynamicDetailHelper.replyCommentOrDynamic(token, type, dynamicId, replyComment, etCommentInput.text.toString(), { newComment ->
            MyToast.showShort(if (replyComment == null) "评论成功" else "回复成功")
            // 恢复view
            KeyboardUtil.hideKeyboard(etCommentInput)

            // 更新数据
            val replyNum = data?.replynum ?: 0
            data?.replynum = replyNum + 1

            // 刷新
            this.comments.add(0, newComment)
            commentAdapter.notifyItemChanged(0)

            // 更新评论数量
            tvCommentNumber.text = "${data?.replynum ?: "评论"}"
            tvCommentNumberBottom.text = "(${data?.replynum ?: 0})"

            showEmptyCommentView(false)
        }, {
            MyToast.showShort(if (replyComment == null) "评论失败" else "回复失败")
            KeyboardUtil.hideKeyboard(etCommentInput)
        })
    }

    private fun afterReplyInitView() {
        replyComment = null

        // 恢复输入框
        etCommentInput.setText("")
        etCommentInput.hint = context?.getString(R.string.dynamic_comment_input_hint)
        etCommentInput.clearFocus()

        // 键盘消失
        // llInput.setVisible(false)
    }


    private var dynamicId: Long = 0L
    private var type: Int = 0
    private var toPage: Int = 1     // 好像已经不用了
    private fun initData() {
        activity?.intent?.extras?.let {
            dynamicId = it.getLong(PARAMS_ID, 0L)
            type = it.getInt(PARAMS_TYPE, 0)
            toPage = it.getInt(PARAMS_PAGE, 1)
        }

        // 获取动态详情数据
        getDynamicDetailData()

        // 获取评论数据
        getDynamicCommentData()
    }

    private fun initEvent() {
        btDetailLeft.setOnClickListener {
            activity?.finish()
        }

        // 头像跳转
        headImg?.iv_head?.setOnClickListener {
            if (NineShowApplication.mUserBase == null) {
                activity?.let {
                    Utils.startLogin(it, it.resources.getString(R.string.live_login_audience))
                }
                return@setOnClickListener
            }

            if (data?.isplay ?: 0L == 1L) {
                data?.info?.rid = data?.rid?.toString()
                Utils.openLiveRoomObj(context, data?.info)
            } else {
                data?.dynamicid?.let {
                    FollowHelper.setDynamicId(it.toString())
                }
                // 跳转到主播个人主页
                PersonalInforActivity.start(context, true, data?.info?.uid)
            }
        }

        // 设置更多
        ivMore.setOnClickListener {
            val tempContext = context
            val tempData = data
            if (tempContext != null && tempData != null && tempData.info != null) {
                DynamicShareDialog(tempContext, tempData.info.uid) { type ->
                    dynamicShare(tempContext, tempData, type)
                }.show()
            }
        }

        // 展开/收起
        tvMore.setOnClickListener {
            if (data?.isUnfold != true) {
                data?.isUnfold = true
                tvContent.maxLines = 50
                tvMore.text = "收起"
            } else {
                data?.isUnfold = false
                tvContent.maxLines = 4
                tvMore.text = "展开"
            }
        }

        // 评论动态
        tvCommentNumber.setOnClickListener {
            replyToSomeOneOrDynamic()
        }

        // 发送评论
        tvCommentSubmit.setOnClickListener {
            replyReal()
        }

        // 表情
        llCommentEmoji.setOnClickListener {
            if (faceManager?.isShow == true) {
                ivCommentEmoji.setImageResource(R.drawable.ic_dynamic_input_emoji)
                faceManager?.goneFaceView()
                etCommentInput.requestFocus()
                KeyboardUtil.showKeyboard(etCommentInput)
            } else {
                ivCommentEmoji.setImageResource(R.drawable.ic_dynamic_input_emoji_selected)
                KeyboardUtil.hideKeyboard(etCommentInput)
                ivCommentEmoji?.postDelayed(Runnable { faceManager?.showLiveFaceView() }, 100)
            }
        }


        // 点赞
        tvLikeNumber.setOnClickListener {
            if (Utils.isFastDoubleClick()) {
                return@setOnClickListener
            }
            if (!NineShowApplication.mAccountManager.isUserLogin) {
                Utils.startLogin(activity, NineShowApplication.applicationContext.getString(R.string.login_dynam))
                return@setOnClickListener
            }

            if (data?.dynamicid == -1L || data?.status == "0") {
                MyToast.MakeToast(context, "动态审核中，无法操作！")
                return@setOnClickListener
            }

            if (data?.ispraise ?: 0 == 0) {
                likeTheDynamic()
            } else {
                MyToast.MakeToast(context, "您已经喜欢过了")
            }
        }

        // 关注
        tvAttention.setOnClickListener {
            followTheDynamic()
        }
        tvAttentionTop.setOnClickListener {
            followTheDynamic()
        }

        // 房间中跳转 : 主播跳转到直播间，普通用户跳转到所在房间
        tvLiving.setOnClickListener {
            if (NineShowApplication.mUserBase == null) {
                Utils.startLogin(activity, getString(R.string.live_login_audience))
                return@setOnClickListener
            }


            if (data != null) {
                val dynamicInfo = data

                if (dynamicInfo != null && dynamicInfo.info != null && dynamicInfo.isplay == 1) {
                    dynamicInfo.info.rid = dynamicInfo.rid.toString()
                    dynamicInfo.info.enterFrom = EnterRoomValue.ENTER_ROOM_DYNAMIC
                    Utils.openLiveRoomObj(context, dynamicInfo.info)
                } else if (dynamicInfo != null && dynamicInfo.info != null && dynamicInfo.info.at_room != null && dynamicInfo.info.at_room > 0L) {
                    Utils.openLiveRoom(context, 0, dynamicInfo.info.at_room.toString(), 0, "")
                }
            }

        }
    }

    private val token: String?
        get() = NineShowApplication.mUserBase?.token

    // 获取动态详情
    private fun getDynamicDetailData() {
        DynamicDetailHelper.getDynamicDetailData(dynamicId, token, { setDynamicDetailData(it) }, { activity?.finish() })
    }

    private var isLoading = false

    // 获取评论数据
    private var pageNumber = 0
    private fun getDynamicCommentData() {
        if (isLoading) {
            return
        }
        isLoading = true
        NSLog.d(Tag, "comment : 加载数据...")
        DynamicDetailHelper.getDynamicCommentData(dynamicId, token, pageNumber, { comments ->
            NSLog.d(Tag, "${comments.size}")
            NSLog.d(Tag, "comment : has more...")

            isHaveMoreComment = true

            if (pageNumber == 0) {
                this.comments.clear()
            }
            this.comments.addAll(comments)
            commentAdapter.notifyDataSetChanged()
            showEmptyCommentView(false)
            pageNumber++
            isLoading = false
            refresh_layout.finishRefresh()      // 结束刷新动作
        }, {
            NSLog.d(Tag, "comment : no more...")
            isHaveMoreComment = false
            if (pageNumber == 0) {
                showEmptyCommentView(true)
            }

            isLoading = false
            refresh_layout.finishRefresh()     // 结束刷新动作
        })
    }

    // 是否还有评论数据,没有的话不需要再去加载了
    private var isHaveMoreComment = true

    private var data: Dynamic? = null

    // 设置动态详情数据
    @SuppressLint("SetTextI18n")
    private fun setDynamicDetailData(data: Dynamic) {
        this.data = data
        data.info?.let { info ->
            // 头像
            headImg?.iv_head?.let { GlideUtils.loadCirclePic(context, info.headimage, headImg?.iv_head) }
            GlideUtils.loadCirclePic(context, info.headimage, ivAnchorTop)
            headImg?.setScale(1.4f)
            headImg?.loadBoxImage(data.info.headframe)

            // 姓名
            tvNickName.text = info.nickname
            tvNickNameTop.text = info.nickname
        }

        // 时间
        tvTime.text = TimeUtil.getDescriptionTimeFromTimestamp(data.addtime)

        // vip认证
        ivVip.setVisible(data.headimgAuth == 1)

        // 点赞
        setDynamicLike(data)

        // 评论
        if (data.replynum > 0) {
            tvCommentNumber.text = "${data.replynum}"
        } else {
            tvCommentNumber.text = "评论"
        }

        tvCommentNumberBottom.text = "(${data.replynum})"

        // 正在直播
        if (context != null && (data.isplay == 1 || (data.info != null && data.info.at_room != null && data.info.at_room > 0L))) {
            val options = RequestOptions()
                    .priority(Priority.NORMAL).centerCrop()
            context?.let {
                Glide.with(it).load(R.drawable.gif_dynamic_liveing).apply(options).into(ivLiving)
            }

            tvLiving.setVisible(true)
            ivLiving.setVisible(true)
        } else {
            tvLiving.setVisible(false)
            ivLiving.setVisible(false)
        }

        // 年龄性别
        if (data.age.toInt() > 0) {
            tvAge.setVisible(true)
            tvAge.text = data.age
            setSex(data.sex)    // 设置性别
        } else {
            tvAge.setVisible(false)
        }

        // 在线
        if(data.info != null && data.info.online_status >= 1) {
            tvOnLine.setVisible(true)
        }else {
            tvOnLine.setVisible(false)
        }

        // 设置关注
        if (data.isfollow == 1L || TextUtils.equals(data.info.uid, NineShowApplication.mUserBase?.uid?.toString())) {
            tvAttention.setVisible(false)
            tvAttentionTop.setVisible(false)
        } else {
            tvAttention.setVisible(true)
            tvAttentionTop.setVisible(true)
        }

        // 设置位置
        if (!TextUtils.isEmpty(data.address)) {
            tvAddress.setVisible(true)
            tvAddress.text = data.address
        } else {
            tvAddress.setVisible(false)
        }


        // 设置浏览数量

        var beforeShow = false
        if (data.view_num <= 0) {
            beforeShow = false
            tvSee.setVisible(false)
        } else {
            beforeShow = true
            tvSee.setVisible(true)
            if (data.type == DynamicDataAdapter.TYPE_DYNAMIC_AUDIO || data.type == DynamicDataAdapter.TYPE_DYNAMIC_VIDEO) {
                tvSee.text = "${DynamicHelper.formatViewNumber(data.view_num)}次播放"
            } else {
                tvSee.text = "${DynamicHelper.formatViewNumber(data.view_num)}次浏览"
            }
        }

        if (data.fview_num <= 0) {
            tvFSee.setVisible(false)
        } else {
            tvFSee.setVisible(true)
            tvFSee.text = "${data.fview_num}次好友播放"
            if (data.type == DynamicDataAdapter.TYPE_DYNAMIC_AUDIO || data.type == DynamicDataAdapter.TYPE_DYNAMIC_VIDEO) {
                if (beforeShow) {
                    tvFSee.text = " · ${DynamicHelper.formatViewNumber(data.fview_num)}次好友播放"
                } else {
                    tvFSee.text = "${DynamicHelper.formatViewNumber(data.fview_num)}次好友播放"
                }
            } else {
                if (beforeShow) {
                    tvFSee.text = " · ${DynamicHelper.formatViewNumber(data.fview_num)}次好友浏览"
                } else {
                    tvFSee.text = "${DynamicHelper.formatViewNumber(data.fview_num)}次好友浏览"
                }
            }
        }

        // 系统动态不展示 文字内容区域
        if(data.type  != DynamicDataAdapter.TYPE_DYNAMIC_SYSTEM) {
            // 设置文本和 展开/收起
            tvContent.post {
                tvContent.maxLines = 50     // 防止刷新出现问题
                if (!TextUtils.isEmpty(data.content)) {
                    tvContent.setVisible(true)
                    val builder = SpannableStringBuilder(data.content)
                    tvContent.text = mSmileyParser.addSmileySpans1(builder)

                    if (data.lines == 0) {
                        data.lines = tvContent.lineCount
                    }
                    if (tvContent.lineCount > 5 || data.lines > 5) {
                        tvMore.setVisible(true)
                        if (data.isUnfold) {
                            tvContent.maxLines = 50
                            tvMore.text = "收起"
                        } else {
                            tvContent.maxLines = 5
                            tvMore.text = "展开"
                        }
                    } else {
                        tvMore.setVisible(false)
                    }
                } else {
                    tvContent.setVisible(false)
                }
            }
        }

        // 打招呼
        setSayHello(data)

        // 设置主要内容区域
        setDynamicContainer(data)
    }

    // 设置打招呼
    private fun setSayHello(data: Dynamic) {
        if (TextUtils.equals(NineShowApplication.mUserBase?.uid?.toString(), data.info.uid)) {
            ivHello.setViewVisible(false)
        } else {
            ivHello.setViewVisible(true)
        }

        ivHello.setOnClickListener {
            StatisticsUtil.onEvent(StatisticsEventID.UM_DYNAMIC_HELLO)
            RequestManager.create().sendGreetChat(data.info.uid, RequestManagerCallBack.RequestCodeMsgCallBack { code, message ->
                if (code == 200) {
                    val bundle = Bundle()
                    bundle.putInt("chat_type", 3)
                    val chatInfo = ChatInfo()
                    chatInfo.type = TIMConversationType.C2C
                    chatInfo.id = data.info.uid
                    chatInfo.chatName = data.info.nickname
                    bundle.putSerializable(TencentContans.CHAT_INFO, chatInfo)
                    HelloChatActivity.start(view.context, bundle)
                } else if (code == 601){
                    val anchorInfo = AnchorInfo()
                    anchorInfo.uid = data.info.uid
                    anchorInfo.nickname = data.info.nickname
                    anchorInfo.headframe = data.info.headframe
                    activity?.let { it1 -> SayHelloHalfActivity.start(it1, anchorInfo) }
                } else if (code == 600){
                    CurrencyDialog.create(activity)
                        .setTitleText(message)
                        .setOnClickCallback { type ->
                            if (type == BaseDialog.SELECT_SECOND) {
                                val chatInfo = ChatInfo()
                                chatInfo.type = TIMConversationType.C2C
                                chatInfo.id = data.info.uid
                                var nickName = data.info.remark_name
                                if (TextUtils.isEmpty(nickName)) {
                                    nickName = data.info.nickname
                                }
                                chatInfo.chatName = nickName
                                val intent = Intent(activity, ConversationActivity::class.java)
                                intent.putExtra(TencentContans.CHAT_INFO, chatInfo)
                                intent.putExtra(TencentContans.IS_STRANGER_CHAT, 1)
                                activity?.startActivity(intent)
                            }
                        }
                }else {
                    if (!TextUtils.isEmpty(message)) {
                        MyToast.MakeToast(message)
                    }
                }
            })
        }
    }


    // 当前页面的滑动状态
    private var currentStatus = STATUS_NORMAL

    // 关注
    private fun followTheDynamic() {
        if (NineShowApplication.mUserBase == null) {
            Utils.startLogin(context as Activity, NineShowApplication.applicationContext.resources.getString(R.string.live_login_sub))
            return
        }

        data?.dynamicid?.let {
            FollowHelper.setDynamicId(it.toString())
        }

        RequestManager.create()
                .attentionUser(data?.info?.uid, 1) { code, message ->
                    if (code == 200 || code == 400) {
                        data?.isfollow = 1L
                        tvAttention.setVisible(false)
                        tvAttentionTop.setVisible(false)
                        setTopStatus()
                    }
                    if(!TextUtils.isEmpty(message)) {
                        MyToast.MakeToast(message)
                    }
                }
    }

    // 设置顶部的状态
    private fun setTopStatus() {
        if (currentStatus == STATUS_NORMAL) {
            tvDynamicTitle.setVisible(true)
            setViewsVisible(false, tvNickNameTop, llTop)
        } else {
            if (data?.isfollow ?: 0L == 1L) {
                tvNickNameTop.setVisible(true)
                setViewsVisible(false, tvDynamicTitle, llTop)
            } else {
                llTop.setVisible(true)
                setViewsVisible(false, tvDynamicTitle, tvNickNameTop)
            }
        }
    }

    // 动态点赞
    private fun likeTheDynamic() {
        StatisticsUtil.onEvent(StatisticsEventID.UM_DYNAMIC_LIKE)
        DynamicDetailHelper.likeTheDynamic(token, dynamicId, {
            data?.ispraise = 1
            val num = data?.upnum ?: 0
            data?.upnum = num + 1
            data?.let { setDynamicLike(it) }
            startLikeAnimation()
            MyToast.MakeToast("喜欢成功")
        }, {
            MyToast.MakeToast(context, "喜欢失败了")
        })
    }

    private fun startLikeAnimation() {
        val o1 = ObjectAnimator.ofFloat(tvLikeNumber, "scaleX", 1f, 1.5f, 1f)
        val o2 = ObjectAnimator.ofFloat(tvLikeNumber, "scaleY", 1f, 1.5f, 1f)
        val set = AnimatorSet()
        set.duration = 500
        set.play(o1).with(o2)
        set.start()
    }

    //点赞
    private fun setDynamicLike(data: Dynamic) {
        if (data.ispraise == 1) {
            context?.let {
                val likeDrawable = ContextCompat.getDrawable(it, R.drawable.ic_dynamic_like_selected)
                likeDrawable?.setBounds(0, 0, likeDrawable.minimumWidth, likeDrawable.minimumHeight)
                tvLikeNumber.setCompoundDrawables(likeDrawable, null, null, null)
            }
        } else {
            context?.let {
                val likeDrawable = ContextCompat.getDrawable(it, R.drawable.ic_dynamic_like_normal)
                likeDrawable?.setBounds(0, 0, likeDrawable.minimumWidth, likeDrawable.minimumHeight)
                tvLikeNumber.setCompoundDrawables(likeDrawable, null, null, null)
            }
        }

        if (data.upnum > 0) {
            tvLikeNumber.text = data.upnum.toString()
        } else {
            tvLikeNumber.text = "喜欢"
        }
    }

    // 设置动态详情内容数据 : 视频,图片,语音,系统
    private fun setDynamicContainer(data: Dynamic) {
        when (data.type) {
            DynamicDataAdapter.TYPE_DYNAMIC_VIDEO -> {
                containerVideo.setVisible(true)
                setViewsVisible(false, containerAudio, containerImages, containerSystem)
                data.shortvideo?.let {
                    // 设置视频封面和时长
                    tvVideoTime.text = Utils.getPKToTime(Utils.parseDouble(it.duration).toInt())
                    GlideUtils.loadSimpleImgWithRoundCorner(context, it.videoImage, ivVideoCover, R.drawable.anthor_moren, ConvertUtils.dp2px(6f))
                }

                // 观看视频
                containerVideo.setOnClickListener {
                    if (data.dynamicid != 0L && data.dynamicid != -1L) {
                        DynamicHelper.addElement(data.dynamicid)
                    }

                    // val strClass: String = context.toString().substring(context.toString().lastIndexOf(".") + 1, context.toString().indexOf("@"))
                    // if (strClass != "SubPageActivity" && data.shortvideo != null) {  //判断如果是个人资料页 则直接跳转到视频播放页
                    val videoInfo = VideoRoomBean.VideoInfo()
                    videoInfo.videoid = data.shortvideo.videoid.toInt()
                    videoInfo.videourl = data.shortvideo.videoUrl
                    val videoInfos = ArrayList<VideoRoomBean.VideoInfo>()
                    videoInfos.add(videoInfo)
                    VideoShowActivity.start(context, "0", 4, videoInfos)
                    // }
                }

                playVideo()
            }

            // 设置系统
            DynamicDataAdapter.TYPE_DYNAMIC_SYSTEM -> {
                containerSystem.setVisible(true)
                setViewsVisible(false, containerAudio, containerImages, containerVideo)
                setDynamicSystemView(data)
            }
            DynamicDataAdapter.TYPE_DYNAMIC_AUDIO -> {
                containerAudio.setVisible(true)
                setViewsVisible(false, containerSystem, containerImages, containerVideo)

                if (data.voice_url.isNullOrBlank()) {
                    containerAudio.setVisible(false)
                } else {
                    data.voice_url?.let {
                        containerAudio.setAudioItemSource(it, data.voice_duration)
                    }
                }
            }
            else -> {
                containerImages.setVisible(true)
                setViewsVisible(false, containerSystem, containerAudio, containerVideo)

                containerImages.layoutParams.width = ScreenUtils.getScreenWidth(context) - ConvertUtils.dp2px(32f)
                containerImages.setDynamicPhotoEntities(data.photo, true)

                containerImages.setAsivClickListener { pos, _, _, _ ->
                    val intentPhoto = Intent(context, AlbumBrowerActivity::class.java)
                    intentPhoto.putExtra("curPosition", pos)
                    intentPhoto.putExtra("dynamicType", 1) // 1动态

                    val photoList = ArrayList<String>()
                    data.photo?.forEach {
                        photoList.add(it.photothumburl)
                    }
                    intentPhoto.putStringArrayListExtra("photoList", photoList)
                    activity!!.startActivity(intentPhoto)
                    activity!!.overridePendingTransition(R.anim.zoom_in, 0) // 切换Activity的过渡动画

                }
            }
        }
    }

    private val completionListener = IMediaPlayer.OnCompletionListener {
        if (ijkPlayerView != null) {
            ijkPlayerView.seekTo(0) // 重新开始播放
            ijkPlayerView.start()
        }
    }

    // 自动播放视频
    private fun startPlayVideo() {
        if (ijkPlayerView != null && data != null) {
            val videoUrl = data?.shortvideo?.videoUrl
            if (videoUrl != null) {
                val proxy = NineShowApplication.getProxy()
                ijkPlayerView.setRender(IjkVideoView.RENDER_SURFACE_VIEW)
                ijkPlayerView.videoPath = proxy.getProxyUrl(videoUrl)
                ijkPlayerView.start()
                ijkPlayerView.visibility = View.VISIBLE
                ijkPlayerView.setOnCompletionListener(completionListener) // 设置播放完成监听
            }
        }
    }

    override fun onResume() {
        super.onResume()
        releaseVideo()
        playVideo()
    }


    override fun onPause() {
        super.onPause()
        releaseVideo()
    }

    private fun playVideo() {
        ijkPlayerView?.postDelayed({
            startPlayVideo()
        }, 1000)
    }

    private fun releaseVideo() {
        if (ijkPlayerView == null) {
            return
        }
        ijkPlayerView.visibility = View.INVISIBLE
        ijkPlayerView.setOnCompletionListener(null)
        ijkPlayerView.stopPlayback()
        ijkPlayerView.release(true)
        ijkPlayerView.setRender(IjkVideoView.RENDER_NONE)
        ijkPlayerView.releaseWithoutStop()
        ijkPlayerView.stopBackgroundPlay()
    }

    // 设置系统消息的view布局
    private fun setDynamicSystemView(data: Dynamic) {
        setViewsVisible(false, tvContent, tvMore)
        val gson = GsonBuilder().create()

        var resultInfo: DynamicSystemMsg? = null
        try {
            resultInfo = gson.fromJson(data.content, DynamicSystemMsg::class.java)
        } catch (e: JsonSyntaxException) {
            e.printStackTrace()
        }
        if (resultInfo != null) {
            if (resultInfo.type == 1) { // 主播升级
                if (ivSystemAnchor.tag == null || ivSystemAnchor.tag != data.info.headimage) {
                    GlideUtils.loadCirclePic(context, data.info.headimage, ivSystemAnchor)
                    ivSystemAnchor.tag = data.info.headimage
                    ivSystemTag.setImageResource(R.drawable.system_msg_leveup)
                    val oldChar = resultInfo.level.toString() + ""
                    val repContent = resultInfo.content.replace(oldChar, " $oldChar")
                    val startLevel = repContent.indexOf(oldChar)
                    val bder = SpannableStringBuilder(repContent)
                    val drawable = Utils.getHostLevelDrawable(resultInfo.level)
                    bder.setSpan(VerticalImageSpan(context, drawable, ImageSpan.ALIGN_BOTTOM),
                            startLevel, repContent.length,
                            Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                    tvSystemDesc.text = bder
                }
            } else if (resultInfo.type == 2) { // 守护
                if (ivSystemAnchor.tag == null
                        || ivSystemAnchor.tag != data.info.headimage) {
                    GlideUtils.loadCirclePic(context, data.info.headimage, ivSystemAnchor)
                    ivSystemTag.setImageResource(R.drawable.system_msg_guard)
                    tvSystemDesc.text = resultInfo.content
                }
            } else {
                tvSystemDesc.text = resultInfo.content
            }
        } else {
            ivSystemTag.visibility = View.GONE
            ivSystemAnchor.visibility = View.GONE
            tvSystemDesc.text = ""
        }
    }

    // 设置性别
    private fun setSex(sex: String) {
        var sexDrawable: Int? = null
        var backDrawable: Int? = null
        when (sex) {
            "1" -> {
                sexDrawable = R.drawable.icon_personal_man
                backDrawable = R.drawable.shape_gradient_man
                context?.let {
                    tvAge.setTextColor(ContextCompat.getColor(it,R.color.color_4785ff))
                }
            }
            "2" -> {
                sexDrawable = R.drawable.icon_personal_woman
                backDrawable = R.drawable.shape_gradient_woman
                context?.let {
                    tvAge.setTextColor(ContextCompat.getColor(it,R.color.color_ff3366))
                }
            }
        }

        if (sexDrawable != null && backDrawable != null) {
            context?.let {
                val drawable = ContextCompat.getDrawable(it, sexDrawable)
                drawable?.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                tvAge.setCompoundDrawables(drawable, null, null, null)
                tvAge.background = ContextCompat.getDrawable(it, backDrawable)
            }
        } else {
            tvAge.setVisible(false)
        }
    }

    @SuppressLint("SetTextI18n")
    private fun showEmptyCommentView(show: Boolean) {
        when (show) {
            true -> {
                llCommentEmpty.setVisible(true)
                setViewsVisible(false, tvAllComment, tvCommentNumberBottom, recyComment)
                // replyToSomeOneOrDynamic()   // 没有数据的时候显示键盘
            }
            else -> {
                llCommentEmpty.setVisible(false)
                setViewsVisible(true, tvAllComment, tvCommentNumberBottom, recyComment)
            }
        }
    }


    // 动态分享
    private fun dynamicShare(context: Context, dynamicInfo: Dynamic, type: String) {
        when (type) {
            ShareUtils.TYPE_NINESHOW -> {   // 九秀好友
                if (dynamicInfo.dynamicid == 0L || dynamicInfo.dynamicid == -1L) {
                    MyToast.showShort("动态审核中,无法操作！")
                    return
                }

                if (dynamicInfo.type == DynamicDataAdapter.TYPE_DYNAMIC_SYSTEM) {
                    MyToast.showShort("系统动态,无法分享")
                    return
                }
                val bundle = Bundle()
                bundle.putSerializable(Constants.DATA_BEAN, dynamicInfo)
                SelectFriendActivity.startActivity(context, SelectFriendActivity.FROM_DYNAMIC, bundle)
            }
            DynamicShareDialog.TYPE_DYNAMIC_JUBAO -> {  // 举报
                ReportActivity.start(context, true, dynamicInfo.info.rid, dynamicInfo.info.uid)
            }
            DynamicShareDialog.TYPE_DYNAMIC_BLACK -> {  // 黑名单
                MBOperationManager.create().showPushdialog(context as Activity, true, Utils.parseLong(dynamicInfo.info.uid))
            }
            DynamicShareDialog.TYPE_DYNAMIC_DELETE -> {  // 删除
                deleteDynamic(dynamicInfo)
            }
        }
    }

    // 删除动态
    private fun deleteDynamic(dynamicInfo: Dynamic) {
        CurrencyBottomDialog.create(context)
                .setFirstText("删除")
                .setFirstTextColor("#E82929")
                .setSecondHideView()
                .setOnClickCallback(OnClickCallback { type ->
                    if (type == BaseDialog.SELECT_FIRST) {
                        RequestManager.create().deleteDynamicTask(dynamicInfo.dynamicid) { code ->
                            if (code == 200) {
                                MyToast.showShort("删除成功")
                                // 删除成功,更新数据
                                val bundle = Bundle()
                                bundle.putString("uid", dynamicInfo.info.uid)
                                bundle.putLong("dynamicid", dynamicInfo.dynamicid)
                                AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.DYNAMIC_SQUARE_REFERSH_ACTION,
                                        NSDataBroadcast.TYPE_OPERATION_DEFAULT, bundle)
                                activity?.finish()
                            }
                        }
                    }
                })
    }

    @SuppressLint("InflateParams")
    override fun inflate(inflater: LayoutInflater): View {
        return inflater.inflate(R.layout.fragment_dynamic_detail_new, null, false)
    }

    override fun onDestroyView() {
        super.onDestroyView()
        releaseVideo()

        // 释放音频资源
        if (data?.type == DynamicDataAdapter.TYPE_DYNAMIC_AUDIO) {
            AudioPlayerManager.releasePlayer()
        }
    }
}