package com.ninexiu.sixninexiu.fragment

import android.Manifest
import android.annotation.SuppressLint
import android.content.Intent
import android.content.IntentFilter
import android.graphics.Typeface
import android.os.Bundle
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentStatePagerAdapter
import androidx.viewpager.widget.ViewPager
import androidx.viewpager.widget.ViewPager.OnPageChangeListener
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.View.OnClickListener
import android.view.ViewGroup
import android.widget.ImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.HomeTagInfo
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.HallTagManager
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.NSLogger
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.common.util.manager.PermissionManager
import com.ninexiu.sixninexiu.view.TypePagerTipsTabStrip
import com.thirdparty.utils.StatusBarUtil

/**
 * @Description:     tab二级列表
 * @Author:          liuguangyu
 * @date  :     2019/5/31 16:25
 * @Version:
 */
class LiveChildHallFragment : BasePagerFragment(), OnClickListener {

    private var rootView: View? = null
    private var bundle: Bundle? = null
    private var indicator: TypePagerTipsTabStrip? = null
    private var viewPager: ViewPager? = null
    private var iv_hall_back: View? = null
    //	private ImageView hot_activity;
    private var adapter: TypePagerAdapter? = null
    private var nearby = "附近"
    private var tabBean: HomeTagInfo.DataBean? = null

    private lateinit var tabList:List<HomeTagInfo.DataBean>

    private val locPermissionList = arrayOf(Manifest.permission.ACCESS_COARSE_LOCATION)


    private var hasDenyReqLocPer = false
    private var mHallTagManager: HallTagManager? = null

    private fun initTabList(): List<HomeTagInfo.DataBean> {

        val dataBeans = bundle?.getParcelableArrayList<HomeTagInfo.DataBean>("subList")
        if (dataBeans!=null && dataBeans.isNotEmpty()) {
            val iterator=dataBeans.iterator()
            while (iterator.hasNext()){
                if (!TextUtils.isEmpty(iterator.next().h5Url)){
                    iterator.remove()
                }
            }
        }
        NSLog.e(TAG, "--------$bundle-----${dataBeans?.size}")
        return dataBeans ?: listOf<HomeTagInfo.DataBean>()


    }


    val currentItem: Int
        get() = if (viewPager != null && adapter != null) {
            viewPager!!.currentItem
        } else -1

    @SuppressLint("ResourceAsColor")
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {
        nearby = AppCnfSpHelper.getInstance().nearby
        if (rootView == null) {
            rootView = inflater.inflate(R.layout.fragment_child_live_hall_layout, null)

            bundle = arguments
            NSLog.e(TAG, "--------$arguments-----${bundle}")
            tabBean = bundle?.getParcelable<HomeTagInfo.DataBean>("tabBean")
            NSLog.e(TAG, "--------$arguments-----${tabBean?.name}")

            tabList = initTabList()

            initTitleBar()
            viewPager = rootView!!.findViewById(R.id.moretab_viewPager)
            viewPager?.offscreenPageLimit = tabList.size//设置限制的页面数
            indicator = rootView!!.findViewById(R.id.moretab_indicator)
            iv_hall_back = rootView!!.findViewById(R.id.iv_hall_back)
            iv_hall_back?.setOnClickListener {
                activity?.finish()
            }
            mHallTagManager = HallTagManager(this.activity)

            adapter = TypePagerAdapter(fragmentManager!!, tabList)

            viewPager?.adapter = adapter
//            indicator?.tipsScroll(0)
//            indicator?.setItemWidthAndInterWidth(0, 10, 0)
            indicator?.setTextColorResource(R.color.white, R.color.hall_indcator_select)
            indicator?.setBackgroundResource(R.drawable.fragment_live_tab_shape, R.drawable.fragment_live_tab_un_shape)
            indicator?.textSize = resources.getDimensionPixelSize(R.dimen.ns_textsize_14)
            indicator?.setTypeface(Typeface.DEFAULT_BOLD, 0)
            indicator?.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_14))
            indicator?.setOnPageChangeListener(object : OnPageChangeListener {
                override fun onPageSelected(arg0: Int) {
//                    indicator!!.tipsScroll(arg0)
                    NSLog.e("-----------onPageSelected-------$arg0")
                    if(tabList.size > arg0) {
                        uMStatistics(tabList.get(arg0))
                    }
//                    when (arg0) {
//
//                        0 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_FLLOW)
//                        1 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_HOT)
//                        2//附近
//                        -> {
//
//                            StatisticsUtil.onEvent(StatisticsEventID.MAIN_PK)
//                        }
//                        3 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_NEWS)
//                        4 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_GAME)
//                        5 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_CITY)
//                        6 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_BEST_DANCER)
//                        7 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_BEST_VOICE)
//                        8 -> StatisticsUtil.onEvent(StatisticsEventID.LIVE_MAINTAB_AUDIO_INDICATOR_EVENT)
//                        9 -> StatisticsUtil.onEvent(StatisticsEventID.MAIN_CHAT)
//
//
//                    }
                }

                override fun onPageScrolled(arg0: Int, arg1: Float, arg2: Int) {}

                override fun onPageScrollStateChanged(arg0: Int) {}
            })
            indicator?.setViewPager(viewPager)
            //切换选中页面
            for (i in 0 until tabList.size) {
                if (TextUtils.equals(tabBean?.name, tabList[i].name)) {
                    viewPager!!.currentItem = i
                }
            }


            hasDenyReqLocPer = AppCnfSpHelper.getInstance().isDenyRequestLoc
        }

        return rootView
    }

    /**
     * 初始化点击事件
     */
    private fun initTitleBar() {
//        StatusBarUtil.setTranslucentForImageViewInFragment(this.activity, rootView!!.findViewById(R.id.rl_title))
        StatusBarUtil.setLightMode(this.activity)
        val mSearchBtn = rootView!!.findViewById<ImageView>(R.id.iv_hall_search)
        val mHistoryBtn = rootView!!.findViewById<ImageView>(R.id.iv_hall_history)
        mSearchBtn.setOnClickListener {
            val intent = Intent(activity, SubPageActivity::class.java)
            intent.putExtra(SubPageActivity.CLASSFRAMENT, SearchFragment::class.java)
            startActivity(intent)
            StatisticsUtil.onEvent(StatisticsEventID.MAIN_SEARCH)
        }
        mHistoryBtn.setOnClickListener {
            val intentShop = Intent(this@LiveChildHallFragment.activity, SubPageActivity::class.java)
            intentShop.putExtra(SubPageActivity.CLASSFRAMENT, HistoryFragment::class.java)
            startActivity(intentShop)
            StatisticsUtil.onEvent(StatisticsEventID.MAIN_HISTORY)
        }
    }

    override fun onResume() {
        super.onResume()
    }

    override fun onDestroyView() {
        super.onDestroyView()
//        if(rootView != null && rootView?.parent != null){
//            val parent = rootView?.parent as ViewGroup
//            parent.removeView(rootView)
//        }
    }


    inner class TypePagerAdapter(fm: androidx.fragment.app.FragmentManager, //private String[] TITLES;
                                 private val hallTags: List<HomeTagInfo.DataBean>) : FragmentStatePagerAdapter(fm) {


        override fun getPageTitle(position: Int): CharSequence? {
            return hallTags[position].name
        }

        override fun getCount(): Int {
            return hallTags.size
        }

        override fun getItem(position: Int): Fragment {
            var fragment: androidx.fragment.app.Fragment? = null
            val hallTag = hallTags[position].name
            val hallTagID = hallTags[position].id
            val index = hallTags[position].position
            NSLogger.e("++++++$hallTag    -----  $hallTags")
            when (hallTagID) {
//                "关注"//关注
//                -> fragment = AttentionFragment()
//                "热门"//热门
//                -> {
//                    val htFragment = LiveHotFragment()
//                    htFragment.setOutViewPager(viewPager)
//                    fragment = htFragment
//                }
                -1//附近
                -> {
                    val bundle = Bundle()
                    fragment = CityFragment()
                    bundle.putInt("province", Utils.dealAddress(NineShowApplication.province))
                    fragment.arguments = bundle
                }
                else -> {
                    fragment = LiveTabChildFragment.Companion.newInstance("$hallTagID", index,hallTag,position)
                }
            }
            return fragment
        }
    }

    override fun onClick(view: View) {
        if (Utils.isNotClickable()) {
            return
        }
        when (view.id) {

        }
    }

    override fun onReceive(action: String, type: Int, bundle: Bundle) {
        if (action == NSReceiverAction.ACTION_LOGIN_SUCCESS) {

        } else if (NSReceiverAction.ACTION_PK_QUALIFYING_GO_PK == action) {
            if (viewPager != null) {
                viewPager!!.postDelayed({ viewPager!!.currentItem = 3 }, 150)
            }
        } else if (NSReceiverAction.ACTION_SET_TAB_POSITION == action) {
            if (activity != null) {
                activity?.finish()
            }
        }
//        } else if (NSReceiverAction.ACTION_UPDATE_HALL_TITLE == action) {
//            setTitle()
//        }
    }

    override fun setBroadcastFilter(filter: IntentFilter) {
        filter.addAction(NSReceiverAction.ACTION_LOGIN_SUCCESS)
        filter.addAction(NSReceiverAction.ACTION_PK_QUALIFYING_GO_PK)
        filter.addAction(NSReceiverAction.ACTION_UPDATE_HALL_TITLE)
        filter.addAction(NSReceiverAction.ACTION_SET_TAB_POSITION)
    }

    override fun registerReceiver(): Boolean {
        return true
    }

    fun changePage(page: Int) {
        if (viewPager != null) {
            viewPager!!.currentItem = page
        }
    }

    fun setTitle() {
        if (nearby == NineShowApplication.province) {
            return
        } else {
            nearby = NineShowApplication.province
            if (adapter != null && mHallTagManager != null) {
                val hallTagNames = mHallTagManager!!.getRightHallTagNames(nearby)
                indicator!!.notifyDataSetChanged(hallTagNames)
                adapter!!.notifyDataSetChanged()
            }
        }
    }





    private fun requestLoc() {
        NineShowApplication.getInstance().startLoc()

    }

    companion object {


        private const val LOC_REQUEST_CODE = 110
        public var TAG = LiveChildHallFragment::class.java.simpleName
    }

    /**
     * 首页二级列表页友盟统计
     */
    private fun uMStatistics(dataBean: HomeTagInfo.DataBean) {
        val dataID = dataBean.id

        when("$dataID"){
            "-1" -> {
                if (TextUtils.isEmpty(NineShowApplication.province)) {
                    PermissionManager.create().showLocation(this){
                        requestLoc()
                    }
                }
                StatisticsUtil.onEvent(StatisticsEventID.MAIN_CITY)
            }
            Constants.LIVEHALL_TYPE_CHANGLIAO -> return  StatisticsUtil.onEvent(StatisticsEventID.MAIN_CHAT)
            Constants.LIVEHALL_TYPE_WUDAO -> return  StatisticsUtil.onEvent(StatisticsEventID.MAIN_BEST_DANCER)
            Constants.LIVEHALL_TYPE_SING -> return StatisticsUtil.onEvent(StatisticsEventID.MAIN_BEST_VOICE)
            Constants.LIVEHALL_TYPE_TESE -> return   StatisticsUtil.onEvent(StatisticsEventID.MAIN_GAME)
//            Constants.LIVEHALL_TYPE_TIANLAI -> return Constants.LIVEHALL_BANNER_TYPE_TIANLAI
//            Constants.LIVEHALL_TYPE_YUEQI -> return Constants.LIVEHALL_BANNER_TYPE_YUEQI
            Constants.LIVEHALL_TYPE_PK -> return StatisticsUtil.onEvent(StatisticsEventID.MAIN_PK)
            Constants.LIVEHALL_TYPE_XINREN -> return  StatisticsUtil.onEvent(StatisticsEventID.MAIN_NEWS)
            Constants.LIVEHALL_TYPE_BROADCASTING -> return  StatisticsUtil.onEvent(StatisticsEventID.LIVE_MAINTAB_AUDIO_SHOW_DATA_EVENT)
            Constants.LIVEHALL_TYPE_MOBILE_LIVE -> return StatisticsUtil.onEvent(StatisticsEventID.TAB_MOBILE_LIVE)
            Constants.LIVEHALL_TYPE_GIRL_GROUP ->  {
                StatisticsUtil.submitClickEvent(StatisticsUtil.STATISTICS_HOME
                        , StatisticsEventID.MAIN_GIRL_GROUP
                        , StatisticsUtil.AD_ACTION_CLICK)//统计事件
                StatisticsUtil.onEvent(StatisticsEventID.MAIN_GIRL_GROUP)
                return
            }
        }
        if (TextUtils.equals(dataBean.name, "关注")) {
            StatisticsUtil.onEvent(StatisticsEventID.MAIN_FLLOW)
        } else if (TextUtils.equals(dataBean.name, "热门")) {
            StatisticsUtil.onEvent(StatisticsEventID.MAIN_HOT)
        }
    }
}
