package com.ninexiu.sixninexiu.fragment

import android.os.Build
import android.os.Bundle
import android.view.View
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.VoiceLiveStartAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.AdvertiseInfo
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.BaseSingleTypeResultInfo
import com.ninexiu.sixninexiu.bean.SingleTypeResultInfo
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.fragment.discovery.BaseViewFragment
import com.ninexiu.sixninexiu.lib.commonpulltorefresh.PtrDefaultHandler
import com.ninexiu.sixninexiu.lib.commonpulltorefresh.PtrFrameLayout
import com.ninexiu.sixninexiu.lib.commonpulltorefresh.recyclerview.RecyclerAdapterWithHF
import com.ninexiu.sixninexiu.view.ScrollGridLayoutManager
import com.thirdparty.utils.StatusBarUtil
import io.reactivex.Observable
import io.reactivex.disposables.Disposable
import io.reactivex.functions.BiFunction
import kotlinx.android.synthetic.main.fragment_live_start_layout.iv_back
import kotlinx.android.synthetic.main.fragment_live_start_layout.tv_bar
import org.jetbrains.anko.support.v4.withArguments
import java.util.ArrayList

/**
  *
  * @ProjectName:
  * @Package:
  * @ClassName:
  * @Description:    多人语音连麦主持人选择列表
  * @Author:         liuguangyu
  * @CreateDate:     2019/7/25 0025 14:42
  * @UpdateUser:     更新者：
  * @UpdateDate:     2019/7/25 0025 14:42
  * @UpdateRemark:   更新说明：
  * @Version:
 */

class MBVoiceLiveStartFragment : BaseViewFragment() {
    private val TAG = MBVoiceLiveStartFragment::class.java.simpleName
    private lateinit var adapterChild: VoiceLiveStartAdapter
    /**
     * //新人数据
     */
    private val highQualityData = ArrayList<AnchorInfo>()
    private var pageNum = 0
    private var isResume:Boolean = true
    private var isfresh = true
    private var zip:Disposable? = null

    companion object {
        val TYPE = "playLiveType"
        var instants = fun(): MBVoiceLiveStartFragment {
            val fragment = MBVoiceLiveStartFragment()
            val pa = Pair(TYPE, 1)
            return fragment.withArguments(pa)
        }
    }
    override fun onResume() {
        super.onResume()
//        //每次都更新主播列表
        if (mEmptyView.visibility == View.VISIBLE) {
            if (mEmptyView.visibility == View.VISIBLE) {
                mEmptyView.visibility = View.INVISIBLE
                mLoadingLayout.visibility = View.VISIBLE
                initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
            } else {
                initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
            }
        }
    }

    override fun inflater(): Int {
        return R.layout.fragment_live_start_layout
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        tv_bar?.height = NineShowApplication.getStatusBarHeight(activity)
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            tv_bar?.setVisibility(View.VISIBLE)
        }
        iv_back.setOnClickListener{
            activity?.finish()
        }
    }
    override fun initView() {
        NSLog.e(TAG,"----init----")
        mRecyclerView.setBackgroundColor(resources.getColor(R.color.transparent))
        adapterChild = VoiceLiveStartAdapter(highQualityData)
        adapterChild.run {

            openLoadAnimation()

            setPreLoadNumber(0)

//            setOnLoadMoreListener({ initTypePageData(Constants.LIVEHALL_TYPE_XINREN, pageNum) }, mRecyclerView)

            isUpFetchEnable = false
            onItemChildClickListener = BaseQuickAdapter.OnItemChildClickListener { adapter, view, position ->
                val item: AnchorInfo? = adapterChild.getItem(position)
                when (view.id) {
                    R.id.parent -> {
                        if (Utils.isNotClickable()) {
                            return@OnItemChildClickListener
                        }
                        if (!RoomUtils.viewLiveRoomNoLogin(activity)) {
                            return@OnItemChildClickListener
                        }
                        item?.fromSoucre ="其他"
                        Utils.openLiveRoom(context, item)

                        StatisticsUtil.onEvent(StatisticsEventID.MAIN_ATTENTION_ALL_ANCHOR_CK)
                    }
                }
            }
        }
        mRecyclerView.adapter = adapterChild
        mRecyclerView.adapter  = RecyclerAdapterWithHF(mRecyclerView.adapter)
        mRecyclerView.run {
            val gridLayoutManager = ScrollGridLayoutManager(activity
                    ?: NineShowApplication.applicationContext, 2)
            gridLayoutManager.spanSizeLookup = object : androidx.recyclerview.widget.GridLayoutManager.SpanSizeLookup() {
                override fun getSpanSize(position: Int): Int {
                    return when (adapterChild.getItemViewType(position)) {
                        AnchorInfo.ITEM_ATTENTION -> 2
                        AnchorInfo.ITEM_NO_BROADCASTING -> 1
                        else -> 2
                    }
                }
            }
            layoutManager = gridLayoutManager
//            setHasFixedSize(true)
            mRecyclerView.addOnScrollListener(object : androidx.recyclerview.widget.RecyclerView.OnScrollListener() {
                override fun onScrolled(recyclerView: androidx.recyclerview.widget.RecyclerView, dx: Int, dy: Int) {
                    super.onScrolled(recyclerView, dx, dy)
                    val itemCount = adapterChild.itemCount
                    val findLastVisibleItemPosition = (recyclerView.layoutManager as androidx.recyclerview.widget.GridLayoutManager).findLastVisibleItemPosition()
                    NSLog.e(TAG,"itemCount======$itemCount========findLastVisibleItemPosition==========$findLastVisibleItemPosition" )
//                    if (!isfresh) {
//                        return
//                    }
//                    if (itemCount - 1 == findLastVisibleItemPosition){
//                        isfresh = false
//                        initTypePageData(Constants.LIVEHALL_TYPE_XINREN, pageNum)
//                    }
                }

                override fun onScrollStateChanged(recyclerView: androidx.recyclerview.widget.RecyclerView, newState: Int) {
                    super.onScrollStateChanged(recyclerView, newState)

                }
            })

        }

        mEmptyView.setOnClickListener {
            mLoadingLayout.visibility = View.VISIBLE
            mEmptyView.visibility = View.INVISIBLE
            initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
        }
        ptrClassicFrameLayout.isLoadMoreEnable = true
        ptrClassicFrameLayout.disableWhenHorizontalMove(true)
        ptrClassicFrameLayout.setOnLoadMoreListener {
        }
        ptrClassicFrameLayout.setPtrHandler(object : PtrDefaultHandler() {
            override fun onRefreshBegin(frame: PtrFrameLayout) {
//                pageNum = 0
//                initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
            }
        })

    }

    override fun initData() {
        initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
    }
    val sing = AnchorInfo()
    private fun initTypePageData(tagType: String, pageCount: Int) {

        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient.setURLEncodingEnabled(false)
        val params = NSRequestParams()
        asyncHttpClient.get(ConstantsVoice.getInstance().getLiveAudioRoomGetHostRoomList(), params, object : NSJsonResponseHandler<SingleTypeResultInfo>() {

            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: SingleTypeResultInfo?) {
//                refreshComplete.invoke()
                NSLogger.e("------$TAG $statusCode   $rawJsonResponse     ${response?.data}")
                ptrClassicFrameLayout.refreshComplete()
                ptrClassicFrameLayout.loadMoreComplete(true)
                isfresh = true
                NSLogger.e(TAG, response?.data.toString())
                if (response != null && activity != null) {
                    if (response.data != null && response.data.size > 0) {
                        //-------------------------------
                        for (i in 0 until response.data.size) {
                            response.data[i].itemType = AnchorInfo.ITEM_NO_BROADCASTING
                        }
                        //-------------------------------
                        NSLogger.e("------$TAG ${response.data}")
                        if (pageCount == 0) {
                            pageNum = 1
                            highQualityData.clear()

                            ITEM_ATTENTION()

                            highQualityData.addAll(response.data)
                            mLoadingLayout.visibility = View.INVISIBLE
                            mEmptyView.visibility = View.INVISIBLE
                            adapterChild.notifyItemRangeChanged(0,adapterChild.itemCount)
                        } else {
                            activity?.runOnUiThread {
                                highQualityData.addAll(response.data)
                            }
                            pageNum++
                            adapterChild.notifyItemRangeChanged(adapterChild.itemCount - highQualityData.size,highQualityData.size)
                        }
                        adapterChild.loadMoreComplete()
                    } else {

                        if (pageCount == 0) {
                            highQualityData.remove(sing)
                            ITEM_ATTENTION()
                        }
                        isfresh = false
                        adapterChild.loadMoreEnd(false)

                        MyToast.MakeToast(activity, "您未被设置为主持人，请联系公会设置")
                        activity?.finish()
                    }
                }else {
                    if (pageCount == 0) {
                        highQualityData.remove(sing)
                        ITEM_ATTENTION()
                    }
                    adapterChild.loadMoreFail()
                    refreshComplete.invoke()
                    isfresh = true
                }

            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
//                MyToast.MakeToast(activity, errorMsg)
                mEmptyView.visibility = View.VISIBLE
                if (pageCount == 0) {
                    highQualityData.remove(sing)
                    ITEM_ATTENTION()
                }
                adapterChild.loadMoreFail()
                refreshComplete.invoke()
                isfresh = true
            }
        })

    }

    fun ITEM_ATTENTION() {
        NSLogger.e("------$TAG ITEM_ATTENTION")
        sing.itemType = AnchorInfo.ITEM_ATTENTION
        sing.headimage = NineShowApplication.mUserBase?.avatarUrl120
        highQualityData.add(sing)
    }

    private fun prepareObservable(qualityDataObservable: Observable<ArrayList<AdvertiseInfo>>?, highQualityDataObservable: Observable<ArrayList<AnchorInfo>>?): Observable<BaseSingleTypeResultInfo>? {
        return Observable.zip(qualityDataObservable, highQualityDataObservable,
                BiFunction<ArrayList<AdvertiseInfo>, ArrayList<AnchorInfo>, BaseSingleTypeResultInfo>
                { t1, t2 -> BaseSingleTypeResultInfo(t2, t1)
                })
    }
}
