package com.ninexiu.sixninexiu.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.TeenagersPassActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.thirdparty.utils.StatusBarUtil
import kotlinx.android.synthetic.main.fragment_parentsafe.parentsafe_btn_confrim
import kotlinx.android.synthetic.main.fragment_parentsafe.parentsafe_tv_title
import kotlinx.android.synthetic.main.title_tab_bar.title

/**
 * author wangyu
 * date: on 2019/10/11.
 * describe:家长模式开启和关闭Fragment
 */
class ParentsSwitchFragment : BaseFragment() {
    var rootView: View? = null
    override fun inflate(inflater: LayoutInflater?): View? {
        rootView = inflater?.inflate(R.layout.fragment_parentsafe, null)
        return rootView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initViews()
    }

    private fun initViews() {
        title?.text = "家长模式"
        StatusBarUtil.setLightMode(activity)
        StatusBarUtil.setColor(activity, resources.getColor(R.color.white))
        parentsafe_btn_confrim.setOnClickListener {
            TeenagersPassActivity.start(activity, false, 1)
        }
    }

    override fun onStart() {
        super.onStart()
        initState()
    }

    private fun initState() {
        if (NineShowApplication.mUserBase != null && NineShowApplication.mUserBase?.family_module == 1) {
            parentsafe_btn_confrim?.text = "关闭家长模式"
            parentsafe_tv_title?.text = "家长模式已开启"
        } else {
            parentsafe_btn_confrim.text = "打开家长模式"
            parentsafe_tv_title?.text = "家长模式未开启"
        }
    }
}