package com.ninexiu.sixninexiu.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.RealLoveDailyTaskAdapter
import com.ninexiu.sixninexiu.adapter.RealLovePrivilegeAdapter
import com.ninexiu.sixninexiu.bean.RealLoveDailyTaskInfo
import com.ninexiu.sixninexiu.bean.RealLovePrivilegeInfo
import com.ninexiu.sixninexiu.common.inter.OnItemClickListener
import com.ninexiu.sixninexiu.common.inter.UserLoveVisibilityChangeListener
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.LiveBaseInterface
import com.ninexiu.sixninexiu.common.util.MBContentFloatManager
import com.ninexiu.sixninexiu.view.MyItemDecoration
import kotlinx.android.synthetic.main.fragment_reallove_daily_task.*
import kotlinx.android.synthetic.main.fragment_reallove_fans_rank.*
import kotlinx.android.synthetic.main.item_reallove_daily_task.view.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/10/09
 *     desc   : 真爱每日任务
 *     version: 1.0
 * </pre>
 */
class RealLoveDailyTaskFragment :BaseFragment() {
    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_reallove_daily_task,null)
    }

    companion object{
        fun newInstance(rid:String,isAnchor:Boolean): RealLoveDailyTaskFragment{
            val args = Bundle()
            args.putString("rid",rid)
            args.putBoolean("isAnchor",isAnchor)
            val fragment = RealLoveDailyTaskFragment()
            fragment.arguments = args
            return fragment
        }
    }

    private var dailyTaslList=ArrayList<RealLoveDailyTaskInfo.DataBean.ListBean>()
    private lateinit var dailyTaskAdapter:RealLoveDailyTaskAdapter

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        val rid=arguments?.getString("rid")
        val isAnchor=arguments?.getBoolean("isAnchor",false)
        getDailyTaskList(rid!!)

        rv_reallove_daily_task.layoutManager=LinearLayoutManager(context)
        dailyTaskAdapter=RealLoveDailyTaskAdapter(context!!,isAnchor!!,dailyTaslList)
        rv_reallove_daily_task.adapter= dailyTaskAdapter
        dailyTaskAdapter.setOnItemClickListener(onTaskOnclickListener)

        rv_reallove_daily_task.addOnScrollListener(object : RecyclerView.OnScrollListener() {
            override fun onScrollStateChanged(recyclerView: RecyclerView, newState: Int) {
                super.onScrollStateChanged(recyclerView, newState)
                if (visibilityListener != null) {
                    visibilityListener!!.userLoveVisibilityChange(newState == RecyclerView.SCROLL_STATE_IDLE)
                }
            }
        })

    }
    private var onTaskOnclickListener:OnItemClickListener<RealLoveDailyTaskInfo.DataBean.ListBean>?=null

    fun setTaskOnClickListener(onTaskOnclickListener:OnItemClickListener<RealLoveDailyTaskInfo.DataBean.ListBean>){
        this.onTaskOnclickListener=onTaskOnclickListener
    }

    private fun getDailyTaskList(rid: String) {
        val params = NSRequestParams()
        params.put("rid", rid)
        params.put("version", 2)
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.GET_REAL_LOVE_DAILY_TASK, params, object : NSGsonObjectCallback<RealLoveDailyTaskInfo>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: RealLoveDailyTaskInfo?) {
                if (response?.code == 200 && response.data!=null && response.data.list!=null) {
                    dailyTaslList.clear()
                    dailyTaslList.addAll(response.data.list)
                    dailyTaskAdapter.notifyDataSetChanged()

                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }


    private lateinit var mLiveBaseInterface: LiveBaseInterface
    private lateinit var manager: MBContentFloatManager
    public fun setLiveBaseInterface(mLiveBaseInterface: LiveBaseInterface, manager: MBContentFloatManager) {
        this.mLiveBaseInterface = mLiveBaseInterface
        this.manager = manager
    }

    private var visibilityListener: UserLoveVisibilityChangeListener? = null

    fun setUserLoveVisibilityChangeListener(visibilityListener: UserLoveVisibilityChangeListener?) {
        this.visibilityListener = visibilityListener
    }
}