package com.ninexiu.sixninexiu.fragment

import android.animation.Animator
import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.app.AlertDialog
import android.content.Intent
import android.graphics.Typeface
import android.os.Bundle
import android.os.Handler
import android.os.Message
import android.text.Html
import android.text.TextUtils
import android.view.*
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import android.view.animation.LinearInterpolator
import android.widget.Button
import android.widget.ImageView
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.blankj.utilcode.util.ToastUtils
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.loopj.android.http.BaseJsonHttpResponseHandler
import com.ninexiu.sixninexiu.BuildConfig
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AdvertiseActivity
import com.ninexiu.sixninexiu.activity.TranslucentPayActivity
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.bean.RealLoveDailyTaskInfo
import com.ninexiu.sixninexiu.bean.RealLoveInfo
import com.ninexiu.sixninexiu.common.inter.OnItemClickListener
import com.ninexiu.sixninexiu.common.inter.UserLoveVisibilityChangeListener
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.pay.PayUtil
import com.ninexiu.sixninexiu.values.Global
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.CurrencyDialog
import com.ninexiu.sixninexiu.view.dialog.ParentsModleHintDialog
import com.ninexiu.sixninexiu.view.dialog.RemindDialog
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.fragment_real_love_fans.*
import kotlin.jvm.Throws

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/09/28
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class RealLoveFansFragment : BasePagerFragment(), View.OnClickListener, UserLoveVisibilityChangeListener {

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fragment_real_love_fans, container, false)
    }

    companion object {
        fun newInstance(rid: String, isAnchor: Boolean): RealLoveFansFragment {
            val args = Bundle()
            args.putString("rid", rid)
            args.putBoolean("isAnchor", isAnchor)
            val fragment = RealLoveFansFragment()
            fragment.arguments = args
            return fragment
        }
    }

    private var handler = Handler(object : Handler.Callback {
        override fun handleMessage(msg: Message): Boolean {
            if (msg.what == 1) {
                tv_reallove_weekrank?.isChecked=!tv_reallove_weekrank.isChecked
                sendEmptyMsg()
            }
            return true
        }
    })

    private lateinit var rid: String
    private var isAnchor = false
    private var lastState = true

    private lateinit var privilegeFragment: RealLovePrivilegeFragment
    private lateinit var dailyTaskFragment: RealLoveDailyTaskFragment
    private lateinit var fansRankFragment: RealLoveFansRankFragment
    private val ads = intArrayOf(R.drawable.true_love_ad_1, R.drawable.true_love_ad_2, R.drawable.true_love_ad_3)
    private var realloveInfo: RealLoveInfo.DataBean? = null
    private lateinit var inAnim: Animation
    private lateinit var outAnim: Animation

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)


        rid = arguments?.getString("rid")!!
        isAnchor = arguments?.getBoolean("isAnchor")!!

        tab_reallove.tipsScroll(0)
        tab_reallove.setItemWidthAndInterWidth(0, 10, 0)
        tab_reallove.setTextColorResource(R.color.c_ff638a, R.color.color_1a1a1a)
        tab_reallove.setTextSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_15))
        tab_reallove.setTypeface(Typeface.DEFAULT_BOLD, 0)
        tab_reallove.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_15))
        tab_reallove.setOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageSelected(arg0: Int) {
                tab_reallove.tipsScroll(arg0)
                if (arg0 == 0) {
                } else if (arg0 == 1) {
                }
            }

            override fun onPageScrolled(arg0: Int, arg1: Float, arg2: Int) {}
            override fun onPageScrollStateChanged(arg0: Int) {}
        })


        val titles = resources.getStringArray(R.array.reallove_tabs)
        val fragments = ArrayList<Fragment>()
        privilegeFragment = RealLovePrivilegeFragment.newInstance(rid)
        fragments.add(privilegeFragment)
        dailyTaskFragment = RealLoveDailyTaskFragment.newInstance(rid,isAnchor)
        fragments.add(dailyTaskFragment)
        fansRankFragment = RealLoveFansRankFragment.newInstance(rid)
        fragments.add(fansRankFragment)

        vp_reallove?.adapter = CommonPagerAdapter(childFragmentManager, titles, fragments)
        vp_reallove?.offscreenPageLimit = titles.size

        tab_reallove?.setViewPager(vp_reallove)


        getRealLoveInfo()


        tv_reallove_anchor_nickname?.setOnClickListener(this)
        tv_reallove_charm_count?.setOnClickListener(this)
        cl_reallove_container?.setOnClickListener(this)
        tv_reallove_renew?.setOnClickListener(this)
        cl_reallove_user?.setOnClickListener(this)

        inAnim = AnimationUtils.loadAnimation(context, R.anim.anim_view_bottom_in)
        outAnim = AnimationUtils.loadAnimation(context, R.anim.anim_view_bottom_out)
        fansRankFragment.setUserLoveVisibilityChangeListener(this)

        outAnim.setAnimationListener(object : Animation.AnimationListener {
            override fun onAnimationRepeat(animation: Animation?) {

            }

            override fun onAnimationEnd(animation: Animation?) {
                cl_reallove_user?.visibility = View.GONE
            }

            override fun onAnimationStart(animation: Animation?) {
            }
        })

        dailyTaskFragment.setUserLoveVisibilityChangeListener(this)
        dailyTaskFragment.setTaskOnClickListener(object : OnItemClickListener<RealLoveDailyTaskInfo.DataBean.ListBean> {
            override fun onItemClick(position: Int, taskInfo: RealLoveDailyTaskInfo.DataBean.ListBean) {
                if (realloveInfo != null && realloveInfo!!.isIsTrueLove && realloveInfo!!.userData.expire * 1000 > System.currentTimeMillis()) {
                    if (taskInfo.id == 6) {//打卡
//                        manager.goneFloat()
                    } else if (taskInfo.id == 7) {//陪伴
//                        manager.goneFloat()
                    } else if (taskInfo.id == 8) {//互动
                        mLiveBaseInterface.showKeyborad()
                        manager.goneFloat()
                    } else if (taskInfo.id == 9) {//赠送
                        mLiveBaseInterface.showGift()
                        manager.goneFloat()
                    } else {
                        manager.goneFloat()
                    }
                } else if (realloveInfo != null && realloveInfo!!.isIsTrueLove) {
                    showRealLoveOverTime()
                }
            }
        })
    }

    private fun getRealLoveInfo() {
        val params = NSRequestParams()
        params.put("rid", rid)
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.GET_REAL_LOVE_INFO, params, object : NSGsonObjectCallback<RealLoveInfo>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: RealLoveInfo?) {
                if (response?.code == 200 && response.data != null) {
                    realloveInfo = response.data
                    setupRealLoveInfo()
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

    private fun sendEmptyMsg(){
        handler.sendEmptyMessageDelayed(1, 10000)
    }

    private fun setupRealLoveInfo() {
        if (realloveInfo != null) {
            GlideUtils.loadCirclePic(context, realloveInfo!!.anchorHeadimage, iv_reallove_anchor_avatar)
            tv_reallove_anchor_nickname?.text = "${realloveInfo!!.anchorNickname}的真爱团"
            tv_reallove_name?.text = realloveInfo!!.badge
            tv_reallove_charm_count?.text = "本月魅力值${realloveInfo!!.points}"
            fansRankFragment.setFansNumber(realloveInfo!!.fans)
            privilegeFragment.setUserLoveLevel(realloveInfo!!.userData.loveLevel)
            if (isAnchor) {
                iv_reallove_name_modify?.visibility = View.VISIBLE
                iv_reallove_name_modify?.setOnClickListener(this)
            } else {
                if (realloveInfo!!.isIsTrueLove) {
                    cl_reallove_user?.visibility = View.VISIBLE
                    rl_reallove_join?.visibility = View.GONE

                    GlideUtils.loadCirclePic(context, realloveInfo!!.userData.headimage, iv_reallove_user_avatar)
                    tv_reallove_name_user?.text = realloveInfo!!.badge
                    tv_reallove_level?.text = realloveInfo?.userData?.loveLevel.toString()
                    iv_reallove_user_level?.setImageResource(Utils.getTrueLoveFansLeve(realloveInfo!!.userData.loveLevel, 1, false,realloveInfo!!.loveTagStyle))
//                val max = realloveInfo.userData.nextlevelpoints - realloveInfo.userData.levelpoints
//                val progress = realloveInfo.userData.points - realloveInfo.userData.levelpoints
                    progress_reallove_level?.max = realloveInfo!!.userData.nextlevelpoints
                    progress_reallove_level?.progress = realloveInfo!!.userData.points.toInt()
                    tv_reallove_level_progress?.text = "${realloveInfo!!.userData.points}/${realloveInfo!!.userData.nextlevelpoints}"

                    if (realloveInfo!!.userData.weekrank < 99) {
                        tv_reallove_weekrank?.text = "周贡献${realloveInfo!!.userData.weekrank}名"
                    } else {
                        tv_reallove_weekrank?.text = "周贡献99+名"
                    }

                    if (realloveInfo!!.userData.expire * 1000 > System.currentTimeMillis()) {
                        tv_reallove_indate?.text = "有效期至\n${Utils.getFormatDate(realloveInfo!!.userData.expire)}"
                    } else {
                        tv_reallove_indate?.text = "已过期"
                    }

                    sendEmptyMsg()
                    tv_reallove_weekrank?.setOnCheckedChangeListener { buttonView, isChecked ->
                        handler.removeMessages(1)
                        startRotationAnim(tv_reallove_weekrank, isChecked)
                        sendEmptyMsg()
                    }

                } else {
                    cl_reallove_user?.visibility = View.GONE
                    rl_reallove_join?.visibility = View.VISIBLE
                    tv_reallove_join?.setOnClickListener {
                        if (realloveInfo!!.recordStatus=="1"){
                            showRealLoveLimit()
                        }else if (realloveInfo!!.userData.opencount >= 10) {
                            showRealLoveOverload()
                        } else {
                            showPayDialog()
                        }
                    }

                }
            }
        }
    }

    private fun startRotationAnim(target: View, showStayTime: Boolean) {
        val animtorRotation1 = ObjectAnimator.ofFloat(target, "rotationY", 0f, 90f)
        val animtorRotation2 = ObjectAnimator.ofFloat(target, "rotationY", 270f, 360f)
        //旋转不停顿
        animtorRotation1.interpolator = LinearInterpolator()
        animtorRotation2.interpolator = LinearInterpolator()
        //设置动画重复次数
        animtorRotation1.repeatCount = 0
        animtorRotation2.repeatCount = 0
        //旋转时长
        animtorRotation1.duration = 300
        animtorRotation2.duration = 300
        //开始旋转
        val animSet = AnimatorSet()
        animSet.play(animtorRotation1).before(animtorRotation2)
        animSet.start()

        animtorRotation1.addListener(object : Animator.AnimatorListener {
            override fun onAnimationRepeat(animation: Animator?) {
            }

            override fun onAnimationEnd(animation: Animator?) {
                if (showStayTime) {
                    tv_reallove_weekrank?.text = "已陪伴${realloveInfo!!.userData.accompanydays}天"
                } else {
                    if (realloveInfo!!.userData.weekrank < 99) {
                        tv_reallove_weekrank?.text = "周贡献${realloveInfo!!.userData.weekrank}名"
                    } else {
                        tv_reallove_weekrank?.text = "周贡献99+名"
                    }
                }
            }

            override fun onAnimationCancel(animation: Animator?) {
            }

            override fun onAnimationStart(animation: Animator?) {
            }

        })
    }


    private lateinit var mLiveBaseInterface: LiveBaseInterface
    private lateinit var manager: MBContentFloatManager
    public fun setLiveBaseInterface(mLiveBaseInterface: LiveBaseInterface, manager: MBContentFloatManager) {
        this.mLiveBaseInterface = mLiveBaseInterface
        this.manager = manager
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.iv_reallove_name_modify -> { //修改真爱团名称
                showEditNickNameDialog()
            }
            R.id.tv_reallove_renew -> {//真爱团续费
//                showChargeDialog()
                showPayDialog()
            }
            R.id.tv_reallove_anchor_nickname -> {//真爱团说明
                if (null == activity) {
                    return
                }
                if (Utils.isNotClickable()) {
                    return
                }
                val intent = Intent(activity, AdvertiseActivity::class.java)
                intent.putExtra("url", Constants.H5_TRUE_LOVE_RULE + "?rid=" + rid + "&token=" + NineShowApplication.mUserBase!!.token)
                intent.putExtra("title", "真爱团")
                intent.putExtra("advertiseMentTitle", "真爱团")
                intent.putExtra("noShare", true)
                startActivity(intent)
            }
            R.id.tv_reallove_charm_count -> {//魅力排行榜
                if (null == activity) {
                    return
                }
                if (Utils.isNotClickable()) {
                    return
                }
                val rankIntent = Intent(activity, AdvertiseActivity::class.java)
                rankIntent.putExtra("url", Constants.H5_TRUE_LOVE_CHARM_LIST + "?rid=" + rid + "&token=" + NineShowApplication.mUserBase!!.token)
                rankIntent.putExtra("title", "魅力排行榜")
                rankIntent.putExtra("advertiseMentTitle", "魅力排行榜")
                rankIntent.putExtra("noShare", true)
                startActivity(rankIntent)
            }
        }
    }


    /**
     * 续费dialog
     */
    private fun showChargeDialog() {
        if (realloveInfo != null) {
            CurrencyDialog.create(activity)
                    .setTitleText("确认续费真爱团？")
                    .setOnClickCallback { type ->
                        if (type == BaseDialog.SELECT_SECOND) {
                            showPayDialog()
                        }
                    }
        }
    }

    private var payType = -1

    // 使用新的 PayDialog
    private fun showPayDialog() {
        if (activity == null) {
            return
        }
        val dialog = AlertDialog.Builder(activity, R.style.CustomBgTransparentDialog).create()
        val dialogView = LayoutInflater.from(activity).inflate(R.layout.active_fans_pay_layout, null)
        dialog.show()
        val window = dialog.window
        window!!.setGravity(Gravity.BOTTOM)
        window.decorView.setPadding(0, 0, 0, 0)
        val layoutParams = window.attributes
        layoutParams.width = WindowManager.LayoutParams.MATCH_PARENT
        //        layoutParams.height= WindowManager.LayoutParams.WRAP_CONTENT;
        window.attributes = layoutParams
        window.setWindowAnimations(R.style.dialogWindowAnim)
        window.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        dialog.setContentView(dialogView)
        val pay_ali_checked = dialogView.findViewById<ImageView>(R.id.pay_ali_checked)
        val pay_wechat_checked = dialogView.findViewById<ImageView>(R.id.pay_wechat_checked)
        val rl_alipay = dialogView.findViewById<RelativeLayout>(R.id.rl_alipay)
        val rl_wechat = dialogView.findViewById<RelativeLayout>(R.id.rl_wechat)
        val recharge = dialogView.findViewById<Button>(R.id.bt_recharge)
        rl_alipay.setOnClickListener {
            pay_ali_checked.visibility = View.VISIBLE
            pay_wechat_checked.visibility = View.GONE
            // payType = 160 : 修改为和支付中心一样
            payType = if (Global.ALIPAY_CHARGE_TYPE != 0) {
                Global.ALIPAY_CHARGE_TYPE
            } else {
                PayUtil.PAY_TYPE_JX_ALIPAY
            }

            if (BuildConfig.PAY_MODE == 1) { //百度视频
                payType = PayUtil.PAY_TYPE_BD_ALIPAY
            }
        }
        rl_wechat.setOnClickListener {
            pay_ali_checked.visibility = View.GONE
            pay_wechat_checked.visibility = View.VISIBLE
            // payType = 159 : 修改为和支付中心一样
            payType = if (Global.WEIXIN_CHARGE_TYPE != 0) {
                Global.WEIXIN_CHARGE_TYPE
            } else {
                PayUtil.PAY_TYPE_JX_WXPAY
            }

            if (BuildConfig.PAY_MODE == 1) { //百度视频
                payType = PayUtil.PAY_TYPE_BD_WXPAY
            }
        }
        recharge.setOnClickListener(View.OnClickListener {
            if (activity == null) {
                dialog.cancel()
                return@OnClickListener
            }

            //处于家长模式
            if (NineShowApplication.mUserBase != null && NineShowApplication.mUserBase!!.family_module == 1) {
                ParentsModleHintDialog(activity!!).show()
                return@OnClickListener
            }

            if(payType == -1) {
                payType = if (Global.ALIPAY_CHARGE_TYPE != 0) {
                    Global.ALIPAY_CHARGE_TYPE
                } else {
                    PayUtil.PAY_TYPE_JX_ALIPAY
                }

                if (BuildConfig.PAY_MODE === 1) { //百度视频
                    payType = PayUtil.PAY_TYPE_BD_ALIPAY
                }
            }

            val intent = Intent(activity, TranslucentPayActivity::class.java)
            val bundle = Bundle()
            bundle.putString("count", "1")
            bundle.putInt("type", payType)
            bundle.putInt("formType", PayUtil.TRUE_LOVE_POWDER)
            bundle.putInt("rid", rid.toInt())
            bundle.putString("subtype",PayUtil.CHARGE_SUB_TYPE_TURELOVE)      // 修改支付payType后，需要为1元支付添加subType区分类型
            intent.putExtras(bundle)
            activity!!.startActivity(intent)
            dialog.cancel()
        })
        dialog.setOnDismissListener { payType = -1 }
    }

    /**
     * 修改真爱团名称弹窗
     */
    fun showEditNickNameDialog() {
        val dialog = AlertDialog.Builder(activity, R.style.CustomBgTransparentDialog).create()
        val dialogView = LayoutInflater.from(activity).inflate(R.layout.mblive_activefans_edit_title, null)
        dialog.show()
        val window = dialog.window
        window!!.setGravity(Gravity.BOTTOM)
        window.decorView.setPadding(0, 0, 0, 0)
        val layoutParams = window.attributes
        layoutParams.width = WindowManager.LayoutParams.MATCH_PARENT
        //        layoutParams.height= WindowManager.LayoutParams.WRAP_CONTENT;
        window.attributes = layoutParams
        window.setWindowAnimations(R.style.dialogWindowAnim)
        window.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        dialog.setContentView(dialogView)
        val tv_tip_01 = dialogView.findViewById<TextView>(R.id.tv_tip_01)
        val tv_tip_02 = dialogView.findViewById<TextView>(R.id.tv_tip_02)
        val tv_tip_03 = dialogView.findViewById<TextView>(R.id.tv_tip_03)
        val tip1 = "1.设置真爱团昵称后,真爱粉可以为您在 <font color=\"#FD265C\">全站代言</font>"
        val tip2 = "2.团勋章昵称格式最多为<font color=\"#FD265C\">3个汉字</font>或数字、英文,也可以中英结合"
        val tip3 = "3.每月(30天)仅限<font color=\"#FD265C\">一次</font>修改机会,如果有不符合命名标准的昵称,官方有权修改."
        tv_tip_01.text = Html.fromHtml(tip1)
        tv_tip_02.text = Html.fromHtml(tip2)
        tv_tip_03.text = Html.fromHtml(tip3)
        val et_love_name = dialogView.findViewById<TextView>(R.id.et_love_name)
        val tv_save = dialogView.findViewById<TextView>(R.id.tv_save)
        tv_save.setOnClickListener { setGroupTitle(et_love_name.text.toString() + "", dialog) }
    }


    /**
     * 真爱团当日退出过，不能加入
     */
    fun showRealLoveLimit() {
        RemindDialog.create(context)
                .setTitleText("退出真爱团后，当天无法再次加入，1天后可再次加入此真爱团。")
                .setCurrencyText("确定")
                .setOnClickCallback { type ->
                    if (type == BaseDialog.SELECT_SECOND) {
                    }
                }
    }


    /**
     * 真爱团加入超过10个
     */
    fun showRealLoveOverload() {
        RemindDialog.create(context)
                .setTitleText("最多可以加入10个真爱团，您已达数量上限，无法加入，您可以选择退出部分真爱团后继续加入。")
                .setCurrencyText("确定")
                .setOnClickCallback { type ->
                    if (type == BaseDialog.SELECT_SECOND) {
                    }
                }
    }


    /**
     * 真爱团加入超过10个
     */
    fun showRealLoveOverTime() {
        RemindDialog.create(context)
                .setTitleText("过期状态下无法完成真爱任务，快去续费吧~")
                .setText("取消", "去续费")
                .setOnClickCallback { type ->
                    if (type == BaseDialog.SELECT_SECOND) {
                        showChargeDialog()
                    }
                }
    }


    /**
     * 修改真爱团名称接口
     */
    private fun setGroupTitle(name: String, dialog: AlertDialog) {
        if (TextUtils.isEmpty(name)) {
            return
        }
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        val requestParams = NSRequestParams()
        requestParams.put("title", name)
        asyncHttpClient[Constants.TRUE_LOVE_SET_GROUP_TITLE, requestParams, object : BaseJsonHttpResponseHandler<BaseResultInfo?>() {
            @Throws(Throwable::class)
            override fun parseResponse(rawJsonData: String, isFailure: Boolean): BaseResultInfo {
                val builder = GsonBuilder()
                val gson = builder.create()
                var baseResultInfo: BaseResultInfo? = null
                baseResultInfo = try {
                    gson.fromJson(rawJsonData, BaseResultInfo::class.java)
                } catch (e: JsonSyntaxException) {
                    e.printStackTrace()
                    null
                }
                return baseResultInfo!!
            }

            override fun onSuccess(statusCode: Int, headers: Array<out Header>?, rawJsonResponse: String?, response: BaseResultInfo?) {
                if (response != null) {
                    if (response.code == 200) {
                        if (tv_reallove_name != null) {
                            tv_reallove_name.setText(name)
                            dialog.dismiss()
                        }
                    }
                    ToastUtils.showShort(response.message)
                }
            }

            override fun onFailure(statusCode: Int, headers: Array<out Header>?, throwable: Throwable?, rawJsonData: String?, errorResponse: BaseResultInfo?) {
                ToastUtils.showShort("网络连接错误!")
            }
        }]
    }

    override fun onDestroy() {
        super.onDestroy()
        if (handler != null) {
            handler.removeMessages(1)
        }
    }

    override fun userLoveVisibilityChange(isShow: Boolean) {
        if (realloveInfo != null && realloveInfo!!.isIsTrueLove) {
            if (lastState == isShow) {
                return
            }
            lastState = isShow
            if (isShow) {
                cl_reallove_user?.visibility = View.VISIBLE
                cl_reallove_user?.startAnimation(inAnim)
            } else {
                cl_reallove_user?.startAnimation(outAnim)

            }
        }
    }

}