package com.ninexiu.sixninexiu.fragment

import android.graphics.Rect
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.RealLovePrivilegeAdapter
import com.ninexiu.sixninexiu.bean.RealLovePrivilegeInfo
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import kotlinx.android.synthetic.main.fragment_reallove_privilege.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2020/10/09
 *     desc   : 真爱特权页
 *     version: 1.0
 * </pre>
 */
class RealLovePrivilegeFragment : BaseFragment() {
    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_reallove_privilege, null)
    }

    companion object {
        fun newInstance(rid: String): RealLovePrivilegeFragment {
            val args = Bundle()
            args.putString("rid", rid)
            val fragment = RealLovePrivilegeFragment()
            fragment.arguments = args
            return fragment
        }
    }

    private var privilegeList = ArrayList<RealLovePrivilegeInfo.DataBean.ListBean>()
    private var privilegeAdapter: RealLovePrivilegeAdapter? = null

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        rv_reallove_privilege.layoutManager = GridLayoutManager(context, 4)
        privilegeAdapter = RealLovePrivilegeAdapter(context!!, privilegeList)
        rv_reallove_privilege.adapter = privilegeAdapter
        rv_reallove_privilege.addItemDecoration(object : RecyclerView.ItemDecoration() {
            override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
                outRect.left = ConvertUtils.dp2px(15f)
                outRect.right = ConvertUtils.dp2px(15f)
                outRect.bottom = ConvertUtils.dp2px(7.5f)
                outRect.top = ConvertUtils.dp2px(7.5f)
            }
        })
        arguments?.let {
            val rid = it.getString("rid","")
            getPrivilegeList(rid)
        }
    }

    private fun getPrivilegeList(rid: String) {
        val params = NSRequestParams()
        params.put("rid", rid)
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.GET_REAL_LOVE_PRIVILEGE, params, object : NSGsonObjectCallback<RealLovePrivilegeInfo>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: RealLovePrivilegeInfo?) {
                if (response?.code == 200 && response.data != null && response.data.list != null) {
                    privilegeList.clear()
                    privilegeList.addAll(response.data.list)
                    privilegeAdapter?.notifyDataSetChanged()
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

    fun setUserLoveLevel(loveLevel:Int){
        privilegeAdapter?.userLoveLevel=loveLevel
        privilegeAdapter?.notifyDataSetChanged()
    }
}