package com.ninexiu.sixninexiu.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.widget.ListView
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.RelatedLicenseAdapter
import com.ninexiu.sixninexiu.bean.RelatedLicenseBean
import com.ninexiu.sixninexiu.common.net.*
import com.ninexiu.sixninexiu.common.util.Constants
import okhttp3.Callback

/**
 * <pre>
 *     @author : gh
 *     time   : 2020/8/11 0011
 *     desc   : 相关许可证
 *     version: 1.0
 * </pre>
 */
class RelatedLicenseFragment : BaseFragment() {

    private var listView: ListView? = null

    override fun inflate(inflater: LayoutInflater): View? {
        var rootView = inflater?.inflate(R.layout.fragment_related_license, null)
        return rootView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        listView = view.findViewById(R.id.list_view)

        var mTitle = view.findViewById<TextView>(R.id.title)
        mTitle.text = "相关许可证"
        getLoadData()

    }

    /**
     * 获取数据
     */
    private fun getLoadData() {
        val asyncHttpClient = NsOkHttpClient.getNsOkHttpClient()
        val params = NSRequestParams()
        asyncHttpClient.doGet(Constants.GET_RELATED_LICENSE, params, object : NSGsonObjectCallback<RelatedLicenseBean>(), Callback {

            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: RelatedLicenseBean?) {
                if (response != null && response.code == 200) {
                    if(response.data!!.size > 0){
                        var adapter: RelatedLicenseAdapter = RelatedLicenseAdapter(response.data,activity)
                        listView?.adapter = adapter
                    }
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
            }
        })
    }


}