package com.ninexiu.sixninexiu.fragment

import android.annotation.SuppressLint
import android.graphics.Rect
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.UserReturnPayActivity
import com.ninexiu.sixninexiu.activity.UserReturnWelfareAndLiveActivity
import com.ninexiu.sixninexiu.adapter.UserReturenActiveTogetherAdapter
import com.ninexiu.sixninexiu.adapter.UserReturenPayTogetherAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.pay.ZhiFuActivity
import com.ninexiu.sixninexiu.view.ORIENTATION_TOP
import com.ninexiu.sixninexiu.view.UserReturnGsonHelper
import com.ninexiu.sixninexiu.view.dialog.OldUserBackGameDialog
import com.ninexiu.sixninexiu.view.fitterViewPosition
import com.ninexiu.sixninexiu.view.fitterViewSize
import kotlinx.android.synthetic.main.fragment_user_return_welfare.*
import java.net.HttpURLConnection

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/23
 *     desc   : 聚合页面 : 回归福利
 *     version: 1.0
 * </pre>
 */
class UserReturnWelfareFragment : BaseManagerFragment() {

    companion object {
        fun getInstance(bundle: Bundle? = null): UserReturnWelfareFragment {
            val fragment = UserReturnWelfareFragment()
            bundle?.let { fragment.arguments = bundle }
            return fragment
        }

        private const val TAG = "UserReturnWelfareFragment >> "
    }

    override fun setLayoutId(): Int = R.layout.fragment_user_return_welfare

    private val screenWidth: Int by lazy {
        resources.displayMetrics.widthPixels
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        llContainer.post {
            // 回归扭蛋机适配
            fitterViewSize(rlLottery, { (screenWidth * 0.883f).toInt() }, { (it * 0.736f).toInt() })
            fitterViewPosition(tvLottryTimeDown, ORIENTATION_TOP, { (screenWidth * 0.12).toInt() })

            // 回归充值适配
            fitterViewSize(llPay, { (screenWidth * 0.883f).toInt() }, { (it * 1.24f).toInt() })
            fitterViewPosition(tvPayTimeDown, ORIENTATION_TOP, { (screenWidth * 0.12).toInt() })
            // fitterViewSize(recyPay, { (screenWidth * 0.787f).toInt() }, { (it * 1.05f).toInt() })
            fitterViewPosition(recyPay, ORIENTATION_TOP, { (screenWidth * 0.211f).toInt() })

            // 回归专属特权适配
            fitterViewSize(llActive, { (screenWidth * 0.886f).toInt() }, { (it * 1.643f).toInt() })
            fitterViewPosition(tvActiveTimeDown, ORIENTATION_TOP, { (screenWidth * 0.12).toInt() })
            // fitterViewSize(recyActive, { (screenWidth * 0.82f).toInt() }, { (it * 1.432f).toInt() })
            fitterViewPosition(recyActive, ORIENTATION_TOP, { (screenWidth * 0.2083f).toInt() })

            // 抽奖扭蛋图片适配大小
            fitterViewSize(ivLottery, { (screenWidth * 0.387).toInt() }, { (it * 1f).toInt() })
        }

        tvLottery.text = getString(R.string.activity_user_return_lottery)

        rlLottery.setOnClickListener {
            if (NineShowApplication.mUserBase != null) {
                when (gameStatus) {
                    1 -> {
                        StatisticsUtil.onEvent(StatisticsEventID.UM_USER_RETURN_TOGETHER_LUCK)
                        val oldUserBackGameDialog = OldUserBackGameDialog.create(context)
                        oldUserBackGameDialog.setUserReturnAlreadyLottary { gameStatus = 2 }
                        oldUserBackGameDialog.show()
                    }
                    2 -> MyToast.MakeToast("今天已抽奖，明天再来哦~")
                    3 -> MyToast.MakeToast("该活动已结束")
                    else -> MyToast.MakeToast("您目前还不能抽奖")
                }
            } else {
                MyToast.MakeToast("您还未登录")
            }
        }

        initFitterView()
    }

    private val dataPay = mutableListOf<UserReturnPayItem>()
    private val dataActive = mutableListOf<GiftReturnItem>()
    private val adapterPay = UserReturenPayTogetherAdapter(dataPay)
    private val adapterActive = UserReturenActiveTogetherAdapter(dataActive)

    // 初始化recy
    private fun initFitterView() {
        val managerPay = GridLayoutManager(context, 2)
        recyPay.layoutManager = managerPay
        recyPay.addItemDecoration(decoration)
        recyPay.adapter = adapterPay


        val managerActive = GridLayoutManager(context, 2)
        recyActive.layoutManager = managerActive
        recyActive.addItemDecoration(decoration1)
        recyActive.adapter = adapterActive

        adapterPay.userClickItem = { status, id, position ->
            NSLog.d(TAG, "status : $status , id : $id , position : $position")
            when (status) {
                UserReturenPayTogetherAdapter.ITEM_CLICK_PAY -> {
                    if (NineShowApplication.mUserBase == null) {
                        MyToast.MakeToast("您还未登录")
                    } else {
                        // 充值
                        context?.let { ZhiFuActivity.startActivity(it) }

                        // startActivity(Intent(context, ZhifuActivity::class.java))
                    }
                }
                UserReturenPayTogetherAdapter.ITEM_CLICK_RECEIVE -> {
                    // 领取
                    receivePayResult(id, position)
                }
            }
        }
    }

    // 获取数据
    override fun onResume() {
        super.onResume()
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.ALL_TOGETHER_ACTIVE, null, object : NSGsonObjectCallback<UserReturnActiveResult>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: UserReturnActiveResult?) {
                when (statusCode) {
                    HttpURLConnection.HTTP_OK -> {
                        val data = response?.data
                        setData(data)
                    }
                    // 当前活动已经过期
                    UserReturnPayActivity.USER_RETURN_ACTIVITY_OVER -> {
                        // 写入数据
                        UserReturnGsonHelper.saveJsonDataOver()
                        MyToast.MakeToast("当前活动已过期")
                        finishDelay()
                    }
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {
                MyToast.MakeToast(errorMsg ?: "")
            }
        })
    }

    fun finishDelay() {
        llContainer.postDelayed({ (context as? UserReturnWelfareAndLiveActivity)?.finish() }, 1000)
    }

    private var gameStatus = -1

    // 设置倒计时
    @SuppressLint("SetTextI18n")
    private fun setData(data: UserReturnActiveData?) {
        tvPayTimeDown?.setTime("活动倒计时: ", data?.rechargeList?.over_time, "天","活动已结束")
        tvActiveTimeDown?.setTime("活动倒计时: ", data?.rechargeList?.over_time, "天","活动已结束")

        // 为回归用户充值福利设置数据
        data?.rechargeList?.list?.let {
            dataPay.clear()
            dataPay.addAll(it)
            adapterPay.notifyDataSetChanged()
        }

        // 为回归充值特权设置数据
        data?.freeBag?.let {
            dataActive.clear()
            dataActive.addAll(it)
            adapterActive.notifyDataSetChanged()
        }

        // 判断是否可以抽奖
        data?.gameList?.let { gameInfo ->
            gameStatus = gameInfo.game_status
            tvLottryTimeDown?.setTime("活动倒计时: ", gameInfo.time, "天","活动已结束")
            tvLottryTimeDown?.gameOver = {
                NSLog.d("userReturnTime >> ", "抽奖活动结束")
                gameStatus = 3  // 倒计时到最后一秒，更改抽奖状态
            }

            if (gameStatus == 0) {
                rlLottery?.visibility = View.GONE
            } else {
                rlLottery?.visibility = View.VISIBLE
            }
        }
    }


    // 领取奖励
    private fun receivePayResult(id: Int, pos: Int) {
        val params = NSRequestParams()
        params.put("id", id)
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.PAY_TASK_RECEIVE, params, object : NSGsonObjectNewCallback<UserReturnPayResult>() {
            override fun onFailure(statusCode: Int, errorMsg: String?) {
                NSLog.d(TAG, "status 0 : $statusCode")
                MyToast.MakeToast(errorMsg ?: "")
            }

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: UserReturnPayResult?) {
                MyToast.MakeToast(message ?: "")
                NSLog.d(TAG, "status : $statusCode")
                if (statusCode == 200) {
                    // 领取成功
                    if (dataPay[pos].id == id && pos < adapterPay.itemCount) {
                        dataPay[pos].status = 2
                        adapterPay.notifyItemChanged(pos)
                    }
                }
            }
        })
    }


    // 设置间隔
    val decoration = object : RecyclerView.ItemDecoration() {
        override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
            val index = parent.getChildLayoutPosition(view)
            if (index > 1) {
                outRect.top = (0.055 * screenWidth).toInt()
            } else {
                outRect.top = 0
            }

            if (index % 2 == 0) {
                outRect.right = (0.036 * screenWidth).toInt()
            } else {
                outRect.left = (0.036 * screenWidth).toInt()
            }
        }
    }

    val decoration1 = object : RecyclerView.ItemDecoration() {
        override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
            val index = parent.getChildLayoutPosition(view)
            if (index > 1) {
                outRect.top = (0.056 * screenWidth).toInt()
            }

            if (index % 2 == 0) {
                outRect.right = (0.033 * screenWidth).toInt()
            } else {
                outRect.left = (0.033 * screenWidth).toInt()
            }
        }
    }

    fun getGameStatus() = gameStatus
}