package com.ninexiu.sixninexiu.fragment.auction

import android.app.Activity
import android.widget.ImageView
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import kotlinx.android.synthetic.main.dialog_auction_failed.*

/**
 * 竞拍失败结果的弹窗
 *
 * @author zhangbing
 * @date 2021/04/13
 */
class AuctionFailedDialog(val context: Activity) : BaseDialog(context) {

    override fun getContentView(): Int {
        return R.layout.dialog_auction_failed
    }

    lateinit var goodsName: String
    lateinit var icon: String
    lateinit var desc: String
    lateinit var ivCover: ImageView
    lateinit var tvName: TextView
    lateinit var tvRemind: TextView

    fun showDialog(goodsName: String,icon: String ,desc: String){
        this.goodsName = goodsName
        this.icon = icon
        this.desc = desc

        if (!isShowing){
            show()
        }

        ivCover = findViewById(R.id.iv_result_goods_cover)
        tvName = findViewById(R.id.tv_result_goods_name)
        tvRemind = findViewById(R.id.tv_result_remind)

        GlideUtils.loadSimpleImgWithRoundCorner(context,icon,ivCover!!,0, Utils.dip2px(context,4f))
        tvName?.text = goodsName
        tvRemind?.text = desc

    }

    override fun initEvents() {
        super.initEvents()
        tv_result_makesure.setOnClickListener {
            if (isShowing){
                dismiss()
            }
        }
    }
}