package com.ninexiu.sixninexiu.fragment.auction

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.Gravity
import android.view.Window
import android.widget.ImageView
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.bean.AuctionOrderData
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.CountDownTextView
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import kotlinx.android.synthetic.main.dialog_auction_succeed.*

/**
 * 竞拍成功结果的弹窗
 *
 * @author zhangbing
 * @date 2021/04/13
 */
class AuctionSucceedDialog(val context: Activity) : BaseDialog(context) {

    override fun getContentView(): Int {
        return R.layout.dialog_auction_succeed
    }

    override fun getWindows(window: Window?) {
        super.getWindows(window)
        window?.setGravity(Gravity.CENTER)
    }

    lateinit var goodsName: String
    lateinit var icon: String
    lateinit var desc: String
    var time: Int = 0
    lateinit var orderId: String
    lateinit var ivCover: ImageView
    lateinit var tvName: TextView
    lateinit var tvRemind: TextView
    lateinit var tvCountdown: CountDownTextView

    fun showDialog(goodsName: String, icon: String, desc: String, time: Int, orderId: String){
        this.goodsName = goodsName
        this.icon = icon
        this.desc = desc
        this.time = time
        this.orderId = orderId

        if (!isShowing){
            show()
        }

        ivCover = findViewById(R.id.iv_result_goods_cover)
        tvName = findViewById(R.id.tv_result_goods_name)
        tvRemind = findViewById(R.id.tv_result_remind)
        tvCountdown = findViewById(R.id.tv_countdown)

        GlideUtils.loadSimpleImgWithRoundCorner(context,icon,ivCover!!,0, Utils.dip2px(context,4f))
        tvName?.text = goodsName
        tvRemind?.text = desc

        tvCountdown?.startCutDown("竞拍订单 支付倒计时：", "", time.toLong() * 60, "") { time: Long ->
            val lsTime = time.toInt()
            val hour = lsTime / 3600
            val minute = lsTime / 60 % 60
            val second = lsTime % 60
            return@startCutDown "${tvCountdown?.timeToString(hour)}时${tvCountdown?.timeToString(minute)}分${tvCountdown?.timeToString(second)}秒"
        }

    }

    override fun initEvents() {
        super.initEvents()
        tv_result_cancel.setOnClickListener {
            if (isShowing){
                dismiss()
            }
        }

        tv_result_makeorder.setOnClickListener {
            if (isShowing){
                dismiss()
            }
            val intent=Intent(context,SubPageActivity::class.java)
            intent.putExtra(SubPageActivity.CLASSFRAMENT, OrderDetailsFragment::class.java)
            val bundle = Bundle()
            var orderData = AuctionOrderData(orderId.toString())
            bundle.putParcelable("order", orderData)
            bundle.putInt("from_type", OrderDetailsFragment.FROM_TYPE_MAKE_ORDER_AUCTION)
            intent.putExtra("bundle", bundle)
            context.startActivity(intent)
        }

    }

}