package com.ninexiu.sixninexiu.fragment.auction

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.blankj.utilcode.util.ToastUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.adapter.auction.AuctionOrderAdapter
import com.ninexiu.sixninexiu.bean.AuctionOrderList
import com.ninexiu.sixninexiu.bean.BaseBean
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.fragment.BaseFragment
import kotlinx.android.synthetic.main.fragment_order_list.*
import kotlinx.android.synthetic.main.layout_for_show_state.*
import kotlinx.android.synthetic.main.title_tab_bar.*

class OrderListFragment : BaseFragment() {
    override fun inflate(inflater: LayoutInflater?): View {
        return inflater?.inflate(R.layout.fragment_order_list, null)!!
    }


    private lateinit var orderAdapter: AuctionOrderAdapter
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        title.text = "我的订单"
        rv_auction_order_list?.layoutManager = LinearLayoutManager(context, LinearLayoutManager.VERTICAL, false)
        orderAdapter = AuctionOrderAdapter(context!!, ArrayList())
        rv_auction_order_list?.adapter = orderAdapter
        getOrderListData(true)


        srl_auction_list?.setOnRefreshListener {
            getOrderListData(true)
        }
        srl_auction_list?.setOnLoadMoreListener {
            getOrderListData(false)
        }

        orderAdapter.onOrderClick={position, orderData ->
            val intent=Intent(context,SubPageActivity::class.java)
            intent.putExtra(SubPageActivity.CLASSFRAMENT, OrderDetailsFragment::class.java)
            val bundle = Bundle()
            bundle.putParcelable("order", orderData)
            bundle.putInt("from_type", OrderDetailsFragment.FROM_TYPE_ORDER_LIST)
            intent.putExtra("bundle", bundle)
            startActivity(intent)
        }

        sv_state_view?.setOnRefreshListener {
            getOrderListData(true)
        }
    }

    /**
     * 获取订单列表
     */
    private var page = 0
    private fun getOrderListData(isRefresh: Boolean) {
        if (isRefresh) {
            page = 0
        } else {
            page++
        }
        val params = NSRequestParams()
        params.put("page", page)
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.GET_AUCTION_ORDER_LIST, params, object : NSGsonObjectNewCallback<AuctionOrderList?>() {

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: AuctionOrderList?) {
                srl_auction_list?.finishRefresh()
                srl_auction_list?.finishLoadMore()
                if (response != null && response.code == 200) {
                    if (isRefresh) {
                        orderAdapter.orderList.clear()
                    }
                    if (isRefresh && response.data.isEmpty()){
                        sv_state_view?.showEmpty("您还没有相关订单")
                    }else{
                        sv_state_view?.showSuccess()
                    }
                    orderAdapter.orderList.addAll(response.data)
                    orderAdapter.notifyDataSetChanged()
                } else {

                    if (isRefresh) {
                        orderAdapter.orderList.clear()
                        orderAdapter.notifyDataSetChanged()
                        sv_state_view?.showEmpty("您还没有相关订单")
                    } else {
                        sv_state_view?.showSuccess()
                    }

                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
                srl_auction_list?.finishRefresh()
                srl_auction_list?.finishLoadMore()
                ToastUtils.showShort(errorMsg)
            }

        })
    }
}