package com.ninexiu.sixninexiu.fragment.discovery

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import android.view.View
import android.widget.FrameLayout
import com.chad.library.adapter.base.BaseQuickAdapter
import com.ijkplayer.widget.media.IjkVideoViewNew
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.PersonalInforActivity
import com.ninexiu.sixninexiu.adapter.SubscribeLiveAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.SubscribeAnchorInfo
import com.ninexiu.sixninexiu.bean.SubscribeResultInfo
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.LoadStateUtil
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.NetworkUtil
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.discovery.contract.SubscribeLiveContract
import com.ninexiu.sixninexiu.fragment.discovery.presenter.SubscribePresenter
import com.ninexiu.sixninexiu.lib.commonpulltorefresh.PtrDefaultHandler
import com.ninexiu.sixninexiu.lib.commonpulltorefresh.PtrFrameLayout
import com.ninexiu.sixninexiu.mvp.MVPBaseFragment
import com.ninexiu.sixninexiu.view.StateView
import com.ninexiu.sixninexiu.view.WrapContentGridLayoutManager
import org.jetbrains.anko.support.v4.withArguments
import java.util.ArrayList

/**
 * @Description:     关注二级页面 未开播主播
 * @Author:          liuguangyu
 * @date  :     2019/5/17 11:49
 * @Version:
 */
class SubscribeLiveFragment : MVPBaseFragment<SubscribeLiveContract.View, SubscribePresenter>() ,SubscribeLiveContract.View, StateView.OnRefreshViewListener {

    private val TAG = SubscribeLiveFragment::class.java.simpleName
    private lateinit var adapterChild: SubscribeLiveAdapter
    private lateinit var ijkvideoviewnew: IjkVideoViewNew
    private var mSvStateView: StateView? = null

    /**
     * //新人数据
     */
    private val highQualityData = ArrayList<SubscribeAnchorInfo>()
    private var pageNum = 0
    private var isResume:Boolean = true
    private var isfresh = true

    companion object {
        val TYPE = "type"
        var instants = fun(): SubscribeLiveFragment {
            val fragment = SubscribeLiveFragment()
            val pa = Pair(TYPE, 1)
            return fragment.withArguments(pa)
        }
    }

    override fun inflater(): Int {
        return R.layout.fragment_subscribe_live_layout
    }
    override fun initView() {
        NSLog.e(TAG,"----init----")
        mSvStateView = mRootView?.findViewById(R.id.sv_state_view)!!
        mSvStateView!!.setOnRefreshListener(this)
        adapterChild = SubscribeLiveAdapter(highQualityData)
        adapterChild.run {
            setPreLoadNumber(1)
            isUpFetchEnable = false
            onItemChildClickListener = BaseQuickAdapter.OnItemChildClickListener { adapter, view, position ->
                val info = adapterChild.getItem(position)
                when (view.id) {
                    R.id.parent -> {
                        //未开播跳转到主播个人主页   开播了跳转到直播间
//                        if (Integer.parseInt(info!!.status) != 1) {
//                            PersonalInforActivity.start(context, true, info?.followuid)
////                            val intentAnchor = Intent(context, TranslucentSubPageActivity::class.java)
////                            intentAnchor.putExtra(TranslucentSubPageActivity.CLASSFRAMENT, PersonalHomePageFragment::class.java)
////                            val bundle = Bundle()
////                            bundle.putString("uid", info?.followuid)
////                            intentAnchor.putExtras(bundle)
////                            startActivity(intentAnchor)
//                        } else {
//                            Utils.openLiveRoom(context, info?.roomType ?: 0, info?.rid, 1, info?.nickname)
//                        }
                        Utils.openLiveRoom(context, info?.roomType ?: 0, info?.rid, 1, info?.nickname)
                    }
                    else -> {
                    }
                }
            }
        }

        mRecyclerView.run {
            adapter = adapterChild
//            itemAnimator = null
//            animation = null
//            mRecyclerView.itemAnimator?.changeDuration = 0
            val gridLayoutManager = WrapContentGridLayoutManager(activity
                    ?: NineShowApplication.applicationContext, 2)
            gridLayoutManager.spanSizeLookup = object : androidx.recyclerview.widget.GridLayoutManager.SpanSizeLookup() {
                override fun getSpanSize(position: Int): Int {
                    return when (adapterChild.getItemViewType(position)) {
                        AnchorInfo.ITEM_ATTENTION -> 2
                        AnchorInfo.ITEM_NO_BROADCASTING -> 1
                        Utils.ITEM_TYPE_2 -> 2
                        else -> 1
                    }
                }
            }
            layoutManager = gridLayoutManager
            setHasFixedSize(false)
            mRecyclerView.addOnScrollListener(object : androidx.recyclerview.widget.RecyclerView.OnScrollListener() {
                override fun onScrolled(recyclerView: androidx.recyclerview.widget.RecyclerView, dx: Int, dy: Int) {
                    super.onScrolled(recyclerView, dx, dy)
                    val itemCount = adapterChild.itemCount
                    val findLastVisibleItemPosition = (recyclerView.layoutManager as androidx.recyclerview.widget.GridLayoutManager).findLastVisibleItemPosition()
//                    NSLog.e(TAG,"itemCount======$itemCount========findLastVisibleItemPosition==========$findLastVisibleItemPosition" )
//                    if (!isfresh) {
//                        return
//                    }
//                    if (itemCount - 1 == findLastVisibleItemPosition){
//                        isfresh = false
//                        mPresenter?.initTypePageData(Constants.LIVEHALL_TYPE_XINREN, pageNum)
//                    }
                }

            })

        }

        ptrClassicFrameLayout.setLoadMoreEnable(true)
        ptrClassicFrameLayout.disableWhenHorizontalMove(true)
        ptrClassicFrameLayout.setOnLoadMoreListener {
            mPresenter?.initTypePageData(Constants.LIVEHALL_TYPE_XINREN, pageNum)
        }
        ptrClassicFrameLayout.setPtrHandler(object : PtrDefaultHandler() {
            override fun onRefreshBegin(frame: PtrFrameLayout) {
                pageNum = 0
                mPresenter?.initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
            }
        })
        if (null != context && !(context as Activity).isFinishing) {
            ijkvideoviewnew = IjkVideoViewNew(context)
        }
        val mBack = mRootView?.findViewById<FrameLayout>(R.id.fl_back)
        mBack?.setOnClickListener {
            activity?.finish()
        }
    }

    override fun initData() {
        LoadStateUtil.showLoading(mSvStateView, highQualityData)
        mPresenter?.initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
    }

    override fun onRefreshView() {
        LoadStateUtil.showLoading(mSvStateView, highQualityData)
        mPresenter?.initTypePageData(Constants.LIVEHALL_TYPE_XINREN, 0)
    }

    override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: Any?, pageCount: Int?) {
        refreshComplete.invoke()
        response as SubscribeResultInfo
        isfresh = true
        NSLog.d(TAG, response?.data.toString())
        if (response != null && activity != null) {
            if (response.data != null && response.data.size > 0) {
                LoadStateUtil.loadState(mSvStateView, highQualityData, true)
                //-------------------------------
                for (i in 0 until response.data.size) {
                    response.data[i].itemType = AnchorInfo.ITEM_NO_BROADCASTING
                }
//                for (i in 0 until response.data.size) {
//                    response.data[i].itemType = AnchorInfo.ITEM_NO_BROADCASTING
//                    if (TextUtils.equals(response.data[i].status, "1")) {
//                        response.data.remove(response.data[i])
//                    }
//
//                }
                //-------------------------------
                NSLog.d(TAG,"${response.data}")
                if (pageCount == 0) {
                    highQualityData.clear()
                    highQualityData.addAll(response.data)
//                    endItemType()
                    adapterChild.notifyItemChanged(0,adapterChild.itemCount)
                } else {
                    highQualityData.addAll(response.data)
//                    endItemType()
                    adapterChild.notifyItemChanged(adapterChild.itemCount - highQualityData.size,highQualityData.size)
                }
                pageNum++

            } else {
                LoadStateUtil.loadState(mSvStateView, highQualityData, false)
                isfresh = false
            }
        }
    }

    override fun onFailure(statusCode: Int, errorMsg: String) {
        MyToast.MakeToast(activity, errorMsg)
        refreshComplete.invoke()
        isfresh = true
        if (NetworkUtil.isNetworkState()) {
            LoadStateUtil.loadState(mSvStateView, highQualityData, false)
        } else {
            MyToast.MakeToast(
                NineShowApplication.applicationContext.resources.getString(R.string.request_no_network))
            LoadStateUtil.showError(mSvStateView, highQualityData)
        }
    }
    /**
     * 底部条目
     */
    private fun endItemType() {
        //end item
        val subscribeAnchorInfo = SubscribeAnchorInfo()
        subscribeAnchorInfo.itemType = Utils.ITEM_TYPE_2
        highQualityData.add(subscribeAnchorInfo)
    }

}
