package com.ninexiu.sixninexiu.fragment.discovery.presenter

import com.ninexiu.sixninexiu.bean.AdvertiseResultInfo
import com.ninexiu.sixninexiu.bean.SingleTypeResultInfo
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.fragment.discovery.contract.LiveTypePagerFragmentContract
import com.ninexiu.sixninexiu.mvp.BasePresenterImpl

class LiveTypePagerFragmentPresenter : BasePresenterImpl<LiveTypePagerFragmentContract.View>(), LiveTypePagerFragmentContract.Presenter {
    private val TAG = LiveTypePagerFragmentPresenter::class.java.simpleName
    override fun initTypePageData(pullToRefresh: Boolean, tagType: String, pageCount: Int) {
        NSLog.e(TAG, "initTypePageData"  + " tagType----"+ tagType)
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient?.setURLEncodingEnabled(false)
        val params = NSRequestParams()
        params.put("tag", tagType)
        params.put("page", pageCount)
        asyncHttpClient.get(Constants.GET_MAIN_CHANNEL_TYPE_LIST, params, object : NSJsonResponseHandler<SingleTypeResultInfo>() {


            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: SingleTypeResultInfo?) {
                NSLog.i(TAG, " mView.onSuccess---- $statusCode $rawJsonResponse $response $pageCount" )
                mView?.onSuccess(statusCode, rawJsonResponse, response, pageCount)
            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
                mView?.onFailure(statusCode, errorMsg, pullToRefresh)
            }
        })
    }

    /**
     * 获取轮播图数据
     */
//    @SuppressLint("CheckResult")
    override fun getAdData(pullToRefresh: Boolean, channelType: String, pageCount: Int) {
        // 请求链接不进行转码
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        val params = NSRequestParams()
        params.add("position", channelType)
        asyncHttpClient.get(Constants.GET_AD_LIST
                , params
                , object : NSJsonResponseHandler<AdvertiseResultInfo>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: AdvertiseResultInfo?) {
                NSLog.e(TAG, " mView.onAdDataSuccess---- $statusCode $rawJsonResponse $response $pageCount" )
                mView?.onAdDataSuccess(statusCode, rawJsonResponse, response, pageCount,channelType,pullToRefresh)
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {
                mView?.onAdDataFailure(statusCode, errorMsg, pullToRefresh,channelType)
            }
        })
    }

    /**
     * 转换type类型
     */
    private fun prepareBannerType(channelType: String):String  {
        /**
         * 5:天籁  3:歌唱 2:舞蹈  1:畅聊 4:特色 游戏 7:女团 15:乐器  16:pk 17:新人 18：电台 19:手机
         */
        when (channelType) {
            Constants.LIVEHALL_TYPE_CHANGLIAO -> return  Constants.LIVEHALL_BANNER_TYPE_CHANGLIAO
            Constants.LIVEHALL_TYPE_WUDAO -> return Constants.LIVEHALL_BANNER_TYPE_WUDAO
            Constants.LIVEHALL_TYPE_SING -> return Constants.LIVEHALL_BANNER_TYPE_SING
            Constants.LIVEHALL_TYPE_TESE -> return Constants.LIVEHALL_BANNER_TYPE_TESE
//            Constants.LIVEHALL_TYPE_TIANLAI -> return Constants.LIVEHALL_BANNER_TYPE_TIANLAI
            Constants.LIVEHALL_TYPE_YUEQI -> return Constants.LIVEHALL_BANNER_TYPE_YUEQI
            Constants.LIVEHALL_TYPE_PK -> return Constants.LIVEHALL_BANNER_TYPE_PK
            Constants.LIVEHALL_TYPE_XINREN -> return Constants.LIVEHALL_BANNER_TYPE_XINREN
            Constants.LIVEHALL_TYPE_BROADCASTING -> return Constants.LIVEHALL_BANNER_TYPE_BROADCASTING
            Constants.LIVEHALL_TYPE_MOBILE_LIVE -> return Constants.LIVEHALL_BANNER_TYPE_MOBILE_LIVE
            Constants.LIVEHALL_TYPE_GIRL_GROUP -> return Constants.LIVEHALL_BANNER_TYPE_TIANLAI
            else -> return Constants.LIVEHALL_BANNER_TYPE_TIANLAI
        }
    }

}