package com.ninexiu.sixninexiu.fragment.discovery.presenter

import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.SubscribeResultInfo
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.fragment.discovery.contract.SubscribeLiveContract
import com.ninexiu.sixninexiu.mvp.BasePresenterImpl

class SubscribePresenter : BasePresenterImpl<SubscribeLiveContract.View>(), SubscribeLiveContract.Presenter {
    override fun initTypePageData(tagType: String, pageCount: Int) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        // 请求链接不进行转码
        asyncHttpClient.setURLEncodingEnabled(false)
        val params = NSRequestParams()
        params.put("token", NineShowApplication.mUserBase?.token)
        params.put("page", pageCount)
        params.put("type", 2)
        params.put("pagesize", 10)
        asyncHttpClient.get(Constants.GET_USER_FOLLOW_LIST_NEW, params, object : NSJsonResponseHandler<SubscribeResultInfo>() {

            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: SubscribeResultInfo?) {
                mView?.onSuccess(statusCode,rawJsonResponse,response,pageCount)
            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
                mView?.onFailure(statusCode,errorMsg)
            }
        })
    }
}
