package com.ninexiu.sixninexiu.fragment.liveroom

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.RoomInfo
import com.ninexiu.sixninexiu.common.util.LiveBaseInterface
import com.ninexiu.sixninexiu.common.util.MBLiveVoiceGrabHatManeger
import com.ninexiu.sixninexiu.common.util.S11Helper
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.BasePagerFragment
import kotlinx.android.synthetic.main.fragment_liveroom_userparent.*

/**
 * 直播间用户列表父容器
 */
class LiveRoomUserParentFragment : BasePagerFragment() {

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fragment_liveroom_userparent, container, false)
    }

    companion object {
        const val CURRENT_CONTRIBUTION_THIS_TIME = 1
        const val ROOM_INFO = "room_info"
        const val CURRENT_PAGE = "current_page"

        fun newInstance(): LiveRoomUserParentFragment {
            return LiveRoomUserParentFragment()
        }
    }

    private var fragment: LiveBaseInterface? = null
    fun setLiveBaseInterface(fragment: LiveBaseInterface) {
        this.fragment = fragment
    }

    // 获取 roomInfo
    private val roomInfo: RoomInfo? by lazy {
        arguments?.getSerializable(ROOM_INFO) as? RoomInfo
    }

    // 获取指定的界面
    /*private val currentPage : Int by lazy {
        arguments?.getInt(CURRENT_PAGE) ?: -1
    }*/

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initView()
    }

    private fun initView() {
        //重置守护View高度 保证在视频下方
        val layoutParams: ViewGroup.LayoutParams = userparent_root_layout.layoutParams
//        if (S11Helper.h5Heigght == 0) {
//        layoutParams.height = NineShowApplication.getScreenHeight(activity) / 2 - Utils.dip2px(activity, 30f)
//        } else {
//            layoutParams.height = S11Helper.h5Heigght
//        }
        userparent_root_layout.layoutParams = layoutParams

        tab_liveroom_user.tipsScroll(0)
        tab_liveroom_user.setTextColorResource(R.color.color_fd638a, R.color.color_666666)
        tab_liveroom_user.textSize = resources.getDimensionPixelSize(R.dimen.ns_textsize_17)
        tab_liveroom_user.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_17))
        tab_liveroom_user.setOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageSelected(arg0: Int) {
                tab_liveroom_user.tipsScroll(arg0)
            }

            override fun onPageScrolled(arg0: Int, arg1: Float, arg2: Int) {}
            override fun onPageScrollStateChanged(arg0: Int) {}
        })


        val titles = if(MBLiveVoiceGrabHatManeger.mStatus != 0){
            arrayOf("心动土豪榜","本场贡献值","月贡献榜","在线用户")
        } else {
            arrayOf("本场贡献值","月贡献榜","在线用户")
        }


        vp_liveroom_user.offscreenPageLimit = titles.size

        var fragments = getFragments()
        vp_liveroom_user.adapter = CommonPagerAdapter(childFragmentManager, titles, fragments)

        tab_liveroom_user.setViewPager(vp_liveroom_user)

        /*if(currentPage != -1 ) {
           vp_liveroom_user.post {
               if(vp_liveroom_user != null && currentPage < vp_liveroom_user.childCount) {
                   vp_liveroom_user.currentItem = currentPage
               }
           }
        }*/
    }

    private fun getFragments(): ArrayList<Fragment> {
        val fragments = ArrayList<Fragment>()
        if(MBLiveVoiceGrabHatManeger.mStatus != 0){
            fragments.add(LiveRoomUserFragment.newInstance(LiveRoomUserFragment.TYPE_VOICE_HEART, roomInfo).apply { setLiveBaseInterface(fragment) })
        }
        // 顺序进行了调整
        fragments.add(LiveRoomUserFragment.newInstance(LiveRoomUserFragment.TYPE_CONTRIBUTION_THIS_TIME, roomInfo).apply { setLiveBaseInterface(fragment) })
        fragments.add(LiveRoomUserFragment.newInstance(LiveRoomUserFragment.TYPE_CONTRIBUTION_RANK, roomInfo).apply { setLiveBaseInterface(fragment) })
        fragments.add(LiveRoomUserFragment.newInstance(LiveRoomUserFragment.TYPE_ONLINE_USER, roomInfo).apply { setLiveBaseInterface(fragment) })
        return fragments
    }
}