package com.ninexiu.sixninexiu.fragment.store

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.store.StoreBeautyNumberAdapter
import com.ninexiu.sixninexiu.bean.Account
import com.ninexiu.sixninexiu.fragment.BaseFragment
import kotlinx.android.synthetic.main.fragment_beauty_number.*
import kotlinx.android.synthetic.main.layout_for_show_state.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/19
 *     desc   : 商城 - 靓号 -靓号列表
 *     version: 1.0
 * </pre>
 */
class BeautyNumberFragment : BaseFragment() {

    companion object {
        private const val KEY_BEAUTY_NUMBER_LIST = "beauty_number_list"
        private const val KEY_TAG = "tag"
        fun newInstance(beautyNumberList: ArrayList<Account>?, tag: String): BeautyNumberFragment {
            val args = Bundle()
            if (beautyNumberList != null) {
                args.putParcelableArrayList(KEY_BEAUTY_NUMBER_LIST, beautyNumberList)
            }
            args.putString(KEY_TAG, tag)
            val fragment = BeautyNumberFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_beauty_number, null)
    }

    var onBeautyNumberChange: (() -> Unit)? = null

    private var beautyNumberList: ArrayList<Account>? = null
    private lateinit var beautyNumberAdapter: StoreBeautyNumberAdapter
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        beautyNumberList = arguments?.getParcelableArrayList(KEY_BEAUTY_NUMBER_LIST)
        setData()
    }

    override fun getFragmentTag(): String {
        arguments?.let {
            return it.getString(KEY_TAG, "")
        }
        return ""
    }


    fun refreshData(numberList: ArrayList<Account>?) {
        beautyNumberList?.clear()
        numberList?.let {
            beautyNumberList?.addAll(numberList)
        }
        setData()
    }

    fun setData() {
        if (!beautyNumberList.isNullOrEmpty()) {
            if (this::beautyNumberAdapter.isInitialized) {
                beautyNumberAdapter.notifyDataSetChanged()
            } else {
                context?.let {
                    sv_state_view?.showSuccess()
                    rv_beauty_number?.layoutManager = GridLayoutManager(it, 3, GridLayoutManager.VERTICAL, false)
                    beautyNumberAdapter = StoreBeautyNumberAdapter(it, false, beautyNumberList!!)
                    rv_beauty_number?.adapter = beautyNumberAdapter

                    beautyNumberAdapter.onNumberClick = { number, position ->
                        val buyDialog = StoreBuyDialog.create(it, number)
                        buyDialog.show()
                        buyDialog.buySucceed = {
                            onBeautyNumberChange?.invoke()
                        }
                        buyDialog.buyFailed = {
                            onBeautyNumberChange?.invoke()
                        }
                    }
                }
            }
        } else {
            sv_state_view?.showEmpty("暂无相关靓号")
        }
    }
}