package com.ninexiu.sixninexiu.fragment.store

import android.animation.ObjectAnimator
import android.annotation.SuppressLint
import android.app.Dialog
import android.content.Context
import android.content.DialogInterface
import android.graphics.drawable.Drawable
import android.text.TextUtils
import android.view.View
import androidx.core.content.ContextCompat
import androidx.lifecycle.LifecycleOwner
import androidx.recyclerview.widget.LinearLayoutManager
import com.bumptech.glide.Glide
import com.bumptech.glide.request.RequestOptions
import com.bumptech.glide.request.target.CustomTarget
import com.bumptech.glide.request.transition.Transition
import com.ninexiu.sixninexiu.CommonApplication
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AccountIdentityDialog
import com.ninexiu.sixninexiu.activity.AdvertiseActivity
import com.ninexiu.sixninexiu.activity.store.StoreGiveActivity
import com.ninexiu.sixninexiu.adapter.store.StorePriceAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.pay.ZhiFuFastCDialog.Companion.showBugDialog
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.OnZhiFuFastDialogDismissListener
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import jp.wasabeef.glide.transformations.RoundedCornersTransformation
import kotlinx.android.synthetic.main.pop_dressup.*
import kotlinx.android.synthetic.main.pop_dressup.cl_buy_container
import kotlinx.android.synthetic.main.pop_dressup.rv_price
import kotlinx.android.synthetic.main.pop_dressup.tv_blance_9bi
import kotlinx.android.synthetic.main.pop_dressup.tv_blance_9dian
import kotlinx.android.synthetic.main.pop_dressup.view_placeholder
import org.json.JSONObject

/**
 * 新版装扮购买弹窗
 *
 * @author wangyu
 * @date 2020/6/16
 */
class DressUpBuyDialog : BaseDialog, View.OnClickListener {

    override fun getContentView(): Int {
        return R.layout.pop_dressup
    }

    private val mContext: Context
    private var needGive = true
    private val dressUpTab: DressUpTab
    private val dressUpGoods: DressUpGoods

    var buyResult: (() -> Unit)? = null

    private var needBack = true
    var needBackCallBack: (() -> Unit)? = null

    constructor(mContext: Context, dressUpTab: DressUpTab, dressUpGoods: DressUpGoods,needGive: Boolean) : super(mContext) {
        this.mContext = mContext
        this.needGive = needGive
        this.dressUpTab = dressUpTab
        this.dressUpGoods = dressUpGoods
    }

    companion object {
        const val TENTHOUSAND: Long = 10000
        const val A_HUNDRED_MILLION: Long = 100000000
        fun create(context: Context, dressUpTab: DressUpTab, dressUpGoods: DressUpGoods, needGive: Boolean = true): DressUpBuyDialog {
            val dialog = DressUpBuyDialog(context, dressUpTab, dressUpGoods,needGive)
            return dialog
        }
    }


    //选中的价格
    private var selectedPrice: BuyTimeList? = null

    override fun initView() {
        super.initView()

//        背景设置
        if (!TextUtils.isEmpty(dressUpGoods.background)) {
            val options = RequestOptions()
                    .transform(RoundedCornersTransformation(dp2px(context, 8), 0))
            Glide.with(context).load(dressUpGoods.background).apply(options).into(object : CustomTarget<Drawable>() {
                override fun onResourceReady(resource: Drawable, transition: Transition<in Drawable>?) {
                    cl_dressup_head_container.background = resource
                }

                override fun onLoadCleared(placeholder: Drawable?) {

                }
            })
        } else {
            cl_dressup_head_container.background = ContextCompat.getDrawable(context, R.drawable.shape_e9eaeb_corner8)
        }

        dressdialpg_tv_name.text = dressUpGoods.name
        dressdialpg_tv_desc.text = dressUpGoods.desc

        if (!TextUtils.isEmpty(dressUpGoods.tips)) {
            tv_dressup_remind.setVisible(true)
            tv_dressup_remind.text = dressUpGoods.tips
        }

        setupState(dressUpGoods.state)
        cl_dressup_head_container.initDressupView(dressUpTab, dressUpGoods, video_dress_up_anim)
    }

    override fun initDatas() {
        super.initDatas()
    }


    /**
     * 购买状态设置
     * @param stateBean  //0 未获得 1已获得 2 无法获得 3 去获得 4购买 5 续费
     */
    private fun setupState(state: Int) {
        when (state) {
            1 -> {
                dressdialpg_tv_state?.setVisible(true)
                dressdialpg_tv_desc?.setVisible(true)
                dressdialpg_tv_state?.text = "已获得"
                dressdialpg_tv_state?.setBackgroundResource(R.drawable.shape_graydark_corner23)
                dressdialpg_tv_state?.setTextColor(ContextCompat.getColor(mContext, R.color.color_333333))
                dressdialpg_tv_state?.isClickable = false
                dressdialpg_tv_state?.isEnabled = false
            }
            2 -> {
                dressdialpg_tv_state?.setVisible(true)
                dressdialpg_tv_desc?.setVisible(true)
                dressdialpg_tv_state?.text = "无法获得"
                dressdialpg_tv_state?.setBackgroundResource(R.drawable.shape_graydark_corner23)
                dressdialpg_tv_state?.setTextColor(ContextCompat.getColor(mContext, R.color.color_333333))
                dressdialpg_tv_state?.isClickable = false
                dressdialpg_tv_state?.isEnabled = false
            }
            3 -> {
                dressdialpg_tv_state.setVisible(true)
                dressdialpg_tv_state?.text = "去获得"
                dressdialpg_tv_desc?.setVisible(true)
                dressdialpg_tv_state?.setBackgroundResource(R.drawable.button_shape_grey_two)
                dressdialpg_tv_state?.setTextColor(ContextCompat.getColor(mContext, R.color.white))
            }

            4 -> { //  可以购买
                dressdialpg_tv_state.setVisible(false)
                dressdialpg_tv_desc.setVisible(false)
                dressdialpg_tv_desc?.setVisible(false)
                dressdialpg_tv_state?.setBackgroundResource(R.drawable.button_shape_grey_two)
                dressdialpg_tv_state?.setTextColor(ContextCompat.getColor(mContext, R.color.white))
                dressdialpg_tv_buy?.text = "购买"
                tv_dresssup_give?.setVisible(needGive)
                UIUtils.showView(cl_buy_container)
                setUpPrice()
                setupBalance()
            }

            5 -> {
                dressdialpg_tv_state.setVisible(false)
                dressdialpg_tv_desc.setVisible(false)
                dressdialpg_tv_desc?.setVisible(false)
                dressdialpg_tv_state?.setBackgroundResource(R.drawable.button_shape_grey_two)
                dressdialpg_tv_state?.setTextColor(ContextCompat.getColor(mContext, R.color.white))
                dressdialpg_tv_buy?.text = "续费"
                tv_dresssup_give?.setVisible(needGive)
                UIUtils.showView(cl_buy_container)
                setUpPrice()
                setupBalance()
            }
            else -> { //未获得
                dressdialpg_tv_state?.setVisible(true)
                dressdialpg_tv_desc?.setVisible(true)
                dressdialpg_tv_state?.text = "未获得"
                dressdialpg_tv_state?.setBackgroundResource(R.drawable.shape_graydark_corner23)
                dressdialpg_tv_state?.setTextColor(ContextCompat.getColor(mContext, R.color.color_333333))
                dressdialpg_tv_state?.isClickable = false
                dressdialpg_tv_state?.isEnabled = false
            }
        }
    }

    /**
     * 价格的列表
     */
    private fun setUpPrice() {
        if (!dressUpGoods.priceInfo.isNullOrEmpty()) {
            rv_price?.layoutManager = LinearLayoutManager(mContext, LinearLayoutManager.HORIZONTAL, false)
            val formatPriceList = mutableListOf<BuyTimeList>()
            formatPriceList.addAll(dressUpGoods.priceInfo)

            setDiscount(dressUpGoods.priceInfo[0])

            val priceAdapter = StorePriceAdapter(mContext, false, formatPriceList)
            rv_price?.adapter = priceAdapter
            priceAdapter.onPriceClick = { position, buyPrice ->
                selectedPrice = buyPrice
                priceAdapter.notifyDataSetChanged()
                setDiscount(buyPrice)
            }
            selectedPrice = dressUpGoods.priceInfo[0]
        }
    }


    fun setDiscount(price: BuyTimeList) {
        if (!TextUtils.isEmpty(price.message)) {
            tv_price_discount_desc?.text = price.message
        }
    }

    private fun setupBalance() {
        var nineCoin: String? = ""
        var nineDot: String? = ""
        CommonApplication.mUserBase?.let {
            if (it.money >= 0 || it.tokencoin >= 0) {
                nineCoin = when {
                    it.money in TENTHOUSAND..A_HUNDRED_MILLION -> {
                        Utils.convertToTenThousand((it.money / (TENTHOUSAND * 1.0)))
                    }
                    it.money > A_HUNDRED_MILLION -> {
                        val double2 = it.money / (A_HUNDRED_MILLION * 1.0)
                        Utils.convertToAHundredMillion(double2)
                    }
                    else -> {
                        it.money.toString() + ""
                    }
                }
                nineDot = when {
                    it.tokencoin in TENTHOUSAND..A_HUNDRED_MILLION -> {
                        Utils.convertToTenThousand((it.tokencoin / (TENTHOUSAND * 1.0)))
                    }
                    it.tokencoin > A_HUNDRED_MILLION -> {
                        Utils.convertToAHundredMillion((it.tokencoin / (A_HUNDRED_MILLION * 1.0)))
                    }
                    else -> {
                        it.tokencoin.toString() + ""
                    }
                }
            }
            tv_blance_9bi?.text = "${nineCoin}九币"
            tv_blance_9dian?.text = "${nineDot}九点"
        }

    }

    override fun initEvents() {
        super.initEvents()
        view_placeholder?.setOnClickListener(this)
        tv_dresssup_give?.setOnClickListener(this)
        dressdialpg_tv_buy?.setOnClickListener(this)
        dressdialpg_tv_state?.setOnClickListener(this)
    }

    override fun onClick(v: View) {
        if (Utils.isNotClickable()) {
            return
        }
        when (v.id) {
            R.id.view_placeholder -> {
                dismiss()
            }
            R.id.tv_dresssup_give -> {//赠送
                selectedPrice?.let {
                    StoreGiveActivity.start(mContext, dressUpTab, dressUpGoods, it) {
                        if (it) {
                            startTransAnim(false)
                        } else {
                            dismiss()
                        }
                    }
                    startTransAnim(true)
                }
            }
            R.id.dressdialpg_tv_buy -> { //购买
                buyDressUp()
            }
            R.id.dressdialpg_tv_state -> {//去获得时的点击
                if (dressUpGoods.state == 3) {
                    AdvertiseActivity.start(mContext, false, dressUpGoods.link)
                }
            }
        }
    }

    /**
     * 装扮的购买
     */
    private fun buyDressUp() {
        if (selectedPrice == null) {
            MyToast.MakeToast("请先选择购买价格！")
            return
        }
        selectedPrice?.let { price ->
            StoreHelper.buyDressUp(dressUpTab.id, dressUpGoods, price, null, { result ->
                MyToast.MakeToast("购买成功")
                buyResult?.invoke()
                needBack = false
                CommonApplication.mUserBase?.let {
                    if (!result.data.isNullOrEmpty()) {
                        it.money = result.data[0].money
                        it.tokencoin = result.data[0].tokencoin
                    }
                }
                setupBalance()
                dismiss()
            }, { code, msg, responseStr ->
                if (4301 == code) {
                    buyResult?.invoke()
                    // 调用充值对话框
                    showBuyDialog(mContext, JSONObject(responseStr))
                    dismiss()
                } else if (4302 == code) {
                    Utils.MakeToast("用户未登录")
                } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                    AccountIdentityDialog.showDialog(mContext, code.toString(), msg)
                } else {// 400请求参数有误
                    MyToast.MakeToast(msg)
                }
            })
        }
    }

    // 快捷支付
    private fun showBuyDialog(context: Context, jsonObject: JSONObject) {
        MyToast.MakeToast(context.getString(R.string.balance_not_enough))
        val dataObj = jsonObject.optJSONObject("data") ?: return
        val diffmoney = dataObj.optLong("diffMoney")

        // 调用充值对话框
        showBugDialog(context, 0, diffmoney, object : OnZhiFuFastDialogDismissListener {
            override fun ondismissCallback() {
                NineShowApplication.mUserBase?.let {
                    tv_blance_9bi?.text = "${it.money}"
                }
                show()
            }
        })
    }


    fun startTransAnim(isDismiss: Boolean) {
        if (isDismiss) {
            val mTranslationOut = ObjectAnimator.ofFloat(dressdialpg_ll_top, "translationY", 0f, dressdialpg_ll_top.height.toFloat())
            mTranslationOut.duration = 200
            mTranslationOut.repeatMode = ObjectAnimator.REVERSE
            mTranslationOut.start()
        } else {
            val mTranslationIn = ObjectAnimator.ofFloat(dressdialpg_ll_top, "translationY", dressdialpg_ll_top.height.toFloat(), 0f)
            mTranslationIn.duration = 200
            mTranslationIn.start()
        }
    }

    override fun onDismiss(dialog: DialogInterface?) {
        super.onDismiss(dialog)
        if (needBack){
            needBackCallBack?.invoke()
        }
    }


    override fun isBottomPop(): Boolean {
        return true
    }

}