package com.ninexiu.sixninexiu.fragment.store

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.store.DressUpAdapter
import com.ninexiu.sixninexiu.bean.DressUpGoods
import com.ninexiu.sixninexiu.bean.DressUpTab
import com.ninexiu.sixninexiu.bean.StoreProps
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.BaseFragment
import kotlinx.android.synthetic.main.fragment_dressup_content.*

/**
 *
 * @CreateDate: 2020/8/26 15:59
 * @Author:     wangyu
 * @Description:装扮内容显示Fragment
 * @Version:    1.0
 */
class DressUpContentFragment : BaseFragment(), View.OnClickListener {


    private var KEY_TAB_TYPE = "key_tab_type"
    private var dressUpGoodsList = mutableListOf<DressUpGoods>()
    private lateinit var dressUpAdapter: DressUpAdapter

    val TAG = "DressUpContentFragment"

    private var dressUpTab: DressUpTab? = null
    private var haveViewInit = false
    private var isVisibleUser = false
    private var haveDataInit = false

    public fun newInstance(dressUpTab: DressUpTab): DressUpContentFragment {
        val args = Bundle()
        val fragment = DressUpContentFragment()
        args.putParcelable(KEY_TAB_TYPE, dressUpTab)
        fragment.arguments = args
        return fragment
    }

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_dressup_content, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        haveViewInit = true
        dressUpTab = arguments?.getParcelable(KEY_TAB_TYPE)

        dressUpTab?.let { dressupTab ->
            activity?.let {
                dressUpAdapter = DressUpAdapter(it, dressupTab.id, dressUpGoodsList)
                dressup_recycle.layoutManager = GridLayoutManager(context, 3)
                dressup_recycle.adapter = dressUpAdapter

                dressUpAdapter.onDressUpItemClick = { dressUpGoods, position ->
                    if (!Utils.isNotClickable()) {
                        val buyDialog = DressUpBuyDialog.create(it, dressupTab, dressUpGoods)
                        buyDialog.show()
                        buyDialog.buyResult = {
                            getDressUpGoodsList(dressupTab.id)
                        }
                    }
                }
            }

            if (isVisibleUser && !haveDataInit) {
                getDressUpGoodsList(dressupTab.id)
            }

            srl_dressup.setOnRefreshListener {
                getDressUpGoodsList(dressupTab.id)
            }
        }

    }

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        isVisibleUser = isVisibleToUser
        if (haveViewInit && isVisibleUser && !haveDataInit) {
            dressUpTab?.let {
                getDressUpGoodsList(it.id)
            }
        }
    }

    /**
     * 获取装扮列表
     */
    private fun getDressUpGoodsList(tab_id: Int) {
        StoreHelper.getDressUpGoodsList(tab_id, {
            dressUpGoodsList.clear()
            srl_dressup?.finishRefresh()
            dressUpGoodsList.addAll(it)
            dressUpAdapter.notifyDataSetChanged()
            haveDataInit = true
        }, { code, msg ->
            srl_dressup?.finishRefresh()
            MyToast.MakeToast(msg)
        })
    }


    override fun onClick(v: View?) {
        when (v?.id) {

        }
    }

}