package com.ninexiu.sixninexiu.fragment.store

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.RelativeLayout
import androidx.core.content.ContextCompat
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.blankj.utilcode.util.ConvertUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.bean.DressUpTab
import com.ninexiu.sixninexiu.common.eventbus.BaseEvent
import com.ninexiu.sixninexiu.common.eventbus.EventContants
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.fragment.BaseFragment
import com.ninexiu.sixninexiu.im.NewsRemindManager
import com.ninexiu.sixninexiu.view.dp2px
import kotlinx.android.synthetic.main.fragment_dressup_user.*
import kotlinx.android.synthetic.main.title_tab_bar.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode

/**
 *
 * @CreateDate: 2020/8/26 15:59
 * @Author:     wangyu
 * @Description:装扮商城
 * @Version:    1.0
 */
class DressUpFragment : BaseFragment() {
    val TAG = "DressUpFragment"

    private var rootView: View? = null

    private var dressUpTabs: List<DressUpTab>? = null

    private var isCheckRemind = false //查看红点

    private var selectPosition = 0 //当前选中位置

    override fun inflate(inflater: LayoutInflater?): View? {
        rootView = inflater?.inflate(R.layout.fragment_dressup_user, null)
        return rootView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        EventBus.getDefault().register(this)
        title.text = "个性装扮"
        right_tv.text = "我的装扮"
        right_tv.visibility = View.VISIBLE
        right_tv.textSize = 13f

        context?.let {
            right_tv.setTextColor(ContextCompat.getColor(it, R.color.white))
            right_tv.delegate.backgroundColor = ContextCompat.getColor(it, R.color.color_ff567b)
            right_tv.delegate.cornerRadius = dp2px(it,12)


            right_tv.layoutParams.height = dp2px(it,24f)

            right_tv.setPadding(Utils.dip2px(it, 8F), 0, Utils.dip2px(it, 8F), 0)
            val layoutParams = right_tv.layoutParams as RelativeLayout.LayoutParams
            layoutParams.setMargins(0, 0, dp2px(it, 8F), 0)
            right_tv.layoutParams = layoutParams

            (right_v_point.layoutParams as ViewGroup.MarginLayoutParams)
                    .setMargins(0, dp2px(it, 8), dp2px(it, 7), 0)
        }



        getStoreTab()

        dressup_indicator.setItemWidthAndInterWidth(0, 10, 0)
        dressup_indicator.setTextColorResource(R.color.zodiac_history_black,
                R.color.sign_title_line)
        dressup_indicator.textSize = resources.getDimensionPixelSize(R.dimen.ns_textsize_15)
        dressup_indicator.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_15))
        dressup_indicator.delegatePageListener = object : ViewPager.OnPageChangeListener {
            override fun onPageScrollStateChanged(state: Int) {

            }

            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
            }

            override fun onPageSelected(position: Int) {
                selectPosition = position
                deleteRemind(position)
            }
        }

        val dressUpRemind = NewsRemindManager.getInstans().getNewsRemind(NewsRemindManager.KEY_MINE_DRESSUP)
        if (dressUpRemind != null && dressUpRemind.status == 1) {
            right_v_point?.visibility = View.VISIBLE
        } else {
            right_v_point?.visibility = View.GONE
        }

        right_tv.setOnClickListener {
            val intent = Intent(activity, SubPageActivity::class.java)
            intent.putExtra(SubPageActivity.CLASSFRAMENT, MyDressUpParentFragment::class.java)
            startActivity(intent)
        }
    }

    /**
     * 获取个性装扮的title
     */
    private fun getStoreTab() {
        StoreHelper.getDressUpTab({
            if (activity != null && !activity!!.isFinishing) {
                dressUpTabs = it
                val fragments = ArrayList<Fragment>()
                for (dressUpTab in it) {
                    fragments.add(DressUpContentFragment().newInstance(dressUpTab))
                }
                val titles = Array(it.size) { index ->
                    it[index].name
                }
                personal_dressup_viewpager?.offscreenPageLimit = it.size
                val dressUpAdapter = CommonPagerAdapter(childFragmentManager, titles, fragments)
                personal_dressup_viewpager?.adapter = dressUpAdapter

                dressup_indicator?.setViewPager(personal_dressup_viewpager)
                showRemind()
            }
        }, { code, msg ->
            MyToast.MakeToast(msg)
        })
    }

    override fun getFragmentTag(): String {
        return TAG
    }

    /**
     * 已查看 删除红点
     */
    private fun deleteRemind(position: Int) {
        dressUpTabs?.let {
            val dressUpTab = it[position]
            isCheckRemind = true
            when (dressUpTab.name) {
                "头像框" -> setPoint(NewsRemindManager.KEY_HEAD_FRAME_DRESS_UP_NEW, position)
                "座驾" -> setPoint(NewsRemindManager.KEY_CAR_DRESS_UP_NEW, position)
                "徽章" -> setPoint(NewsRemindManager.KEY_BADGE_DRESS_UP_NEW, position)
                "发言气泡" -> setPoint(NewsRemindManager.KEY_SPEECH_BUBBLE_DRESS_UP_NEW, position)
                "资料卡" -> setPoint(NewsRemindManager.KEY_DATA_CARD_DRESS_UP_NEW, position)
                "麦位光圈" -> setPoint(NewsRemindManager.KEY_APERTURE_DRESS_UP_NEW, position)
                "进房特效" -> setPoint(NewsRemindManager.KEY_SPECIAL_EFFECTS_DRESS_UP_NEW, position)
            }
        }
    }

    /**
     * 初始化红点
     */
    private fun showRemind() {
        dressUpTabs?.let {
            isCheckRemind = false
            it.forEachIndexed { index, dressUpTab ->
                when (dressUpTab.name) {
                    "头像框" -> setPoint(NewsRemindManager.KEY_HEAD_FRAME_DRESS_UP_NEW, index)
                    "座驾" -> setPoint(NewsRemindManager.KEY_CAR_DRESS_UP_NEW, index)
                    "徽章" -> setPoint(NewsRemindManager.KEY_BADGE_DRESS_UP_NEW, index)
                    "发言气泡" -> setPoint(NewsRemindManager.KEY_SPEECH_BUBBLE_DRESS_UP_NEW, index)
                    "资料卡" -> setPoint(NewsRemindManager.KEY_DATA_CARD_DRESS_UP_NEW, index)
                    "麦位光圈" -> setPoint(NewsRemindManager.KEY_APERTURE_DRESS_UP_NEW, index)
                    "进房特效" -> setPoint(NewsRemindManager.KEY_SPECIAL_EFFECTS_DRESS_UP_NEW, index)
                }
            }
            if (it.isNotEmpty()) {
                deleteRemind(0)
            }
        }
    }

    /**
     * 设置红点是否显示状态
     * model   类型
     * index 在指示器中的位置
     * isCheckRemind true 查看  false 初始化 或接收到上新IM消息
     */
    private fun setPoint(model: String, index: Int) {
        if (isCheckRemind) {
            NewsRemindManager.getInstans().delete(model)
            dressup_indicator?.hidePoint(index)
            val isDressUpNew = (isHasRemind(NewsRemindManager.KEY_HEAD_FRAME_DRESS_UP_NEW) || isHasRemind(NewsRemindManager.KEY_CAR_DRESS_UP_NEW)
                    || isHasRemind(NewsRemindManager.KEY_BADGE_DRESS_UP_NEW) || isHasRemind(NewsRemindManager.KEY_SPEECH_BUBBLE_DRESS_UP_NEW)
                    || isHasRemind(NewsRemindManager.KEY_DATA_CARD_DRESS_UP_NEW) || isHasRemind(NewsRemindManager.KEY_APERTURE_DRESS_UP_NEW)
                    || isHasRemind(NewsRemindManager.KEY_SPECIAL_EFFECTS_DRESS_UP_NEW))
            if (!isDressUpNew) {
                //刷新装扮上新
                NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_PERSONALITY_DRESS_UP_NEW)
            }
        } else {
            if (isHasRemind(model)) {
                dressup_indicator?.showPoint(index)
            } else {
                dressup_indicator?.hidePoint(index)
            }
        }
    }

    private fun isHasRemind(model: String): Boolean {
        val newsRemind = NewsRemindManager.getInstans().getNewsRemind(model)
        return newsRemind != null && newsRemind.status == 1
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun refreshReMind(baseEvent: BaseEvent<*>) {
        when (baseEvent.tag) {
            EventContants.EVENT_MINE_DRESS -> {  //刷新我的装扮小红点
                right_v_point?.let {
                    if (isHasRemind(NewsRemindManager.KEY_MINE_DRESSUP)) {
                        it.visibility = View.VISIBLE
                    } else {
                        it.visibility = View.GONE
                    }
                }
            }
            EventContants.EVENT_PERSONALITY_DRESS_UP_NEW -> {   //刷新装扮上新
                val pushCount = baseEvent.data as String
                havePushRemind(pushCount)
            }
        }
    }

    /**
     * 接收到推送设置红点
     */
    private fun havePushRemind(pushCount: String) {
        dressUpTabs?.let { dressUpTabs ->
            isCheckRemind = false
            var model = ""
            when (pushCount) {
                "头像框" -> model = NewsRemindManager.KEY_HEAD_FRAME_DRESS_UP_NEW
                "座驾" -> model = NewsRemindManager.KEY_CAR_DRESS_UP_NEW
                "徽章" -> model = NewsRemindManager.KEY_BADGE_DRESS_UP_NEW
                "发言气泡" -> model = NewsRemindManager.KEY_SPEECH_BUBBLE_DRESS_UP_NEW
                "资料卡" -> model = NewsRemindManager.KEY_DATA_CARD_DRESS_UP_NEW
                "麦位光圈" -> model = NewsRemindManager.KEY_APERTURE_DRESS_UP_NEW
                "进房特效" -> model = NewsRemindManager.KEY_SPECIAL_EFFECTS_DRESS_UP_NEW
            }
            dressUpTabs.singleOrNull {
                it.name.equals(pushCount)
            }?.let {
                if (selectPosition == dressUpTabs.indexOf(it)) {
                    deleteRemind(selectPosition)
                } else {
                    setPoint(model, dressUpTabs.indexOf(it))
                }
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        EventBus.getDefault().unregister(this)
    }

}