package com.ninexiu.sixninexiu.fragment.store

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.bean.DressUpTab
import com.ninexiu.sixninexiu.common.eventbus.BaseEvent
import com.ninexiu.sixninexiu.common.eventbus.EventContants
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.fragment.BaseFragment
import com.ninexiu.sixninexiu.im.NewsRemindManager
import kotlinx.android.synthetic.main.fragment_dressup_user.*
import kotlinx.android.synthetic.main.fragment_my_dressup_parent.*
import kotlinx.android.synthetic.main.title_tab_bar.*
import org.greenrobot.eventbus.EventBus

/**
 *
 * @CreateDate: 2020/8/26 15:59
 * @Author:     wangyu
 * @Description: 我的装扮页
 * @Version:    1.0
 */
class MyDressUpParentFragment : BaseFragment() {

    private var isCheckRemind = false //查看红点
    private var dressUpTabs: List<DressUpTab>? = null

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_my_dressup_parent, null)

    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        tab_my_dressup.setItemWidthAndInterWidth(0, 10, 0)
        tab_my_dressup.setTextColorResource(R.color.color_333333,
                R.color.color_666666)
        tab_my_dressup.textSize = resources.getDimensionPixelSize(R.dimen.ns_textsize_15)
        tab_my_dressup.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_15))
        tab_my_dressup.delegatePageListener = object : ViewPager.OnPageChangeListener{
            override fun onPageScrollStateChanged(state: Int) {

            }

            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
            }

            override fun onPageSelected(position: Int) {
                deleteRemind(position)
            }
        }

        title.text = "我的装扮"

        left_btn.setOnClickListener {
            activity?.finish()
        }

        getTabData()
    }

    private fun getTabData() {
        StoreHelper.getMyDressupTab({
            if (activity!=null && !activity!!.isFinishing) {
                if (!it.isNullOrEmpty()) {
                    dressUpTabs = it
                    val fragments = ArrayList<Fragment>()
                    for (dressupTab in it) {
                        val dressUpChildFragment = MyDressUpChildFragment.newInstance(dressupTab)
                        dressUpChildFragment.onDressChange = { tab, goods, isDress ->
                            fl_my_dressup_container?.initDressupView(tab, goods, video_gift_dress_up_anim, isDress)
                        }
                        fragments.add(dressUpChildFragment)
                    }
                    val titles = Array(it.size) { index -> it[index].name }
                    vp_my_dressup?.offscreenPageLimit = titles.size
                    vp_my_dressup?.adapter = CommonPagerAdapter(childFragmentManager, titles, fragments)
                    tab_my_dressup?.setViewPager(vp_my_dressup)

                    vp_my_dressup?.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
                        override fun onPageScrollStateChanged(state: Int) {

                        }

                        override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {

                        }

                        override fun onPageSelected(position: Int) {
                            if (it.size > position + 1 && it[position].id == 6) {
                                iv_my_dressup_bg?.setImageResource(R.drawable.icon_dressup_miccircle_bg)
                            } else {
                                iv_my_dressup_bg?.setImageResource(R.drawable.my_dressup_topbg)
                            }
                        }

                    })
                    showRemind()
                }
            }

        }, { code, msg ->
            MyToast.MakeToast(msg)
        })
    }

    /**
     * 下载自封神加载失败的资源
     * @param url
     */
    private fun reDownloadHighGrade(url: String, fileName: String) { //fix bug
        if (activity == null) {
            return
        }
        Thread(Runnable {
            try {
                val cache = Utils.getCachDir(activity)
                Utils.downloadFile(cache, url, fileName)
            } catch (e: Exception) {
                e.printStackTrace()
            }
        }).start()
    }

    private fun deleteRemind(position: Int){
        dressUpTabs?.let {
            val dressUpTab = it[position]
            isCheckRemind = true
            when (dressUpTab.name) {
                "头像框" -> setPoint(NewsRemindManager.KEY_MINE_HEAD_FRAME_DRESS_UP_NEW,position)
                "座驾" -> setPoint(NewsRemindManager.KEY_MINE_CAR_DRESS_UP_NEW,position)
                "徽章" ->  setPoint(NewsRemindManager.KEY_MINE_BADGE_DRESS_UP_NEW,position)
                "发言气泡" -> setPoint(NewsRemindManager.KEY_MINE_SPEECH_BUBBLE_DRESS_UP_NEW,position)
                "资料卡" -> setPoint(NewsRemindManager.KEY_MINE_NAMEPLATE_DRESS_UP_NEW,position)
                "麦位光圈" -> setPoint(NewsRemindManager.KEY_MINE_APERTURE_DRESS_UP_NEW,position)
                "进房特效" -> setPoint(NewsRemindManager.KEY_MINE_SPECIAL_EFFECTS_DRESS_UP_NEW,position)
            }
        }
    }

    private fun showRemind(){
        dressUpTabs?.let {
            isCheckRemind = false
            it.forEachIndexed { index, dressUpTab ->
                when (dressUpTab.name) {
                    "头像框" -> setPoint(NewsRemindManager.KEY_MINE_HEAD_FRAME_DRESS_UP_NEW,index)
                    "座驾" -> setPoint(NewsRemindManager.KEY_MINE_CAR_DRESS_UP_NEW,index)
                    "徽章" ->  setPoint(NewsRemindManager.KEY_MINE_BADGE_DRESS_UP_NEW,index)
                    "发言气泡" -> setPoint(NewsRemindManager.KEY_MINE_SPEECH_BUBBLE_DRESS_UP_NEW,index)
                    "资料卡" -> setPoint(NewsRemindManager.KEY_MINE_NAMEPLATE_DRESS_UP_NEW,index)
                    "麦位光圈" -> setPoint(NewsRemindManager.KEY_MINE_APERTURE_DRESS_UP_NEW,index)
                    "进房特效" -> setPoint(NewsRemindManager.KEY_MINE_SPECIAL_EFFECTS_DRESS_UP_NEW,index)
                }
            }
            if(it.isNotEmpty()){
                deleteRemind(0)
            }
        }
    }

    private fun setPoint(model: String,index: Int){
        if(isCheckRemind){
            NewsRemindManager.getInstans().delete(model)
            tab_my_dressup?.hidePoint(index)
            val isDressUpNew = (isHasRemind(NewsRemindManager.KEY_MINE_HEAD_FRAME_DRESS_UP_NEW) || isHasRemind(NewsRemindManager.KEY_MINE_CAR_DRESS_UP_NEW)
                    ||isHasRemind(NewsRemindManager.KEY_MINE_BADGE_DRESS_UP_NEW) || isHasRemind(NewsRemindManager.KEY_MINE_SPEECH_BUBBLE_DRESS_UP_NEW)
                    ||isHasRemind(NewsRemindManager.KEY_MINE_APERTURE_DRESS_UP_NEW) || isHasRemind(NewsRemindManager.KEY_MINE_APERTURE_DRESS_UP_NEW)
                    ||isHasRemind(NewsRemindManager.KEY_MINE_SPECIAL_EFFECTS_DRESS_UP_NEW))
            if(!isDressUpNew){
                //刷新我的装扮按钮
                NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_MINE_DRESSUP)
                EventBus.getDefault().post(BaseEvent<String>(EventContants.EVENT_MINE_DRESS, ""))
            }
        }else{
            if(isHasRemind(model)){
                tab_my_dressup?.showPoint(index)
            }else{
                tab_my_dressup?.hidePoint(index)
            }
        }
    }

    private fun isHasRemind(model: String): Boolean{
        val newsRemind = NewsRemindManager.getInstans().getNewsRemind(model)
        return newsRemind !=null && newsRemind.status == 1
    }

}