package com.ninexiu.sixninexiu.fragment.store

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.drawable.Drawable
import android.text.TextUtils
import androidx.core.content.ContextCompat
import com.bumptech.glide.Glide
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.request.target.Target
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.dialog_my_dressup.*
import kotlinx.android.synthetic.main.dialog_my_props.*
import kotlinx.android.synthetic.main.dialog_my_props.tv_beauty_number
import kotlinx.android.synthetic.main.dialog_store_buy.*
import kotlinx.android.synthetic.main.item_dress_up.view.*

/**
 * 我的道具 -操作弹窗  启用和续费
 *
 * @author wangyu
 * @date 2020/6/16
 */
class MyPropsDialog private constructor(val mContext: Context, val props: Props) : BaseDialog(mContext) {

    companion object {
        const val TENTHOUSAND: Long = 10000
        const val A_HUNDRED_MILLION: Long = 100000000
        fun create(context: Context, props: Props): MyPropsDialog {
            return MyPropsDialog(context, props)
        }
    }

    override fun getContentView(): Int {
        return R.layout.dialog_my_props
    }

    override fun setDialogWith(): Float {
        return 1f
    }

    override fun isBottomPop(): Boolean {
        return true
    }

    var onPropsStateChange: (() -> Unit)? = null

    override fun initView() {
        super.initView()

        tv_props_name.text = props.name
        tv_props_time_remain.text = props.deadLine
        when (props.stocktype) {
            4 -> {//VIP
                tv_props_opt.setVisible(false)
                if (props.status == 1) {
                    tv_props_state.text = "启用中"
                } else {
                    tv_props_state.text = "已暂停"
                    tv_props_state.setTextColor(ContextCompat.getColor(mContext, R.color.color_999999))
                }
                when (props.gid) {
                    "800001" -> {
                        iv_props_cover.setImageResource(R.drawable.icon_store_vip_1)
                    }
                    "800002" -> {
                        iv_props_cover.setImageResource(R.drawable.icon_store_vip_2)
                    }
                    "800003" -> {
                        iv_props_cover.setImageResource(R.drawable.icon_store_vip_3)
                    }
                    "800004" -> {
                        iv_props_cover.setImageResource(R.drawable.icon_store_vip_4)
                    }
                }
            }
            11 -> {//隐身卡
                if (props.isactive == 1) {
                    tv_props_state.text = "启用中"
                    tv_props_opt.text = "取消"
                } else {
                    tv_props_state.text = "未启用"
                    tv_props_opt.text = "启用"
                }
                iv_props_cover.setImageResource(R.drawable.icon_store_prop_yinshen)
            }
            12 -> {//靓号
                tv_props_name.text = "靓号${props.gid}"
                tv_beauty_number.setVisible(true)
                tv_beauty_number.text = props.gid
                if (props.isactive == 1) {
                    tv_props_state.text = "启用中"
                    tv_props_opt.text = "取消"
                } else {
                    tv_props_state.text = "未启用"
                    tv_props_opt.text = "启用"
                }
                props.gid?.let {
                    when (it.length) {
                        3 -> {
                            iv_props_cover.setImageResource(R.drawable.icon_store_beauty_number_bg_3)
                            tv_beauty_number.setTextColor(ContextCompat.getColor(mContext, R.color.color_ffda9e))
                        }
                        4 -> {
                            iv_props_cover.setImageResource(R.drawable.icon_store_beauty_number_bg_4)
                            tv_beauty_number.setTextColor(ContextCompat.getColor(mContext, R.color.color_333333))
                        }
                        5 -> {
                            iv_props_cover.setImageResource(R.drawable.icon_store_beauty_number_bg_5)
                            tv_beauty_number.setTextColor(ContextCompat.getColor(mContext, R.color.white))
                        }
                        6 -> {
                            iv_props_cover.setImageResource(R.drawable.icon_store_beauty_number_bg_6)
                            tv_beauty_number.setTextColor(ContextCompat.getColor(mContext, R.color.white))
                        }
                        else -> {
                            iv_props_cover.setImageResource(R.drawable.icon_store_beauty_number_bg_7)
                            tv_beauty_number.setTextColor(ContextCompat.getColor(mContext, R.color.white))
                        }
                    }
                }
            }
        }

    }

    override fun initDatas() {
        super.initDatas()

        //启用禁用
        tv_props_opt.setOnClickListener {
            if (props.stocktype == 12) {//靓号
                operateBeautyNumber()
            } else if (props.stocktype == 11) {//隐身卡
                operateYinShen()
            }
        }

        //购买
        tv_props_buy.setOnClickListener {
            var buyDialog: StoreBuyDialog? = null
            when (props.stocktype) {
                4 -> {//VIP
                    val vipinfo = VipPrivilege(props.gid, null, props.name, props.priceInfo, 0)
                    buyDialog = StoreBuyDialog.create(context, vipinfo, false)
                }
                11 -> {//隐身卡
                    val propsInfo = StoreProps(props.tips, props.name, props.priceInfo)
                    buyDialog = StoreBuyDialog.create(context, propsInfo, false)
                }
                12 -> {//靓号
                    val beautyNumber = Account()
                    beautyNumber.accountid = props.gid
                    beautyNumber.bit = if (props.gid == null) "0" else props.gid.length.toString()
                    beautyNumber.priceInfo = props.priceInfo
                    buyDialog = StoreBuyDialog.create(context, beautyNumber, false)

                }
            }
            buyDialog?.let {
                buyDialog.show()
                buyDialog.buySucceed = { //购买成功回调
                    AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_MY_PROPS_CHANGE)
                }
            }
            dismiss()
        }
    }

    /**
     * 操作隐身卡
     */
    private fun operateYinShen() {
        props.gid?.let {
            StoreHelper.operateYinShen(if (props.isactive == 1) 0 else 1, {
                if (props.isactive == 1) {
                    props.isactive = 0
                    tv_props_state?.text = "未启用"
                    tv_props_opt?.text = "启用"
                    MyToast.MakeToast("隐身状态已关闭")
                } else {
                    props.isactive = 1
                    tv_props_state?.text = "已启用"
                    tv_props_opt?.text = "取消"
                    MyToast.MakeToast("隐身状态已开启")
                }
                onPropsStateChange?.invoke()
                dismiss()
            }, { code, msg ->
                MyToast.MakeToast(msg)
            })
        }
    }

    /**
     * 操作靓号
     */
    private fun operateBeautyNumber() {
        props.gid?.let {
            StoreHelper.opterateBeautyNumber(props.gid, {
                if (props.isactive == 1) {
                    props.isactive = 0
                    tv_props_state?.text = "未启用"
                    tv_props_opt?.text = "启用"
                    MyToast.MakeToast("取消成功")
                } else {
                    props.isactive = 1
                    tv_props_state?.text = "已启用"
                    tv_props_opt?.text = "取消"
                    MyToast.MakeToast("启用成功")
                }
                onPropsStateChange?.invoke()
                dismiss()
            }, { code, msg ->
                MyToast.MakeToast(msg)
            })
        }
    }

}