package com.ninexiu.sixninexiu.fragment.store

import android.content.IntentFilter
import android.graphics.Typeface
import android.os.Bundle
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import androidx.fragment.app.Fragment
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.fragment.BaseFragment
import com.ninexiu.sixninexiu.im.NewsRemindManager
import kotlinx.android.synthetic.main.fragment_my_props_parent.*
import kotlinx.android.synthetic.main.title_tab_bar.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/23
 *     desc   : 新版我的道具
 *     version: 1.0
 * </pre>
 */
class MyPropsParentFragment : BaseFragment() {

    companion object {
        const val TAG = "MyPropsParentFragment"
        fun newInstance(): MyPropsParentFragment {
            val args = Bundle()

            val fragment = MyPropsParentFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_my_props_parent, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        title.text = "我的道具"
        tab_my_props.setTextColorResource(R.color.color_333333, R.color.color_666666)
        tab_my_props.textSize = resources.getDimensionPixelSize(R.dimen.ns_textsize_15)
        tab_my_props.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.ns_textsize_15))
        tab_my_props.setTypeface(Typeface.DEFAULT_BOLD, 0)

        getMyProps()
    }

    val fragments = ArrayList<Fragment>()

    private fun getMyProps() {

        StoreHelper.getMyProps({ data ->
            context?.let {
                if (fragments.isEmpty()) {
                    val titles = Array<String>(data.data.size) { if (TextUtils.isEmpty(data.data[it].title)) "" else data.data[it].title!! }
                    vp_my_prop?.offscreenPageLimit = titles.size

                    for (propsList in data.data) {
                        fragments.add(MyPropsChildFragment.newInstance(propsList))
                    }
                    NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_MINE_GET_NEW_ITEM)
                    NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_MINE_PROP_GIFT)
                    NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_MINE_PROP_PRIVILEGE)
                    NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_STEALTHCARD_EXPIRED)
                    NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_ACCOUNTID_EXPIRED)
                    NewsRemindManager.getInstans().delete(NewsRemindManager.KEY_GIFT_EXPIRED)

                    vp_my_prop?.adapter = CommonPagerAdapter(childFragmentManager, titles, fragments)
                    tab_my_props?.setViewPager(vp_my_prop)
                } else {
                    for ((index, fragment) in fragments.withIndex()) {
                        (fragments[index] as MyPropsChildFragment).setNewData(data.data[index].list)
                    }
                }
            }

        }, { code, msg ->
            MyToast.MakeToast(msg)
        })
    }


    override fun registerReceiver(): Boolean {
        return true
    }

    override fun setBroadcastFilter(filter: IntentFilter?) {
        super.setBroadcastFilter(filter)
        filter?.addAction(NSReceiverAction.ACTION_MY_PROPS_CHANGE)
    }

    override fun onReceive(action: String?, type: Int, bundle: Bundle?) {
        if (action.equals(NSReceiverAction.ACTION_MY_PROPS_CHANGE)) {
            getMyProps()
        }
    }
}