package com.ninexiu.sixninexiu.fragment.store

import android.content.Context
import android.text.TextUtils
import com.contrarywind.adapter.WheelAdapter
import com.contrarywind.listener.OnItemSelectedListener
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.Props
import com.ninexiu.sixninexiu.bean.TimePeriod
import com.ninexiu.sixninexiu.bean.TimePeriodResult
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dp2px
import kotlinx.android.synthetic.main.dialog_my_props_select_time.*

/**
 * 我的道具 置顶卡操作弹窗
 *
 * @author wangyu
 * @date 2020/6/16
 */
class MyPropsSelectTimeDialog private constructor(val mContext: Context, val timeList: MutableList<TimePeriod>? = null, val props: Props) : BaseDialog(mContext) {

    companion object {
        fun create(context: Context, timeList: MutableList<TimePeriod>? = null, props: Props): MyPropsSelectTimeDialog {
            return MyPropsSelectTimeDialog(context, timeList, props)
        }
    }

    override fun getContentView(): Int {
        return R.layout.dialog_my_props_select_time
    }

    var onSelectResult: ((String) -> Unit)? = null

    override fun setDialogWith(): Float {
        return 1f
    }

    override fun isBottomPop(): Boolean {
        return true
    }


    override fun initView() {
        super.initView()
    }

    override fun initDatas() {
        super.initDatas()

        if (timeList == null) {
            tv_props_title.text = "选择日期"
            setDate()
        } else {
            tv_props_title.text = "选择时间"
            setTimeList()
        }

        wheel_time.setCyclic(false)
        wheel_time.setItemsVisibleCount(5)
        wheel_time.setLineSpacingMultiplier(3f)

        tv_make_sure.setOnClickListener {
            if (timeList == null) {
                date?.let {
                    onSelectResult?.invoke(it)
                }
            } else {
                timePeriod?.let {
                    onSelectResult?.invoke(it.time)
                }
            }
            dismiss()
        }

        iv_props_back.setOnClickListener {
            dismiss()
        }
    }

    var date: String? = null
    var timePeriod: TimePeriod? = null

    //获取可选日期，根据系统时间获取
    private fun setDate() {
        val dateList = mutableListOf<String>()
        dateList.add(Utils.getDateOfToday())
        dateList.add(Utils.getDateOfTomorrow())



        wheel_time.adapter = object : WheelAdapter<String> {
            override fun indexOf(o: String?): Int {
                return dateList.indexOf(o)
            }

            override fun getItemsCount(): Int {
                return dateList.size
            }

            override fun getItem(index: Int): String {
                return dateList[index]
            }
        }
        wheel_time.currentItem = 0
        date = dateList[0]

        wheel_time.setOnItemSelectedListener {
            date = dateList[it]
        }
    }


    //获取可选日期，根据系统时间获取
    private fun setTimeList() {
        timeList?.let {
            wheel_time.adapter = object : WheelAdapter<TimePeriod> {
                override fun indexOf(o: TimePeriod?): Int {
                    return timeList.indexOf(o)
                }

                override fun getItemsCount(): Int {
                    return timeList.size
                }

                override fun getItem(index: Int): TimePeriod {
                    return timeList[index]
                }
            }

            wheel_time.currentItem = 0
            timePeriod = timeList[0]

            wheel_time.setOnItemSelectedListener {
                timePeriod = timeList[it]
            }
        }
    }


}