package com.ninexiu.sixninexiu.fragment.store

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.core.content.ContextCompat
import androidx.fragment.app.Fragment
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.store.StoreBeautyNumberSearchActivity
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.fragment.BaseFragment
import kotlinx.android.synthetic.main.fragment_store_beauty_number.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/19
 *     desc   : 商城-靓号
 *     version: 1.0
 * </pre>
 */
class StoreBeautyNumberFragment : BaseFragment() {

    companion object {
        fun newInstance(): StoreBeautyNumberFragment {
            val args = Bundle()
            val fragment = StoreBeautyNumberFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_store_beauty_number, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        context?.let {
            tab_beauty_number.setTextColorResource(R.color.color_eacc9d, R.color.color_8a7f69)
            tab_beauty_number.setTextSelectSize(resources.getDimensionPixelSize(R.dimen.history_tab_textsize))
            tab_beauty_number.textSize = resources.getDimensionPixelSize(R.dimen.history_tab_textsize)
        }
        getBeautyNumber()

        tv_search.setOnClickListener {
            activity?.let {
                StoreBeautyNumberSearchActivity.start(it, tv_search)
            }
        }
    }

    val fragments = ArrayList<Fragment>()
    private fun getBeautyNumber() {
        StoreHelper.getBeautyNumberList({
            if (activity != null && !activity!!.isFinishing) {
                if (fragments.isEmpty()) {
                    val titles = arrayOf("限定3位", "典藏4位", "史诗5位", "稀缺6位", "珍贵7位")
                    vp_beauty_number?.offscreenPageLimit = titles.size
                    for (i in 3..7) {
                        val beautyNumberFragment = BeautyNumberFragment.newInstance(it[i.toString()],i.toString())
                        beautyNumberFragment.onBeautyNumberChange = {
                            getBeautyNumber()
                        }
                        fragments.add(beautyNumberFragment)
                    }
                    vp_beauty_number?.adapter = CommonPagerAdapter(childFragmentManager, titles, fragments)
                    tab_beauty_number?.setViewPager(vp_beauty_number)
                } else {
                    for (fragment in fragments) {
                        fragment as BeautyNumberFragment
                        fragment.refreshData(it[fragment.fragmentTag])
                    }
                }
            }

        }, { code, msg ->
            MyToast.MakeToast(msg)
        })
    }
}