package com.ninexiu.sixninexiu.fragment.store

import android.content.Context
import android.content.DialogInterface
import android.text.TextUtils
import android.view.Window
import android.view.WindowManager
import com.ninexiu.sixninexiu.CommonApplication
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AccountIdentityDialog
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.pay.ZhiFuFastCDialog
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.OnZhiFuFastDialogDismissListener
import com.ninexiu.sixninexiu.view.dp2px
import com.tencent.qcloud.tim.uikit.utils.SoftKeyBoardUtil
import kotlinx.android.synthetic.main.dialog_store_give.*
import org.json.JSONObject


/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/19
 *     desc   : 新版商城赠送弹窗
 *     version: 1.0
 * </pre>
 */
class StoreGiveDialog : BaseDialog {

    private var mContext: Context
    private var type: Int = 0
    private var beautyNumber: Account? = null
    private var props: StoreProps? = null
    private var vipInfo: VipPrivilege? = null
    private var dressUpTab: DressUpTab? = null
    private var dressupGoods: DressUpGoods? = null
    private var price: BuyTimeList

    //是否需要返回上一页面
    private var needBack = true

    //需要返回的回调
    var onBackClick: (() -> Unit)? = null

    constructor(mContext: Context, beautyNumber: Account, price: BuyTimeList) : super(mContext) {
        type = StoreHelper.TYPE_BEAUTY_NUMBER
        this.mContext = mContext
        this.beautyNumber = beautyNumber
        this.price = price
    }

    constructor(mContext: Context, props: StoreProps, price: BuyTimeList) : super(mContext) {
        type = StoreHelper.TYPE_BEAUTY_PROPS
        this.mContext = mContext
        this.props = props
        this.price = price
    }


    constructor(mContext: Context, vipInfo: VipPrivilege, price: BuyTimeList) : super(mContext) {
        type = StoreHelper.TYPE_BEAUTY_VIP
        this.mContext = mContext
        this.vipInfo = vipInfo
        this.price = price
    }

    constructor(mContext: Context, dressUpTab: DressUpTab, dressupGoods: DressUpGoods, price: BuyTimeList) : super(mContext) {
        type = StoreHelper.TYPE_BEAUTY_DRESSUP
        this.mContext = mContext
        this.price = price
        this.dressUpTab = dressUpTab
        this.dressupGoods = dressupGoods

    }


    companion object {
        fun create(context: Context, goodsNumber: Account, price: BuyTimeList): StoreGiveDialog {
            val dialog = StoreGiveDialog(context, goodsNumber, price)
            return dialog
        }

        fun create(context: Context, props: StoreProps, price: BuyTimeList): StoreGiveDialog {
            val dialog = StoreGiveDialog(context, props, price)
            return dialog
        }

        fun create(context: Context, vipInfo: VipPrivilege, price: BuyTimeList): StoreGiveDialog {
            val dialog = StoreGiveDialog(context, vipInfo, price)
            return dialog
        }

        fun create(context: Context, dressUpTab: DressUpTab, dressupGoods: DressUpGoods, price: BuyTimeList): StoreGiveDialog {
            val dialog = StoreGiveDialog(context, dressUpTab, dressupGoods, price)
            return dialog
        }
    }

    override fun getContentView(): Int {
        return R.layout.dialog_store_give
    }


    override fun initView() {
        super.initView()
        setupBalance()
        tv_store_give_price.text = "${price?.money}九币"
        tv_store_give_desc.text = when (type) {
            StoreHelper.TYPE_BEAUTY_NUMBER -> {
                "赠送给Ta 靓号：${beautyNumber?.accountid}*${price.type}个月"
            }
            StoreHelper.TYPE_BEAUTY_PROPS -> {
                "赠送给Ta 隐身卡：${props?.name}*${price.type}个月"
            }
            StoreHelper.TYPE_BEAUTY_DRESSUP -> {
                "赠送给Ta ${dressUpTab?.name}：${dressupGoods?.name}*${price.type}个月"
            }
            StoreHelper.TYPE_BEAUTY_VIP -> {
                "赠送给Ta ${vipInfo?.name}*${price.type}个月"
            }
            else -> ""
        }

        SoftKeyBoardUtil.SoftKeyboardStateHelperNew(window?.decorView, object : SoftKeyBoardUtil.SoftKeyboardStateListener {
            override fun onSoftKeyboardClosed() {
                NSLog.e("隐藏键盘 ------------------")
                cl_give_container.translationY = 0f
            }

            override fun onSoftKeyboardOpened(keyboardHeightInPx: Int) {
                NSLog.e("打开键盘 ==================="+keyboardHeightInPx)
                cl_give_container.translationY = -dp2px(mContext, 100).toFloat()

            }
        })

    }

    override fun initDatas() {
        super.initDatas()
    }

    override fun initEvents() {
        super.initEvents()

        tv_give.setOnClickListener {
            if (type == StoreHelper.TYPE_BEAUTY_NUMBER) {
                giveBeautyNumber()
            } else if (type == StoreHelper.TYPE_BEAUTY_PROPS) {
                giveProps()
            } else if (type == StoreHelper.TYPE_BEAUTY_DRESSUP) {
                giveDressUp()
            } else if (type == StoreHelper.TYPE_BEAUTY_VIP) {
                giveVip()
            }
        }

        iv_give_close.setOnClickListener {
            dismiss()
        }
    }


    /**
     * 余额设置
     */
    private fun setupBalance() {
        var nineCoin: String? = ""
        var nineDot: String? = ""
        CommonApplication.mUserBase?.let {
            if (it.money >= 0 || it.tokencoin >= 0) {
                nineCoin = when {
                    it.money in StoreHelper.TENTHOUSAND..StoreHelper.A_HUNDRED_MILLION -> {
                        Utils.convertToTenThousand((it.money / (StoreHelper.TENTHOUSAND * 1.0)))
                    }
                    it.money > StoreHelper.A_HUNDRED_MILLION -> {
                        val double2 = it.money / (StoreHelper.A_HUNDRED_MILLION * 1.0)
                        Utils.convertToAHundredMillion(double2)
                    }
                    else -> {
                        it.money.toString() + ""
                    }
                }
                nineDot = when {
                    it.tokencoin in StoreHelper.TENTHOUSAND..StoreHelper.A_HUNDRED_MILLION -> {
                        Utils.convertToTenThousand((it.tokencoin / (StoreHelper.TENTHOUSAND * 1.0)))
                    }
                    it.tokencoin > StoreHelper.A_HUNDRED_MILLION -> {
                        Utils.convertToAHundredMillion((it.tokencoin / (StoreHelper.A_HUNDRED_MILLION * 1.0)))
                    }
                    else -> {
                        it.tokencoin.toString() + ""
                    }
                }
            }
            tv_blance_9bi?.text = "${nineCoin}九币"
            tv_blance_9dian?.text = "${nineDot}九点"
        }
    }


    /**
     * 赠送靓号
     */
    private fun giveBeautyNumber() {
        if (Utils.isNotClickable()) {
            return
        }

        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(mContext.resources.getString(R.string.super_account_input_number))
            return
        }

        if (beautyNumber == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            dismiss()
            return
        }

        beautyNumber?.let { goods ->
            StoreHelper.buyBeautyNumber(beautyNumber = goods, price = price, sendTo = giveId, onSuccess = {
                MyToast.MakeToast("赠送成功")
                needBack = false
                dismiss()
            }, onFail = { code, msg, json ->
                if (4301 == code) {
                    // 调用充值对话框
                    showBuyDialog(JSONObject(json))
                    needBack = false
                    dismiss()
                } else if (4302 == code) {
                    Utils.MakeToast("用户未登录")
                } else if (409 == code) {// 409被占用
                    Utils.MakeToast("该靓号已被占用")
                } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                    AccountIdentityDialog.showDialog(mContext, code.toString(), msg)
                } else {// 400请求参数有误
                    MyToast.MakeToast(msg)
                }
            })
        }
    }

    /**
     * 赠送 隐身卡
     */
    private fun giveProps() {
        if (Utils.isNotClickable()) {
            return
        }

        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(mContext.resources.getString(R.string.super_account_input_number))
            return
        }

        if (props == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            dismiss()
            return
        }

        props?.let { goods ->
            StoreHelper.buyPropsYinshen(props = goods, price = price, sendTo = giveId, onSuccess = {
                MyToast.MakeToast("赠送成功")
                needBack = false
                dismiss()
            }, onFail = { code, msg, json ->
                if (4301 == code) {
                    // 调用充值对话框
                    showBuyDialog(JSONObject(json))
                    needBack = false
                    dismiss()
                } else if (4302 == code) {
                    Utils.MakeToast("用户未登录")
                } else if (409 == code) {// 409被占用
                    Utils.MakeToast("该靓号已被占用")
                } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                    AccountIdentityDialog.showDialog(mContext, code.toString(), msg)
                } else {// 400请求参数有误
                    MyToast.MakeToast(msg)
                }
            })
        }
    }

    /**
     * 赠送 隐身卡
     */
    private fun giveVip() {
        if (Utils.isNotClickable()) {
            return
        }

        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(mContext.resources.getString(R.string.super_account_input_number))
            return
        }

        if (vipInfo == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            dismiss()
            return
        }

        vipInfo?.let { goods ->
            StoreHelper.buyVip(vipInfo = goods, price = price, sendTo = giveId, onSuccess = {
                MyToast.MakeToast("赠送成功")
                needBack = false
                dismiss()
            }, onFail = { code, msg, json ->
                if (4301 == code) {
                    // 调用充值对话框
                    showBuyDialog(JSONObject(json))
                    needBack = false
                    dismiss()
                } else if (4302 == code) {
                    Utils.MakeToast("用户未登录")
                } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                    AccountIdentityDialog.showDialog(mContext, code.toString(), msg)
                } else {// 400请求参数有误
                    MyToast.MakeToast(msg)
                }
            })
        }
    }

    /**
     * 装扮的购买
     */
    private fun giveDressUp() {
        val giveId = et_store_give.text.toString()

        if (TextUtils.isEmpty(giveId)) {
            MyToast.MakeToast(mContext.resources.getString(R.string.super_account_input_number))
            return
        }

        if (dressUpTab != null && dressupGoods == null) {
            MyToast.MakeToast("未获取到商品信息，请重试！")
            needBack = false
            dismiss()
            return
        }

        StoreHelper.buyDressUp(dressUpTab!!.id, dressupGoods!!, price, giveId, {
            MyToast.MakeToast("赠送成功")
            dismiss()
        }, { code, msg, responseStr ->
            if (4301 == code) {
                // 调用充值对话框
                showBuyDialog(JSONObject(responseStr))
                dismiss()
            } else if (4302 == code) {
                Utils.MakeToast("用户未登录")
            } else if (AccountIdentityDialog.CODE_BIND_PHONE == code.toString() || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code.toString()) {  // 绑定手机号/实名认证
                AccountIdentityDialog.showDialog(mContext, code.toString(), msg)
            } else {// 400请求参数有误
                MyToast.MakeToast(msg)
            }
        })
    }


    // 快捷支付
    private fun showBuyDialog(jsonObject: JSONObject) {
        MyToast.MakeToast(context.getString(R.string.yue_not_enough))
        val dataObj = jsonObject.optJSONObject("data") ?: return
        val diffmoney = dataObj.optLong("diffMoney")
        // 调用充值对话框
        ZhiFuFastCDialog.showBugDialog(mContext, 0, diffmoney, object : OnZhiFuFastDialogDismissListener {
            override fun ondismissCallback() {
                needBack = true
                this@StoreGiveDialog.show()
            }
        })
    }

    override fun isBottom(): Boolean {
        return true
    }

    override fun onDismiss(dialog: DialogInterface?) {
        super.onDismiss(dialog)
        if (needBack) {
            onBackClick?.invoke()
        }
    }


}