package com.ninexiu.sixninexiu.fragment.store

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import androidx.core.content.ContextCompat
import androidx.fragment.app.Fragment
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.CommonPagerAdapter
import com.ninexiu.sixninexiu.common.util.SystemUtil
import com.ninexiu.sixninexiu.fragment.BaseFragment
import kotlinx.android.synthetic.main.fragment_store_parent.*
import kotlinx.android.synthetic.main.title_tab_bar_tra.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/18
 *     desc   :  新版商城父类
 *     version: 1.0
 * </pre>
 */
class StoreParentFragment : BaseFragment() {

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_store_parent, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        left_btn.setImageResource(R.drawable.icon_arrow_left_white)
        title.text = "商城"
        context?.let {
            title.setTextColor(ContextCompat.getColor(it, R.color.white))
            fl_title.layoutParams = (fl_title.layoutParams as ViewGroup.MarginLayoutParams).also { layoutParams ->
                layoutParams.topMargin = SystemUtil.getStatusBarHeight(it)
            }
        }

        rg_store_title.check(R.id.rb_store_title_vip)

        val fragments = ArrayList<Fragment>()
        fragments.add(StoreVipFragment.newInstance())
        fragments.add(StorePropFragment.newInstance())
        fragments.add(StoreBeautyNumberFragment.newInstance())

        val titles = arrayOf("VIP", "道具", "靓号")
        vp_store.offscreenPageLimit = 3
        vp_store.adapter = CommonPagerAdapter(fragmentManager, titles, fragments)

        rg_store_title.setOnCheckedChangeListener { group, checkedId ->
            when (checkedId) {
                R.id.rb_store_title_vip -> {
                    vp_store.setCurrentItem(0, false)
                }
                R.id.rb_store_title_prop -> {
                    vp_store.setCurrentItem(1, false)
                }
                R.id.rb_store_title_beauty_number -> {
                    vp_store.setCurrentItem(2, false)
                }
            }
        }
    }


}