package com.ninexiu.sixninexiu.fragment.store

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.store.StorePropsAdapter
import com.ninexiu.sixninexiu.bean.StoreProps
import com.ninexiu.sixninexiu.common.httphelp.StoreHelper
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.fragment.BaseFragment
import kotlinx.android.synthetic.main.fragment_store_prop.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/19
 *     desc   : 商城-道具
 *     version: 1.0
 * </pre>
 */
class StorePropFragment : BaseFragment() {

    companion object {
        fun newInstance(): StorePropFragment {
            val args = Bundle()
            val fragment = StorePropFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun inflate(inflater: LayoutInflater?): View? {
        return inflater?.inflate(R.layout.fragment_store_prop, null)
    }

    private val propsList = mutableListOf<StoreProps>()
    private lateinit var propsAdapter: StorePropsAdapter

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)


        context?.let {
            rv_store_props.layoutManager = LinearLayoutManager(it, LinearLayoutManager.VERTICAL, false)
            propsAdapter = StorePropsAdapter(it, propsList)
            rv_store_props.adapter = propsAdapter

            propsAdapter.onPropClick = { props, position ->
                val storeBuyDialog= StoreBuyDialog.create(it,props)
                storeBuyDialog.show()
            }
        }

        getPropDetails()
    }


    fun getPropDetails() {
        StoreHelper.getPropDetail({
            propsList.clear()
            propsList.addAll(it)
            propsAdapter.notifyDataSetChanged()
        }, { code, msg ->
            MyToast.MakeToast(msg)
        })
    }
}