package com.ninexiu.sixninexiu.fragment.store

import android.app.Activity
import android.content.Context
import android.view.Gravity
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.VipPrivilegeInfo
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import kotlinx.android.synthetic.main.dialog_vip_privilege_info.*

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/26
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class VipPrivilegeInfoDialog(val mContext: Context, val privilegeInfo: VipPrivilegeInfo) : BaseDialog(mContext) {

    companion object {
        fun create(context: Context, privilegeInfo: VipPrivilegeInfo): VipPrivilegeInfoDialog {
            val dialog = VipPrivilegeInfoDialog(context, privilegeInfo)
            return dialog
        }
    }

    override fun initView() {
        super.initView()
        vip_privilege_name.text = privilegeInfo.name
        GlideUtils.loadNormalImg(context, privilegeInfo.background, vip_privilege_iv)
        vip_privilege_content.text = privilegeInfo.message
        //延迟判断，把文字靠左
        vip_privilege_content.postDelayed({
            if (vip_privilege_content.lineCount > 2) {
                vip_privilege_content.gravity = Gravity.LEFT
            }
        }, 100)

        vip_privilege_sure.setOnClickListener {
            if (mContext is Activity && !mContext.isFinishing) {
                dismiss()
            }
        }
    }

    override fun getContentView(): Int {
        return R.layout.dialog_vip_privilege_info
    }

}