package com.ninexiu.sixninexiu.fragment.tencentim


import android.content.Intent
import android.content.IntentFilter
import android.os.Bundle
import android.os.Handler
import android.os.Parcelable
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.View.OnClickListener
import android.view.ViewGroup
import androidx.core.app.NotificationManagerCompat
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentStatePagerAdapter
import cn.thinkingdata.android.ScreenAutoTracker
import com.google.gson.Gson
import com.loopj.android.http.TextHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.MainTabActivity
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.DynamicNoticeInfo
import com.ninexiu.sixninexiu.bean.FriendRequestListBean
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.AppCacheData
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.ConfigSpHelper
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.fragment.BasePagerFragment
import com.ninexiu.sixninexiu.fragment.friend.FriendsListFragment
import com.ninexiu.sixninexiu.push.CheckNotificeUtils
import com.ninexiu.sixninexiu.tencentim.UnreadMsgCountManager
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.CurrencyDialog
import com.tencent.imsdk.*
import com.tencent.qcloud.tim.uikit.NoticeEvent
import com.tencent.qcloud.tim.uikit.PushContants
import com.tencent.qcloud.tim.uikit.bean.SysAndAnchorBean
import com.tencent.qcloud.tim.uikit.TUIKitImpl
import com.tencent.qcloud.tim.uikit.modules.conversation.ConversationLayout
import com.tencent.qcloud.tim.uikit.utils.DateTimeUtil
import com.thirdparty.utils.StatusBarUtil
import kotlinx.android.synthetic.main.msg_messsagecenter_fragment.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import java.util.*

/**
 * author wangyu
 * date: on 2020/4/15
 * describe: 消息中心Fragment
 */
@Suppress("DEPRECATION")
class MessageCenterFragment : BasePagerFragment(), OnClickListener {

    private var rootView: View? = null
    private var isFirst: Boolean? = true
    private var isShowRedPoint: Boolean? = false //是否显示好友页面未读小红点

    private var handler = Handler()

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?): View? {
        if (rootView == null) {
            rootView = inflater?.inflate(R.layout.msg_messsagecenter_fragment, null)
        }
        return rootView
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        EventBus.getDefault().register(this)
    }

    override fun onDestroy() {
        super.onDestroy()
        EventBus.getDefault().unregister(this)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        messagecenter_tv_close_push?.setOnClickListener(this)
        messagecenter_tv_openpush?.setOnClickListener(this)
        messagecenter_clv_interactivenews?.setOnClickListener(this)
        messagecenter_fv_setting?.setOnClickListener(this)
        messagecenter_fv_friends?.setOnClickListener(this)
        messagecenter_clv_systemnotification?.setOnClickListener(this)
        messagecenter_iv_reportread?.setOnClickListener(this)

        setupDynamicNoticeMessage()
        if (!TextUtils.isEmpty(ConfigSpHelper.getInstance().timFriendMessage) && NineShowApplication.mUserBase != null) {
            val res = Gson().fromJson(ConfigSpHelper.getInstance().timFriendMessage, NoticeEvent::class.java)
            if (res != null && res.isRead) {
                isShowRedPoint = false
            } else {
                isShowRedPoint = true
                AppBroadcastHelper.getInstance()
                    .sendBroadcast(NSReceiverAction.ACTION_UNREAD_SYSTEMMSG,
                        NSDataBroadcast.TYPE_OPERATION_DEFAULT, null)
            }
        }

        loadNewFriend()
        setLastSystemPushMessage(UnreadMsgCountManager.INSTANCE.lastSystemBean)
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        if (isFirst!!) {
            childFragmentManager?.beginTransaction()
                ?.replace(R.id.messagecenter_rv_container, NsTConversationFragment(), "ConversationFragment")
                ?.commitAllowingStateLoss()
            initData()
            isFirst = false
        }
    }

    override fun onResume() {
        super.onResume()
        //检测是否开启通知权限
        var notification = activity?.let { NotificationManagerCompat.from(it) }
        var isEnabled = notification?.areNotificationsEnabled()
        if (isEnabled!! || AppCacheData.instance.messagePushCloseStatus == 1) {
            UIUtils.goneView(pushCardView)
        } else {
            UIUtils.showView(pushCardView)
        }
    }

    private fun initData() {
        if (activity != null) {
            StatusBarUtil.setTranslucentForImageViewInFragment(activity, messagecenter_v_top)
            StatusBarUtil.setLightMode(activity)
        }
    }

    /**
     * 互动消息设置
     */
    private fun setupDynamicNoticeMessage() {
        val conversation = TIMManager.getInstance().getConversation(TIMConversationType.C2C,  //会话类型：单聊
            "500000")
        conversation.getMessage(10, null, object : TIMValueCallBack<List<TIMMessage>> {
            override fun onSuccess(list: List<TIMMessage>?) {
                NSLog.d("MessageCenterNum : ", "${list?.size ?: "null"}")
                if (list == null || list.isEmpty()) {
                    UIUtils.goneView(messagecenter_tv_interactivenews_pushtime)
                    UIUtils.goneView(messagecenter_iv_unreadinteractivenews)
                } else {
                    val lastMessage = list.get(0)
                    val unreadNum = UnreadMsgCountManager.INSTANCE.getDynamicMessageUnreadNum(conversation)
                    NSLog.d("MessageCenterNum : ", "${unreadNum}")
                    if (unreadNum > 0) {
                        UIUtils.showView(messagecenter_iv_unreadinteractivenews)
                        messagecenter_iv_unreadinteractivenews?.text = "$unreadNum"
                    } else {
                        UIUtils.goneView(messagecenter_iv_unreadinteractivenews)
                    }
                    val element: TIMElem = lastMessage.getElement(0)
                    val customElem = element as TIMCustomElem
                    val desc = customElem.desc
                    val dynamicNoticeInfo = Gson().fromJson(desc, DynamicNoticeInfo::class.java)
                    UIUtils.showView(messagecenter_tv_interactivenews_pushtime)
                    messagecenter_tv_interactivenews_pushtime?.text = DateTimeUtil.getTimeFormatText(Date(dynamicNoticeInfo.send_time * 1000L))

                    /**
                     * 更新本地存储的用户信息
                     */
                    val ids = mutableListOf<String>()
                    for (message in list) {
                        val element = message.getElement(0)
                        val customElem = element as TIMCustomElem
                        val desc = customElem.desc
                        val dynamicNoticeInfo = Gson().fromJson(desc, DynamicNoticeInfo::class.java)
                        if (dynamicNoticeInfo.extra != null && !TextUtils.isEmpty(dynamicNoticeInfo.extra.fromuid) && !ids.contains(dynamicNoticeInfo.extra.fromuid)) {
                            ids.add(dynamicNoticeInfo.extra.fromuid)
                        }
                    }
                    TIMFriendshipManager.getInstance().getUsersProfile(ids, true, null)
                    messagecenter_tv_interactivenews_pushtime?.text =
                        DateTimeUtil.getTimeFormatText(Date(dynamicNoticeInfo.send_time * 1000L))
                }
            }

            override fun onError(p0: Int, p1: String?) {
            }
        })
    }

    private fun setLastSystemPushMessage(lastSystemMessage: SysAndAnchorBean?) {
        if (lastSystemMessage != null) {
            if (!TextUtils.isEmpty(lastSystemMessage.title)) {
                if (lastSystemMessage?.unReadCount > 0) {
                    UIUtils.showView(messagecenter_iv_unreadsystemnotification)
                    messagecenter_iv_unreadsystemnotification?.text =
                        if (lastSystemMessage.unReadCount < 99) lastSystemMessage?.unReadCount.toString() else "99+"
                } else {
                    UIUtils.goneView(messagecenter_iv_unreadsystemnotification)
                }

                messagecenter_tv_systemnotification_content?.text = lastSystemMessage?.title
                messagecenter_tv_systemnotification_pushtime?.text =
                    DateTimeUtil.getTimeFormatText(Date(lastSystemMessage.lastMessageTime * 1000L))
                UIUtils.showView(messagecenter_tv_systemnotification_pushtime)
            }
        } else {
            messagecenter_tv_systemnotification_content?.text = "暂无新消息通知"
            UIUtils.goneView(messagecenter_tv_systemnotification_pushtime)
            UIUtils.goneView(messagecenter_iv_unreadsystemnotification)
            AppCnfSpHelper.getInstance().timSystemLastMessage = ""
        }
    }

    override fun onClick(p0: View?) {
        if (Utils.isNotClickable()) {
            return
        }
        when (p0?.id) {
            //取消推送提示
            R.id.messagecenter_tv_close_push -> {
                AppCacheData.instance.messagePushCloseStatus = 1
                UIUtils.goneView(pushCardView)
            }
            //打开推送设置
            R.id.messagecenter_tv_openpush -> {
                activity?.let {
                    CheckNotificeUtils.gotoSet(it)
                }
            }
            //设置
            R.id.messagecenter_fv_setting -> {
                if (Utils.isNotClickable()) {
                    return
                }
                if (NineShowApplication.mUserBase == null && activity != null) {
                    Utils.startLogin(activity, "请先登录")
                    return
                }
                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SETUP)
                val imSettingIntent = Intent(activity, SubPageActivity::class.java)
                imSettingIntent.putExtra(SubPageActivity.CLASSFRAMENT, TimSettingFragment::class.java)
                startActivity(imSettingIntent)
            }
            //好友列表
            R.id.messagecenter_fv_friends -> {
                if (Utils.isNotClickable()) {
                    return
                }
                if (NineShowApplication.mUserBase == null && activity != null) {
                    Utils.startLogin(activity, resources.getString(R.string.live_login_audience))
                    return
                }
                StatisticsUtil.onEvent(StatisticsEventID.MESSAGE_FRIENDS_LIST)
                val intentFriendsList = Intent(activity, SubPageActivity::class.java)
                intentFriendsList.putExtra(SubPageActivity.CLASSFRAMENT, FriendsListFragment::class.java)
                val bundle = Bundle()
                isShowRedPoint?.let { bundle.putBoolean("isShowRedPoint", it) }
                intentFriendsList.putExtra("bundle", bundle)
                startActivity(intentFriendsList)
            }
            //系统消息
            R.id.messagecenter_clv_systemnotification -> {
                if (Utils.isNotClickable()) {
                    return
                }
                activity?.let {
                    StatisticsUtil.onEvent(StatisticsEventID.MESSAGE_SYSTEM_NOTICE)
                    val systemIntent = Intent(it, SubPageActivity::class.java)
                    systemIntent.putExtra(SubPageActivity.CLASSFRAMENT, TencentSystemFragment::class.java)
                    it.startActivity(systemIntent)
                }
            }
            //互动消息
            R.id.messagecenter_clv_interactivenews -> {
                if (Utils.isNotClickable()) {
                    return
                }
                if (NineShowApplication.mUserBase == null && activity != null) {
                    Utils.startLogin(activity, "请先登录")
                    return
                }
                UnreadMsgCountManager.INSTANCE.setDynamicMessageRead()
                StatisticsUtil.onEvent(StatisticsEventID.MESSAGE_INTERACT_MESSAGE)
                activity?.let {
                    val dynamicIntent = Intent(it, SubPageActivity::class.java)
                    dynamicIntent.putExtra(SubPageActivity.CLASSFRAMENT, DynamicNoticeFragment::class.java)
                    it.startActivity(dynamicIntent)
                }
            }
            //上报所有已读
            R.id.messagecenter_iv_reportread -> {
                if (NineShowApplication.mUserBase == null && activity != null) {
                    Utils.startLogin(activity, "请先登录")
                    return
                }
                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_IGNOREALL)
                CurrencyDialog.create(activity)
                    .setTitleText("确定忽略所有提示内容吗")
                    .setCurrencyText("确认忽略")
                    .setOnClickCallback { type ->
                        if (type == BaseDialog.SELECT_SECOND) {
                            val tIMConversations = TIMManager.getInstance().conversationList
                            tIMConversations?.forEach {
                                it.setReadMessage(null, object : TIMCallBack {
                                    override fun onSuccess() {
                                    }

                                    override fun onError(p0: Int, p1: String?) {
                                    }
                                })
                            }
                            isShowRedPoint = false
                            //                                UIUtils.inVisibleView(messagecenter_iv_unreadsystemnotification)
                            UIUtils.inVisibleView(messagecenter_iv_unreadinteractivenews)
                            AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_UPLOAD_ALLREAD)
                            UnreadMsgCountManager.INSTANCE.setSystemMsgRead(
                                if (UnreadMsgCountManager.INSTANCE.lastSystemBean == null) "" else PushContants.systemBean?.tm_id!!.toString())
                            //清空互动消息未读数
                            UnreadMsgCountManager.INSTANCE.setDynamicMessageRead()
                        }

                    }
            }

        }
    }

    class fragmentPagerAdapter(fm: FragmentManager) : FragmentStatePagerAdapter(fm) {
        private val mTitile = arrayOf("最近聊天", "在线好友")

        override fun getCount(): Int {
            return mTitile.size
        }

        override fun saveState(): Parcelable? {
            return null
        }

        override fun getPageTitle(position: Int): CharSequence? {
            return mTitile[position]
        }

        override fun getItem(position: Int): Fragment {
            val fragment: Fragment
            if (position == 0) {
                fragment = NsTConversationFragment()
            } else {
                fragment = NsOnLineFriendsFragment()
            }
            return fragment
        }
    }

    override fun registerReceiver(): Boolean {
        return true
    }

    override fun setBroadcastFilter(filter: IntentFilter) {
        super.setBroadcastFilter(filter)
        filter.addAction(NSReceiverAction.LOGOUT_ACTION)
        filter.addAction(NSReceiverAction.REFERSH_BADGE)
        filter.addAction(NSReceiverAction.ACTION_TASK_REFRESH_GAMELIST)
        filter.addAction(NSReceiverAction.ACTION_UPLOAD_SYSTEMREAD)
        filter.addAction(NSReceiverAction.ACTION_UPLOAD_FRIENDREAD)
        filter.addAction(NSReceiverAction.ACTION_UPLOAD_INTERACTIVEREAD)
        filter.addAction(NSReceiverAction.ACTION_UPLOAD_INTERACTIVEREAD)
        filter.addAction(NSReceiverAction.ACTION_SYSTEMMESSAGE_REFRESH)
        filter.addAction(NSReceiverAction.LOGIN_ACTION)
    }

    override fun onReceive(action: String, type: Int, bundle: Bundle) {
        super.onReceive(action, type, bundle)
        if (TextUtils.equals(action, NSReceiverAction.REFERSH_BADGE)) { //登录
            if (TUIKitImpl.isInitTimSDK && activity != null) {
                isFirst = true
                ConversationLayout(activity).initDefault(0)
            }
        } else if (TextUtils.equals(action, NSReceiverAction.LOGOUT_ACTION)) { //退出
            isFirst = true
            messagecenter_tv_systemnotification_content?.text = "暂无新消息通知"
            UIUtils.goneView(messagecenter_tv_systemnotification_pushtime)

            UIUtils.goneView(messagecenter_tv_interactivenews_pushtime)
            UIUtils.goneView(messagecenter_iv_unreadinteractivenews)
            isShowRedPoint = false
        } else if (TextUtils.equals(action, NSReceiverAction.ACTION_UPLOAD_SYSTEMREAD)) { //系统消息已读
            UIUtils.goneView(messagecenter_iv_unreadsystemnotification)
        } else if (TextUtils.equals(action, NSReceiverAction.ACTION_UPLOAD_FRIENDREAD)) { //好友请求已读
            loadNewFriend()
            isShowRedPoint = false
        } else if (TextUtils.equals(action, NSReceiverAction.ACTION_UPLOAD_INTERACTIVEREAD)) { //互动通知已读
            UIUtils.goneView(messagecenter_iv_unreadinteractivenews)
        } else if (TextUtils.equals(action, NSReceiverAction.ACTION_TASK_REFRESH_GAMELIST)) { //登录成功延时重新加载Fragment
            initData()
        } else if (TextUtils.equals(action, NSReceiverAction.ACTION_SYSTEMMESSAGE_REFRESH)) { //系统消息刷新
            val systemMsgBean = bundle.getSerializable("last_system_msg")
            if (systemMsgBean != null) {
                setLastSystemPushMessage(systemMsgBean as SysAndAnchorBean)
            } else {
                setLastSystemPushMessage(null)
            }
        } else if (TextUtils.equals(action, NSReceiverAction.LOGIN_ACTION)) {
            UnreadMsgCountManager.INSTANCE.getLastSystemPushMessage()
        }
    }

    @Subscribe(threadMode = ThreadMode.MAIN, sticky = true)
    public fun onEvent(messageEvent: NoticeEvent) {
        when (messageEvent.noticeType) {
            1 -> {

                //系统消息
                messagecenter_iv_unreadsystemnotification?.visibility = View.VISIBLE
                messagecenter_tv_systemnotification_content?.text = messageEvent?.noticeName
                messagecenter_tv_systemnotification_pushtime?.text = messageEvent.noticeTime
                messagecenter_tv_systemnotification_pushtime?.visibility = View.VISIBLE

                AppCnfSpHelper.getInstance().timSystemLastMessage = Gson().toJson(messageEvent)
            }

            2 -> {
                //好友请求
                if (!messageEvent.isRead) {
                    AppCnfSpHelper.getInstance().isFriendsAddMessage = false
                    //                    messagecenter_iv_unreadfriends?.visibility = View.VISIBLE
                    AppBroadcastHelper.getInstance()
                        .sendBroadcast(NSReceiverAction.ACTION_UNREAD_SYSTEMMSG,
                            NSDataBroadcast.TYPE_OPERATION_DEFAULT, null)
                    isShowRedPoint = true
                } else {
                    isShowRedPoint = false
                }
                ConfigSpHelper.getInstance().setTIFriendMessage(Gson().toJson(messageEvent))
            }

            5 -> {
                //互动通知
                if (!messageEvent.isRead) {
                    AppBroadcastHelper.getInstance()
                        .sendBroadcast(NSReceiverAction.ACTION_CHAT_MESSAGE_UNREAD,
                            NSDataBroadcast.TYPE_OPERATION_DEFAULT, null)
                }
                setupDynamicNoticeMessage()
            }

            7 -> {

            }

        }
    }

    /**
     * 初始化数据
     */
    fun loadNewFriend() {
        //        messagecenter_iv_unreadfriends?.visibility = View.GONE
        val asyncHttpClient = NsOkHttpClient.getNsOkHttpClient()
        val params = NSRequestParams()
        asyncHttpClient.doGet(Constants.GET_NEW_FRIEND_REQUEST_LIST, params,
            object : NSGsonObjectCallback<FriendRequestListBean>() {

                override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: FriendRequestListBean?) {
                    if (response != null
                        && response?.code == 200
                        && response?.data != null
                    ) {

                        for (item in response.data.within3days) {
                            if (item.status == 0 && !AppCnfSpHelper.getInstance().isFriendsAddMessage) {

                                handler.post(Runnable {
                                    //                                UIUtils.showView(messagecenter_iv_unreadfriends)
                                })
                                return
                            }
                        }
                    }
                }

                override fun onFailure(statusCode: Int, errorMsg: String) {
                }
            })
    }
}