package com.ninexiu.sixninexiu.fragment.tencentim

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.fragment.BaseFragment
import android.view.View.OnClickListener
import androidx.recyclerview.widget.LinearLayoutManager
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.loopj.android.http.BaseJsonHttpResponseHandler
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.adapter.tencentIm.AddFriendsMessageAdapter
import com.ninexiu.sixninexiu.adapter.tencentIm.AddFriendsMessageAdapter.OnMessageItemClick
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.AddFriendsBean
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.common.ConfigSpHelper
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.fragment.tencentim.ImUserInfoFragment.IMSettingFragment
import com.ninexiu.sixninexiu.im.FriendListBean
import com.ninexiu.sixninexiu.im.IMUserInfoManager
import com.tencent.imsdk.*
import com.tencent.imsdk.TIMConversationType
import com.tencent.imsdk.TIMElemType.Custom
import com.tencent.imsdk.TIMManager
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.msg_addfriends_fragment.add_left_btn
import kotlinx.android.synthetic.main.msg_addfriends_fragment.addfriend_rl_right_tv
import kotlinx.android.synthetic.main.msg_addfriends_fragment.addfriend_title
import kotlinx.android.synthetic.main.msg_addfriends_fragment.friend_message_list
import kotlinx.android.synthetic.main.msg_addfriends_fragment.loading_layout
import kotlinx.android.synthetic.main.msg_addfriends_fragment.no_data
import kotlinx.android.synthetic.main.msg_addfriends_fragment.rl_tips
import kotlinx.android.synthetic.main.msg_addfriends_fragment.tv_close_tip
import kotlinx.android.synthetic.main.msg_addfriends_fragment.tv_to_setting

/**
 * author wangyu
 * date: on 2020/3/16
 * describe: 好友请求
 */
@Suppress("DEPRECATION") class TencentNewFriendsFragment : BaseFragment(), OnClickListener {

    private var rootView: View? = null
    private var addFriendsDatas: ArrayList<AddFriendsBean>? = null
    private var conversation: TIMConversation? = null
    private var addFriendsMessageAdapter: AddFriendsMessageAdapter? = null

    override fun inflate(inflater: LayoutInflater): View? {
        rootView = inflater?.inflate(R.layout.msg_addfriends_fragment, null)
        return rootView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        initData()
    }

    override fun onClick(v: View?) {
        when (v?.id) {

            R.id.tv_close_tip -> {
                rl_tips.visibility = View.GONE
                ConfigSpHelper.getInstance().friendSettingTips = false
            }

            R.id.tv_to_setting -> {
                val notifyIntent = Intent(activity, SubPageActivity::class.java)
                notifyIntent.putExtra(SubPageActivity.CLASSFRAMENT, IMSettingFragment::class.java)
                startActivity(notifyIntent)
            }

            R.id.add_left_btn -> {
                activity?.finish()
            }
        }
    }

    private fun initData() {
        addfriend_title.text = "好友请求"
        addfriend_rl_right_tv.visibility = View.VISIBLE
        addfriend_rl_right_tv.text = "清空"

        tv_close_tip.setOnClickListener(this)
        tv_to_setting.setOnClickListener(this)
        add_left_btn.setOnClickListener(this)

        addfriend_rl_right_tv.setOnClickListener {
            addFriendsDatas?.clear()
            addFriendsMessageAdapter?.notifyDataSetChanged()

            no_data.visibility = View.VISIBLE
            conversation?.deleteLocalMessage(object : TIMCallBack {
                override fun onError(i: Int, s: String) {
                }

                override fun onSuccess() {
                }
            })

        }


        if (ConfigSpHelper.getInstance().friendSettingTips) {
            rl_tips.visibility = View.VISIBLE
        } else {
            rl_tips.visibility = View.GONE
        }

        addFriendsDatas = ArrayList<AddFriendsBean>()

        friend_message_list?.layoutManager = LinearLayoutManager(activity)
        conversation = TIMManager.getInstance().getConversation(TIMConversationType.C2C, //会话类型：单聊
            "200000")




        conversation?.getMessage(Integer.MAX_VALUE, null, object : TIMValueCallBack<List<TIMMessage>> {
            override fun onError(i: Int, s: String) {
                no_data.visibility = View.VISIBLE
                loading_layout.visibility = View.GONE
            }

            override fun onSuccess(timMessages: List<TIMMessage>) {

                if (timMessages.isEmpty()) {
                    no_data.visibility = View.VISIBLE
                    return
                }

                var add = ArrayList<AddFriendsBean>()

                for (timMessage in timMessages) {
                    val element = timMessage.getElement(0)
                    when (element.type) {
                        Custom -> {
                            val element = element as TIMCustomElem
                            val desc = element.desc
                            val builder = GsonBuilder()
                            val gson = builder.create()
                            var result: AddFriendsBean? = null
                            try {
                                result = gson.fromJson<AddFriendsBean>(desc, AddFriendsBean::class.java)


                                add?.add(result)
                            } catch (e: Exception) {
                                e.printStackTrace()
                            }
                        }
                    }
                }




                addFriendsDatas?.addAll(filterList(add))



                fetchFriendsInfo()
            }
        })

        var conversation = TIMManager.getInstance().getConversation(
            TIMConversationType.C2C,    //会话类型：单聊
            "200000")                     //会话对方用户帐号
        //将此会话的所有消息标记为已读
        conversation.setReadMessage(null, object : TIMCallBack {
            override fun onSuccess() {
            }

            override fun onError(p0: Int, p1: String?) {
            }
        })
    }

    /**
     * 接受好友请求
     */
    private fun acceptRqeuest(dstId: String?) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        val params = NSRequestParams()
        params.put("srcuid", dstId)
        asyncHttpClient.post(Constants.ACCEPT_ADD_FRIEND, params, object : BaseJsonHttpResponseHandler<BaseResultInfo>() {
            override fun onSuccess(statusCode: Int, headers: Array<Header>?, rawJsonResponse: String,
                response: BaseResultInfo?) {
                if (response != null) {
                    if (response.code == 200 || response.code == 402) { //200添加成功 402已经是好友不能重复添加
                        initData() //重新获取本地消息刷新列表
                        if (activity != null) {
                            MyToast.MakeSysToast(activity, response.message)
                        }
                    } else {
                        if (activity != null) {
                            MyToast.MakeSysToast(activity, response.message)
                        }
                    }
                }
            }

            override fun onFailure(statusCode: Int, headers: Array<Header>?, throwable: Throwable, rawJsonData: String,
                errorResponse: BaseResultInfo?) {
                MyToast.MakeSysToast(NineShowApplication.applicationContext, "网络连接失败!")
            }

            override fun parseResponse(rawJsonData: String, isFailure: Boolean): BaseResultInfo? {
                val builder = GsonBuilder()
                val gson = builder.create()
                var resultInfo: BaseResultInfo?
                try {
                    resultInfo = gson.fromJson(rawJsonData, BaseResultInfo::class.java)
                } catch (e: JsonSyntaxException) {
                    resultInfo = null
                    e.printStackTrace()
                }

                return resultInfo
            }
        })
    }

    /**
     * 服务端获取列表
     */
    private fun fetchFriendsInfo() {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient.get(Constants.GET_FRIEND_LIST, null, object : BaseJsonHttpResponseHandler<FriendListBean>() {
            override fun onSuccess(statusCode: Int, headers: Array<Header>?, rawJsonResponse: String,
                response: FriendListBean?) {
                if (response != null && response.code == 200) {
                    val list = response.data.list
                    if (list != null) {
                        val friendList = IMUserInfoManager.getInstans().addFriends(list) //服务端好友数据
                        if (friendList != null && friendList?.size > 0) {
                            for (friend in friendList) {
                                addFriendsDatas?.forEach {
                                    if (friend.uid == it.user.id) {
                                        addFriendsDatas?.remove(it)
                                    }
                                }
                            }
                        }
                    }
                }

                addFriendsMessageAdapter = AddFriendsMessageAdapter(activity, addFriendsDatas)
                friend_message_list.adapter = addFriendsMessageAdapter
                loading_layout.visibility = View.GONE
                if (addFriendsDatas != null && addFriendsDatas!!.size > 0) {
                    no_data.visibility = View.GONE
                } else {
                    no_data.visibility = View.VISIBLE
                }

                //接受好友请求
                addFriendsMessageAdapter?.setOnMessageItemListener { dstId -> acceptRqeuest(dstId) }
            }

            override fun onFailure(statusCode: Int, headers: Array<Header>?, throwable: Throwable, rawJsonData: String,
                errorResponse: FriendListBean?) {
                MyToast.MakeSysToast(NineShowApplication.applicationContext, "网络连接出错!请重试!")
                addFriendsMessageAdapter = AddFriendsMessageAdapter(activity, addFriendsDatas)
                friend_message_list.adapter = addFriendsMessageAdapter

                //接受好友请求
                addFriendsMessageAdapter?.setOnMessageItemListener(object : OnMessageItemClick {
                    override fun acceptBtnClick(dstId: String?) {
                        acceptRqeuest(dstId)
                    }
                })

                loading_layout.visibility = View.GONE
            }


            override fun parseResponse(rawJsonData: String, isFailure: Boolean): FriendListBean? {
                val builder = GsonBuilder()
                val gson = builder.create()
                var info: FriendListBean?
                try {
                    info = gson.fromJson(rawJsonData, FriendListBean::class.java)
                } catch (e: JsonSyntaxException) {
                    info = null
                    MyToast.MakeSysToast(NineShowApplication.applicationContext, "好友列表数据解析出错")
                    e.printStackTrace()
                }

                return info
            }
        })
    }

    private fun filterList(items: List<AddFriendsBean>): List<AddFriendsBean> {
        val wis = java.util.ArrayList<AddFriendsBean>()
        for (w in items) {
            if (wis != null && wis.size > 0) {
                for (wi in wis) {
                    if (w.user.id != wi.user.id) {
                        wis.add(w)
                    }
                }
            } else {
                wis.add(w)
            }
        }
        return wis
    }
}