package com.ninexiu.sixninexiu.fragment.tencentim

import android.os.Bundle
import android.os.Handler
import android.view.LayoutInflater
import android.view.View
import android.widget.LinearLayout
import androidx.recyclerview.widget.LinearLayoutManager
import cn.thinkingdata.android.ScreenAutoTracker
import com.loopj.android.http.TextHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.tencentIm.SystemMessageAdapter
import com.ninexiu.sixninexiu.bean.IMSystemMessage
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.common.util.S11Helper
import com.ninexiu.sixninexiu.fragment.BaseFragment
import com.ninexiu.sixninexiu.lib.smartrefresh.api.RefreshLayout
import com.ninexiu.sixninexiu.lib.smartrefresh.listener.OnRefreshLoadMoreListener
import com.ninexiu.sixninexiu.push.GsonUtils
import com.ninexiu.sixninexiu.tencentim.UnreadMsgCountManager
import com.tencent.imsdk.TIMCallBack
import com.tencent.imsdk.TIMConversationType
import com.tencent.imsdk.TIMManager
import com.tencent.qcloud.tim.uikit.PushContants
import com.tencent.qcloud.tim.uikit.modules.conversation.ConversationManagerKit
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.msg_system_fragment.*
import kotlinx.android.synthetic.main.title_tab_bar.*
import kotlinx.android.synthetic.main.view_photopreview.view.*
import org.json.JSONObject
import java.lang.Exception
import java.util.*
import kotlin.collections.ArrayList

/**
 * author wangyu
 * date: on 2020/3/16
 * describe: 系统通知
 */
class TencentSystemFragment : BaseFragment(), OnRefreshLoadMoreListener , ScreenAutoTracker {
    override fun getScreenUrl(): String? {
        return null
    }

    override fun getTrackProperties(): JSONObject? {
        try {
            val properties = JSONObject()
            properties.put("entrance_page_id", "News-02")
            properties.put("entrance_page_name", "消息_对话页")
            return properties
        } catch (e: Exception) {
            // ignore
        }

        return null
    }

    private var rootView: View? = null
    private var systemDatas: ArrayList<IMSystemMessage.DataBean.ListBean>? = null
    private var page: Int = 1
    private var total: Int = 0
    private var systemAdapter: SystemMessageAdapter? = null
    private var layoutHeightIsAll:Boolean = true

    override fun inflate(inflater: LayoutInflater): View? {
        rootView = inflater?.inflate(R.layout.msg_system_fragment, null)
        return rootView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        title.text = activity?.getString(R.string.app_name)
        live_title_top.text = "系统消息"

        initData()
//        //动态设置 确保弹窗再播放器下方。
//            val layoutParams = system_content_layout.layoutParams as LinearLayout.LayoutParams
//            if (S11Helper.h5Heigght == 0 || layoutHeightIsAll) {
//                layoutParams.height = 0
//                layoutParams.weight = 5f
//            } else {
//                layoutParams.height = S11Helper.h5Heigght
//            }
//            system_content_layout.layoutParams = layoutParams
        getLastSystemPushMessage(true)
        PushContants.ISOPEANSYSTEM = true
    }

    override fun onLoadMore(refreshLayout: RefreshLayout) {
//        if ( total == systemDatas?.size){
//            refresh_layout.finishLoadMoreWithNoMoreData()
//            return
//        }
//        page++
//        getLastSystemPushMessage(false)
    }

    override fun onRefresh(refreshLayout: RefreshLayout) {
//        page =1
//        getLastSystemPushMessage(true)
        if (total == systemDatas?.size) {
            refresh_layout.finishRefresh()
            return
        }
        page++
        getLastSystemPushMessage(false)
    }

    private fun getLastSystemPushMessage(isRefresh: Boolean) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        var params = NSRequestParams()
        params.put("msgtype", "1")
        params.put("limit", "20")
        params.put("page", page)
        asyncHttpClient?.get(Constants.TPUSHMESSAGELIST, params, object : NSJsonResponseHandler<IMSystemMessage>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: IMSystemMessage?) {
                if (response?.code == 200) {
                    total = response?.data!!.total
                    if (isRefresh) {
                        systemDatas?.clear()
                    }
                    systemDatas?.addAll(response?.data!!.list)
                    systemAdapter?.notifyDataSetChanged()
                    if (systemDatas != null && systemDatas!!.size > 0) {
                        UnreadMsgCountManager.INSTANCE.setSystemMsgRead(systemDatas?.get(0)?.tm_id!!.toString())
                    }

                }
                if (isRefresh) {
                    refresh_layout?.finishRefresh()
                } else {
//                    refresh_layout?.finishLoadMore()
                    refresh_layout?.finishRefresh()
                }
                if (systemDatas?.size!! > 0) {
                    no_data?.visibility = View.GONE
                } else {
                    no_data?.visibility = View.VISIBLE
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

    private fun initData() {
        refresh_layout.setEnableLoadMore(false)
        refresh_layout.setOnRefreshLoadMoreListener(this)
        val layoutManager=LinearLayoutManager(context)
        sys_recycle?.layoutManager = layoutManager
        layoutManager.reverseLayout=true
        systemDatas = ArrayList()

        systemAdapter = SystemMessageAdapter(activity, systemDatas)
        sys_recycle.adapter = systemAdapter
        val bundle = arguments
        bundle?.let {
            layoutHeightIsAll = it.getBoolean("is_show_all_height",true)
        }
        var mType = bundle?.getInt("type")
        if (mType == 2){
            view_top?.visibility = View.VISIBLE
            view_title?.visibility = View.GONE
            live_viewtop?.visibility = View.VISIBLE
        }else{
            view_top?.visibility = View.GONE
            view_title?.visibility = View.VISIBLE
            live_viewtop?.visibility = View.GONE
        }

        iv_left?.setOnClickListener{
            val bundle = Bundle()
            bundle.putInt("chat_type", 2)
            AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_HIDE_MBLIVE_CHAT, bundle)
        }
    }


    override fun onDestroy() {
        super.onDestroy()
        PushContants.ISOPEANSYSTEM = false
    }
}