package com.ninexiu.sixninexiu.fragment.tencentim

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.LinearLayoutManager
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.loopj.android.http.BaseJsonHttpResponseHandler
import com.loopj.android.http.TextHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.TimPrivateSetAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.bean.ParsePrivateSetBean
import com.ninexiu.sixninexiu.bean.PrivateSetBean
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.fragment.BaseManagerFragment
import com.ninexiu.sixninexiu.fragment.BasePagerFragment
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.tim_privatesetting_layout.*
import kotlinx.android.synthetic.main.title_tab_bar.*
import org.json.JSONObject
import kotlin.jvm.Throws

/**
 * author wangyu
 * date: on 2020/04/24
 * describe: 私聊设置Fragment
 */

class TimPrivateSettingFragment : BaseManagerFragment() {

    private var datas: ArrayList<ParsePrivateSetBean>? = null
    private var adapter: TimPrivateSetAdapter? = null
    private var lastPosition: Int? = 0

    private var currentPosition :Int = 0


    override fun setLayoutId(): Int {
        return R.layout.tim_privatesetting_layout
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        datas = ArrayList()


        adapter = activity?.let { TimPrivateSetAdapter(it, datas!!) }
        tim_privateset_recycle?.layoutManager = LinearLayoutManager(activity)
        tim_privateset_recycle?.adapter = adapter
        var intent: Intent? = activity?.intent
        val extras = intent?.extras
        val type = extras?.getInt("type", 0)
        type?.let {
            if (it == 1){
                title?.text = "好友申请设置"
            }else if (it == 2){
                title?.text = "打招呼设置"
            }
            getAddFriendPermission(it) }
    }

    private fun getAddFriendPermission(type: Int) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient.post(Constants.GET_USER_ADD_PERMISSSION, null,
                object : NSJsonResponseHandler<PrivateSetBean>() {
                    override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: PrivateSetBean?) {

                        var jsonObject = JSONObject(rawJsonResponse)
                        val responceCode = jsonObject.optInt("code")
                        if (responceCode == 200) {
                            datas?.clear()


                            if (type == 1) {
                                val topData = response?.data?.get(0)
                                val data1 = topData?.data
                                for (i in 0 until data1?.size!! + 1) {
                                    var parseData = ParsePrivateSetBean()
                                    if (i == 0) {
                                        parseData?.title = topData?.title
                                    } else {
                                        parseData?.title = null
                                        parseData.index = data1[i - 1].index
                                        parseData.option = data1[i - 1].option
                                        parseData.optioname = data1[i - 1].optioname
                                        parseData.value = data1[i - 1].value
                                    }
                                    datas?.add(parseData)
                                }
                            } else if (type == 2) {
                                val secondData = response?.data?.get(1)
                                val data2 = secondData?.data
                                for (i in 0 until data2?.size!! + 1) {
                                    var parseData = ParsePrivateSetBean()
                                    if (i == 0) {
                                        parseData?.title = secondData?.title
                                    } else {
                                        parseData?.title = null
                                        parseData.index = data2[i - 1].index
                                        parseData.option = data2[i - 1].option
                                        parseData.optioname = data2[i - 1].optioname
                                        parseData.value = data2[i - 1].value
                                    }

                                    datas?.add(parseData)
                                }
                            }





                            datas?.let {
                                for (i in 0 until it.size) {
                                    if (it[i].value == 1){
                                        currentPosition = it[i].index
                                    }
                                }

                            }

                            adapter?.setOnItemClickListener(object : TimPrivateSetAdapter.OnItemClickListener {
                                override fun onItemClick(position: Int, onoff: Int) {
                                    if (currentPosition != position){
                                        setAddFriendPermission(type, position, onoff)
                                    }else{
                                        adapter?.notifyDataSetChanged()
                                    }
                                    currentPosition = position

                                }

                            })


                        }
                        adapter?.notifyDataSetChanged()
                    }

                    override fun onFailure(statusCode: Int, errorMsg: String?) {

                    }


                })
    }

    /**
     * 1=允许加好友(默认)，2=不允许别人加好友，3=仅限主播添加，4=5富以上可添加
     */
    private fun setAddFriendPermission(type: Int, position: Int, onoff: Int) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        val params = NSRequestParams()
        var onOroff: Int = 1
        if (onoff == 1) {
            onOroff = 2
        } else {
            onOroff = 1
        }

        if (type == 1) {
            var tempVaule = 0
            var secondVaule = 0
            for (i in 0 until adapter?.getData()?.size!! - 1) {
                if (adapter?.getData()!![i].value == 1) {
                    tempVaule++
                }
            }

            //取消这次点击效果(好友申请必须有一个选中)
            if ((onOroff == 2 && tempVaule < 2) && position < 7) {
                adapter?.notifyDataSetChanged()
                return
            }


            for (i in adapter?.getData()?.size!! - 4 until adapter?.getData()?.size!!) {
                if (adapter?.getData()!![i].value == 1) {
                    secondVaule++
                }
            }

            //取消这次点击效果(打招呼必须有一个选中)
            if ((onOroff == 2 && secondVaule < 2) && position >= 7) {
                adapter?.notifyDataSetChanged()
                return
            }
        }else if (type == 2){


            if (lastPosition == position){
                adapter?.notifyDataSetChanged()
                return
            }
            lastPosition = position

        }





        params.put("type", position)
        params.put("onoff", onOroff)



        asyncHttpClient.post(Constants.SET_USER_ADD_PERMISSSION, params,
                object : BaseJsonHttpResponseHandler<BaseResultInfo>() {


                    override fun onSuccess(statusCode: Int, headers: Array<Header>?, rawJsonResponse: String?,
                                           response: BaseResultInfo?) {

                        if (response != null) {
                            if (response.code == 200) {
                                MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置成功!")


                                if (type == 1) {
                                    when (position) {
                                        1 -> {
                                            for (i in 0 until adapter?.getData()?.size!!) {
                                                if (i == 1) {
                                                    adapter?.getData()!![1].value = 1
                                                } else {
                                                    adapter?.getData()!![i].value = 2
                                                }
                                            }
                                        }
                                        6 -> {
                                            for (i in 0 until adapter?.getData()?.size!!) {
                                                if (i == 6) {
                                                    adapter?.getData()!![6].value = 1
                                                } else {
                                                    adapter?.getData()!![i].value = 2
                                                }
                                            }
                                        }

                                        else -> {
                                            if (position in 2..5) {
                                                adapter?.getData()!![position].value = onOroff
                                            }

                                            for (i in 0 until adapter?.getData()?.size!!) {
                                                if (i == 1) {
                                                    adapter?.getData()!![1].value = 2
                                                } else if (i == 6) {
                                                    adapter?.getData()!![6].value = 2
                                                }
                                            }


                                        }
                                    }

                                } else if (type == 2) {
                                    for (i in 0 until adapter?.getData()?.size!!) {
                                        if (i == position - 6) {
                                            adapter?.getData()!![i].value = 1
                                        } else {
                                            adapter?.getData()!![i].value = 2
                                        }
                                    }
                                }


                                adapter?.notifyDataSetChanged()
                            } else {
                                MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置失败!")
                            }

                        } else {
                            MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置失败!")

                        }
                    }

                    override fun onFailure(statusCode: Int, headers: Array<Header>?, throwable: Throwable,
                                           rawJsonData: String?, errorResponse: BaseResultInfo?) {

                        MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置失败!网络错误!")

                    }

                    @Throws(Throwable::class)
                    override fun parseResponse(rawJsonData: String?, isFailure: Boolean): BaseResultInfo? {
                        val builder = GsonBuilder()
                        val gson = builder.create()
                        var resultInfo: BaseResultInfo? = null
                        try {
                            resultInfo = gson.fromJson(rawJsonData, BaseResultInfo::class.java)
                        } catch (e: JsonSyntaxException) {
                            e.printStackTrace()
                            resultInfo = null
                        }

                        return resultInfo
                    }
                })
    }

}