package com.ninexiu.sixninexiu.fragment.tencentim

import android.content.Intent
import android.os.Bundle
import android.view.View
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.fragment.BaseManagerFragment
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import com.ninexiu.sixninexiu.view.dialog.CurrencyDialog
import com.tencent.imsdk.TIMCallBack
import com.tencent.imsdk.TIMConversationType
import com.tencent.imsdk.TIMManager
import com.tencent.imsdk.TIMMessage
import com.tencent.imsdk.TIMValueCallBack
import com.tencent.qcloud.tim.uikit.modules.conversation.ConversationManagerKit
import kotlinx.android.synthetic.main.tim_setting_layout.*
import kotlinx.android.synthetic.main.title_tab_bar.*
import kotlin.Int.Companion

/**
 * author wangyu
 * date: on 2020/04/23
 * describe: IM设置Fragment
 */
class TimSettingFragment : BaseManagerFragment() {

    override fun setLayoutId(): Int {
       return R.layout.tim_setting_layout
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        title?.text = "设置"
        //清空本地会话
        tim_setting_tv_clearrecord?.setOnClickListener {
            activity?.let {
                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SETUP_CLEARALL)
                CurrencyDialog.create(it)
                    ?.setTitleText("将删除所有你与个人、主播的聊天记录")
                    ?.setOnClickCallback { type ->
                        if (type == BaseDialog.SELECT_SECOND) {
                            val conversationList = TIMManager.getInstance().conversationList
                            if (conversationList != null) {
                                for (timConversation in conversationList) {
                                    timConversation.deleteLocalMessage( object : TIMCallBack {
                                        override fun onError(i: Int, s: String) {

                                        }

                                        override fun onSuccess() {

                                        }
                                    })
                                    ConversationManagerKit.getInstance()?.deleteConversation(timConversation.peer, false)
                                }
                            }
                            AppBroadcastHelper.getInstance()
                                .sendBroadcast(NSReceiverAction.ACTION_CLEAR_ALLRECORD,
                                    NSDataBroadcast.TYPE_OPERATION_DEFAULT, null)
                            MyToast.MakeToast("清空会话成功了")
                            activity?.finish()
                        }
                    }
            }
        }
        tim_setting_rv_friendset?.setOnClickListener {
            StatisticsUtil.onEvent(StatisticsEventID.UM_IMSETTING_FRIENDS)
            openTypeSetting(1)
        }

        tim_setting_rv_greetset?.setOnClickListener {
            StatisticsUtil.onEvent(StatisticsEventID.UM_IMSETTING_GREET)
            openTypeSetting(2)
        }

    }

    /**
     * 打开不同的设置界面
     * 1好友申请设置，2打招呼设置，3语音通话设置
     */
    private fun openTypeSetting(type :Int){

        when(type){
            1->{
                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SETUP_FRIENDSET)
            }

            2->{
                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SETUP_GREETSET)
            }

//            3->{
//                StatisticsUtil.onEvent(StatisticsEventID.UM_IM_SETUP_VOICECALLSET)
//            }
        }

        if (type != 3){
            val imSettingIntent = Intent(activity, SubPageActivity::class.java)
            imSettingIntent.putExtra(SubPageActivity.CLASSFRAMENT, TimPrivateSettingFragment::class.java)
            val bundle = Bundle()
            bundle.putInt("type", type)
            imSettingIntent.putExtras(bundle)
            startActivity(imSettingIntent)
        }else{
//            val imSettingIntent = Intent(activity, SubPageActivity::class.java)
//            imSettingIntent.putExtra(SubPageActivity.CLASSFRAMENT, TimVoiceSettingFragment::class.java)
//            startActivity(imSettingIntent)
        }

    }
}