package com.ninexiu.sixninexiu.fragment.tencentim

import android.content.IntentFilter
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.loopj.android.http.BaseJsonHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.SubPageActivity
import com.ninexiu.sixninexiu.adapter.TimVoiceSetAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.bean.IsAllowListBean
import com.ninexiu.sixninexiu.bean.ParsePrivateSetBean
import com.ninexiu.sixninexiu.bean.VoiceSetBean
import com.ninexiu.sixninexiu.bean.VoiceUserSetBean
import com.ninexiu.sixninexiu.common.net.*
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.fragment.BaseManagerFragment
import com.ninexiu.sixninexiu.fragment.friend.VoiceFriendsListFragment
import cz.msebera.android.httpclient.Header
import kotlinx.android.synthetic.main.tim_voicesetting_layout.*
import kotlinx.android.synthetic.main.title_tab_bar.*
import org.json.JSONObject

/**
 * author wangyu
 * date: on 2020/08/04
 * describe: 语音通话设置Fragment
 */

class TimVoiceSettingFragment : BaseManagerFragment() {

    private var datas: ArrayList<ParsePrivateSetBean>? = null
    private var allowList: ArrayList<IsAllowListBean>? = null
    private var noAllowList: ArrayList<IsAllowListBean>? = null
    private var adapter: TimVoiceSetAdapter? = null
    private var isCanOpenFriend: Boolean? = false//是否可以打开好友列表

    private var currentPosition :Int = 0

    override fun setLayoutId(): Int {
        return R.layout.tim_voicesetting_layout
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        title?.text = "语音通话设置"
        datas = ArrayList()
        allowList = ArrayList()
        noAllowList = ArrayList()


        adapter = activity?.let { TimVoiceSetAdapter(it, datas!!, allowList!!, noAllowList!!) }
        tim_voiceset_recycle?.layoutManager = LinearLayoutManager(activity)
        tim_voiceset_recycle?.adapter = adapter
        getVoicePermission()
        getUserVoicePermission(0,0)
    }

    private fun getVoicePermission() {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient.post(Constants.POST_VOICECALL_SETTING, null,
                object : NSJsonResponseHandler<VoiceSetBean>() {
                    override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: VoiceSetBean?) {

                        var jsonObject = JSONObject(rawJsonResponse)
                        val responceCode = jsonObject.optInt("code")
                        if (responceCode == 200) {
                            datas?.clear()
                            val topData = response?.data
                            var parseData = ParsePrivateSetBean()
                            parseData.title = "语音通话设置"
                            datas?.add(parseData)
                            for (i in 0 until topData?.size!!) {
                                var parseData = ParsePrivateSetBean()
                                parseData.index = topData[i].index
                                parseData.option = topData[i].option
                                parseData.optioname = topData[i].optioname
                                parseData.value = topData[i].value
                                datas?.add(parseData)
                            }
                            adapter?.notifyDataSetChanged()
                            adapter?.setOnItemClickListener(object : TimVoiceSetAdapter.OnItemClickListener{
                                override fun onItemClick(position: Int, onoff: Int,name :String) {
                                    //允许部分人发起语音通话、不允许部分人发起语音通话
                                    if (TextUtils.equals(name,"allowPart") || TextUtils.equals(name,"notAllowPart")){
                                        isCanOpenFriend?.let {
                                            if(it!!){
                                                val bundle = Bundle()
                                                bundle.putString("showType", name)
                                                bundle.putParcelableArrayList("allowList", allowList)
                                                bundle.putParcelableArrayList("noAllowList", noAllowList)
                                                SubPageActivity.start(activity, bundle, VoiceFriendsListFragment::class.java)
                                            }
                                        }
                                    }
                                }

                            })

                            datas?.let {
                                for (i in 0 until it.size) {
                                    if (it[i].value == 1){
                                        currentPosition = it[i].index
                                    }
                                }

                            }

                            adapter?.setOnCheckClickListener(object : TimVoiceSetAdapter.OnCheckClickListener{
                                override fun onCheckClick(position: Int, onoff: Int, name: String) {
                                    if (currentPosition != position){
                                        setAddFriendPermission(position,onoff)
                                    }else{
                                        adapter?.notifyDataSetChanged()
                                    }
                                    currentPosition = position
                                }

                            })
                        }

                    }

                    override fun onFailure(statusCode: Int, errorMsg: String?) {

                    }


                })
    }

    private fun getUserVoicePermission(type: Int,position: Int) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient.post(Constants.POST_VOICECALL_USERSETTING, null,
                object : NSJsonResponseHandler<VoiceUserSetBean>() {
                    override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: VoiceUserSetBean?) {

                        var jsonObject = JSONObject(rawJsonResponse)
                        val responceCode = jsonObject.optInt("code")
                        if (responceCode == 200) {
                            allowList?.clear()
                            noAllowList?.clear()
                            isCanOpenFriend = true

                            response?.data?.allowList?.let { allowList?.addAll(it) }
                            response?.data?.noAllowList?.let { noAllowList?.addAll(it) }
                            adapter?.notifyDataSetChanged()
                            if (type == 1) {
                                adapter = activity?.let { TimVoiceSetAdapter(it, datas!!, allowList!!, noAllowList!!) }
                                tim_voiceset_recycle?.layoutManager = LinearLayoutManager(activity)
                                tim_voiceset_recycle?.adapter = adapter

                                adapter?.setOnItemClickListener(object : TimVoiceSetAdapter.OnItemClickListener{
                                    override fun onItemClick(position: Int, onoff: Int,name :String) {
                                        //允许部分人发起语音通话、不允许部分人发起语音通话
                                        if (TextUtils.equals(name,"allowPart") || TextUtils.equals(name,"notAllowPart")){
                                            isCanOpenFriend?.let {
                                                if(it!!){
                                                    val bundle = Bundle()
                                                    bundle.putString("showType", name)
                                                    bundle.putParcelableArrayList("allowList", allowList)
                                                    bundle.putParcelableArrayList("noAllowList", noAllowList)
                                                    SubPageActivity.start(activity, bundle, VoiceFriendsListFragment::class.java)
                                                }
                                            }
                                        }
                                    }

                                })

                                adapter?.setOnCheckClickListener(object : TimVoiceSetAdapter.OnCheckClickListener{
                                    override fun onCheckClick(position: Int, onoff: Int, name: String) {
                                        if (currentPosition != position){
                                            setAddFriendPermission(position,onoff)
                                        }else{
                                            adapter?.notifyDataSetChanged()
                                        }
                                        currentPosition = position
                                    }

                                })

                                setAddFriendPermission(position, 2)
                            }
                        }else{
                            isCanOpenFriend = false
                        }

                    }

                    override fun onFailure(statusCode: Int, errorMsg: String?) {
                        isCanOpenFriend = false
                    }


                })
    }

    /**
     * 1=允许加好友(默认)，2=不允许别人加好友，3=仅限主播添加，4=5富以上可添加
     */
    private fun setAddFriendPermission( position: Int, onoff: Int) {
        val asyncHttpClient = NsOkHttpClient.getNsOkHttpClient()
        val params = NSRequestParams()
        var onOroff: Int = 1
        if (onoff == 1) {
            onOroff = 2
        } else {
            onOroff = 1
        }

        params.put("type", position)
        params.put("onoff", onOroff)

        asyncHttpClient.doPost(Constants.POST_VOICECALL_SETIMVOICE, params,
                object : NSGsonObjectCallback<BaseResultInfo>() {
                    override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: BaseResultInfo?) {
                        if (response != null) {
                            if (response.code == 200) {
                                MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置成功!")
                                for (i in 0 until adapter?.getData()?.size!!) {
                                    if (i == position) {
                                        adapter?.getData()!![i].value = 1
                                    } else {
                                        adapter?.getData()!![i].value = 2
                                    }
                                }
                                adapter?.notifyDataSetChanged()
                            } else {
                                MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置失败!")
                            }

                        } else {
                            MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置失败!")

                        }
                    }

                    override fun onFailure(statusCode: Int, errorMsg: String?) {
                        MyToast.MakeSysToast(NineShowApplication.applicationContext, "设置失败!网络错误!")
                    }

                })
    }

    override fun registerReceiver(): Boolean {
        return true
    }

    override fun setBroadcastFilter(filter: IntentFilter) {
        super.setBroadcastFilter(filter)
        filter.addAction(NSReceiverAction.ACTION_VOICESETTING_REFERSH)

    }

    override fun onReceive(action: String, type: Int, bundle: Bundle) {
        super.onReceive(action, type, bundle)
        if (action == NSReceiverAction.ACTION_VOICESETTING_REFERSH) {//所有已读
            val position = bundle.getInt("position")
            getVoicePermission()
            getUserVoicePermission(1,position)


        }
    }

}