package com.ninexiu.sixninexiu.mvp

import android.os.Bundle
import com.ninexiu.sixninexiu.activity.BaseActivity
import java.lang.reflect.ParameterizedType

abstract class MVPBaseActivity<V : BaseView<*>, T : BasePresenterImpl<V>> : BaseActivity() {
    public var mPresenter: T? = null

    init {

    }

    companion object {
        private val TAG = "MVPBaseActivity"
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        mPresenter = getInstance<T>(this, 1)
        mPresenter?.attachView(this as V)
        super.onCreate(savedInstanceState)
    }
    protected fun <T> getInstance(o: Any, i: Int): T? {
         try {
             return ((((o::class.java.genericSuperclass) as ParameterizedType).actualTypeArguments[i]) as Class<T>).newInstance()
        } catch (e:InstantiationException) {
            e.printStackTrace()
        } catch (e:IllegalAccessException) {
             e.printStackTrace()
        } catch (e:ClassCastException) {
             e.printStackTrace()
        }
        return null
    }

    override fun onDestroy() {
        super.onDestroy()
        if (mPresenter != null)
            mPresenter?.detachView()
    }
}
