package com.ninexiu.sixninexiu.mvp

import android.os.Bundle
import com.ninexiu.sixninexiu.common.util.NSLogger
import com.ninexiu.sixninexiu.fragment.discovery.BaseViewFragment
import java.lang.reflect.ParameterizedType

abstract class MVPBaseFragment<V : BaseView<*>, T : BasePresenterImpl<V>> :  BaseViewFragment(){
    public var mPresenter: T? = null

    init {

    }

    companion object {
        private val TAG = "MVPBaseFragment"

    }

    override fun onCreate(savedInstanceState: Bundle?) {
        mPresenter = getInstance<T>(this, 1)
        mPresenter?.attachView(this as V)
        super.onCreate(savedInstanceState)
    }
    protected fun <T> getInstance(o: Any, i: Int): T? {
        try {
            return ((((o::class.java.genericSuperclass) as ParameterizedType).actualTypeArguments[i]) as Class<T>).newInstance()
            NSLogger.d(TAG," ParameterizedType---- ${o::class.java.genericSuperclass} ----" +
                    "simpleName----${((((o::class.java.genericSuperclass) as ParameterizedType)
                            .actualTypeArguments[i]) as Class<T>)::class.java.simpleName}")
        } catch (e: java.lang.InstantiationException) {
            e.printStackTrace()
        } catch (e:IllegalAccessException) {
            e.printStackTrace()
        } catch (e:ClassCastException) {
            e.printStackTrace()
        }
        return null
    }

    override fun onDestroy() {
        super.onDestroy()
        if (mPresenter != null)
            mPresenter?.detachView()
    }
}