package com.ninexiu.sixninexiu.view

import android.animation.AnimatorSet
import android.content.Context
import android.util.AttributeSet
import android.widget.Scroller
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.common.util.AnimatorUtils

/**
 * @Description:     发现页Tab
 * @Author:          liuguangyu
 * @date  :     2019/5/22 18:20
 * @Version:
 */
class DiscoveryPagerTipsTabSrip @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : PagerTipsTabStrip(context, attrs, defStyleAttr) {
    private val mScroller = Scroller(context)

    /**
     * 过渡动画 区分选中 未选中
     * @param position
     */
    fun tipsScroll(position: Int) {
        //当前选中Tab
        val childAt = tabsContainer.getChildAt(position)
        val count = tabsContainer.childCount
        var animatorSetNormal = AnimatorUtils.changeTabNormal(childAt)
        var animatorSetSelect =AnimatorUtils.changeTabSelect(childAt)
        //遍历所有Tab
        for (i in 0 until count) {
            //Tab中的View
            val view = tabsContainer.getChildAt(i)
            //未选中
            if (childAt !== view) {
                childAt.isSelected = false
                animatorSetNormal.start()
            } else {
                //选中
                childAt.isSelected = true
                animatorSetSelect.start()
            }
        }
    }
    fun tipScrollNew(position: Int) {
        if(tabsContainer == null || position >= tabsContainer.childCount) {
            return
        }
        for(index in 0 until tabsContainer.childCount) {
            val child = tabsContainer.getChildAt(index)
            if(position == index) {
                var animatorSetSelect = AnimatorUtils.changeTabSelect(child)
                animatorSetSelect.start()
            }else{
                var animatorSetNormal = AnimatorUtils.changeTabNormal(child)
                animatorSetNormal.start()
            }
        }
    }

    private val widthScreen: Int by lazy {
        context.resources.displayMetrics.widthPixels
    }

    private var reverse : Boolean = false
    private var isAutoScroll : Boolean = false
    fun startScroll(reverse: Boolean = false) {  // 传入false
        this.reverse = reverse
        isAutoScroll = true
        /*if (childCount <= 3) {
            return
        }*/

        // 滑动距离
        val dis = if (reverse) {
            -(measuredWidth - widthScreen / 3)      // 向右滑动
        } else {
            (measuredWidth - widthScreen / 3)       // 向左滑动
        }

        mScroller.startScroll(scrollX, 0, dis, 0)
        invalidate()
    }

    override fun computeScroll() {
        if(!isAutoScroll) {
            super.computeScroll()
        }else {
            if(mScroller.computeScrollOffset()) {
                scrollTo(mScroller.currX, mScroller.currY)
                invalidate()
            }else {
                reverse = !reverse
                if(reverse){
                    postDelayed({ startScroll(true)},1000)
                }else {
                    isAutoScroll = false
                }
            }
        }
    }


}
