package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.MotionEvent
import androidx.core.widget.NestedScrollView

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/04/01
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class DynamicNestedScrollView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : NestedScrollView(context, attrs, defStyleAttr) {
    var onScrollViewClick: (() -> Unit)? = null     // 让外界键盘消失
    override fun dispatchTouchEvent(ev: MotionEvent?): Boolean {
        when (ev?.action) {
            MotionEvent.ACTION_DOWN -> {
                onScrollViewClick?.invoke()
            }
        }
        return super.dispatchTouchEvent(ev)
    }
}
