package com.ninexiu.sixninexiu.view

import android.content.Context
import android.text.TextUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.ShareUtils
import com.ninexiu.sixninexiu.view.dialog.BaseDialog
import kotlinx.android.synthetic.main.dialog_dynamic_share.*
import org.jetbrains.anko.displayMetrics

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/23
 *     desc   : 动态分享
 *     version: 1.0
 * </pre>
 */
class DynamicShareDialog(context: Context,val uid: String, private val onShareItemClick: ((String) -> Unit)? = null) : BaseDialog(context) {
    companion object {
        const val TYPE_DYNAMIC_JUBAO = "type_dynamic_jubao"
        const val TYPE_DYNAMIC_BLACK = "type_dynamic_black"
        const val TYPE_DYNAMIC_DELETE = "type_dynamic_delete"
    }

    override fun initView() {
        super.initView()
        tvJuBao.post {
            val itemWidth = (widthScreen - dp2px(context, 32)) / 5
            fitterViewSize(tvJuBao, { itemWidth })
            fitterViewSize(tvBlack, { itemWidth })
            fitterViewSize(tvDelete, { itemWidth })
            fitterViewSize(tvFriend, { itemWidth })
        }

        val baseInfo = NineShowApplication.mUserBase
        baseInfo?.uid?.let {
            if(TextUtils.equals(it.toString(),uid)) {
                tvDelete.setVisible(true)
                tvJuBao.setVisible(false)
                tvBlack.setVisible(false)
            }else {
                tvDelete.setVisible(false)
                tvJuBao.setVisible(true)
                tvBlack.setVisible(true)
            }
        }

        // 九秀好友
        tvFriend.setOnClickListener {
            StatisticsUtil.onEvent(StatisticsEventID.UM_DYNAMIC_SHARE)
            onShareItemClick?.invoke(ShareUtils.TYPE_NINESHOW)
            dismiss()
        }
        // 举报
        tvJuBao.setOnClickListener {
            onShareItemClick?.invoke(TYPE_DYNAMIC_JUBAO)
            dismiss()
        }
        // 拉黑
        tvBlack.setOnClickListener {
            onShareItemClick?.invoke(TYPE_DYNAMIC_BLACK)
            dismiss()
        }
        // 删除
        tvDelete.setOnClickListener {
            onShareItemClick?.invoke(TYPE_DYNAMIC_DELETE)
            dismiss()
        }
    }

    override fun isBottom() = true

    override fun getContentView() = R.layout.dialog_dynamic_share

    private val widthScreen: Int by lazy {
        context.displayMetrics.widthPixels
    }
}