package com.ninexiu.sixninexiu.view

import android.content.Context
import android.text.Html
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AdvertiseActivity
import com.ninexiu.sixninexiu.bean.GiftInfo
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.GiftPicDownManage.Companion.get
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.manager.RequestManager
import kotlinx.android.synthetic.main.view_blind_box_gift.view.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2021/07/07
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class GiftBlindBoxView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_blind_box_gift, this)
    }

    fun setBlindGift(info: GiftInfo?, type: Int) {
        if (info != null) {
            visibility = View.VISIBLE
            tv_blind_box_name?.text = info.name
            val v = get().getSvgaUpdate("" + info.gid)
            val build:SpannableStringBuilder
            if (info.gid == 2000731) {//2000731银星盒
                build=SpannableStringBuilder("有机会出大烟花和隐藏款")
                build.setSpan(ForegroundColorSpan(ContextCompat.getColor(context,R.color.color_80ffc651)), 4, 7, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                tv_blind_box_remind?.text=build
                iv_blind_box?.setImageResource(R.drawable.icon_8years_box_sliver)
            } else if (info.gid == 2000732) {//2000732金星盒
                build=SpannableStringBuilder("有机会出守护星球和隐藏款")
                build.setSpan(ForegroundColorSpan(ContextCompat.getColor(context,R.color.color_80ffc651)), 4, 8, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
                tv_blind_box_remind?.text=build
                iv_blind_box?.setImageResource(R.drawable.icon_8years_box_gold)
            }
        } else {
            visibility = View.INVISIBLE
        }

        // type:1 视频房间  2：语音房间
        iv_blind_box_help?.setOnClickListener {
            AdvertiseActivity.start(context, false, "https://www.9xiu.com/activity/ac2021/AutumnAnchor/Introduction.html?type=" + type)
        }

    }
}