package com.ninexiu.sixninexiu.view

import android.content.Context
import android.text.Html
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AdvertiseActivity
import com.ninexiu.sixninexiu.bean.GiftInfo
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.GiftPicDownManage.Companion.get
import com.ninexiu.sixninexiu.common.util.GlideUtils
import kotlinx.android.synthetic.main.view_suit_gift.view.*

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/12
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class GiftSuitGiftView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_suit_gift, this)
    }

    fun setSuitGiftVGift(info: GiftInfo?) {
        if (info != null) {
            visibility = View.VISIBLE
            val v = get().getSvgaUpdate("" + info.gid)
            GlideUtils.loadDiskImg(context, Constants.LIVE__ROOM_GIFT_URL + info.gid + ".png?v=" + v, iv_suit_gift, R.drawable.icon_gift_default)
            if (info.gid == 2000724) {//2000724豪华
                tv_suit_gift.text="豪华套装"
                tv_suit_gift_remind?.text = "内含10种超豪华礼物，"
                suit_gift_bg.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_b3844800)
                tv_suit_gift_remind_color.setTextColor(ContextCompat.getColor(context, R.color.color_ffc744))
            } else if (info.gid == 2000725) {//2000725超浪漫
                tv_suit_gift.text="恋爱套装"
                suit_gift_bg.delegate.backgroundColor = ContextCompat.getColor(context, R.color.color_b37f001a)
                tv_suit_gift_remind?.text = "内含5种超浪漫礼物，"
                tv_suit_gift_remind_color.setTextColor(ContextCompat.getColor(context, R.color.color_ffaec3))
            }
        } else {
            visibility = View.INVISIBLE
        }

    }
}