package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Color
import android.graphics.drawable.AnimationDrawable
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.RelativeLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.AnchorInfo
import com.ninexiu.sixninexiu.bean.SubLabelsAnchor
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.HomeHotHelper
import com.ninexiu.sixninexiu.common.util.HomeHotHelper.formatViewerCountNew
import com.ninexiu.sixninexiu.common.util.Utils
import kotlinx.android.synthetic.main.fragement_discovery_child_family_adapter_item.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/01
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class HomeHotAnchorItemView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : RelativeLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.item_hot, this)
    }

    private var mImageViewHeight = -10

    private val widthScreen: Int by lazy {
        context.resources?.displayMetrics?.widthPixels ?: 0
    }

    fun setAnchor(info: AnchorInfo?, index: Int, onClick: ((AnchorInfo) -> Unit)? = null) {
        setAnchor(info, onClick)

        // 设置间距
        if (index % 2 == 0) { // 左边
            this.setPadding(dp2px(context,7f),0, dp2px(context,3.5f),0)
        } else {
            this.setPadding(dp2px(context,3.5f),0, dp2px(context,7f),0)
        }
    }

    fun setAnchor(info: AnchorInfo?, onClick: ((AnchorInfo) -> Unit)? = null) {
        if (info == null) {
            this.visibility = View.GONE
            return
        }

        this.visibility = View.VISIBLE

        // 设置宽度
        /* val params = this.layoutParams
         params.width = (widthScreen - dp2px(context, 7)) / 2
         this.layoutParams = params*/

        setOnClickListener {
            onClick?.invoke(info)
        }

        setAnchorInfo(info)
    }

    // 设置主播数据
    @SuppressLint("SetTextI18n")
    private fun setAnchorInfo(info: AnchorInfo) {
        val (first,second,three) = formatViewerCountNew(context,info.status,info.usercount,info.fanscount)
        first?.let { anchor_count.typeface = it }
        anchor_count.text = second
        tvAnchorSuffix.text = "${three?:""}人观看"

        anchor_name.text = HomeHotHelper.getUserName(info.nickname)

        recommend_anthor_leftTag.setVisible(false)

        // 设置 666 和 999 房间
        if (info.uid.equals("666") || info.uid.equals("999")) {
            recommend_anthor_leftTag.setVisible(true)
            recommend_anthor_leftTag.setBackgroundResource(if (info.uid.equals("666")) {
                R.drawable.fragment_live_666_icon
            } else {
                R.drawable.fragment_live_999_icon
            })

            iv_room_Tag.setVisible(false)
            tv_left_name.setVisible(false)
        }

        // 设置右边
        val rightLable: SubLabelsAnchor? = info.subTag
        if (rightLable != null) {
            val school_name = rightLable.name
            val tagImg = rightLable.tagImg

            if (!tagImg.isNullOrBlank()) {
                iv_left_sublabels.setVisible(true)
                tv_school_name.setVisible(false)
                GlideUtils.loadNormalImg(context, tagImg, iv_left_sublabels)
            } else if (!school_name.isNullOrBlank()) {
                iv_left_sublabels.setVisible(false)
                tv_school_name.setVisible(true)
                tv_school_name.text = school_name
            }
        } else {
            iv_left_sublabels.setVisible(false)
            tv_school_name.setVisible(false)
        }

        // 设置左边
        val leftLable: SubLabelsAnchor? = info.mainTag
        if (recommend_anthor_leftTag.visibility != View.VISIBLE && leftLable != null) {
            val school_name = leftLable.name
            val tagImg = leftLable.tagImg

            if (!tagImg.isNullOrBlank()) {
                iv_room_Tag.setVisible(true)
                tv_left_name.setVisible(false)
                if (info.tagId == 2) {       // 周星需要单独使用本地的帧动画处理
                    iv_room_Tag.setBackgroundResource(R.drawable.animation_week_star)
                    val animation: AnimationDrawable? = iv_room_Tag.background as? AnimationDrawable
                    animation?.start()
                } else {
                    iv_room_Tag.background = null
                    GlideUtils.loadNormalImg(context, tagImg, iv_room_Tag)
                }
            } else if (!school_name.isNullOrBlank()) {
                tv_left_name.text = school_name
                tv_left_name.delegate.backgroundColor = Color.parseColor(leftLable.color)
                iv_room_Tag.setVisible(false)
                tv_left_name.setVisible(true)
            } else {
                iv_room_Tag.setVisible(false)
                tv_left_name.setVisible(false)
            }

        } else {
            iv_room_Tag.setVisible(false)       // mRoomTagIcon
            tv_left_name.setVisible(false)      // mRoomTagTv
        }

        // 条目大小
        val params = icon.layoutParams
        if (params.height != mImageViewHeight) {
            mImageViewHeight = Utils.getHallAnchorIconHeight(context)
            params.height = mImageViewHeight
            icon.layoutParams = params
        }

        // 主播封面
        if (icon.tag == null || !icon.tag.equals(info.phonehallposter)) {
            GlideUtils.loadDiskImg(context, info.phonehallposter, icon, R.drawable.anthor_moren_item)
            icon.tag = info.phonehallposter
        }
    }


}