package com.ninexiu.sixninexiu.view

import android.content.Context
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import com.ninexiu.sixninexiu.common.util.NSLog

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/08
 *     desc   : 不规则样式的G ridLayoutManager
 *     version: 1.0
 * </pre>
 */
class IrRegularGridLayoutManager(val context: Context, spanCount: Int) : GridLayoutManager(context, spanCount) {
    companion object {
        private const val Tag = "UserReturnGridLayoutManager >> "
    }

    // 针对5个样式重新layout
    override fun layoutDecoratedWithMargins(child: View, left: Int, top: Int, right: Int, bottom: Int) {
        NSLog.d(Tag, "$childAllCount ... ${getPosition(child)}")
        when (childAllCount) {
            5 -> {
                if (getPosition(child) < 3) {
                    super.layoutDecoratedWithMargins(child, left, top, right, bottom)
                } else {
                    val leftTem = left + child.measuredWidth / 2
                    val rightTem = right + child.measuredWidth / 2
                    // 设置特定的样式
                    super.layoutDecoratedWithMargins(child, leftTem, top, rightTem, bottom)
                }
            }
            else -> super.layoutDecoratedWithMargins(child, left, top, right, bottom)
        }
    }

    private var childAllCount = 0

    // 拿不到准确的条目个数，因为是在不断的添加
    fun setChildAllCount(count: Int) {
        childAllCount = count
    }

    fun dp2px(dp: Int) = (context.resources.displayMetrics.density * dp).toInt()
}