package com.ninexiu.sixninexiu.view

import android.content.Context
import android.text.TextUtils
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.common.util.NSLog
import java.io.File

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/02
 *     desc   : 直播间主播的 一元AR礼物购买
 *     version: 1.0
 * </pre>
 */
object MBLiveAlphaVideoHelper {
    const val Tag = "MBLiveAlphaVideoHelper >> :"

    // 获取文件名
    fun getFileName(): String? {
        val fileName = NineShowApplication.arAgencyAnchorAvatar
        if (TextUtils.isEmpty(fileName)) {
            return null
        }
        var index = fileName.lastIndexOf("/")
        if (index < 0) {
            return null
        }

        return if(index + 1 < fileName.length) {
            NSLog.d(Tag, "file name is : ${fileName.substring(index+1)}")
            fileName.substring(index+1)
        }else {
            null
        }
    }

    // 创建保存文件的路径 ： 1. 先取外部存储私有路径   2. 内部存储路径
    fun getAlphaVideoFileDir(context: Context): String {
        return context.cacheDir.path
    }

    // 判断文件是否已经存在(获取文件地址)
    fun isVideoFileExit(context: Context): String? {
        if (TextUtils.isEmpty(getFileName())) {
            return null
        }
        val file = File(getAlphaVideoFileDir(context), getFileName())
        if (file.exists() && file.length() > 0) {
            return file.absolutePath
        }
        return null
    }


    // 获取下载地址 (todo : 先写死[后台未配置])
    fun getVideoDownLoadUrl(): String? {
        // https://img.img.9xiu.com/resource/mobile/liveAr/ar_1.mp4
        NSLog.d(Tag, "down load url : ${NineShowApplication.arAgencyAnchorAvatar ?: "empty"}")
        if (TextUtils.isEmpty(NineShowApplication.arAgencyAnchorAvatar)) {
            return null
        }
        return NineShowApplication.arAgencyAnchorAvatar
    }

}