package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Color
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.ImageView
import android.widget.RelativeLayout
import androidx.core.content.ContextCompat
import com.makeramen.roundedimageview.RoundedImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.NSLog
import kotlinx.android.synthetic.main.fragment_real_love_fans.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/08/30
 *     desc   : 头像重叠样式通用组件
 *     version: 1.0
 * </pre>
 */
@SuppressLint("Recycle")
class MultiplyImageView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : RelativeLayout(context, attrs, defStyleAttr) {
    private val ivWidth: Int
    private val strokeWidth: Int
    private val margin: Int
    private val strokeColor: Int

    init {
        val attr = context.obtainStyledAttributes(attrs, R.styleable.MultiplyImageView)
        ivWidth = attr.getDimension(R.styleable.MultiplyImageView_multiply_width, 60f).toInt()
        strokeWidth = attr.getDimension(R.styleable.MultiplyImageView_multiply_stroke_width, 2f).toInt()
        margin = attr.getDimension(R.styleable.MultiplyImageView_multiply_margin, 40f).toInt()
        strokeColor = attr.getColor(R.styleable.MultiplyImageView_multiply_stoke_color, Color.WHITE)
        attr.recycle()
    }

    // 高度 & margin  & 边框宽度 & 边框颜色

    fun addTheMultiplySingleView(url: String?) {
        if (url.isNullOrBlank()) {
            return
        }

        val iv = createIv()
        addView(iv)

        GlideUtils.loadGaussianCirclePic(context,url,iv)
    }

    private fun createIv(): ImageView {
        val iv = RoundedImageView(context)
        var width = ivWidth - 2 * strokeWidth
        if (this.childCount > 0) {
            iv.borderColor = strokeColor
            iv.borderWidth = strokeWidth.toFloat()
            iv.cornerRadius = ( ivWidth / 2).toFloat()
            width = ivWidth
        }

        val params = LayoutParams(width, width)
        params.addRule(CENTER_VERTICAL)
        params.marginStart =childCount * margin
        iv.layoutParams = params

        return iv
    }

    fun clear() {
        removeAllViews()
    }

}