package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.view_person_center_item.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/06
 *     desc   : 个人主页item
 *     version: 1.0
 * </pre>
 */
@SuppressLint("Recycle")
class PersonCenterItemView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_person_center_item, this)

        val att = context.obtainStyledAttributes(attrs, R.styleable.PersonCenterItemView)
        val title = att.getText(R.styleable.PersonCenterItemView_android_text)
        val img = att.getResourceId(R.styleable.PersonCenterItemView_android_src, -1)
        val showToggle = att.getBoolean(R.styleable.PersonCenterItemView_show_toggle, false)
        val showArrow = att.getBoolean(R.styleable.PersonCenterItemView_show_arrow, true)
        val show_divider = att.getBoolean(R.styleable.PersonCenterItemView_show_divider, true)

        if(img != -1) {
            ivIcon.setImageResource(img)
        }

        title?.let {
            tvTitle.text = it
        }

        toggleBt.setVisible(showToggle)
        ivArrow.setVisible(showArrow)
        viewDivider.setVisible(show_divider)
        att.recycle()

        post {
            // 统一设置间距
            this.setPadding(dp2px(context,14),0, dp2px(context,11),11)
        }
    }

    fun setDividerVisible(visible: Boolean) {
        viewDivider?.setVisible(visible)
    }

    fun setDotVisible(visible : Boolean){
        ivRemindDot?.setVisible(visible)
    }

    fun setTimeOver(visible: Boolean, overContent: String = "") {
        tvRemindTimeOver?.setVisible(visible)
        tvRemindTimeOver?.text = overContent
    }

    // 点击事件
    fun setOnclickItem(click : ()->Unit) {
        // todo : 统一判断登录

        click.invoke()
    }
}