package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.HomeHotHelper
import kotlinx.android.synthetic.main.view_person_center_friend_item.view.*
import kotlinx.android.synthetic.main.view_person_center_friend_item.view.tvName

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/06
 *     desc   : 个人主页item
 *     version: 1.0
 * </pre>
 */
@SuppressLint("Recycle")
class PersonFriendItemView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_person_center_friend_item, this)

        val att = context.obtainStyledAttributes(attrs, R.styleable.PersonFriendItemView)
        val name = att.getText(R.styleable.PersonFriendItemView_android_text)

        tvName.text = name
        att.recycle()
    }

    fun setNumber(theNumber: Int?) {
        val typeface = HomeHotHelper.getTypeFace(context)
        typeface?.let { tvNumber?.typeface = it }
        tvNumber.text = (theNumber ?: 0).toString()
    }

    fun setDotVisible(visible : Boolean){
        ivRemindDot?.setVisible(visible)
    }


    // 点击事件
    fun setOnclickItem(click : ()->Unit) {
        // todo : 统一判断登录

        click.invoke()
    }
}