package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.view_person_center_item.view.*
import kotlinx.android.synthetic.main.view_person_center_shop_item.view.*
import kotlinx.android.synthetic.main.view_person_center_shop_item.view.ivRemindDot

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/06
 *     desc   : 个人主页item
 *     version: 1.0
 * </pre>
 */
@SuppressLint("Recycle")
class PersonShopItemView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_person_center_shop_item, this)

        val att = context.obtainStyledAttributes(attrs, R.styleable.PersonShopItemView)
        val name = att.getText(R.styleable.PersonShopItemView_android_text)
        val src = att.getResourceId(R.styleable.PersonShopItemView_android_src,-1)

        if(src != -1) {
            ivTop.setImageResource(src)
        }

        tvName.text = name
        att.recycle()
    }

    fun setDotVisible(visible : Boolean){
        ivRemindDot?.setVisible(visible)
    }


    // 点击事件
    fun setOnclickItem(click : ()->Unit) {
        // todo : 统一判断登录

        click.invoke()
    }
}