package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.HomeHotHelper
import kotlinx.android.synthetic.main.view_person_center_shop_item.view.*
import kotlinx.android.synthetic.main.view_person_center_wealth_item.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/06
 *     desc   : 个人主页item
 *     version: 1.0
 * </pre>
 */
@SuppressLint("Recycle")
class PersonWealthItemView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_person_center_wealth_item, this)

        val att = context.obtainStyledAttributes(attrs, R.styleable.PersonWealthItemView)
        val title = att.getText(R.styleable.PersonWealthItemView_wealth_title)
        val category = att.getText(R.styleable.PersonWealthItemView_wealth_category)

        tvTitle.text = title
        tvCategory.text = category

        att.recycle()
    }

    fun setWealth(count: String?,suffix : String?, showTitle: Boolean = true, showFirstRecharge: Boolean = false) {
        val typeFace = HomeHotHelper.getTypeFace(context)
        typeFace?.let { tvNumber?.typeface = it }
        tvNumber?.text = "${count?:0}"
        tvFirstRecharge.setVisible(showFirstRecharge)

        if(suffix.isNullOrEmpty()) {
            tvWan.setVisible(false)
        }else {
            tvWan.setVisible(true)
            tvWan.text = suffix
        }

        if (showTitle) {
            tvTitle.setVisible(true)
        } else {
            tvTitle.visibility = View.INVISIBLE
        }
    }

}