package com.ninexiu.sixninexiu.view

import android.content.Context
import android.os.Bundle
import android.os.Handler
import android.os.Message
import android.text.TextUtils
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.FrameLayout
import android.widget.ImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.ChatMessage
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.opensource.svgaplayer.SVGACallback
import com.opensource.svgaplayer.SVGADrawable
import com.opensource.svgaplayer.SVGAImageView
import com.opensource.svgaplayer.SVGAParser
import com.opensource.svgaplayer.SVGAVideoEntity
import okhttp3.OkHttpClient
import okhttp3.Request
import java.io.IOException
import java.io.InputStream
import java.lang.ref.WeakReference
import java.net.MalformedURLException
import java.net.URL
import java.util.LinkedList

/**
 *
 * @ProjectName:
 * @Package:
 * @ClassName:
 * @Description:    多人语音连麦表情动画
 * @Author:         liuguangyu
 * @CreateDate:     2019/8/8 0008 17:04
 * @UpdateUser:     更新者：
 * @UpdateDate:     2019/8/8 0008 17:04
 * @UpdateRemark:   更新说明：SVGA网络加载有点慢 -> 预加载 本地
 * @Version:
 */

class PhizSVGAView : FrameLayout {

    private val TAG: String = "PhizSVGAView"
    private lateinit var mContext: Context
    lateinit var mGiftIv: SVGAImageView
    lateinit var mGiftSecIv: SVGAImageView
    lateinit var mPlaceholderIv: ImageView
    private var emotionType: Int = 0
    private var emotionResult: Int = 0
    private var emotionId: Int = 0

    //    private lateinit var parser: SVGAParser

    private var qeque = LinkedList<String>()
    var cacheEmojy = HashMap<String, ChatMessage>()
    private var mHandler = LiveHotHandler(this)

    private var pollFirst: String? = null

    constructor(context: Context) : super(context) {
        init(context)
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
        init(context)
    }

    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {
        init(context)
    }

    private fun init(context: Context) {
        this.mContext = context
        LayoutInflater.from(context).inflate(R.layout.ns_effect_palyer_layout, this)
        mGiftIv = findViewById(R.id.il_gift_effect)
        mGiftSecIv = findViewById(R.id.il_gift_second_effect)
        mPlaceholderIv = findViewById(R.id.iv_placeholder_icon)
        mPlaceholderIv.visibility = View.GONE
        mGiftSecIv.visibility = View.GONE

        setSVGAImageViewCallBack(mGiftIv)
    }

    class LiveHotHandler internal constructor(adapter: PhizSVGAView) : Handler() {
        var wr: WeakReference<PhizSVGAView> = WeakReference(adapter)

        override fun handleMessage(msg: Message) {
            //            super.handleMessage(msg)
            wr.get()?.mPlaceholderIv?.visibility = View.GONE
            when (msg.what) {
                1 -> {
                    var mSv: SVGAImageView = msg.obj as SVGAImageView
                    mSv.setTag(R.id.tag_svg_loading, false)

//                    var bundle: Bundle = Bundle()
//                    if (wr.get()?.cacheEmojy != null) {
//                        var chatMessage: ChatMessage? = wr.get()?.cacheEmojy?.get(wr.get()?.pollFirst)
//                        bundle.putSerializable("chatMessage", chatMessage)
//                    }
//                    AppBroadcastHelper.getInstance()
//                        .sendBroadcast(NSReceiverAction.ACTION_CHAT_EMOJY_ANIMATION, bundle)
                }

                2 -> {
                    var mSv: SVGAImageView = msg.obj as SVGAImageView
                    mSv.setTag(R.id.tag_svg_loading, false)

//                    var bundle: Bundle = Bundle()
//                    if (wr.get()?.cacheEmojy != null) {
//                        var chatMessage: ChatMessage? = wr.get()?.cacheEmojy?.get(wr.get()?.pollFirst)
//                        bundle.putSerializable("chatMessage", chatMessage)
//                    }
//                    AppBroadcastHelper.getInstance()
//                        .sendBroadcast(NSReceiverAction.ACTION_CHAT_EMOJY_ANIMATION, bundle)
                }

                else -> {
                }
            }

            wr.get()?.nextHideMessage()
        }
    }

    private fun setSVGAImageViewCallBack(mSv: SVGAImageView) {

        with(mSv) {
            callback = object : SVGACallback {
                override fun onPause() {}

                override fun onFinished() {
                    NSLog.e(TAG, "onFinished =  $emotionResult   emotionType =  $emotionType")

                    when (emotionType) {
                        0 -> {
                            mGiftIv?.setTag(R.id.tag_svg_loading, false)
                            nextHideMessage()
                        }

                        1 -> {
                            mPlaceholderIv.visibility = View.VISIBLE
                            mPlaceholderIv.setImageResource(get4Drawing())
                            var message = Message()
                            message.obj = mSv
                            message.what = 1
                            mHandler.sendMessageDelayed(message, 2000)
                        }

                        2 -> {
                            mPlaceholderIv.visibility = View.VISIBLE
                            mPlaceholderIv.setImageResource(get3Drawing())
                            var message = Message()
                            message.obj = mSv
                            message.what = 2
                            mHandler.sendMessageDelayed(message, 2000)
                        }

                        else -> {

                            mGiftIv?.setTag(R.id.tag_svg_loading, false)
                            nextHideMessage()
                        }
                    }
                }

                override fun onRepeat() {}

                override fun onStep(frame: Int, percentage: Double) {}
            }
        }
    }

    /**
     * 骰子结果
     */
    var get4Drawing = fun(): Int {
        return when (emotionResult) {
            0 -> return R.drawable.phiz_dice_1_icon
            1 -> return R.drawable.phiz_dice_2_icon
            2 -> return R.drawable.phiz_dice_3_icon
            3 -> return R.drawable.phiz_dice_4_icon
            4 -> return R.drawable.phiz_dice_5_icon
            5 -> return R.drawable.phiz_dice_6_icon

            else -> {
                R.drawable.phiz_dice_3_icon
            }
        }
    }
    /**
     * 猜拳结果
     */
    var get3Drawing = fun(): Int {
        return when (emotionResult) {
            0 -> return R.drawable.phiz_morra_cloth_icon
            1 -> return R.drawable.phiz_morra_scissor_icon
            2 -> return R.drawable.phiz_morra_stone_icon

            else -> {
                R.drawable.phiz_morra_scissor_icon
            }
        }
    }

    private fun nextHideMessage() {
        val isFun = !getSvgaIvLoading(mGiftIv)
        NSLog.e(TAG, "isFun = $isFun ")
        if (isFun && qeque.size > 0) {
            pollFirst = qeque.pollFirst()
            if (!TextUtils.isEmpty(pollFirst)) {
                NSLog.e(TAG, "nextHideMessage $pollFirst")

                loadGiftEffect(pollFirst!!)
            }
        }
    }

    fun startPlay(entry: String?, chatMassage: ChatMessage?) {
        synchronized(this) {
            if (entry != null) {

                qeque.add(entry)
                cacheEmojy[entry] = chatMassage!!
                this.emotionResult = chatMassage?.emotionResult ?: 0
                this.emotionId = chatMassage?.emotionId ?: 0

                NSLog.e(TAG, "startPlay   size = ${qeque.size}     ")
                //下一条消息
                nextHideMessage()
            }

        }
    }

    private fun getSvgaIvLoading(sIv: SVGAImageView): Boolean {
        val tag = sIv.getTag(R.id.tag_svg_loading)
        return if (tag != null) {
            tag as Boolean
        } else false
    }

    private fun loadGiftEffect(path: String) {
        loadAnimation(path, mGiftIv)
    }

    fun release() {
        if (mGiftIv != null) {
            mGiftIv.stopAnimation()
        }
    }

    private fun loadAnimation(path: String, mSVGAImageView: SVGAImageView) {
        if (mHandler != null) {
            mHandler.removeCallbacksAndMessages(null)
        }
        with(mSVGAImageView) {
            val mParseCompletion = object : SVGAParser.ParseCompletion {
                override fun onComplete(videoItem: SVGAVideoEntity) {

                    NSLog.e(TAG, "ParseCompletion onComplete")

                    emotionType = cacheEmojy[path]?.emotionType ?: 0

                    setVideoItem(videoItem)

                    //                    val drawable = SVGADrawable(videoItem)
                    //                    setImageDrawable(drawable)

                    startAnimation()
                    mSVGAImageView.setTag(R.id.tag_svg_loading, true)
                }

                override fun onError() {
                    NSLog.e(TAG, "ParseCompletion onError ")
                    mSVGAImageView.setTag(R.id.tag_svg_loading, false)
                }
            }

            var parser = SVGAParser(mContext)

            if (path.startsWith("http") || path.startsWith("https")) {
                try {
                    parser?.decodeFromURL(URL(path), mParseCompletion,null)
                } catch (e: MalformedURLException) {
                    e.printStackTrace()
                    mSVGAImageView.setTag(R.id.tag_svg_loading, false)
                }
            } else {
                parser?.decodeFromAssets(path, mParseCompletion)
            }

        }
    }

    /**
     * 设置下载器，这是一个可选的配置项。
     *
     * @param parser
     */
    private fun resetDownloader(parser: SVGAParser) {

        parser.fileDownloader = object : SVGAParser.FileDownloader() {
            override fun resume(url: URL, complete: Function1<InputStream, Unit>,
                failure: Function1<Exception, Unit>): Function0<Unit> {
                //可以试一下协程
                Thread(Runnable {
                    val client = OkHttpClient()
                    val request = Request.Builder().url(url).get().build()
                    try {
                        val response = client.newCall(request).execute()
                        complete.invoke(response.body()!!.byteStream())
                    } catch (e: IOException) {
                        e.printStackTrace()
                        failure.invoke(e)
                    }
                }).start()
                return super.resume(url, complete, failure)
            }
        }
    }

    override fun onDetachedFromWindow() {
        super.onDetachedFromWindow()
        mGiftIv.stopAnimation()
    }
}
