package com.ninexiu.sixninexiu.view

import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.Rect
import android.view.View
import androidx.recyclerview.widget.RecyclerView
import com.blankj.utilcode.util.ConvertUtils

class SpaceColorItemDecoration : RecyclerView.ItemDecoration {
    private var space: Int = ConvertUtils.dp2px(10f)
    private lateinit var paint: Paint

    constructor(space: Int, color: Int) {
        this.space = space
        paint = Paint()
        paint.color = color
    }

    override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
        super.getItemOffsets(outRect, view, parent, state)
        outRect.bottom = ConvertUtils.dp2px(10f)
    }

    override fun onDraw(c: Canvas, parent: RecyclerView, state: RecyclerView.State) {
        super.onDraw(c, parent, state)
        val childCount = parent.childCount
        val left = parent.paddingLeft
        val right = parent.width - parent.paddingRight

        for (i in 0 until childCount-1) {
            val view = parent.getChildAt(i)
            val top = view.bottom
            val bottom = view.bottom + space
            c.drawRect(left.toFloat(), top.toFloat(), right.toFloat(), bottom.toFloat(), paint)
        }
    }
}

