package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.widget.LinearLayout
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.view_toast.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/25
 *     desc   : 用户回归领取奖励｜抽奖提示
 *     version: 1.0
 * </pre>
 */
class ToastView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : LinearLayout(context, attrs, defStyleAttr) {
    companion object {
        const val TIME = 1000L
    }

    init {
        LayoutInflater.from(context).inflate(R.layout.view_toast, this)
        setBackgroundResource(R.drawable.shape_black_4)
        gravity = Gravity.CENTER
        orientation = VERTICAL

        val array = context.obtainStyledAttributes(attrs, R.styleable.ToastView)
        val imgSrc = array.getResourceId(R.styleable.ToastView_android_src, 0)
        if (imgSrc != 0) {
            ivView.visibility = View.VISIBLE
            ivView.setImageResource(imgSrc)
        } else {
            ivView.visibility = View.GONE
        }

        val tvInfo = array.getText(R.styleable.ToastView_android_text)
        tvInfo?.let { tvView.text = it }

        array.recycle()
    }

    val runnable: Runnable = Runnable {
        visibility = View.GONE
    }

    // 显示 View
    fun show() {
        if (this.visibility == View.VISIBLE) {
            removeCallbacks(runnable)
        } else {
            visibility = View.VISIBLE
        }
        postDelayed(runnable, TIME)
    }

    override fun onDetachedFromWindow() {
        super.onDetachedFromWindow()
        removeCallbacks(runnable)
    }
}