package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.RectF
import android.util.AttributeSet
import android.view.View
import androidx.appcompat.widget.AppCompatTextView
import androidx.core.content.ContextCompat
import com.ninexiu.sixninexiu.R


/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/15
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class TopicLoadingView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : AppCompatTextView(context, attrs, defStyleAttr) {

    private var step = 0
    private var padding :Int = dp2px(context,6)
    private val paint: Paint by lazy {
        Paint()
    }
    private var radius = dp2px(context, 3)

    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec)
    }

    private val runnable = {
        step++
        invalidate()
        startLoading()
    }

    fun startLoading(){
        removeCallbacks(runnable)
        postDelayed(runnable, 250)
    }

    fun stopLoading(){
        removeCallbacks(runnable)
    }

    override fun onDetachedFromWindow() {
        super.onDetachedFromWindow()
        stopLoading()
    }

    @SuppressLint("DrawAllocation")
    override fun onDraw(canvas: Canvas?) {
        super.onDraw(canvas)
        paint.style = Paint.Style.FILL
        for (index in 0..2) {
            if (index == step % 3) {
                paint.color = ContextCompat.getColor(context, R.color.color_ff567b)
            } else {
                paint.color = ContextCompat.getColor(context, R.color.color_33ff567b)
            }
            val left=index * radius + index * padding.toFloat()
            val oval = RectF(left, 0f, left + 2 * radius, 2 * radius.toFloat())
            canvas?.drawArc(oval, 0f, 360f, false, paint)
        }

    }

}