package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.MotionEvent
import android.view.View
import android.view.ViewConfiguration
import androidx.constraintlayout.widget.ConstraintLayout
import com.blankj.utilcode.util.ScreenUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import kotlinx.android.synthetic.main.dialog_ture_love_group_progess_layout.view.*
import kotlinx.android.synthetic.main.true_love_progress_drag_layout.view.*
import kotlinx.android.synthetic.main.true_love_progress_drag_layout.view.progress_layout

/**
 * @author: lou
 * @date: 2021/9/15
 * desc:真爱成团日可滑动进度条
 */
class TrueLoveProgressView @JvmOverloads constructor(
    context: Context,
    attrs: AttributeSet? = null,
    defStyleAttr: Int = 0
) : ConstraintLayout(context, attrs, defStyleAttr), View.OnTouchListener {
    private var margin = 0
    var lastY = 0
    private var downY = 0f
    private var slop = 0
    private var screenHeight = 0

    init {
        LayoutInflater.from(context).inflate(R.layout.true_love_progress_drag_layout, this)
        margin =
            NineShowApplication.applicationContext.resources.getDimension(R.dimen.mb_live_video_margin_top)
                .toInt()
        slop = ViewConfiguration.get(getContext()).scaledTouchSlop
        screenHeight = ScreenUtils.getScreenHeight()


    }


    override fun dispatchTouchEvent(event: MotionEvent?): Boolean {
        parent.requestDisallowInterceptTouchEvent(true)
        return super.dispatchTouchEvent(event)
    }

    fun showProgressView(context: Context, percent: Int) {


        if (img_true_love_group_heart != null && progress_layout != null && progress_layout.visibility == GONE) {
            img_true_love_group_heart.setVisible(true)
        }

        consTrueLove.setOnTouchListener(this)

        consTrueLove.setOnClickListener{

           if (progress_layout.visibility == GONE){
               img_true_love_group_heart.setVisible(false)
               progress_layout.setVisible(true)
           }else{
               img_true_love_group_heart.setVisible(true)
               progress_layout.setVisible(false)
           }

        }


        setProgress(percent, context)


    }

    private fun setProgress(percent: Int, context: Context) {

        var present = percent.toFloat() / 999 * 100

        if (present > 100) {
            present = 100f
        }


        val percentFloat: Float = present / 100.0f
        var marginEnd = percentFloat * dp2px(context, 120)
        if (marginEnd == 0f) {
            marginEnd = 1f
        }
        p_cover_iv.layoutParams =
            ConstraintLayout.LayoutParams(dp2px(context, 14), marginEnd.toInt()).apply {
                startToStart = R.id.progress_layout
                endToEnd = R.id.progress_layout
                bottomToBottom = R.id.p_bot_iv
                marginStart = 1

            }
        trueLoveNumText.text = percent.toString()
        p_cover_iv?.postInvalidate()
        progress_layout.postInvalidate()
    }


    override fun onTouch(v: View?, event: MotionEvent?): Boolean {
        val y = event?.rawY?.toInt()
        when (event?.action) {
            MotionEvent.ACTION_DOWN -> downY = event.rawY
            MotionEvent.ACTION_MOVE -> {
                //计算y坐标上的差值
                //要平移的y值
                if (event.rawY < lastY && event.rawY - margin < event.y) {
                    return false
                }
                if (event.rawY > lastY && event.rawY + height - event.y + margin > screenHeight) {
                    return false
                }
                val max: Float =
                    screenHeight - event.rawY - height + event.y + translationY - margin
                val min: Float = event.y - event.rawY + translationY + margin
                val deltaY: Int = y?.minus(lastY) ?: 0
                val tranY = translationY + deltaY
                translationY = if (tranY > max) {
                    max
                } else if (tranY < min) {
                    min
                } else {
                    tranY
                }
            }
            MotionEvent.ACTION_UP -> {
                val v1 = event.rawY - downY
                if (Math.abs(v1) < slop) {
                    consTrueLove.performClick()
                }
            }
            else -> {
            }
        }
        if (y != null) {
            lastY = y
        }
        return true
    }

}