package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.View
import com.ninexiu.sixninexiu.common.util.NSLog

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/01
 *     desc   : 用户回归倒计时
 *     version: 1.0
 * </pre>
 */
class UserReturnCountTextView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : androidx.appcompat.widget.AppCompatTextView(context, attrs, defStyleAttr) {
    private var time: Long = 0L
    private var prefix: String? = null
    private var postfix: String? = null
    private var endfixC: String? = null

    var gameOver: (() -> Unit)? = null

    @SuppressLint("SetTextI18n")
    fun setTime(prefix: String? = null, time: Long?, postfix: String? = null,endfix : String? = null) {
        this.endfixC = endfix
        if (null == time) {
            removeCallbacks(runnable)
            visibility = View.INVISIBLE
            return
        }

        visibility = View.VISIBLE
        if(shouldShow) {
            visibility = View.VISIBLE
        }else {
            visibility = View.INVISIBLE
            return
        }

        if (time <= 0L) {
            removeCallbacks(runnable)
            gameOver?.invoke()
            text = endfixC
            return
        }

        this.time = time
        this.prefix = prefix
        this.postfix = prefix

        text = when (UserReturnGsonHelper.overOneDay(time)) {
            true -> {
                val day = UserReturnGsonHelper.formatDay(time).toString()
                "${prefix ?: ""}${day}${postfix ?: ""}"
            }
            false -> {
                // 开启倒计时
                postDelayed(runnable, 1000L)
                UserReturnGsonHelper.formatTime(time)
            }
        }
    }

    var shouldShow  = true

    val runnable = Runnable {
        setTime(prefix, --time, postfix)
    }

    override fun onDetachedFromWindow() {
        super.onDetachedFromWindow()
        removeCallbacks(runnable)
    }
}
