package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.Gravity
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import com.ninexiu.sixninexiu.common.util.NSLog

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/29
 *     desc   : 用户回归礼物数量数字组合
 *     version: 1.0
 * </pre>
 */
class UserReturnLinearlayout @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : LinearLayout(context, attrs, defStyleAttr) {
    init {
        orientation = HORIZONTAL
        gravity = Gravity.BOTTOM
    }

    /**
     * 设置礼物数量
     */
    fun setNumber(number : Int){
        if(number <= 0 || number >= 100) {
            visibility = View.INVISIBLE
            return
        }

        removeAllViews()

        val str = "x$number"

        for(res in str) {
            val resId: Int = resources.getIdentifier("ic_return_num_$res","drawable",context.packageName)
            if(resId == 0) {
                visibility = View.INVISIBLE
                return
            }

            NSLog.d("UserReturnLinearlayout >> ", "$resId")

            addSelfView(resId)
        }
        visibility = View.VISIBLE
    }

    private fun addSelfView(resId : Int) {
        val iv = ImageView(context)
        val params = LayoutParams(dp2px(12),dp2px(22))
        iv.scaleType = ImageView.ScaleType.FIT_XY
        iv.layoutParams = params
        iv.setImageResource(resId)
        addView(iv)
    }

    fun dp2px(dp : Int) = (resources.displayMetrics.density * dp ).toInt()
}