package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.ImageView
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.VoiceGameSvgHelper
import com.opensource.svgaplayer.SVGAParser
import com.opensource.svgaplayer.SVGAVideoEntity
import kotlinx.android.synthetic.main.view_voice_chaos_win.view.*
import kotlinx.android.synthetic.main.view_voice_game_svg.view.*

/**
 * <pre>
 *     @author : wtengfei
 *     time   : 2021/9/17
 *     desc   : 语音房跨房pk胜利动画
 *     version: 1.0
 * </pre>
 */
class VoiceChaosSvgaView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null,
                                                   defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {

    companion object {
        const val Tag = "VoiceChaosSvgaView : "
    }

    init {
        LayoutInflater.from(context).inflate(R.layout.view_voice_chaos_win, this)
    }

    // 播放烟花动画
    fun showVoiceChaosWin(path :String) {
        val svgaVoiceWin: SVGAVideoEntity? = VoiceGameSvgHelper.svgaVoiceWin

        if (svgaVoiceWin == null) {
            VoiceGameSvgHelper.initVoiceWinSvg(path,object : SVGAParser.ParseCompletion{
                override fun onComplete(videoItem: SVGAVideoEntity) {
                    voiceChaosView.callback = object : SVGACallbackImpl() {
                        override fun onFinished() {
                            super.onFinished()
                            this@VoiceChaosSvgaView.setVisible(false)
                            voiceChaosView.setVisible(false)
                        }
                    }
                    VoiceGameSvgHelper.svgaVoiceWin = videoItem
                    this@VoiceChaosSvgaView.setVisible(true)
                    voiceChaosView.setVisible(true)
                    voiceChaosView.setVideoItem(VoiceGameSvgHelper.svgaVoiceWin)
                    voiceChaosView.startAnimation()
                }

                override fun onError() {
                }
            })
        }else{
            voiceChaosView.callback = object : SVGACallbackImpl() {
                override fun onFinished() {
                    super.onFinished()
                    this@VoiceChaosSvgaView.setVisible(false)
                    voiceChaosView.setVisible(false)
                }
            }
            this.setVisible(true)
            voiceChaosView.setVisible(true)
            voiceChaosView.setVideoItem(svgaVoiceWin)
            voiceChaosView.startAnimation()
        }
    }

    // 重置操作,防止高度影响其他view的显示(如直播间聊天区域)
    fun reset(){
        voiceGameSvg.setVisible(false)
        this.setVisible(false)
    }


}