package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.view_voice_love_game_process.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/09/09
 *     desc   : 心动现场进度view
 *     version: 1.0
 * </pre>
 */
class VoiceLoveGameProcesssView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    companion object {
        const val TYPE_START = 0    // 嘉宾交流
        const val TYPE_MIDDLE = 1   // 选择心动
        const val TYPE_END = 2      // 公布结果
    }

    init {
        LayoutInflater.from(context).inflate(R.layout.view_voice_love_game_process, this)
    }

    // 设置步骤
    fun setStep(step: Int) {
        when (step) {
            TYPE_MIDDLE -> {
                ivStepOne.setImageResource(R.drawable.ic_voice_game_step_one)
                ivStepTwo.setImageResource(R.drawable.ic_voice_game_step_twoing)
                ivStepThree.setImageResource(R.drawable.ic_voice_game_step_three)
                setStepViewChange(ivStepTwo, ivStepOne, ivStepThree)
            }
            TYPE_END -> {
                ivStepOne.setImageResource(R.drawable.ic_voice_game_step_one)
                ivStepTwo.setImageResource(R.drawable.ic_voice_game_step_two)
                ivStepThree.setImageResource(R.drawable.ic_voice_game_step_threeing)
                setStepViewChange(ivStepThree, ivStepTwo, ivStepOne)
            }
            else -> {
                ivStepOne.setImageResource(R.drawable.ic_voice_game_step_oneing)
                ivStepTwo.setImageResource(R.drawable.ic_voice_game_step_two)
                ivStepThree.setImageResource(R.drawable.ic_voice_game_step_three)
                setStepViewChange(ivStepOne, ivStepTwo, ivStepThree)
            }
        }
    }

    private fun setStepViewChange(currentStepView: View, unSelectedView1: View, unSelectedView2: View) {
        fitterViewPosition(currentStepView, ORIENTATION_BOTTOM) { 0 }
        fitterViewPosition(unSelectedView1, ORIENTATION_BOTTOM) { dp2px(context, 4) }
        fitterViewPosition(unSelectedView2, ORIENTATION_BOTTOM) { dp2px(context, 4) }
    }
}