package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.view_voice_game_pk_publish_result.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/09/10
 *     desc   : 对团战pk的结果和惩罚进行封装
 *     version: 1.0
 * </pre>
 */
class VoicePkGamePublishResultView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_voice_game_pk_publish_result, this)
    }

    fun setPkPublish(publish: String?) {
        tvPkGamePublish.text = publish
    }

    fun setPkGameResult(result: Int) {
        ivLeftResult?.setVisible(true)
        ivRightResult?.setVisible(true)
        when (result) {
            1 -> {
                ivIcon?.setVisible(true)
                ivLeftResult?.setImageResource(R.drawable.ic_voice_game_pk_left_win)
                ivRightResult?.setImageResource(R.drawable.ic_voice_game_pk_right_lose)
            }
            2 -> {
                ivIcon?.setVisible(true)
                ivLeftResult?.setImageResource(R.drawable.ic_voice_game_pk_left_lose)
                ivRightResult?.setImageResource(R.drawable.ic_voice_game_pk_right_win)
            }
            else -> {
                ivLeftResult.setVisible(false)
                ivRightResult.setVisible(false)
            }
        }
    }

    fun showOnlyPublish(svgSuccess : Boolean){
        tvPkGamePublish?.setVisible(true)
        if(svgSuccess) ivIcon?.visibility = View.INVISIBLE else ivIcon?.visibility = View.VISIBLE
    }
}