package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.RelativeLayout
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.item_zhifu_type.view.*
import kotlinx.android.synthetic.main.item_zhifu_type.view.ivSelected

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/25
 *     desc   : 封装的支付方式 : 微信支付和支付宝支付
 *     version: 1.0
 * </pre>
 */
class ZhiFuItemTypeView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : RelativeLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.item_zhifu_type, this)
    }

    companion object {
        // 类型 : 微信和支付宝
        const val WECHAT = 0
        const val ALIPAY = 1
    }

    private var payType = WECHAT
    fun setPayType(type : Int) : ZhiFuItemTypeView{
        this.payType = type
        tvZhifu.setTextColor(resources.getColor(R.color.color_999999))
        setBackgroundResource(R.drawable.shap_item_zhifu_normal)
        when(type) {
            WECHAT -> {
                ivZhifu.setImageResource(R.drawable.ic_pay_wechat_darker)
                tvZhifu.text = context.getString(R.string.zhifu_wechat)
            }
            ALIPAY -> {
                ivZhifu.setImageResource(R.drawable.ic_pay_ali_darker) // todo : 修改
                tvZhifu.text = context.getString(R.string.zhifu_ali)
            }
        }
        return this
    }

    fun setPaySelected(selected : Boolean) : ZhiFuItemTypeView{
        if(selected) {
            tvZhifu.setTextColor(resources.getColor(R.color.color_ff567b))
            setBackgroundResource(R.drawable.shap_item_zhifu_selected)
            ivSelected.setVisible(true)
        }else {
            tvZhifu.setTextColor(resources.getColor(R.color.color_999999))
            setBackgroundResource(R.drawable.shap_item_zhifu_normal)
            ivSelected.setVisible(false)
        }

        when(payType) {
            WECHAT -> {
                if(selected) {
                    ivZhifu.setImageResource(R.drawable.ic_pay_wechat_selected)
                }else {
                    ivZhifu.setImageResource(R.drawable.ic_pay_wechat_darker)
                }
            }
            ALIPAY -> {
                if(selected) {
                    ivZhifu.setImageResource(R.drawable.ic_pay_ali_selected)
                }else {
                    ivZhifu.setImageResource(R.drawable.ic_pay_ali_darker)
                }
            }
        }
        return this
    }

}