package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.fitterViewSize
import kotlinx.android.synthetic.main.dialog_account_hide.*
import org.jetbrains.anko.displayMetrics

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/29
 *     desc   : 隐私设置中用户选择隐身和在线的dialog
 *     version: 1.0
 * </pre>
 */
class AccountHideBottomDialog(context: Context, val showOnLine: Int = 0, val isHide: ((Boolean) -> Unit)? = null) : BaseDialog(context) {

    private val width: Int by lazy {
        context.displayMetrics.widthPixels
    }

    override fun initEvents() {
        super.initEvents()

        llHide.setOnClickListener {
            CommonConfirmCancelDialog.showDialog(context, "要进入隐身状态吗?", "隐身后，他人将无法看到你的在线状态,你也看不到他人是否在线.", "取消", "确定") {
                hide(true)
            }
        }

        llOnLine.setOnClickListener {
            hide(false)
        }
    }

    private fun hide(hide: Boolean) {
        if (hide) {
            tvHide.setTextColor(context.resources.getColor(R.color.color_ff567b))
            tvOnLine.setTextColor(context.resources.getColor(R.color.color_333333))
            llHide.setBackgroundResource(R.drawable.shape_account_hide)
            llOnLine.background = null
            isHide?.invoke(true)
        } else {
            tvOnLine.setTextColor(context.resources.getColor(R.color.color_ff567b))
            tvHide.setTextColor(context.resources.getColor(R.color.color_333333))
            llOnLine.setBackgroundResource(R.drawable.shape_account_hide)
            llHide.background = null
            isHide?.invoke(false)
        }
    }

    override fun initView() {
        super.initView()

        // 适配
        llHide.post {
            val itemW = width - dp2px(context, 48)
            fitterViewSize(llHide, { itemW / 2 })
            fitterViewSize(llOnLine, { itemW / 2 })
        }

        if (showOnLine == 1) {
            hide(false)
        } else {
            hide(true)
        }
    }

    override fun getContentView() = R.layout.dialog_account_hide

    override fun isBottom() = true
}