package com.ninexiu.sixninexiu.view.dialog

import android.app.Activity
import android.graphics.Color
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextPaint
import android.text.method.LinkMovementMethod
import android.text.style.BackgroundColorSpan
import android.text.style.ClickableSpan
import android.text.style.ForegroundColorSpan
import android.view.View
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.pay.ZhiFuFastCDialog.Companion.showBugDialog
import kotlinx.android.synthetic.main.dialog_bidding_margin_rule.*

/**
 * <pre>
 *     @author : gh
 *     time   : 2021/4/14 0013
 *     desc   : 买家保证金
 *     version: 1.0
 * </pre>
 */
class BiddingMarginRuleDialog(val context: Activity) :BaseDialog(context){

    override fun getContentView(): Int {
        return R.layout.dialog_bidding_margin_rule
    }

    override fun setDialogWith(): Float {
        return 1f
    }

    override fun isBottomPop(): Boolean {
        return true
    }

    lateinit var goodsId: String
    var depositPrice: String = ""
    var bidDialog: BiddingMarginRuleInfoDialog? = null

    fun showDialog(goodsId: String, depositPrice: String){
        this.goodsId = goodsId
        this.depositPrice = depositPrice
        if (!isShowing){
            show()
        }

        tv_price.text = "${depositPrice}九币"

        val content = "竞拍结束后，落拍将退回保证金，拍中则在订单支付完成后退回保证金。具体规则遵循《保证金规则》"
        val ss = SpannableStringBuilder(content)
        ss.setSpan( ForegroundColorSpan(Color.parseColor("#FFFF567B")), content.indexOf("《"), content.indexOf("》") + 1, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
//        ss.setSpan(object: ClickableSpan(){
//
//            @Override
//            override fun updateDrawState(ds: TextPaint) {
//                ds.isUnderlineText = false
//                ds.color = NineShowApplication.applicationContext.resources.getColor(R.color.white)
//            }
//
//            override fun onClick(widget: View) {
//
//
//            }
//
//        }, content.indexOf("《"), content.indexOf("》"), Spannable.SPAN_INCLUSIVE_EXCLUSIVE)

        tv_rule.movementMethod = LinkMovementMethod.getInstance()

        tv_rule.text = ss

        tv_rule.setOnClickListener {
            if (!context.isFinishing){
                bidDialog = BiddingMarginRuleInfoDialog(context)
            }

            bidDialog?.showDilog()
        }
    }

    override fun initEvents() {
        super.initEvents()
        iv_close.setOnClickListener {
            if (isShowing){
                dismiss()
            }
        }

        btn_submit.setOnClickListener {

            submitData()
        }

    }

    /**
     * 买家保证金
     */
    private fun submitData(){

        var okHttpClient = NsOkHttpClient.getNsOkHttpClient()
        var params = NSRequestParams()
        params.put("goods_id",goodsId)
        okHttpClient.doGet(Constants.GET_SHOP_PAYDEPOSIT, params, object : NSGsonObjectNewCallback<BaseResultInfo>() {

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: BaseResultInfo?) {

                if (statusCode == 200 && isShowing){
                    dismiss()
                } else if (statusCode == 4202 && isShowing && !context.isFinishing){
                    // 调用充值对话框
                    showBugDialog(context, 0, depositPrice?.toLong(), object : OnZhiFuFastDialogDismissListener {
                        override fun ondismissCallback() {
                            show()
                        }
                    })
                }
                MyToast.showShort(message!!)
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

}
