package com.ninexiu.sixninexiu.view.dialog

import android.app.Activity
import android.os.Build
import android.view.View
import android.webkit.WebSettings
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import kotlinx.android.synthetic.main.dialog_bidding_margin_rule_info.*
import org.json.JSONObject

/**
 * <pre>
 *     @author : gh
 *     time   : 2021/4/15 0013
 *     desc   : 保证金规则
 *     version: 1.0
 * </pre>
 */
class BiddingMarginRuleInfoDialog(val context: Activity) : BaseDialog(context) {

    companion object{
        fun create(context: Activity):BiddingMarginRuleInfoDialog{
            return BiddingMarginRuleInfoDialog(context)
        }
    }

    override fun getContentView(): Int {
        return R.layout.dialog_bidding_margin_rule_info
    }

    override fun setDialogWith(): Float {
        return 0.8f
    }

    fun showDilog(){

        if (!isShowing){
            show()
        }

//        requestData()

    }

    override fun initDatas() {
        super.initDatas()
        val webSettings: WebSettings? = tv_content?.getSettings()
        webSettings?.setAppCacheEnabled(true)
        webSettings?.databaseEnabled = true
        webSettings?.domStorageEnabled = true
        webSettings?.cacheMode = WebSettings.LOAD_DEFAULT
        webSettings?.allowFileAccess = true
        webSettings?.javaScriptEnabled = true
        webSettings?.defaultTextEncodingName = "UTF-8"
        webSettings?.useWideViewPort = true //将图片调整到适合webview的大小
        if (Build.VERSION.SDK_INT >= 21) {
            webSettings!!.mixedContentMode = 0
            tv_content?.setLayerType(View.LAYER_TYPE_HARDWARE, null)
        } else if (Build.VERSION.SDK_INT >= 19) {
            tv_content?.setLayerType(View.LAYER_TYPE_HARDWARE, null)
        } else if (Build.VERSION.SDK_INT >= 11 && Build.VERSION.SDK_INT < 19) {
            tv_content?.setLayerType(View.LAYER_TYPE_SOFTWARE, null)
        }

//        webSettings?.loadWithOverviewMode = true //缩放至屏幕大小

        webSettings?.domStorageEnabled = true
        tv_content?.loadUrl(Constants.URL_SHOP_MARGIN_INFO)
    }

    override fun initEvents() {
        super.initEvents()
        iv_close.setOnClickListener {
            if (isShowing) {
                dismiss()
            }
        }
    }

    /**
     * 买家保证金
     */
    fun requestData() {

        var okHttpClient = NsOkHttpClient.getNsOkHttpClient()
        var params = NSRequestParams()
        params.put("os","1")
        params.put("type","2")
        okHttpClient.doGet(Constants.GET_SHOP_SERVICEDESC, params, object : NSGsonObjectNewCallback<BaseResultInfo>() {

            override fun onSuccess(statusCode: Int, responseString: String?, message: String?, response: BaseResultInfo?) {
                if (context == null) {
                    return
                }
                if (statusCode == 200) {
                    try {
                        var jsonObject = JSONObject(responseString)
                        var dataBean = jsonObject.optJSONObject("data")
                        var desc = dataBean.optString("desc")
                        tv_content.loadData(desc,"text/html; charset=UTF-8", null)
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {

            }

        })
    }

}
