package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.content.DialogInterface
import android.view.LayoutInflater
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AccountBindPhoneActivity
import com.ninexiu.sixninexiu.bean.BlindBoxGiftResultInfo
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.GiftPicDownManage
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.fitterViewSize
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.dialog_blind_box_gift_result.*
import kotlinx.android.synthetic.main.dialog_s11_result.*
import kotlinx.android.synthetic.main.layout_blind_box_gift_result.view.*

/**
 * <pre>
 *     @author : zhangbing
 *     time   : 2021/07/07
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class BlindBoxGiftResultDialog(context: Context, var isVip: Boolean, var giftResult: MutableList<BlindBoxGiftResultInfo>) : BaseDialog(context) {
    companion object {
        fun create(context: Context, isVip: Boolean, giftResult: ArrayList<BlindBoxGiftResultInfo>): BlindBoxGiftResultDialog {
            return BlindBoxGiftResultDialog(context, isVip, giftResult)
        }
    }

    override fun getContentView(): Int = R.layout.dialog_blind_box_gift_result

    override fun initView() {
        super.initView()
        setUI()
    }

    fun setUI() {
        ll_gift_container?.removeAllViews()
        if (giftResult.isNotEmpty()) {
            if (giftResult.size > 2) {
                giftResult = giftResult.subList(0, 2)
            }
            for (gift in giftResult) {
                val giftView = LayoutInflater.from(context).inflate(R.layout.layout_blind_box_gift_result, ll_gift_container, false)
                val v = GiftPicDownManage.get().getSvgaUpdate("" + gift.gid)
                GlideUtils.loadNormalImg(context, Constants.LIVE__ROOM_GIFT_URL + gift.gid + ".png?v=" + v, giftView.iv_gift_img)
                giftView?.tv_gift_name?.text = gift.name
                giftView?.tv_gift_num?.text = "${gift.count}"
                ll_gift_container?.addView(giftView)
            }
        }

        iv_result_title?.setImageResource(if (isVip) R.drawable.icon_8years_gift_get else R.drawable.icon_8years_gift_send)

        iv_result_colse?.setOnClickListener {
            dismiss()
        }

        iv_result_bg?.postDelayed({
            dismiss()
        }, 2000)
    }

    override fun initEvents() {
        super.initEvents()

    }
}
