package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.view.fitterViewSize
import kotlinx.android.synthetic.main.dialog_common_confirm_cancel_other.*
import org.jetbrains.anko.displayMetrics

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/09
 *     desc   : 通用提示弹窗
 *     version: 1.0
 * </pre>
 */
class CommonConfirmCancelNoTitleDialog(context: Context, val title: String? = null, val cancel: String? = null, val confirm: String? = null, val onCancel: (() -> Unit)? = null, val onConfirm: (() -> Unit)? = null) : BaseDialog(context) {

    override fun getContentView(): Int {
        return R.layout.dialog_common_confirm_cancel_other
    }

    override fun initView() {
        super.initView()
        tvInfo.text = title ?: "提示"
        tvCancel.text = cancel ?: "取消"
        tvConfirm.text = confirm ?: "解绑"

        tvCancel.setOnClickListener {
            onCancel?.invoke()
            dismiss()
        }

        tvConfirm.setOnClickListener {
            onConfirm?.invoke()
            dismiss()
        }

        // 适配
        val width = context.displayMetrics.widthPixels
        fitterViewSize(dialogContainer, { (width * 0.72).toInt() }, { (it * 0.589).toInt() })
    }
}