package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.fragment.DynamicPublicFragment
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.dialog_dynamic_bottom.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/22
 *     desc   : 发语音/发视频/发图片
 *     version: 1.0
 * </pre>
 */
class DynamicBottomDialog(context: Context, val dynamicClickType: ((Int) -> Unit)? = null) : BaseDialog(context) {
    companion object {
        const val TYPE_DYNAMIC = 0
        const val TYPE_VIDEO = 1
    }

    override fun initView() {
        super.initView()

        tvDynamic.setOnClickListener {
            dynamicClickType?.invoke(TYPE_DYNAMIC)
            dismiss()
        }

        tvVideo.setOnClickListener {
            dynamicClickType?.invoke(TYPE_VIDEO)
            dismiss()
        }

        tvDynamicCancel.setOnClickListener {
            dismiss()
        }
    }


    override fun getContentView() = R.layout.dialog_dynamic_bottom
    override fun isBottom() = true
}