package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.os.Bundle
import android.view.View
import android.view.Window
import androidx.recyclerview.widget.GridLayoutManager
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.AnchorDialogAdapter
import com.ninexiu.sixninexiu.bean.*
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.*
import kotlinx.android.synthetic.main.dialog_leave_room_normal.*
import kotlinx.android.synthetic.main.personal_user_center.*

/**
 * @author: lou
 * @date: 2021/8/26
 * desc:离开直播间时长低于5分钟的dialog 宽高比已适配
 */
class LeaveRoomNormalDialog(context: Context, val data:List<AdviseAnchorInfo>) : BaseDialog(context),
    View.OnClickListener {

    override fun getContentView(): Int = R.layout.dialog_leave_room_normal

    override fun isBottom(): Boolean = true

    override fun initView() {
        super.initView()
        txt_leave_room_close.setOnClickListener(this)
        txt_back_room.setOnClickListener(this)


        setOnCancelListener{
            StatisticsUtil.onEvent(StatisticsEventID.UM_ZBJ_OUT_RECOMMEND_CLOSE)
        }

    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.txt_leave_room_close -> {
                StatisticsUtil.onEvent(StatisticsEventID.UM_ZBJ_OUT_RECOMMEND_LEAVE)
                val bundle = Bundle()
                bundle.putInt("status", 1)
                AppBroadcastHelper.getInstance().sendBroadcast(
                    NSReceiverAction.ACTION_NEW_GOTOCLOSE_LIVEROOM,
                    NSDataBroadcast.TYPE_OPERATION_DEFAULT,
                    bundle)
                dismiss()
            }
            R.id.txt_back_room -> {
                StatisticsUtil.onEvent(StatisticsEventID.UM_ZBJ_OUT_RECOMMEND_CLOSE)
                dismiss()
            }
        }
    }

    override fun initDatas() {
        super.initDatas()
        val adapter = AnchorDialogAdapter(data)
        val gridLayoutManager: GridLayoutManager =
            object : GridLayoutManager(context, 2) {
                override fun canScrollVertically(): Boolean {
                    return false
                }
            }
        recycler_anchor_info.layoutManager = gridLayoutManager
        recycler_anchor_info.adapter = adapter
        adapter.onItemClickListener =
            BaseQuickAdapter.OnItemClickListener { _: BaseQuickAdapter<Any, BaseViewHolder>, _: View, i: Int ->
                if (Utils.isNotClickable()) {
                    return@OnItemClickListener
                }
                // 跳转到直播间
                val item = adapter.data[i] as AdviseAnchorInfo

                val mMBAnchor = AnchorInfo()
                mMBAnchor.roomType = Integer.valueOf(item.room_type)
                mMBAnchor.status = Integer.valueOf(item.status)
                mMBAnchor.rid = item.rid
                mMBAnchor.phonehallposter = item.phonehallposter
                mMBAnchor.headimage = item.headimage
                mMBAnchor.headimage120 = item.headimage120
                sendCloseLiveRoomBroadCastReceiver(false)
                StatisticsUtil.onEvent(StatisticsEventID.UM_ZBJ_OUT_RECOMMEND_SUC)
                Utils.openLiveRoom(context, mMBAnchor)

            }
    }

    override fun getWindows(window: Window?) {
        super.getWindows(window)
        window?.setWindowAnimations(R.style.bottomAnimation)
    }
}