package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.graphics.Bitmap
import androidx.constraintlayout.widget.ConstraintLayout
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.style.ForegroundColorSpan
import android.view.Gravity
import android.view.View
import android.view.Window
import android.widget.Button
import android.widget.ImageView
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.RoomInfo
import com.ninexiu.sixninexiu.bean.VoiceMicListBean
import com.ninexiu.sixninexiu.bean.VoiceTokenResult
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.view.CircleImageFrameView
import io.reactivex.Observable
import io.reactivex.Observer
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import org.reactivestreams.Subscriber
import org.reactivestreams.Subscription

import java.util.concurrent.TimeUnit

/**
 * @Description: 多人语音连麦贵宾位Popup
 * @Author: liuguangyu
 * @Version:
 */

class LiveMoreVoiceGuestDialog : BaseDialog{
    override fun getContentView(): Int {
        return R.layout.pw_voice_lianmai_guest
    }

    private var mContext: Context? = null
    private var btnLianmaiPost: Button? = null
    private var userIconIv: CircleImageFrameView? = null
    private var codeCountDownSub: Disposable? = null
    private var so: Observer<Long>? = null
    private var mTime: Int = 0
    /**
     * 空位图
     */
    private var userEmptyIv: ImageView? = null
    private var tvNoHeadphonesTitle: TextView? = null
    /**
     *
     */
    private var mNoConnectMacTitleTv: TextView? = null
    private var mNoHeadphonesTimeTv: TextView? = null
    /**
     * 贵宾昵称
     */
    private var bomNameTv: TextView? = null
    private var roomInfo: RoomInfo? = null
    private var vipInfoBean: VoiceTokenResult? = null

    constructor(context: Context, roomInfo: RoomInfo) : super(context) {
        this.mContext = context
        this.roomInfo = roomInfo
        NSLog.d(TAG, roomInfo.toString())
    }

    override fun initView() {
    super.initView()

        btnLianmaiPost = findViewById(R.id.btn_lianmai_post)
        mNoConnectMacTitleTv = findViewById(R.id.tv_no_lian_mai_title)
        mNoHeadphonesTimeTv = findViewById(R.id.tv_no_headphones_time)
        bomNameTv = findViewById(R.id.tv_bom_name)
        bomNameTv?.isSelected = true
        userEmptyIv = findViewById(R.id.user_empty_icon)
        userIconIv = findViewById(R.id.iv_user_icon)
        tvNoHeadphonesTitle = findViewById(R.id.tv_no_headphones_title)

        btnLianmaiPost?.setOnClickListener(View.OnClickListener {
            if (NineShowApplication.mUserBase == null) {
                return@OnClickListener
            }
            NSLog.e(TAG,"POST_SET_VIP_SEAT  $roomInfo")
            val mRequestParams = NSRequestParams()
            mRequestParams.put("rid", roomInfo?.rid)
            NSAsyncHttpClient.getInstance()
                .post(ConstantsVoice.getInstance().getLiveAudioRoomSetVipSeat(), mRequestParams,
                    object : NSJsonResponseHandler<VoiceMicListBean>() {
                        override fun onFailure(
                            statusCode: Int,
                            errorMsg: String?
                        ) {
                            NSLog.i(TAG, "onFailure $statusCode  $errorMsg")
                            if (statusCode == 200) {
                                // 打开送礼面板
                                AppBroadcastHelper.getInstance()
                                    .sendBroadcast(NSReceiverAction.ACTION_SHOW_GIFT_DIALOG)
                            }
                            security()
                        }

                        override fun onSuccess(
                            statusCode: Int,
                            rawJsonResponse: String?,
                            response: VoiceMicListBean?
                        ) {
                            security()
                            if (response != null && response.code != 200) {
                                MyToast.MakeToast(response.message)

                            }
                        }
                    })
        })

        initData()

    }

    private fun initData() {
        btnLianmaiPost?.visibility = View.VISIBLE
        //贵宾位有人
        if (!TextUtils.isEmpty(vipInfoBean?.data?.nickname)) {
            userEmptyIv?.visibility = View.GONE
            //不是神秘人
            if (vipInfoBean?.data?.isStealth == 0) {
                bomNameTv?.text = vipInfoBean?.data?.nickname
                GlideUtils.loadCirclePic(context, vipInfoBean?.data?.headimage, userIconIv, R.drawable.icon_vippostion_pop)
            } else {
                userIconIv?.setImageResource(R.drawable.sendgift_mystery_head_icon);
                bomNameTv?.text = "神秘人"
            }
            //贵宾位没有人
        } else {
            userEmptyIv?.visibility = View.VISIBLE
            bomNameTv?.text = "贵宾位"
        }

        if (TextUtils.equals(
                "${vipInfoBean?.data?.vipUid}", "${NineShowApplication.mUserBase?.uid}"
            )
        ) {
            tvNoHeadphonesTitle?.visibility = View.GONE
            mNoHeadphonesTimeTv?.visibility = View.VISIBLE
            mNoConnectMacTitleTv?.visibility = View.VISIBLE

            NSLog.d(TAG,"您的贵宾位还剩余    ${vipInfoBean.toString()}")
            reloadGetSecurity()
            takePopuWindow(vipInfoBean?.data?.endTime ?: 0)
            btnLianmaiPost?.visibility = View.GONE
        } else {
            tvNoHeadphonesTitle?.visibility = View.VISIBLE

            mNoHeadphonesTimeTv?.visibility = View.GONE
            mNoConnectMacTitleTv?.visibility = View.GONE

            if (mContext != null) {
                var loginBuilder: SpannableStringBuilder

                if (vipInfoBean?.data?.myMoney!! >= vipInfoBean?.data?.vipMoney!!) {

                    loginBuilder = SpannableStringBuilder("现在您已具备贵宾资格，欢迎您上位")
                } else if (vipInfoBean?.data?.myMoney!! > 0 && !TextUtils.isEmpty(vipInfoBean?.data?.nickname)) {
                    var money = vipInfoBean?.data?.vipMoney!! - vipInfoBean?.data?.myMoney!!
                    loginBuilder = SpannableStringBuilder(
                        String.Companion.format(
                            mContext!!.getString(R.string.popu_tips_guest_money), money
                        )
                    )
                    loginBuilder.setSpan(
                        ForegroundColorSpan(mContext!!.getResources().getColor(R.color.c_ff3d55))
                        , 2, "${money}".length + 2 + 2, Spannable.SPAN_INCLUSIVE_EXCLUSIVE
                    )
                } else {
                    loginBuilder = SpannableStringBuilder(
                        String.Companion.format(
                            mContext!!.getString(R.string.popu_tips_guest), vipInfoBean?.data?.vipMoney
                        )
                    )
                    loginBuilder.setSpan(
                        ForegroundColorSpan(mContext!!.getResources().getColor(R.color.c_ff3d55))
                        , 7, "${vipInfoBean?.data?.vipMoney}".length + 2 + 7,
                        Spannable.SPAN_INCLUSIVE_EXCLUSIVE
                    )
                }

                tvNoHeadphonesTitle?.text = loginBuilder
            }
        }
    }

    override fun initEvents() {
        super.initEvents()
        setCanceledOnTouchOutside(true)
        setCancelable(true)
    }

    override fun getWindows(window: Window?) {
        super.getWindows(window)
        if (window != null) {
            window.setGravity(Gravity.BOTTOM)
        }
    }

    /**
     * 设置时间
     */
    fun prepareTimer(time: Int) {
        NSLog.d(TAG,"您的贵宾位还剩余$time")
        //        val timer = /*Utils.secToTime(time)*/formatTime(time.toLong())
        var timer = "${time / 60}分${time % 60}秒"

        if (time % 60 < 10) {
            timer = "${time / 60}分0${time % 60}秒"
        }

        NSLog.d(TAG,"您的贵宾位还剩余$timer")
        val loginBuilder: SpannableStringBuilder = SpannableStringBuilder("(您的贵宾位还剩余$timer)")
        if (mContext != null) {
            if ("(您的贵宾位还剩余$timer)".length > 9) {
                loginBuilder.setSpan(
                    ForegroundColorSpan(mContext!!.resources.getColor(R.color.c_ff3d55)), 9,
                    "(您的贵宾位还剩余$timer)".length - 1
                    , Spannable.SPAN_INCLUSIVE_EXCLUSIVE
                )
            }
        }

        mNoHeadphonesTimeTv?.text = loginBuilder
    }

    /**
     * 嘉宾位倒计时
     */
    fun takePopuWindow(i: Int) {
        //        val take = (i % (1000 * 60)) / 1000
        val take = i - (System.currentTimeMillis() / 1000).toInt()

        NSLog.d(TAG,"-----take----$i")
        var time = 0
        if (mTime == 0) {
            time = take
        } else {
            time = (take - mTime)
        }

        if (take <= 0 || time <= 0) {
            return
        }

        so = object : Observer<Long> {
            override fun onSubscribe(d: Disposable) {
                codeCountDownSub=d
            }

            override fun onComplete() {
                reloadGetSecurity()
            }


            override fun onNext(t: Long) {
                prepareTimer(time - t.toInt())
                //                cancel?.text = "拒绝(${time - t}S)"
                if ((time - t) == 1L) {
                    security()
                }
            }



            override fun onError(e: Throwable) {
                e.printStackTrace()
                dismiss()
                reloadGetSecurity()
            }
        }
        //
        Observable.interval(1, TimeUnit.SECONDS)
        .observeOn(AndroidSchedulers.mainThread())
            .take(take.toLong())
            .subscribe(so!!)
    }

    fun reloadGetSecurity() {
        if (codeCountDownSub != null && so != null) {
            codeCountDownSub?.dispose()
            codeCountDownSub = null
            so = null
        }
    }

    /**
     * 消失
     */
    fun security() {
        reloadGetSecurity()
        dismiss()
    }

    fun setInfo(
        roomInfo: RoomInfo,
        response: VoiceTokenResult
    ) {
        this.roomInfo = roomInfo
        this.vipInfoBean = response
        initData()
//        update()
    }

    //    @JvmStatic
    companion object {
        private val TAG = LiveMoreVoiceGuestDialog::class.java.simpleName

    }
}
