package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.widget.LinearLayout
import androidx.recyclerview.widget.LinearLayoutManager
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.MoreCommenDialogAdapter
import kotlinx.android.synthetic.main.dialog_live_more_common.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/23
 *     desc   : 点击更多时弹出的通用dialog : 只适合一行(RecyclerView)的情况
 *     version: 1.0
 * </pre>
 */
data class MoreDataBean(val name: String, val res: Int, val type: Int)

class MBLiveMoreCommenDialog(context: Context, val data: List<MoreDataBean>, val onItemClick: ((Int) -> Unit)? = null) : BaseDialog(context) {

    override fun initView() {
        recy.adapter = MoreCommenDialogAdapter(data){
            onItemClick?.invoke(it)
            dismiss()
        }
        recy.layoutManager = LinearLayoutManager(context, LinearLayoutManager.HORIZONTAL, false)
    }

    override fun getContentView(): Int = R.layout.dialog_live_more_common

    override fun isBottom(): Boolean = true

    override fun setBackgroundDimAlpha() = 0f
}
