package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.content.DialogInterface
import android.view.View
import androidx.constraintlayout.widget.Constraints
import com.blankj.utilcode.util.ToastUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.ConfigSpHelper
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.fitterViewSize
import com.ninexiu.sixninexiu.view.getScreenWidth
import kotlinx.android.synthetic.main.dialog_autumn_charge.*
import kotlinx.android.synthetic.main.dialog_newcomer_reward.*
import okhttp3.OkHttpClient
import org.jetbrains.anko.displayMetrics

/**
 * @author: lou
 * @date: 2021/8/6
 * desc:新用户活动
 */
class NewcomerRewardDialog(context: Context,var dismiss : (()->Unit)? = null) : BaseDialog(context), View.OnClickListener {

    companion object {
        //宽相对屏幕的比例
        const val DIALOG_WIDTH_PERCENT = 0.8

    }

    override fun getContentView(): Int =
            R.layout.dialog_newcomer_reward


    override fun initView() {
        super.initView()
        //适配宽度  高度用宽高比的方式在xml中适配
        val width = (getScreenWidth(context) * DIALOG_WIDTH_PERCENT).toInt()
        newcomerRewardDialogContainer.post {
            fitterViewSize(newcomerRewardDialogContainer, { width })

        }

        img_newcomer_reward_receive.setOnClickListener(this)
        img_newcomer_reward_close.setOnClickListener(this)

    }

    override fun initDatas() {
        super.initDatas()
    }


    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.img_newcomer_reward_receive -> {
                receiveNewUserGift()
            }
            R.id.img_newcomer_reward_close -> {
                dismiss()
            }
        }
    }

    //领取礼物
    private fun receiveNewUserGift() {
        NsOkHttpClient.getNsOkHttpClient().doGet(Constants.URL_RECEIVE_NEW_USER_GIFT, null, object : NSGsonObjectCallback<BaseResultInfo>() {
            override fun onSuccess(statusCode: Int, rawJsonResponse: String?, response: BaseResultInfo?) {

                if (statusCode==200) {
                    ConfigSpHelper.getInstance().isActNewUserGift = 1
                }

                ToastUtils.showLong(response?.message)
                dismiss()

            }

            override fun onFailure(statusCode: Int, errorMsg: String?) {
                ToastUtils.showLong(errorMsg)
                dismiss()
            }

        })
    }

    override fun onDismiss(dialog: DialogInterface?) {
        super.onDismiss(dialog)
        dismiss?.invoke()
    }

}