package com.ninexiu.sixninexiu.view.dialog

import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.graphics.Paint
import android.os.Bundle
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.ninexiu.sixninexiu.BuildConfig
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.TranslucentPayActivity
import com.ninexiu.sixninexiu.adapter.AutumnChargeTitleAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.AutumnChargeBean
import com.ninexiu.sixninexiu.bean.AutumnChargeItemBean
import com.ninexiu.sixninexiu.common.net.NSGsonObjectNewCallback
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.pay.PayUtil
import com.ninexiu.sixninexiu.values.Global
import com.ninexiu.sixninexiu.view.UserReturnGsonHelper
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.active_fans_pay_layout.*
import kotlinx.android.synthetic.main.dialog_autumn_charge.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/08/06
 *     desc   : 抽取出来的支付对话框
 *     version: 1.0
 * </pre>
 */
class PayDialog private constructor(context: Context, val rid: Int, val count: Int = 1, val formType: Int = 0, val subtype: String = PayUtil.CHARGE_SUB_TYPE_TURELOVE,val otherIdentity : String? = null) : BaseDialog(context, R.style.CustomBgTransparentDialog) {
    companion object {
        const val OTHER_IDENTITY = "otherIdentity"
        const val Tag = "PayDialog : "

        fun showDialog(context: Context, rid: Int, count: Int = 1, formType: Int = PayUtil.TRUE_LOVE_POWDER, subtype: String = PayUtil.CHARGE_SUB_TYPE_TURELOVE,otherIdentity : String? = null) {
            PayDialog(context, rid, count, formType, subtype,otherIdentity).show()
        }
    }

    override fun getContentView() = R.layout.active_fans_pay_layout

    override fun initDatas() {
    }

    var payType = -1

    @SuppressLint("SetTextI18n")
    override fun initView() {
        super.initView()
        val window = this.window
        window?.setGravity(Gravity.BOTTOM)

        val params = window?.attributes
        params?.width = WindowManager.LayoutParams.MATCH_PARENT
        window?.attributes = params

        window?.setWindowAnimations(R.style.dialogWindowAnim)
        window?.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)

        rl_alipay.setOnClickListener {
            pay_ali_checked.setVisible(true)
            pay_wechat_checked.setVisible(false)

            // payType = 160 : 修改为和支付中心一样
            payType = if (Global.ALIPAY_CHARGE_TYPE != 0) {
                Global.ALIPAY_CHARGE_TYPE
            } else {
                PayUtil.PAY_TYPE_JX_ALIPAY
            }

            if (BuildConfig.PAY_MODE == 1) { //百度视频
                payType = PayUtil.PAY_TYPE_BD_ALIPAY
            }
        }

        rl_wechat.setOnClickListener {
            pay_ali_checked.setVisible(false)
            pay_wechat_checked.setVisible(true)
            // payType = 159 : 修改为和支付中心一样
            payType = if (Global.WEIXIN_CHARGE_TYPE != 0) {
                Global.WEIXIN_CHARGE_TYPE
            } else {
                PayUtil.PAY_TYPE_JX_WXPAY
            }

            if (BuildConfig.PAY_MODE == 1) { //百度视频
                payType = PayUtil.PAY_TYPE_BD_WXPAY
            }
        }

        bt_recharge.text = "确认支付 ¥ $count"

        bt_recharge.setOnClickListener { pay() }
    }

    private fun pay() {
        //处于家长模式
        val userBase = NineShowApplication.mUserBase
        if (userBase != null && userBase.family_module == 1) {
            ParentsModleHintDialog(context).show()
            return
        }

        if (payType == -1) {
            payType = if (Global.ALIPAY_CHARGE_TYPE != 0) {
                Global.ALIPAY_CHARGE_TYPE
            } else {
                PayUtil.PAY_TYPE_JX_ALIPAY
            }

            if (BuildConfig.PAY_MODE === 1) { //百度视频
                payType = PayUtil.PAY_TYPE_BD_ALIPAY
            }
        }

        val intent = Intent(context, TranslucentPayActivity::class.java)
        val bundle = Bundle()
        bundle.putString("count", "$count")
        bundle.putInt("type", payType)
        bundle.putInt("formType", formType)
        bundle.putInt("rid", rid)
        bundle.putString("subtype", subtype)      // 修改支付payType后，需要为1元支付添加subType区分类型
        bundle.putString(OTHER_IDENTITY,otherIdentity) // 提供一个扩展的表示(这里使用 map扩展比较好)
        intent.putExtras(bundle)
        context?.let {
            it.startActivity(intent)
        }
        dismiss()
    }
}