package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.fragment.DynamicPublicFragment
import com.ninexiu.sixninexiu.view.setVisible
import kotlinx.android.synthetic.main.dialog_dynamic_bottom.*
import kotlinx.android.synthetic.main.dialog_dynamic_person_help.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/22
 *     desc   : 帮助中心
 *     version: 1.0
 * </pre>
 */
class PersonHelpBottomDialog(context: Context, val clickType: ((Int) -> Unit)? = null) : BaseDialog(context) {
    companion object {
        const val TYPE_QQ = 0
        const val TYPE_PHONE = 1
        const val TYPE_UNADULT = 2
    }

    override fun initView() {
        super.initView()

        tvQQ?.setOnClickListener {
            clickType?.invoke(TYPE_QQ)
            dismiss()
        }

        tvPhone?.setOnClickListener {
            clickType?.invoke(TYPE_PHONE)
            dismiss()
        }

        tvUnAdult?.setOnClickListener {
            clickType?.invoke(TYPE_UNADULT)
            dismiss()
        }

        tvCancel.setOnClickListener {
            dismiss()
        }
    }


    override fun getContentView() = R.layout.dialog_dynamic_person_help
    override fun isBottom() = true
}