package com.ninexiu.sixninexiu.view.dialog

import android.app.Activity
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.RoomInfo
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.GlideUtils
import kotlinx.android.synthetic.main.pop_follow_tips.*

/**
 * <pre>
 *     @author : gh
 *     time   : 2021/4/20 0013
 *     desc   : 房间主播关注
 *     version: 1.0
 * </pre>
 */
class RoomAnchorFollowDialog(val context: Activity) :BaseDialog(context){

    var onFollowInterface: OnFollowInterface? = null

    override fun getContentView(): Int {
        return R.layout.pop_follow_tips
    }

    override fun setDialogWith(): Float {
        return 1f
    }

    override fun setBackgroundDimAlpha(): Float {
        return 0f
    }

    override fun isBottomPop(): Boolean {
        return true
    }

    lateinit var roomInfo: RoomInfo

    fun showDialog(roomInfo: RoomInfo){
        this.roomInfo = roomInfo
        if (!isShowing){
            StatisticsUtil.onEvent(StatisticsEventID.LIVEROOM_POP_FOLLOW_TIPS_SHOW)
            show()
        }

        GlideUtils.loadCirclePic(context, roomInfo?.headimage, iv_anchor_avatar)
        tv_anchor_name?.text = roomInfo?.nickname
        tv_anchor_slogn?.text = "关注主播，不错过任何一次直播"

    }

    override fun initEvents() {
        super.initEvents()
        iv_follow_anchor?.setOnClickListener {
            onFollowInterface?.onFollow(roomInfo)
        }

    }

    interface OnFollowInterface {
        fun onFollow(roomInfo: RoomInfo)
    }

}
