package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.text.TextUtils
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.BaseResultInfo
import com.ninexiu.sixninexiu.common.net.NSGsonObjectCallback
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.net.NsOkHttpClient
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.login.ServerException
import com.ninexiu.sixninexiu.pay.ZhiFuFastCDialog.Companion.showBugDialog
import com.tencent.qcloud.tim.uikit.utils.ToastUtil
import kotlinx.android.synthetic.main.dialog_ture_love_group_buy_layout.*
import org.json.JSONObject
import java.lang.Exception

/**
 * @author: lou
 * @date: 2021/9/13
 * desc:真爱成团日购买礼包弹窗
 */
class TrueLoveGroupBuyDialog(context: Context, val rid: Int) : BaseDialog(context) {

    override fun getContentView(): Int {
        return R.layout.dialog_ture_love_group_buy_layout
    }

    override fun initView() {
        super.initView()

        imgBuyClose.setOnClickListener {
            dismiss()
        }

        tvBuy.setOnClickListener {

            var params = NSRequestParams()
            params.put("rid", rid)
            tvBuy.isEnabled = false

            NsOkHttpClient.getNsOkHttpClient()
                .doGet(Constants.GET_USER_BUY_TRUE_LOVE_GIFT_BAG, params, object :
                    NSGsonObjectCallback<BaseResultInfo>() {
                    override fun onSuccess(
                        statusCode: Int,
                        rawJsonResponse: String?,
                        response: BaseResultInfo?
                    ) {

                        tvBuy.isEnabled = true

                        try {

                            when (response?.message) {
                                "您的余额不足，快去充值吧" -> {
                                    showBugDialog(context,
                                        object : OnZhiFuFastDialogDismissListener {
                                            override fun ondismissCallback() {

                                            }
                                        })
                                    StatisticsUtil.onEvent(StatisticsEventID.LIVEROOM_GIFT_CHARGE)
                                }
                                "购买成功" -> {
                                    val jb = JSONObject(rawJsonResponse)
                                    val data: JSONObject = jb.getJSONObject("data")
                                    val jiubi = data.optLong("jiubi")
                                    NineShowApplication.mUserBase?.money = jiubi
                                    dismiss()
                                    ToastUtil.MakeToastCenter(response?.message)
                                }
                                else -> {
                                    ToastUtil.MakeToastCenter(response?.message)
                                    dismiss()
                                }
                            }


                        }catch (e:Exception){
                            NSLog.e("TrueLove Error:$e")
                        }

                    }

                    override fun onFailure(statusCode: Int, errorMsg: String?) {
                        tvBuy.isEnabled = true
                        dismiss()
                    }

                })

        }

    }



}