package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.core.content.ContextCompat
import com.ninexiu.sixninexiu.R

/**
 * <pre>
 *     @author : wtengfei
 *     time   : 2021/9/26
 *     desc   : 语音大乱斗报名结果dialog
 *     version: 1.0
 * </pre>
 */
class VoiceChaosReportDialog(val mContext : Context) :BaseDialog(mContext) {

    private var reportTitleTv : TextView? = null
    private var reportContentTv : TextView? = null
    private var reportOkTv : TextView? = null
    private var backIv :ImageView? = null

    override fun getContentView():Int{
        return  R.layout.dialog_voice_chaos_report
    }

    override fun setDialogWith(): Float {
        return 0.75f
    }

    override fun setOnKeyDown(): Boolean {
        return true
    }

    override fun initView() {
        super.initView()
        reportTitleTv = findViewById(R.id.reportTitleTv)
        reportContentTv = findViewById(R.id.reportContentTv)
        reportOkTv = findViewById(R.id.reportOkTv)
        backIv = findViewById(R.id.backIv)
    }

    override fun isCenter(): Boolean {
        return true
    }

    fun show(type :Boolean,message :String) {
        super.show()
        reportContentTv?.text = message
        if(type){
            reportOkTv?.setTextColor(ContextCompat.getColor(mContext,R.color.color_C01848))
            backIv?.setImageResource(R.drawable.bg_report_success)
        }else{
            reportOkTv?.setTextColor(ContextCompat.getColor(mContext,R.color.color_3660a2))
            backIv?.setImageResource(R.drawable.bg_report_failed)
        }
        reportTitleTv?.postDelayed({
            dismiss()
        }, 2000)
    }

    override fun initEvents() {
        super.initEvents()
        reportOkTv?.setOnClickListener(View.OnClickListener {
            dismiss()
        })

    }
}