package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.text.TextUtils
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.showOrGoneView

/**
 * <pre>
 *     @author : wtengfei
 *     time   : 2021/9/15
 *     desc   : 多麦房语音大乱斗 得到奖励
 *     version: 1.0
 * </pre>
 */
class VoiceChaosResultDialog(val mContext :Context) :BaseDialog(mContext) {

    private var titleLayout :ConstraintLayout? = null
    private var contentLayout :ConstraintLayout? = null
    private var failedLayout :ConstraintLayout? = null
    private var winTitle :TextView? = null
    private var backIv :ImageView? = null
    private var voiceChaosResult :TextView? = null
    private var voiceChaosResultIv :ImageView? = null
    private var okButton : ImageView? = null
    private var failedTitle : TextView? = null
    private var failedContentTv : TextView? = null

    override fun getContentView():Int{
        return  R.layout.dialog_voice_chaos
    }

    override fun setDialogWith(): Float {
        return 1f
    }

    override fun setOnKeyDown(): Boolean {
        return true
    }

    override fun initView() {
        super.initView()
        titleLayout = findViewById(R.id.title_layout)
        contentLayout = findViewById(R.id.contentLayout)
        failedLayout = findViewById(R.id.failedLayout)
        winTitle = findViewById(R.id.winTitle)
        backIv = findViewById(R.id.backIv)
        voiceChaosResult = findViewById(R.id.voiceChaosResult)
        voiceChaosResultIv = findViewById(R.id.voiceChaosResultIv)
        okButton = findViewById(R.id.okButton)
        failedTitle = findViewById(R.id.failedTitle)
        failedContentTv = findViewById(R.id.failedContentTv)

    }

     fun show(count :Int, name :String,url :String,isResult :String,total :Int) {
         super.show()
         var result = isResult
         if(TextUtils.equals("3",isResult) && total == 0){
             result = "2"
         }
         when (result) {
             "1" -> {
                 titleLayout.showOrGoneView(true)
                 contentLayout.showOrGoneView(true)
                 failedLayout.showOrGoneView(false)
                 winTitle.showOrGoneView(true)
                 winTitle?.text = "宝箱领取成功"
                 backIv?.setImageResource(R.drawable.bg_voice_chaos_result)
                 voiceChaosResult?.text = "[${count}个$name]"
                 GlideUtils.loadNormalCacheImg(mContext, url, voiceChaosResultIv)
             }
             "2" -> {
                 failedLayout.showOrGoneView(true)
                 contentLayout.showOrGoneView(false)
                 titleLayout.showOrGoneView(false)
                 winTitle.showOrGoneView(false)
                 failedTitle?.text = "非常抱歉 本局PK失败"
                 failedContentTv?.text = "再接再厉"
                 backIv?.setImageResource(R.drawable.bg_voice_chaos_failed_result)
                 failedLayout?.postDelayed({
                     dismiss()
                 }, 2000)
             }
             else -> {
                 failedLayout.showOrGoneView(true)
                 contentLayout.showOrGoneView(false)
                 titleLayout.showOrGoneView(false)
                 winTitle.showOrGoneView(false)
                 failedTitle?.text = "本局PK赛平局"
                 failedContentTv?.text = "继续加油"
                 backIv?.setImageResource(R.drawable.bg_voice_chaos_failed_result)
                 failedLayout?.postDelayed({
                     dismiss()
                 }, 2000)
             }
         }
    }

    override fun initEvents() {
        super.initEvents()
        okButton?.setOnClickListener {
            dismiss()
        }
    }

    override fun isCenter(): Boolean {
        return true
    }
}