package com.ninexiu.sixninexiu.view.popuwindo

import android.app.Activity
import android.content.Context
import android.graphics.drawable.BitmapDrawable
import android.media.AudioManager
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.PagerAdapter
import androidx.viewpager.widget.ViewPager
import android.view.Gravity
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import android.widget.GridView
import android.widget.PopupWindow
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.adapter.MoreVoicePhizAdapter
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.bean.FindCanGetTreasureInfo
import com.ninexiu.sixninexiu.bean.FindCanGetTreasureInfo.TreasuresBean
import com.ninexiu.sixninexiu.bean.RoomInfo
import com.ninexiu.sixninexiu.bean.UserBase
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.lib.indicator.CirclePageIndicator
import org.json.JSONException
import java.util.Random

/**
 * @Description:     表情选择面板
 * @Author:         liuguangyu
 * @Version:
 */
class LiveMoreVoicePhizPopup : PopupWindow {
    private var mType: Int = 0
    /**
     * 麦序 传入的都要+1
     * 1.初始化构造传入 LiveMoreVoiceAudiencePopup
     * 2.退出直播间再次重连进入 切换界面[]
     * 3.setMicNum 传入
     */
    private var micNum: Int = 0
    private var treasuresInt = 0
    private var loadingLayout: View? = null
    private var mContext: Context? = null
    private lateinit var fragment: androidx.fragment.app.Fragment
    private var tvNoHeadphonesTitle: TextView? = null
    private var tvTitleContent: TextView? = null
    private var viewPager: androidx.viewpager.widget.ViewPager? = null
    private var viewpagerIndicator: CirclePageIndicator? = null
    private lateinit var treasureChestPagerAdapter: TreasureChestPagerAdapter
    private lateinit var findCanGetTreasureInfo: FindCanGetTreasureInfo
    private lateinit var roomInfo: RoomInfo
    private val items = arrayListOf<TreasuresBean>()

    constructor(fragment: androidx.fragment.app.Fragment, micNum: Int, roomInfo: RoomInfo) {
        this.mContext = fragment.context
        this.fragment = fragment
        //麦序为 1-8
        this.micNum = micNum + 1
        this.roomInfo = roomInfo
        isOutsideTouchable = true
        isTouchable = true
        initView()
        getTalKImagesData()
    }

    private fun initView() {
        contentView = View.inflate(mContext, R.layout.pw_live_lian_mai_phiz, null)
        setBackgroundDrawable(BitmapDrawable())
        width = ViewGroup.LayoutParams.MATCH_PARENT
        height = ViewGroup.LayoutParams.MATCH_PARENT
        softInputMode = WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE
        if (contentView == null) {
            MyToast.MakeToast("表情面板初始化异常！")
            return
        }
        tvTitleContent = contentView?.findViewById(R.id.tv_title_content)
        viewPager = contentView?.findViewById(R.id.view_pager)
        viewpagerIndicator = contentView?.findViewById(R.id.mblive_room_gift_viewpager_indicator)
        loadingLayout = contentView?.findViewById(R.id.loading_layout)
        loadingLayout?.visibility = View.GONE

        tvNoHeadphonesTitle = contentView?.findViewById(R.id.tv_no_headphones_title)
        val audioManager = mContext?.getSystemService(Context.AUDIO_SERVICE) as AudioManager
        if (!audioManager.isWiredHeadsetOn) {
            tvNoHeadphonesTitle?.visibility = View.VISIBLE
        } else {
            tvNoHeadphonesTitle?.visibility = View.GONE
        }
        contentView?.setOnClickListener { v ->
            startDismissAnimation()
        }
        initViewPagerData()
    }

    private fun initViewPagerData() {
        treasureChestPagerAdapter = TreasureChestPagerAdapter(treasuresInt, items, this)
        viewPager?.adapter = treasureChestPagerAdapter
        viewPager?.offscreenPageLimit = 2
        viewpagerIndicator?.setViewPager(viewPager)
    }

    /**
     * popup退出动画
     */
    private fun startDismissAnimation() {
        val outAnim = AnimationUtils.loadAnimation(mContext, R.anim.activity_games_bottom_out)
        outAnim.setAnimationListener(object : Animation.AnimationListener {
            override fun onAnimationStart(animation: Animation) {}

            override fun onAnimationEnd(animation: Animation) {
                security()
            }

            override fun onAnimationRepeat(animation: Animation) {}
        })
        contentView?.startAnimation(outAnim)
    }

    /**
     * popup入场动画
     */
    fun startAnimation() {
        val outAnim = AnimationUtils.loadAnimation(mContext, R.anim.activity_games_bottom_in)
        outAnim.setAnimationListener(object : Animation.AnimationListener {
            override fun onAnimationStart(animation: Animation) {}

            override fun onAnimationEnd(animation: Animation) {}

            override fun onAnimationRepeat(animation: Animation) {}
        })
        contentView?.startAnimation(outAnim)
    }

    /**
     * 显示互动表情面板
     */
    fun showPhizPop(view: View){
        if (contentView != null && mContext != null && mContext is Activity && !(mContext as Activity).isFinishing) {
            Utils.fitPopupWindowOverStatusBar(true, this)
            startAnimation()
            showAtLocation(view, Gravity.CENTER, 0, 0)
        }else{
            MyToast.showShort("状态异常，请退出直播间重试！")
        }

    }



    /**
     * 隐藏弹框
     */
    fun security() {
        dismiss()
    }

    class TreasureChestPagerAdapter() : PagerAdapter() {

        private var treasuresInt = 1
        private var viewArray = ArrayList<View>()
        private lateinit var phizItems: ArrayList<TreasuresBean>
        private lateinit var liveMoreVoicePhizPopup: LiveMoreVoicePhizPopup
        /**
         * 公聊对象
         */
        private var publicChatObject = UserBase(0, "所有人")

        /**
         * 点击时间间隔不能小于3秒
         */
        private var lastClickTime:Long = 0

        constructor(treasuresInt: Int, items: ArrayList<TreasuresBean>,
            liveMoreVoicePhizPopup: LiveMoreVoicePhizPopup) : this() {
            this.treasuresInt = treasuresInt
            this.phizItems = items
            this.liveMoreVoicePhizPopup = liveMoreVoicePhizPopup
        }

        fun setTreasuresInt(treasuresInt: Int, phizItems: ArrayList<TreasuresBean>) {
            this.treasuresInt = treasuresInt
            for (i in 1..treasuresInt) {
                val view = View.inflate(NineShowApplication.applicationContext, R.layout.pw_live_lian_mai_phiz_view, null)
                val gridView = view.findViewById<GridView>(R.id.live_voice_grid_view)
                val moreVoiceCompereAdapter = MoreVoicePhizAdapter(refreshAdapter(phizItems, i - 1),liveMoreVoicePhizPopup?.mContext)
                gridView.adapter = moreVoiceCompereAdapter
                viewArray.add(view)
                gridView.setOnItemClickListener { parent, view, position, id ->

                    if(System.currentTimeMillis() - lastClickTime < 1000 * 3){
                        MyToast.MakeToast("别点那么快哦")
                        return@setOnItemClickListener
                    }

                    //TODO 表情 -> 接口 or 长连接
                    val info = parent.getItemAtPosition(position) as TreasuresBean
                    val emotionBean = EmotionBaen()
                    with(emotionBean) {
                        emotionId = info.id
                        emotionType = info.type
                        emotionResult = when (info.type) {
                            1 -> {
                                Random().nextInt(6)
                            }
                            2 -> {
                                Random().nextInt(3)
                            }
                            else -> {
                                -1
                            }
                        }
                    }
                    try {
                        if ("所有人" == publicChatObject.nickname) {
                            //公聊
                            ClientManager.getInstance()
                                .sendMessage(MessageUtil.MESSAGE_PUBLIC_CHAT, NineShowApplication.mUserBase
                                    , publicChatObject, -1, "", null, null, null, emotionBean,0)
                        } else {
                            //对某人说
                            ClientManager.getInstance()
                                .sendMessage(MessageUtil.MESSAGE_PUBLIC_CHAT, NineShowApplication.mUserBase, publicChatObject,
                                    publicChatObject.os, "")
                        }
                        lastClickTime = System.currentTimeMillis()
                    } catch (e: JSONException) {
                        e.printStackTrace()
                    }
//                    liveMoreVoicePhizPopup.security()
                }
            }
        }

        private fun refreshAdapter(treasures: ArrayList<TreasuresBean>, i: Int): MutableList<TreasuresBean> {

            if (i == 0) {
                // subList(2, 4) 包含第2个元素和第3个元素但是不包含第4个元素
                if (treasures.size >= 10) {
                    return treasures.subList(i, 10)
                } else {
                    return treasures.subList(i, treasures.size + 1)
                }
            } else if (i < treasures.size / 10) {
                return treasures.subList(10 * i, 10 * (i + 1))
            } else {
                return treasures.subList(10 * i, treasures.size)
            }
        }

        override fun instantiateItem(container: ViewGroup, position: Int): Any {
            container.addView(viewArray.get(position))
            return viewArray.get(position)
        }

        override fun isViewFromObject(p0: View, p1: Any): Boolean {
            return p0 == p1
        }

        override fun setPrimaryItem(container: ViewGroup, position: Int, `object`: Any) {
            super.setPrimaryItem(container, position, `object`)
        }

        override fun destroyItem(container: ViewGroup, position: Int, `object`: Any) {
            container.removeView(viewArray.get(position))
        }

        override fun getCount(): Int = treasuresInt
    }

    /**
     * 获取互动表情图片信息
     */
    private fun getTalKImagesData() {
        loadingLayout?.visibility = View.VISIBLE
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        asyncHttpClient.setURLEncodingEnabled(false)
        val params = NSRequestParams()
        asyncHttpClient.get(ConstantsVoice.getInstance().getLiveAudioRoomGetTalkImages(), params, object : NSJsonResponseHandler<FindCanGetTreasureInfo>() {

            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: FindCanGetTreasureInfo?) {
                if (response != null) {
                    if (response.data != null && response.data.size > 0) {
                        loadData(response)
                    }
                }
            }
            override fun onFailure(statusCode: Int, errorMsg: String) {
//                MyToast.MakeToast(mContext, errorMsg)
            }
        })
    }

    private fun loadData(findCanGetTreasureInfo: FindCanGetTreasureInfo) {
        if (findCanGetTreasureInfo.code == 200) {
            for (i in findCanGetTreasureInfo.data) {
                i.itemType = Utils.ITEM_TYPE_0
            }
            loadingLayout?.visibility = View.GONE
            this.findCanGetTreasureInfo = findCanGetTreasureInfo
            items.addAll(findCanGetTreasureInfo.data)
            if (items.size > 0) {
                if (items.size % 10 == 0) {
                    treasureChestPagerAdapter.setTreasuresInt(items.size / 10, items)
                } else {
                    treasureChestPagerAdapter.setTreasuresInt(items.size / 10 + 1, items)
                }
            }
        }
        treasureChestPagerAdapter.notifyDataSetChanged()
    }
}
