package com.ninexiu.sixninexiu.view.popwindow

import android.app.Activity
import android.content.Context
import android.os.Bundle
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.widget.NestedScrollView
import android.view.Gravity
import android.view.View
import android.view.View.OnClickListener
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.PopupWindow
import android.widget.RadioButton
import android.widget.TextView
import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import com.loopj.android.http.BaseJsonHttpResponseHandler
import com.loopj.android.http.TextHttpResponseHandler
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.ContentTalentRecardBean
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import cz.msebera.android.httpclient.Header
import org.json.JSONObject

/**
 * author wangyu
 * date: on 2019/10/31
 * describe:内容创造营弹窗
 */
class ContentTalentPopWindow : PopupWindow, OnClickListener {

    private var context: Context? = null
    private var isCanUseCard: Boolean? = null
    private var contentTalentPopWindow: ContentTalentPopWindow? = null
    private var layoutView: View? = null

    private var rbtn_mycard: RadioButton? = null
    private var rbtn_acvitityrules: RadioButton? = null
    private var cl_mycard: ConstraintLayout? = null
    private var nsv_activityrlues: NestedScrollView? = null
    private var tv_use: TextView? = null
    private var iv_sing: ImageView? = null
    private var tv_singnumber: TextView? = null
    private var iv_dance: ImageView? = null
    private var tv_dancenumber: TextView? = null
    private var iv_game: ImageView? = null
    private var tv_gamenumber: TextView? = null
    private var iv_other: ImageView? = null
    private var isCanClick: Boolean = false //使用按钮是否可以点击
    private var type: Int = 0 //使用卡片类型 1唱歌 2跳舞 3游戏
    private var singNumber: Int = 0 //唱歌卡片数量
    private var danceNumber: Int = 0 //舞蹈卡片数量
    private var gameNumber: Int = 0 //游戏卡片数量

    constructor(context: Context, isCanUseCard: Boolean) {
        this.context = context
        this.isCanUseCard = isCanUseCard
    }

    fun showView() {
        contentTalentPopWindow = context?.let { isCanUseCard?.let { it1 -> ContentTalentPopWindow(it, it1) } }
        layoutView = View.inflate(context, R.layout.pop_contenttalent, null)
        contentTalentPopWindow?.contentView = layoutView
        //动态设置宽高
        contentTalentPopWindow?.width = ViewGroup.LayoutParams.MATCH_PARENT
        contentTalentPopWindow?.height = ViewGroup.LayoutParams.WRAP_CONTENT
        contentTalentPopWindow?.isFocusable = true //可获取焦点状态
        contentTalentPopWindow?.isTouchable = true //设置点击外部消失
        //设置动画样式
        contentTalentPopWindow?.animationStyle = R.style.PopupWindowBottomAnimation

        //设置底部弹出
        contentTalentPopWindow?.showAtLocation((context as Activity).window.decorView.rootView, Gravity.BOTTOM, 0, 0)

        initView()
        getCardInfo()
    }

    private fun initView() {

        rbtn_mycard = layoutView?.findViewById<RadioButton>(R.id.contentalent_rbtn_mycard)
        rbtn_mycard?.setOnClickListener(this)
        rbtn_acvitityrules = layoutView?.findViewById<RadioButton>(R.id.contentalent_rbtn_acvitityrules)
        rbtn_acvitityrules?.setOnClickListener(this)
        cl_mycard = layoutView?.findViewById<ConstraintLayout>(R.id.contentalent_cl_mycard)
        nsv_activityrlues = layoutView?.findViewById<NestedScrollView>(R.id.contentalent_nsv_activityrlues)
        iv_sing = layoutView?.findViewById<ImageView>(R.id.contentalent_iv_sing)
        iv_sing?.setOnClickListener(this)
        tv_singnumber = layoutView?.findViewById<TextView>(R.id.contentalent_tv_singnumber)
        tv_singnumber?.setOnClickListener(this)
        iv_dance = layoutView?.findViewById<ImageView>(R.id.contentalent_iv_dance)
        iv_dance?.setOnClickListener(this)
        tv_dancenumber = layoutView?.findViewById<TextView>(R.id.contentalent_tv_dancenumber)
        tv_dancenumber?.setOnClickListener(this)
        iv_game = layoutView?.findViewById<ImageView>(R.id.contentalent_iv_game)
        iv_game?.setOnClickListener(this)
        tv_gamenumber = layoutView?.findViewById<TextView>(R.id.contentalent_tv_gamenumber)
        tv_gamenumber?.setOnClickListener(this)
        iv_other = layoutView?.findViewById<ImageView>(R.id.contentalent_iv_other)
        iv_other?.setOnClickListener(this)
        tv_use = layoutView?.findViewById<TextView>(R.id.contentalent_tv_use)
        tv_use?.setOnClickListener(this)
        context?.resources?.getColor(R.color.color_contenttalnet_use)?.let { tv_use?.setTextColor(it) }
        val iv_quit = layoutView?.findViewById<ImageView>(R.id.contentalent_iv_quit)
        iv_quit?.setOnClickListener(this)

        iv_sing?.setBackgroundResource(R.drawable.icon_contenttalent_singfalse)
        iv_dance?.setBackgroundResource(R.drawable.icon_contenttalent_dancefalse)
        iv_game?.setBackgroundResource(R.drawable.icon_contenttalent_gamefalse)

    }

    override fun onClick(v: View?) {

        when (v?.id) {
            //我的卡片
            R.id.contentalent_rbtn_mycard -> {
                topVisible(true)
            }
            //活动规则
            R.id.contentalent_rbtn_acvitityrules -> {
                topVisible(false)
            }
            //唱歌
            R.id.contentalent_iv_sing,
            R.id.contentalent_tv_singnumber -> {
                contentVisible(1)
                type = 1
            }
            //跳舞
            R.id.contentalent_iv_dance,
            R.id.contentalent_tv_dancenumber -> {
                contentVisible(2)
                type = 2
            }
            //游戏
            R.id.contentalent_iv_game,
            R.id.contentalent_tv_gamenumber -> {
                contentVisible(3)
                type = 3
            }
            //其他
            R.id.contentalent_iv_other -> {
                contentVisible(4)
            }
            //使用
            R.id.contentalent_tv_use -> {
                StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_USE)
                if (this?.isCanClick) {
                    useCardInfo(type)
                }
            }
            //退出
            R.id.contentalent_iv_quit -> {
                contentTalentPopWindow?.dismiss()
            }
        }
    }

    /**
     * 顶部按钮我的卡片和活动规则点击
     */
    private fun topVisible(isVisibility: Boolean) {
        if (isVisibility) {
            cl_mycard?.visibility = View.VISIBLE
            tv_use?.visibility = View.VISIBLE
            nsv_activityrlues?.visibility = View.GONE
            rbtn_mycard?.setBackgroundResource(R.drawable.contentalent_top_lefttrue)
            rbtn_acvitityrules?.setBackgroundResource(R.drawable.contentalent_top_righttrue)
            rbtn_mycard?.isChecked = true
            rbtn_acvitityrules?.isChecked = false
            StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_MYCARD)
        } else {
            cl_mycard?.visibility = View.GONE
            tv_use?.visibility = View.GONE
            nsv_activityrlues?.visibility = View.VISIBLE
            rbtn_mycard?.setBackgroundResource(R.drawable.contentalent_top_rightfalse)
            rbtn_acvitityrules?.setBackgroundResource(R.drawable.contentalent_top_leftfalse)
            rbtn_mycard?.isChecked = false
            rbtn_acvitityrules?.isChecked = true
            StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_ACVITITYRULES)
        }
    }

    /**
     * 4个内容按钮点击
     * source 1唱歌 2跳舞 3游戏 4其他
     */
    private fun contentVisible(source: Int) {
        when (source) {
            1 -> {
                iv_sing?.setBackgroundResource(R.drawable.icon_contenttalent_singtrue)
                iv_dance?.setBackgroundResource(R.drawable.icon_contenttalent_dancefalse)
                iv_game?.setBackgroundResource(R.drawable.icon_contenttalent_gamefalse)
                StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_SING)
                isCanClick = true
                context?.resources?.getColor(R.color.white)?.let { tv_use?.setTextColor(it) }
            }

            2 -> {
                iv_sing?.setBackgroundResource(R.drawable.icon_contenttalent_singfalse)
                iv_dance?.setBackgroundResource(R.drawable.icon_contenttalent_dancetrue)
                iv_game?.setBackgroundResource(R.drawable.icon_contenttalent_gamefalse)
                StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_DANCE)
                isCanClick = true
                context?.resources?.getColor(R.color.white)?.let { tv_use?.setTextColor(it) }
            }

            3 -> {
                iv_sing?.setBackgroundResource(R.drawable.icon_contenttalent_singfalse)
                iv_dance?.setBackgroundResource(R.drawable.icon_contenttalent_dancefalse)
                iv_game?.setBackgroundResource(R.drawable.icon_contenttalent_gametrue)
                StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_GAME)
                isCanClick = true
                context?.resources?.getColor(R.color.white)?.let { tv_use?.setTextColor(it) }
            }

            4 -> {
                iv_sing?.setBackgroundResource(R.drawable.icon_contenttalent_singfalse)
                iv_dance?.setBackgroundResource(R.drawable.icon_contenttalent_dancefalse)
                iv_game?.setBackgroundResource(R.drawable.icon_contenttalent_gamefalse)
                StatisticsUtil.onEvent(StatisticsEventID.CONTENTTALENT_OTHER)
                isCanClick = false
                context?.resources?.getColor(R.color.color_contenttalnet_use)?.let { tv_use?.setTextColor(it) }
            }
        }
    }

    /**
     *使用卡片
     */
    private fun useCardInfo(type: Int) {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        // 请求链接不进行转码
        asyncHttpClient.setURLEncodingEnabled(false)
        var params = NSRequestParams()
        params.put("type", type)
        asyncHttpClient.get(Constants.GET_CONTENTTALENT_USECARD, params,
            object : TextHttpResponseHandler() {
                override fun onFailure(statusCode: Int, headers: Array<out Header>?, responseString: String?,
                    throwable: Throwable?) {
                }

                override fun onSuccess(statusCode: Int, headers: Array<out Header>?, responseString: String?) {

                    var jsonObject = JSONObject(responseString)
                    var code = jsonObject.optInt("code")
                    val msg = jsonObject.optString("message")
                    if (code == 200) {
                        AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_TEENS_CONTENTTALENT_USEROOM)

                        when (type) {
                            1 -> {
                                tv_singnumber?.text = (singNumber - 1).toString()
                            }

                            2 -> {

                                tv_dancenumber?.text = (danceNumber - 1).toString()
                            }

                            3 -> {

                                tv_gamenumber?.text = (gameNumber - 1).toString()
                            }

                        }
                        AppBroadcastHelper.getInstance()
                            .sendBroadcast(NSReceiverAction.ACTION_TEENS_CONTENTTALENT_USECARDINFORMATION, null)
                        contentTalentPopWindow?.dismiss()
                    }
                    MyToast.MakeToast(context, msg)
                }
            })
    }

    /**
     *获取剩余卡片数量
     */
    private fun getCardInfo() {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        // 请求链接不进行转码
        asyncHttpClient.setURLEncodingEnabled(false)

        asyncHttpClient.get(Constants.GET_CONTENTTALENT_REMAININGAMOUNT, null,
            object : BaseJsonHttpResponseHandler<ContentTalentRecardBean>() {

                override fun parseResponse(rawJsonData: String, isFailure: Boolean): ContentTalentRecardBean? {
                    val builder = GsonBuilder()
                    val gson = builder.create()
                    var resultInfo: ContentTalentRecardBean? = null
                    try {
                        resultInfo = gson.fromJson(rawJsonData, ContentTalentRecardBean::class.java)
                    } catch (e: JsonSyntaxException) {
                        e.printStackTrace()
                        resultInfo = null
                        MyToast.MakeToast(context, "数据解析异常，请重试")
                    }

                    return resultInfo
                }

                override fun onSuccess(statusCode: Int, headers: Array<Header>?, rawJsonResponse: String,
                    response: ContentTalentRecardBean?) {
                    if (response != null && response.code == 200) {
                        if (response.data.sing_card_nums > 0) {
                            tv_singnumber?.visibility = View.VISIBLE
                            singNumber = response.data.sing_card_nums
                            tv_singnumber?.text = singNumber.toString()
                        }

                        if (response.data.dance_card_nums > 0) {
                            tv_dancenumber?.visibility = View.VISIBLE
                            danceNumber = response.data.dance_card_nums
                            tv_dancenumber?.text = danceNumber.toString()
                        }

                        if (response.data.nvteam_card_nums > 0) {
                            tv_gamenumber?.visibility = View.VISIBLE
                            gameNumber = response.data.nvteam_card_nums
                            tv_gamenumber?.text = gameNumber.toString()
                        }
                    } else {
                        MyToast.MakeSysToast(context, response?.message)
                    }
                }

                override fun onFailure(statusCode: Int, headers: Array<Header>?, throwable: Throwable, rawJsonData: String,
                    errorResponse: ContentTalentRecardBean?) {
                }
            })
    }


}